;*******************************************************************************
; PROCEDURE.SQL:   VERSION 2.3.2.150                                (24.06.2009)
;                  Definition von Generatoren, Proceduren und Triggers
;*******************************************************************************
;
;  Zustzlich in Radius:
;     GDI_SortFeld,
;     GDI_RAD_BelegPosInsert, GDI_RAD_BelegPosUpdate
;     GDI_RAD_Artikel_BeforeInsert, GDI_RAD_Artikel_BeforeUpdate
;
--
create generator Buchen_Disabled
--
set generator Buchen_Disabled to 0
--
create generator Prueflauf_Aktiv
--
set generator Prueflauf_Aktiv to 0
--
create generator Offline_Disabled
--
create generator Historie_Disabled
--
create generator ShopWGr_ID
--
set generator ShopWGr_ID to 0
--

create procedure GDI_WAEHRUMRECHNEN
   (IWert      Double Precision,
    IFaktoralt Double Precision,
    IFaktorneu Double Precision,
    IAltwaehr  VarChar(3),
    INeuwaehr  VarChar(3),
    IHauswaehr VarChar(3))
returns
   (AWert Double Precision)
as
   declare variable FHausWaehr VarChar(3);
   declare variable FArt Char(1);
   declare variable FRundArt Char(1);
   declare variable FNK SmallInt;
   declare variable FFaktor Double Precision;
   declare variable FEinheit SmallInt;
   declare variable FZwWert Double Precision;
begin
   if (IHausWaehr = "" or IHausWaehr is null) then
      select first 1 copy(w5,1,3) from gdidef where satzart = "FA2" into :FHausWaehr;
   else
      FHausWaehr = IHausWaehr;
   if ((IAltWaehr = "") or (IAltWaehr is null)) then
      IAltWaehr = FHausWaehr;
   if ((INeuWaehr = "") or (INeuWaehr is null)) then
      INeuWaehr = FHausWaehr;
   FRundArt = "+";
   FNK      = 2;
   FEinheit = 0;
   FArt     = "E";
   if      (IAltWaehr = "ATS") then FFaktor = 13.7603;
   else if (IAltWaehr = "BEF") then FFaktor = 40.3399;
   else if (IAltWaehr = "DEM") then FFaktor = 1.95583;
   else if (IAltWaehr = "ESP") then FFaktor = 166.386;
   else if (IAltWaehr = "FIM") then FFaktor = 5.94573;
   else if (IAltWaehr = "FRF") then FFaktor = 6.55957;
   else if (IAltWaehr = "GRD") then FFaktor = 340.750;
   else if (IAltWaehr = "IEP") then FFaktor = 0.787564;
   else if (IAltWaehr = "ITL") then FFaktor = 1936.27;
   else if (IAltWaehr = "LUF") then FFaktor = 40.3399;
   else if (IAltWaehr = "NLG") then FFaktor = 2.20371;
   else if (IAltWaehr = "PTE") then FFaktor = 200.482;
   else if (IAltWaehr = "EUR") then FFaktor = 1.00000;
   else if (IAltWaehr = "SIT") then FFaktor = 239.640;
   else if (IAltWaehr = "CYP") then FFaktor = 0.585274;
   else if (IAltWaehr = "MTL") then FFaktor = 0.42930;
   else begin
      FFaktor = 0;
      select rundart,nkstellen,faktor,einheit
      from Waehrung where isocode = :IAltWaehr
      into :FRundArt, :FNK, :FFaktor, :FEinheit;
      if ((FFaktor = 0) or (FFaktor is null)) then
         FArt = "N";
      else
         FArt = "X";
   end
   if ((IAltWaehr = INeuWaehr) and (FArt = "E")) then begin
      AWert = IWert;
      suspend;
      exit;
   end
   if (FArt = "N") then begin
   /* Fehlermeldung?! */
      AWert = IWert;
      suspend;
      exit;
   end
   if (IFaktorAlt > 0) then
      FFaktor = IFaktorAlt;
   while (FEinheit > 0) do begin
      FEinheit = FEinheit -1;
      FFaktor = FFaktor * 10;
   end
   FZwWert = IWert / FFaktor;
   FRundArt = "+";
   FNK      = 2;
   FEinheit = 0;
   FArt     = "E";
   if      (INeuWaehr = "ATS") then FFaktor = 13.7603;
   else if (INeuWaehr = "BEF") then FFaktor = 40.3399;
   else if (INeuWaehr = "DEM") then FFaktor = 1.95583;
   else if (INeuWaehr = "ESP") then FFaktor = 166.386;
   else if (INeuWaehr = "FIM") then FFaktor = 5.94573;
   else if (INeuWaehr = "FRF") then FFaktor = 6.55957;
   else if (INeuWaehr = "GRD") then FFaktor = 340.750;
   else if (INeuWaehr = "IEP") then FFaktor = 0.787564;
   else if (INeuWaehr = "ITL") then FFaktor = 1936.27;
   else if (INeuWaehr = "LUF") then FFaktor = 40.3399;
   else if (INeuWaehr = "NLG") then FFaktor = 2.20371;
   else if (INeuWaehr = "PTE") then FFaktor = 200.482;
   else if (INeuWaehr = "EUR") then FFaktor = 1.00000;
   else if (INeuWaehr = "SIT") then FFaktor = 239.640;
   else if (INeuWaehr = "CYP") then FFaktor = 0.585274;
   else if (INeuWaehr = "MTL") then FFaktor = 0.42930;
   else begin
      FFaktor = 0;
      select rundart,nkstellen,faktor,einheit
      from waehrung where isocode= :INeuWaehr
      into :FRundArt, :FNK, :FFaktor, :FEinheit;
      if ((FFaktor = 0) or (FFaktor is null)) then
         FArt = "N";
      else
         FArt = "X";
   end
   if (FArt = "N") then begin
   /* Fehlermeldung?! */
      AWert = IWert;
      suspend;
      exit;
   end
   if (IFaktorNeu > 0) then
      FFaktor = IFaktorNeu;
   while (FEinheit > 0) do begin
      FEinheit = FEinheit -1;
      FFaktor = FFaktor * 10;
   end
   FZwWert = FZwWert * FFaktor;
   AWert = Runden(FzwWert, FNK);
   suspend;
end
--

CREATE PROCEDURE GDI_KORE_EXPORT
    (IVONGDAT    DATE,
     IBISDATE    DATE,
     IVONADRNR   INTEGER,
     IBISADRNR   INTEGER,
     IVONKST     VARCHAR(12),
     IBISKST     VARCHAR(12),
     IVONKTR     VARCHAR(12),
     IBISKTR     VARCHAR(12),
     IVONKOART   DOUBLE PRECISION,
     IBISKOART   DOUBLE PRECISION,
     IBELEGARTEN VARCHAR(255),
     IKZVARPARAM VARCHAR(50))
/*
   IKZVARPARAMS Stellen:
   1 KzKore          ??? IKZKORE msste noch vereinbart werden
   2 KzMitGes0       ??? IKZMITGES0 Welcher Wert soll <> 0 sein?
   3 "J" Warengruppe als Kostenart
   4 "J" Adressnummer als Kostenstelle oder Kostentrger
   5 "J" Adressnummer nur als Kostenstellen
*/
returns (RKST        VARCHAR(12),
         RKTR        VARCHAR(12),
         RKART       DOUBLE PRECISION,
         RBELEGTYP   VARCHAR(1),
         RBELEGART   VARCHAR(5),
         RBELEGNR    INTEGER,
         RBELEGDAT   DATE,
         RADRESSNR   INTEGER,
         RWAEHRFAKT  DOUBLE PRECISION,
         RWAEHRBEZ   VARCHAR(3),
         RWAEHRNK    INTEGER,
         RWAEHRUNG   INTEGER,
         RISOWAEHR   VARCHAR(3),
         RNAME1      VARCHAR(30),
         RPLZ        VARCHAR(9),
         RORT        VARCHAR(30),
         RIDENTNR    VARCHAR(12),
         RIDNRBEZ    VARCHAR(30),
         RPOSNR      INTEGER,
         RGESAMT     DOUBLE PRECISION,
         RLAGERME    DOUBLE PRECISION,
         RTEXT       VARCHAR(254),
         RMENGENEINH VARCHAR(30),
         RLEISTNR    INTEGER,
         RLEISTBEZ   VARCHAR(255),
         RKALKEK     DOUBLE PRECISION,
         RARTIKELART VARCHAR(1),
         RHAUSWAEHR  VARCHAR(3))
AS
     declare variable FILIALE integer;
     declare variable ARTIKELNR varchar(30);
     declare variable MENGENEINH integer;
     declare variable WGR varchar(6);
     declare variable KZKORE varchar(1);
     declare variable KZMITGES0 varchar(1);
     declare variable MINLIEFERNR integer;
begin
   if (IBISADRNR < 1) then
      select W4 from gdidef where satzart = "FA3"
           into :IBISADRNR;

   select W3 from gdidef where satzart = "FA3"
           into :MINLIEFERNR;

   for select BELEGTYP,BELEGART,BELEGNR,BELEGDAT,ADRESSNR,WAEHRFAKT,
         WAEHRBEZ,WAEHRNK,ISOWAEHR,NAME1,PLZ,ORT,FILIALE
       from beleg
       where belegdat >= :IVONGDAT and belegdat <= :IBISDATE
            and adressnr >= :IVONADRNR and adressnr <= :IBISADRNR
       into :RBELEGTYP,:RBELEGART,:RBELEGNR,:RBELEGDAT,:RADRESSNR,
           :RWAEHRFAKT,:RWAEHRBEZ,:RWAEHRNK,:RISOWAEHR,:RNAME1,:RPLZ,:RORT,
           :FILIALE
   do begin
      if (Pos(RBELEGART, IBELEGARTEN) > 0) then begin
         select FILIALE, BEZEICHNUNG
             from FILIALE
             where FILIALE = :FILIALE
             into :RIDENTNR, :RIDNRBEZ;
         for select POSNR,GESAMT,KST,KTR,STRTOFLOAT(KART),LAGERME,
                  COPY(BLOBTOSTR(TEXT),1,254),MENGENEINH,ARTIKELNR, WGR
             from belegpos
             where BELEGTYP = :RBELEGTYP and BELEGART = :RBELEGART
                  and BELEGNR = :RBELEGNR
             into :RPOSNR,:RGESAMT,:RKST,:RKTR,:RKART,:RLAGERME,:RTEXT,:MENGENEINH,
                  :ARTIKELNR, :WGR
         do begin
            select F1 from gdidef where satzart = "ME" and w0 = :MENGENEINH
                 into :RMENGENEINH;

            select /*LEISTNR,*/ARTTEXT,KALKEK,KZART from ARTIKEL
                   where artikelnr = :artikelnr
                   into /*:RLEISTNR,*/:RLEISTBEZ,:RKALKEK,:RARTIKELART;

            select W5 from gdidef where satzart = "FA2" and w0 = 0
                 into :RHAUSWAEHR;

            if ( not (RBELEGTYP||RBELEGART in ("VRE","EGU"))) then
               RGESAMT = RGESAMT * (-1);

            RWAEHRFAKT = 1;
            RWAEHRBEZ = 'EUR';
            RISOWAEHR = 'EUR';
            if (CompareText('DEM',RISOWAEHR) = 0) then
               RWAEHRUNG = 1;
            else if (CompareText('EUR',RISOWAEHR) = 0) then
               RWAEHRUNG = 2;
            else begin
               select AWERT from GDI_WAEHRUMRECHNEN(
                     :RGESAMT,-1,-1,:RISOWAEHR,"EUR","")
                     into :RGESAMT;

               RWAEHRUNG = 2;
               RWAEHRFAKT = 1;
               RWAEHRBEZ = 'EUR';
               RISOWAEHR = 'EUR';
            end

            select NKSTELLEN from WAEHRUNG where ISOCODE = :RISOWAEHR
                  into :RWAEHRNK;

            KZKORE = "N";
            KZMITGES0 = "N";

            if (Pos(copy(IKZVARPARAM,1,1),"jJtToO1") > 0) then
               KZKORE = "J";
            if (Pos(copy(IKZVARPARAM,2,1),"jJtToO1") > 0) then
               KZMITGES0 = "J";
            if ((RKART < 1) and (Pos(copy(IKZVARPARAM,3,1),"jJtToO1") > 0)) then
               RKART = StrToFloat(WGR);
            if ((StrToFloat(RKST) < 1)
                  and ((Pos(copy(IKZVARPARAM,4,1),"jJtToO1") > 0)
                    or (Pos(copy(IKZVARPARAM,5,1),"jJtToO1") > 0)) ) then begin
               if ((RADRESSNR < MINLIEFERNR)
                   and (Pos(copy(IKZVARPARAM,5,1),"jJtToO1") = 0)) then
                  RKTR = IntToStr(RADRESSNR);
               else
                  RKST = IntToStr(RADRESSNR);
            end

            if (IVONKST = "") then     IVONKST = "0";
            if (IBISKST = "") then     IBISKST = "999999999999";
            if (IVONKTR = "") then     IVONKTR = "";
            if (IBISKTR = "") then     IBISKTR = "";
            if (IBISKOART  < 1) then   IBISKOART = 99999.99;
            if (IBELEGARTEN = "") then IBELEGARTEN = "RE,BE,GU,MA";

            if ( (StrToFLoat(RKST) >= StrToFloat(IVONKST))
                 and (StrToFLoat(RKST) <= StrToFloat(IBISKST))
                 and (comparetext(RKTR,IVONKTR) >= 0)
                 and (comparetext(RKTR,IBISKTR) <= 0)
                 and (RKART >= IVONKOART)
                 and (RKART <= IBISKOART)) then
               suspend;
         end
      end
   end
end
--

create procedure GDI_DELDATEI
   (Datei VarChar(30), Indexfeld VarChar(100), Referenz VarChar(255))
as
   declare Variable FFiliale  Integer;
begin
   if (gen_id(offline_disabled, 0) = 0) then begin
      select first 1 k2 from GDIDEF where Satzart = "FA2" into :FFiliale;
      insert into DelDatei (Art, Datei, Indexfeld, Referenz, Bediener, Datum, Modus, Filiale)
      values ("D",:Datei,Upper(:Indexfeld),:Referenz,"","now","",:FFiliale);
   end
end
--

create procedure GDI_OPHAUS
   (AdressNr Integer)
returns
   (OPHaus Double Precision)
as
   declare variable FBelegArt  VarChar(10);
   declare variable FOPHAUS    Double Precision;
   declare variable FNK        Integer;
begin
   FNK = null;
   select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNK;
   if ((FNK is null) or (FNK = 0)) then
      FNK = 2;
   OPHaus = 0.0;
   for select BelegArt,OPHAUS from Beleg
      where AdressNr = :AdressNr and
            BelegArt in ("RE","GU") and OPBetrag <> 0.0
      into  :FBelegArt, :FOPHaus
   do begin
      if (FBelegArt = "GU") then
         OPHaus = OPHaus - FOPHaus;
      else
         OPHaus = OPHaus + FOPHaus;
   end
   OPHaus = Runden(OPHaus,FNK);
   suspend;
end
--

create procedure GDI_ADRART_UMSATZ
   (AdressNr Integer, VonDatum Date, BisDatum Date)
returns
   (Artikelnr VarChar(30),
    HerStell  VarChar(30),
    Profil    VarChar(30),
    ArtText   VarChar(255),
    Menge     Double Precision,
    Gesamt    Double Precision,
    LagerMe   Double Precision,
    LagerPr   Double Precision)
as
   declare variable FArtikelnr VarChar(30);
   declare variable FBelegArt  VarChar(10);
   declare variable FMenge     Double Precision;
   declare variable FGesamt    Double Precision;
   declare variable FLagerMe   Double Precision;
   declare variable FLagerPr   Double Precision;
   declare variable FKzDruck   Char(1);
   declare variable FNKStatis  Integer;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;

   if (VonDatum is null) then VonDatum = "01.01.1900";
   if (BisDatum is null) then BisDatum = "31.12.2999";

   Artikelnr = "";
   for select Artikelnr,BelegArt,sum(MENGE),sum(GESAMT),
              sum(LAGERME),sum(LAGERPR), kzDruck from BelegPos
      where AdressNr = :AdressNr and
            Artikelnr <> "" and
            ((not (KZDRUCK in ("t","T","C","P","E","S","R","A"))) or (kzDruck is null)) and
            BelegArt in ("RE","GU","LI","MA","RL") and
            (DatumMe >= :VonDatum) and
            (DatumMe < :Bisdatum +1)
      group by Artikelnr,BelegArt, KzDruck
      into  :FArtikelnr, :FBelegArt, :FMenge, :FGesamt, :FLagerMe, :FLagerPr, :FKzDruck
   do begin
      if (Artikelnr <> FArtikelnr) then begin
         select ArtText,HerStell,Profil from Artikel where Artikelnr = :Artikelnr
         into :ArtText, :HerStell, :Profil;
         if (Artikelnr <> "") then
            suspend;
         Artikelnr = FArtikelnr;
         Menge  = 0.0;
         Gesamt = 0.0;
         LagerMe = 0.0;
         LagerPr = 0.0;
      end

      if (FKzDruck = "M") then begin
         FGesamt = 0.0;
         FLagerPr = 0.0;
      end
      else if (FKzDruck = "W") then begin
         FMenge   = 0.0;
         FLagerMe = 0.0;
      end

      if (FBelegArt in ("GU","RL")) then begin
         Menge   = Menge - FMenge;
         Gesamt  = Runden(Gesamt - FGesamt, FNKStatis);
         LagerMe = LagerMe - FLagerMe;
         LagerPr = Runden(LagerPr - FLagerPr, FNKStatis);
      end else begin
         Menge   = Menge + FMenge;
         Gesamt  = Runden(Gesamt + FGesamt, FNKStatis);
         LagerMe = LagerMe + FLagerMe;
         LagerPr = Runden(LagerPr + FLagerPr, FNKStatis);
      end
   end
   select ArtText,HerStell,Profil from Artikel where Artikelnr = :Artikelnr
   into :ArtText, :HerStell, :Profil;
   suspend;
end
--

create procedure GDI_ARTADR_UMSATZ
   (Artikelnr VarChar(30), VonDatum Date, BisDatum Date)
returns
   (AdressNr  Integer,
    Menge     Double Precision,
    Gesamt    Double Precision,
    LagerMe   Double Precision,
    LagerPr   Double Precision)
as
   declare variable FAdressnr  Integer;
   declare variable FBelegArt  VarChar(10);
   declare variable FMenge     Double Precision;
   declare variable FGesamt    Double Precision;
   declare variable FLagerMe   Double Precision;
   declare variable FLagerPr   Double Precision;
   declare variable FKzDruck   Char(1);
   declare variable FNKStatis  Integer;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;

   if (VonDatum is null) then VonDatum = "01.01.1900";
   if (BisDatum is null) then BisDatum = "31.12.2999";

   Adressnr = 0;
   for select Adressnr,BelegArt,sum(MENGE),sum(GESAMT),
              sum(LAGERME),sum(LAGERPR), kzDruck from BelegPos
      where Artikelnr = :Artikelnr and
            Adressnr <> 0 and
            ((not (KZDRUCK in ("t","T","C","P","E","S","R","A"))) or (kzDruck is null)) and
            BelegArt in ("RE","GU","LI","MA","RL") and
            (DatumMe >= :VonDatum) and
            (DatumMe < :Bisdatum +1)
      group by Adressnr, BelegArt, KzDruck
      into  :FAdressnr, :FBelegArt, :FMenge, :FGesamt, :FLagerMe, :FLagerPr, :FKzDruck
   do begin
      if (Adressnr <> FAdressnr) then begin
         if (Adressnr <> 0) then
            suspend;
         Adressnr = FAdressnr;
         Menge  = 0.0;
         Gesamt = 0.0;
         LagerMe = 0.0;
         LagerPr = 0.0;
      end

      if (FKzDruck = "M") then begin
         FGesamt = 0.0;
         FLagerPr = 0.0;
      end
      else if (FKzDruck = "W") then begin
         FMenge   = 0.0;
         FLagerMe = 0.0;
      end

      if (FBelegArt in ("GU","RL")) then begin
         Menge   = Menge - FMenge;
         Gesamt  = Runden(Gesamt - FGesamt, FNKStatis);
         LagerMe = LagerMe - FLagerMe;
         LagerPr = Runden(LagerPr - FLagerPr, FNKStatis);
      end else begin
         Menge   = Menge + FMenge;
         Gesamt  = Runden(Gesamt + FGesamt, FNKStatis);
         LagerMe = LagerMe + FLagerMe;
         LagerPr = Runden(LagerPr + FLagerPr, FNKStatis);
      end
   end
   suspend;
end
--

create procedure GDI_SERIEN_UPD
   (BelegTyp Char(1),     BelegArt VarChar(5),
    BelegNr  Integer,     PosArt   VarChar(5),
    SerienNr VarChar(20), AdressNr Integer,
    DatumPr  Date,        LagerEP  Double Precision,
    KzSerie  Char(1))
as
   declare variable FKundennr Integer;
   declare variable FLiefernr Integer;
   declare variable FVK       Double Precision;
   declare variable FEK       Double Precision;
   declare variable FKzFrei   Char(1);
   declare variable FKzEkFrei Char(1);
   declare variable FKuLiNr   Integer;
   declare variable FKuLiDat  Date;
   declare variable FKuRlNr   Integer;
   declare variable FKuRlDat  Date;
   declare variable FKuReNr   Integer;
   declare variable FKuReDat  Date;
   declare variable FKuGuNr   Integer;
   declare variable FKuGuDat  Date;
   declare variable FLiLiNr   Integer;
   declare variable FLiLiDat  Date;
   declare variable FLiRlNr   Integer;
   declare variable FLiRlDat  Date;
   declare variable FLiReNr   Integer;
   declare variable FLiReDat  Date;
   declare variable FLiGuNr   Integer;
   declare variable FLiGuDat  Date;
   declare variable FV_Freigabe Integer;
begin
   /* Freigabe fr V-Gutschriften/Rcklieferungen?
      0=Keine, 1=GU, 2=RL, 3=GU+RL */
   FV_Freigabe = null;
   select first 1 StrToInt(Copy(ListValue(M1,"SERIEN.FREIGABE.VERKAUF"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FV_Freigabe;
   if ((FV_Freigabe is null) or (FV_Freigabe not in (0,1,2,3))) then
      FV_Freigabe = 0;

   select kundennr, liefernr, vk, ek, kzfrei, kzekfrei,
          kulinr, kulidat, kurenr, kuredat, kugunr, kugudat,
          lilinr, lilidat, lirenr, liredat, ligunr, ligudat
   from   Serien
   where  seriennr = :SerienNr
   into   :FKundennr, :FLiefernr, :FVK, :FEK, :FKzfrei, :FKzEKfrei,
          :FKuLiNr, :FKuLiDat, :FKuReNr, :FKuReDat, :FKuGuNr, :FKuGuDat,
          :FLiLiNr, :FLiLiDat, :FLiReNr, :FLiReDat, :FLiGuNr, :FLiGuDat;

   if ((BelegTyp = "V") or (BelegTyp || PosArt = "LA")) then begin
      Fvk = LagerEP;

      FkzFrei = "0";
      if ((FV_Freigabe = 1) and (BelegArt = "GU")) then
         FkzFrei = "1";
      else if ((FV_Freigabe = 2) and (BelegArt = "RL")) then
         FkzFrei = "1";
      else if ((FV_Freigabe = 3) and (BelegArt in ("GU","RL"))) then
         FkzFrei = "1";

      if (KZSerie in ("1","2")) then begin
         Fkundennr = AdressNr;
      end
      if (BelegArt = "LI") then begin
         Fkulinr = BelegNr; Fkulidat = DatumPr;
      end else if (BelegArt = "RL") then begin
         Fkurlnr = BelegNr; Fkurldat = DatumPr;
      end else if (BelegArt = "RE") then begin
         Fkurenr = BelegNr; Fkuredat = DatumPR;
      end else if (BelegArt = "GU") then begin
         Fkugunr = BelegNr; Fkugudat = DatumPr;
      end
   end else if ((BelegTyp = "E") or (BelegTyp || PosArt = "LZ")) then begin
      Fek = LagerEP; FkzekFrei = "0";

/*      FkzFrei = "1"; */
      if ((FV_Freigabe = 1) and (BelegArt = "GU")) then
         FkzFrei = "0";
      else if ((FV_Freigabe = 2) and (BelegArt = "RL")) then
         FkzFrei = "0";
      else if ((FV_Freigabe = 3) and (BelegArt in ("GU","RL"))) then
         FkzFrei = "0";

      if (KZSerie in ("1","2")) then begin
         Fliefernr = AdressNr;
      end
      if (BelegArt = "LI") then begin
         Flilinr = BelegNr; Flilidat = DatumPr;
      end else if (BelegArt = "RL") then begin
         Flirlnr = BelegNr; Flirldat = DatumPr;
      end else if (BelegArt = "RE") then begin
         Flirenr = BelegNr; Fliredat = DatumPr;
      end else if (BelegArt = "GU") then begin
         Fligunr = BelegNr; Fligudat = DatumPr;
      end
   end
   update Serien
   set    kundennr = :FKundennr, liefernr = :FLiefernr, vk = :FVK, ek = :FEK,
          kzfrei = :FKzfrei, kzekfrei = :FKzEKfrei,
          kulinr = :FKuLiNr, kulidat = :FKuLiDat, kurenr = :FKuReNr, kuredat = :FKuReDat,
          kugunr = :FKuGuNr, kugudat = :FKuGuDat, lilinr = :FLiLiNr, lilidat = :FLiLiDat,
          lirenr = :FLiReNr, liredat = :FLiReDat, ligunr = :FLiGuNr, ligudat = :FLiGuDat
   where  seriennr = :SerienNr;
end
--

create procedure GDI_STATIS
   (INr         SmallInt,
    IVondatum   Date,
    IBisdatum   Date,
    IKzdatum    Char(1),
    IBelegarten VarChar(100),
    IBelArtFlag Char(1))
returns
   (OK Integer)
as
   declare variable FArtikelnr VarChar(100);
   declare variable FArtikelnr2 VarChar(100);
   declare variable FFiliale Integer;
   declare variable FAdressNr Integer;
   declare variable FVertretnr Integer;
   declare variable FPersonal VarChar(5);
   declare variable FLiefernr Integer;
   declare variable FMonteur1  VarChar(5);
   declare variable FMonteur2  VarChar(5);
   declare variable FMonteur3  VarChar(5);
   declare variable FTyp VarChar(2);
   declare variable FArt VarChar(5);
   declare variable FPosArt VarChar(5);
   declare variable FKZDruck VarChar(5);
   declare variable FKZErloes VarChar(5);
   declare variable FLagerMe Double Precision;
   declare variable FLagerPr Double Precision;
   declare variable FEKGesamt Double Precision;
   declare variable FMPunkte Double Precision;
   declare variable ZEKME Double Precision;
   declare variable ZEKWert Double Precision;
   declare variable ZVKME Double Precision;
   declare variable ZVKWert Double Precision;
   declare variable ZErloes Double Precision;
   declare variable ZMPunkte Double Precision;
   declare variable ZAnzahl Integer;
   declare variable ZFiliale Integer;
   declare variable ZArtikelnr VarChar(100);
   declare variable ZAdressNr Integer;
   declare variable ZVertretnr Integer;
   declare variable ZPersonal VarChar(5);
   declare variable ZLiefernr Integer;
   declare variable ZMonteur1  VarChar(5);
   declare variable ZMonteur2  VarChar(5);
   declare variable ZMonteur3  VarChar(5);
   declare variable FBerechnen Char(1);
   declare variable FVonDatum Date;
   declare variable FBisDatum Date;
   declare variable FLastDatum Date;
   declare variable FCount Double Precision;
   declare variable FBelegArten VarChar(200);
   declare variable FOldBelegArten VarChar(200);
   declare variable FErloesWert Double Precision;
   declare variable FNKStatis  Integer;
   declare variable FEKGesamtKB Double Precision;
   declare variable ZEKWertKB Double Precision;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;
   OK = 0;
   FBelegArten = UpperCase(:IBelegArten);
   /* Datum der letzten Berechnung */
   FLastDatum = null;
   ZArtikelnr = null;
   select Artikelnr,Zeitraum from Statis
   where  Artikelnr = "AM" || IntToStr(:INr) and Filiale = 0 and AdressNr = -1 and
          Vertretnr = -1
   into   :ZArtikelnr,:FLastDatum;
   if ((ZArtikelnr is null) or (ZArtikelnr = "")) then
      FLastDatum = null;
   /* Ermittlung Zeitraum */
   FArtikelnr  = null;
   FArtikelnr2 = null;
   FVonDatum   = null;
   FBisDatum   = null;
   FBerechnen = "0";
   select Artikelnr, Zeitraum from Statis
   where  ArtikelNr = "VONDATUM" || IntToStr(:INr) and Filiale = 0 and
          AdressNr  = -1 and Vertretnr = -1 and Personalnr = "-1"
   into   :FArtikelnr, :FVonDatum;
   select Artikelnr, Zeitraum from Statis
   where  ArtikelNr = "BISDATUM" || IntToStr(:INr) and Filiale = 0 and
          AdressNr = -1 and Vertretnr = -1 and Personalnr = "-1"
   into   :FArtikelnr2, :FBisDatum;

/* Zeitraum lschen */
   if ((IVonDatum is null) and (IBisDatum is null)) then begin
      update Statis set Zeitraum = null
      where Artikelnr = "VONDATUM" || IntToStr(:INr) and Filiale = 0 and
            AdressNr = -1 and Vertretnr = -1 and Personalnr = "-1";
      update Statis set Zeitraum = null
      where Artikelnr = "BISDATUM" || IntToStr(:INr) and Filiale = 0 and
            AdressNr = -1 and Vertretnr = -1 and Personalnr = "-1";
      FBerechnen = "1";
   end

/* Prfung Zeitraum */
   else begin
      if ((FVonDatum is null) or (FVonDatum <> :IVonDatum)) then begin
         if (FArtikelnr is null) then
            insert into Statis
                      ( ArtikelNr,Filiale,AdressNr,Vertretnr,Personalnr,Liefernr,
                        Monteur1,Monteur2,Monteur3,Zeitraum)
               Values ( "VONDATUM" || IntToStr(:INr),0,-1,-1,"-1",-1,"","","",:IVonDatum);
         else
            update Statis set Zeitraum = :IVonDatum
            where ArtikelNr = "VONDATUM" || IntToStr(:INr) and Filiale = 0 and
                  AdressNr = -1 and Vertretnr = -1 and Personalnr = "-1";
         FBerechnen= "1";
      end
      if ((FBisDatum is null) or (FBisDatum <> :IBisDatum)) then begin
         if (FArtikelnr2 is null) then
            insert into Statis
                      ( ArtikelNr,Filiale,AdressNr,Vertretnr,Personalnr,Liefernr,
                        Monteur1,Monteur2,Monteur3,Zeitraum)
               Values ( "BISDATUM" || IntToStr(:INr),0,-1,-1,"-1",-1,"","","",:IBisDatum);
         else
            update Statis set Zeitraum = :IBisDatum
            where ArtikelNr = "BISDATUM" || IntToStr(:INr) and Filiale = 0 and
                  AdressNr  = -1 and Vertretnr = -1 and Personalnr = "-1";
         FBerechnen= "1";
      end
   end

   /* Belegarten abspeichern + Alte Arten merken */
   ZArtikelnr     = null;
   FOldBelegArten = null;

   select Artikelnr from Statis
   where  Copy(Artikelnr,1, StrLen("BELEGARTEN=")) = "BELEGARTEN=" and
          Filiale = 0 and AdressNr  = -1 and Vertretnr = -1 and Personalnr = "-1"
   into :FOldBelegArten;

   /* Aktualisierung nur beim letzten Durchlauf */
   if (IBelArtFlag = "1") then begin
      if (FOldBelegArten is null) then
         insert into Statis
                   (ArtikelNr, Filiale, AdressNr,Vertretnr,Personalnr,
                    Liefernr,Monteur1,Monteur2,Monteur3)
            Values ( "BELEGARTEN=" || :FBelegArten, 0,-1,-1,"-1",-1,"","","");
      else begin
         update Statis set ArtikelNr = "BELEGARTEN=" || :FBelegArten
         where Copy(ArtikelNr,1, StrLen("BELEGARTEN=")) = "BELEGARTEN=" and
               Filiale = 0 and AdressNr  = -1 and Vertretnr = -1 and Personalnr = "-1";
      end
   end

   if (FOldBelegArten is null) then
      FOldBelegArten = "";

   FOldBelegArten = Copy(FOldBelegArten,StrLen("BELEGARTEN=")+1,100);

   if ((FBelegArten <> FOldBelegArten) or
       (FLastDatum is null) or (:IKzDatum = "I")) then
      FBerechnen= "1";

   /* Belegpos-Prfung */
   if ((:IKzDatum = "S") and (FBerechnen= "0")) then begin
      select count(*) from Belegpos
      where datumpr >= :IVonDatum and datumpr < :IBisDatum + 1 and
            AendDatum > :FLastDatum and
            ArtikelNr <> "" and
            ((not (KzDruck in ("A","E","P","T","t","S","C"))) or (kzDruck is null)) and
             (Pos(Belegtyp||Belegart,:FBelegarten) > 0)
      into ZAnzahl;
      if (ZAnzahl > 0) then
         FBerechnen= "1";
   end

   /* Zeitraum neu berechnen */
   if (FBerechnen= "1") then begin
      /* Felder fr Zeitraum lschen */
      if (INr = 1) then begin
         delete from Statis
         where AdressNr >= 0 and Vertretnr >= 0 and
               EkMe2   = 0 and EkMe3   = 0 and EkMe4   = 0 and
               EkWert2 = 0 and EkWert3 = 0 and EkWert4 = 0 and
               EKWertKB2 = 0 and EKWertKB3 = 0 and EKWertKB4 = 0 and
               VkMe2   = 0 and VkMe3   = 0 and VkMe4   = 0 and
               VkWert2 = 0 and VkWert3 = 0 and VkWert4 = 0 and
               Erloes2 = 0 and Erloes3 = 0 and Erloes4 = 0 and
               MPunkte2= 0 and MPunkte3= 0 and MPunkte4= 0;
         update statis
         set EkMe1=0,EkWert1=0,EKWertKB1=0,VkMe1=0,VkWert1=0,Erloes1=0,MPunkte1=0
         where AdressNr >= 0 and Vertretnr >= 0;
      end
      else if (INr = 2) then begin
         delete from Statis
         where AdressNr >= 0 and Vertretnr >= 0 and
               EkMe1   = 0 and EkMe3   = 0 and EkMe4   = 0 and
               EkWert1 = 0 and EkWert3 = 0 and EkWert4 = 0 and
               EKWertKB1 = 0 and EKWertKB3 = 0 and EKWertKB4 = 0 and
               VkMe1   = 0 and VkMe3   = 0 and VkMe4   = 0 and
               VkWert1 = 0 and VkWert3 = 0 and VkWert4 = 0 and
               Erloes1 = 0 and Erloes3 = 0 and Erloes4 = 0 and
               MPunkte1= 0 and MPunkte3= 0 and MPunkte4= 0;
         update statis
         set EkMe2=0,EkWert2=0,EKWertKB2=0,VkMe2=0,VkWert2=0,Erloes2=0,MPunkte2=0
         where AdressNr >= 0 and Vertretnr >=0;
      end
      else if (INr = 3) then begin
         delete from Statis
         where AdressNr >= 0 and Vertretnr >= 0 and
               EkMe1   = 0 and EkMe2   = 0 and EkMe4   = 0 and
               EkWert1 = 0 and EkWert2 = 0 and EkWert4 = 0 and
               EKWertKB1 = 0 and EKWertKB2 = 0 and EKWertKB4 = 0 and
               VkMe1   = 0 and VkMe2   = 0 and VkMe4   = 0 and
               VkWert1 = 0 and VkWert2 = 0 and VkWert4 = 0 and
               Erloes1 = 0 and Erloes2 = 0 and Erloes4 = 0 and
               MPunkte1= 0 and MPunkte2= 0 and MPunkte4= 0;
         update statis
         set EkMe3=0,EkWert3=0,EKWertKB3=0,VkMe3=0,VkWert3=0,Erloes3=0,MPunkte3=0
         where AdressNr >= 0 and Vertretnr >= 0;
      end
      else if (INr = 4) then begin
         delete from Statis
         where AdressNr >= 0 and Vertretnr >= 0 and
               EkMe1   = 0 and EkMe2   = 0 and EkMe3   = 0 and
               EkWert1 = 0 and EkWert2 = 0 and EkWert3 = 0 and
               EKWertKB1 = 0 and EKWertKB2 = 0 and EKWertKB3 = 0 and
               VkMe1   = 0 and VkMe2   = 0 and VkMe3   = 0 and
               VkWert1 = 0 and VkWert2 = 0 and VkWert3 = 0 and
               Erloes1 = 0 and Erloes2 = 0 and Erloes3 = 0 and
               MPunkte1= 0 and MPunkte2= 0 and MPunkte3= 0;
         update statis
         set EkMe4=0,EkWert4=0,EKWertKB4=0,VkMe4=0,VkWert4=0,Erloes4=0,MPunkte4=0
         where AdressNr >= 0 and Vertretnr >= 0;
      end

      if ((IVonDatum is not null) and (IBisDatum is not null)) then begin
         ZArtikelnr = "";
         ZFiliale   = -1;
         ZAdressNr  = -2;
         ZVertretnr = -2;
         ZPersonal  = "-2";
         ZLiefernr  = -2;
         ZMonteur1  = "-2"; ZMonteur2  = "-2"; ZMonteur3  = "-2";
         for Select p.ArtikelNr, p.Filiale, p.AdressNr, p.BelegTyp, p.BelegArt,
                    p.PosArt, p.KZDruck, p.KzErloes, p.LagerMe, p.LagerPr, p.EkGesamt, runden(p.lagerme*p.kbwert,2),
                    p.Vertreter, p.Bediener,b.Liefernr,
                    p.Monteur1,p.Monteur2,p.Monteur3, p.LagerMe * p.MPunkte
            from Belegpos p
            left outer join Beleg b
            on              p.BelegTyp = b.BelegTyp and
                            p.BelegArt = b.BelegArt and
                            p.BelegNr  = b.BelegNr
            where p.DatumPr >= :IVonDatum and  p.DatumPr < :IBisDatum+1 and
                  p.ArtikelNr <> "" and
                  ((not (p.KzDruck in ("A","E","P","T","t","S","C"))) or (p.KzDruck is null)) and
                  (((p.Belegtyp in ("V","E")) and (Pos(p.Belegtyp||p.Belegart,:IBelegarten) > 0)) or
                   ((p.Belegtyp = "L")        and (Pos(p.Belegtyp||p.Posart,  :IBelegarten) > 0)))
            order by p.ArtikelNr, p.Filiale, p.AdressNr, p.Vertreter, p.Bediener,
                     b.Liefernr, p.Monteur1, p.Monteur2, p.Monteur3, p.DatumPr
            into :FArtikelNr, :FFiliale, :FAdressNr, :FTyp, :FArt, :FPosArt,
                 :FKzDruck, :FKzErloes, :FLagerMe, :FLagerPr, :FEKGesamt, :FEKGesamtKB,:FVertretnr,
                 :FPersonal, :FLiefernr, :FMonteur1, :FMonteur2, :FMonteur3, :FMPunkte do begin

            if (FArtikelNr is null) then FArtikelNr = "";
            if (FFiliale   is null) then FFiliale   = 0;
            if (FAdressNr  is null) then FAdressNr  = 0;
            if (FVertretnr is null) then FVertretnr = 0;
            if (FPersonal  is null) then FPersonal  = "";
            if (FLiefernr  is null) then FLiefernr  = 0;
            if (FMonteur1  is null) then FMonteur1  = "";
            if (FMonteur2  is null) then FMonteur2  = "";
            if (FMonteur3  is null) then FMonteur3  = "";

            if ((FArtikelNr <> ZArtikelNr) or (FFiliale   <> ZFiliale)   or
                (FAdressNr  <> ZAdressNr)  or (FVertretnr <> ZVertretnr) or
                (FPersonal  <> ZPersonal)  or (FLiefernr  <> ZLiefernr)  or
                (FMonteur1  <> ZMonteur1)  or (FMonteur2  <> ZMonteur2)  or
                (FMonteur3  <> ZMonteur3))                               then begin

               /* Monteurspunkte durch Anzahl eingetragener Monteure teilen */
               FCount = 0;
               if (FMonteur1<> "") then
                  FCount = 1;
               if (FMonteur2<> "") then
                  FCount = FCount + 1;
               if (FMonteur3<> "") then
                  FCount = FCount + 1;
               if (FCount > 0) then
                  FMPunkte = Runden(FMPunkte / FCount,0);

               if (ZArtikelnr <> "") then begin
                  select count(*) from Statis
                     where ArtikelNr  = :ZArtikelNr and Filiale   = :ZFiliale   and
                           AdressNr   = :ZAdressNr  and Vertretnr = :ZVertretnr and
                           Personalnr = :ZPersonal  and Liefernr  = :ZLiefernr  and
                           Monteur1  = :ZMonteur1   and Monteur2   = :ZMonteur2 and
                           Monteur3  = :ZMonteur3
                     into :ZAnzahl;
                  if (ZAnzahl = 0) then begin
                     if (INr = 1) then begin
                        insert into Statis
                                  (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                                   Liefernr,Monteur1,Monteur2,Monteur3,MPunkte1,
                                   EKMe1,EKWert1,EKWertKB1,VKMe1,VKWert1,Erloes1)
                           Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                                   :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                                   :ZEKMe,:ZEKWert,:ZEKWertKB, :ZVKMe,:ZVkWert,:ZErloes);
                     end
                     else if (INr = 2) then begin
                        insert into Statis
                                  (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                                   Liefernr,Monteur1,Monteur2,Monteur3,MPunkte2,
                                   EKMe2,EKWert2,EKWertKB2,VKMe2,VKWert2,Erloes2)
                           Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                                   :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                                   :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
                     end
                     else if (INr = 3) then begin
                        insert into Statis
                                  (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                                   Liefernr,Monteur1,Monteur2,Monteur3,MPunkte3,
                                   EKMe3,EKWert3,EKWertKB3,VKMe3,VKWert3,Erloes3)
                           Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                                   :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                                   :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
                     end
                     else if (INr = 4) then begin
                        insert into Statis
                                  (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                                   Liefernr,Monteur1,Monteur2,Monteur3,MPunkte4,
                                   EKMe4,EKWert4,EKWertKB4,VKMe4,VKWert4,Erloes4)
                           Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                                   :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                                   :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
                     end
                  end else begin
                     if (INr = 1) then begin
                        update Statis set EKMe1=:ZEKMe,EKWert1=:ZEKWert, EKWertKB1 =:ZEKWertKB,
                                          VKMe1=:ZVKMe,VKWert1=:ZVkWert,
                                          Erloes1=:ZErloes,MPunkte1=:ZMPunkte
                           where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                                 AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                                 Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                                 Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                                 Monteur3  = :ZMonteur3;
                     end
                     else if (INr = 2) then begin
                        update Statis set EKMe2=:ZEKMe,EKWert2=:ZEKWert, EKWertKB2 =:ZEKWertKB,
                                          VKMe2=:ZVKMe,VKWert2=:ZVkWert,
                                          Erloes2=:ZErloes,MPunkte2=:ZMPunkte
                           where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                                 AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                                 Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                                 Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                                 Monteur3  = :ZMonteur3;
                     end
                     else if (INr = 3) then begin
                        update Statis set EKMe3=:ZEKMe,EKWert3=:ZEKWert, EKWertKB3 =:ZEKWertKB,
                                          VKMe3=:ZVKMe,VKWert3=:ZVkWert,
                                          Erloes3=:ZErloes,MPunkte3=:ZMPunkte
                           where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                                 AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                                 Personalnr = :ZPersonal and Liefernr  = :ZLiefernr and
                                 Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2 and
                                 Monteur3  = :ZMonteur3;
                     end
                     else if (INr = 4) then begin
                        update Statis set EKMe4=:ZEKMe,EKWert4=:ZEKWert, EKWertKB4 =:ZEKWertKB,
                                          VKMe4=:ZVKMe,VKWert4=:ZVkWert,
                                          Erloes4=:ZErloes,MPunkte4=:ZMPunkte
                           where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                                 AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                                 Personalnr = :ZPersonal and Liefernr  = :ZLiefernr and
                                 Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2 and
                                 Monteur3  = :ZMonteur3;
                     end
                  end
               end
               ZEKME = 0; ZVKME = 0; ZEKWert = 0; ZEKWertKB = 0; ZVKWert = 0; ZErloes = 0; ZMPunkte =0;
            end
            ZArtikelNr = FArtikelNr;
            ZFiliale   = FFiliale;
            ZAdressNr  = FAdressNr;
            ZVertretnr = FVertretnr;
            ZPersonal  = FPersonal;
            ZLiefernr  = FLiefernr;
            ZMonteur1  = FMonteur1; ZMonteur2  = FMonteur2; ZMonteur3  = FMonteur3;

            /* Erlsberechnung */
            FErloesWert = 0;
            if (FKzDruck <> "M") then begin
               if (FKzErloes <> "2") then begin
                  if (FKZErloes = "1") then begin
                     if (FEKGesamt <> 0) then
                        FErloesWert = FLagerPr - FEKGesamt;
                  end else
                     FErloesWert = FLagerPr - FEKGesamt;
               end
            end

            if (FKzDruck = "M") then begin
               FLagerPr = 0;
            end
            else if (FKzDruck = "W") then begin
               FLagerMe = 0;
            end

            if (FTyp = "V") then begin
               if (FArt in ("LI","RE","MA")) then begin
                  ZVKME   = ZVKME  + FLagerMe;
                  ZVKWert = ZVKWert + FLagerPr;
                  ZErloes = ZErloes + FErloesWert;
                  if (FArt = "RE") then
                     ZMPunkte = ZMPunkte + FMPunkte;
               end else if (FArt in ("GU", "RL")) then begin
                  ZVKME   = ZVKME  - FLagerMe;
                  ZVKWert = ZVKWert - FLagerPr;
                  ZErloes = ZErloes - FErloesWert;
                  ZMPunkte = ZMPunkte - FMPunkte;
               end else if (FArt = "FU") then begin
                  ZEKME   = ZEKME   - FLagerMe;
                  ZEKWert = ZEKWert - FLagerPr;
               end
            end else if (Ftyp = "E") then begin
               if (FArt in ("LI","RE","MA")) then begin
                  ZEKME   = ZEKME   + FLagerMe;
                  ZEKWert = ZEKWert + FLagerPr;
                  ZEKWertKB = ZEKWertKB + FEKGesamtKB;
               end else if (FArt in ("GU", "RL")) then begin
                  ZEKME   = ZEKME   - FLagerMe;
                  ZEKWert = ZEKWert - FLagerPr;
                  ZEKWertKB = ZEKWertKB - FEKGesamtKB;
               end else if (FArt = "FU") then begin
                  ZEKME   = ZEKME   + FLagerMe;
                  ZEKWert = ZEKWert + FLagerPr;
                  ZEKWertKB = ZEKWertKB + FEKGesamtKB;
               end
            end else if (Ftyp = "L") then begin
               if (FPosArt in ("A")) then begin
                  ZVKME   = ZVKME  + FLagerMe;
                  ZVKWert = ZVKWert + FLagerPr;
                  ZErloes = ZErloes + FErloesWert;
               end
               else if (FPosArt in ("Z","K")) then begin
                  ZEKME   = ZEKME   + FLagerMe;
                  ZEKWert = ZEKWert + FLagerPr;
                  ZEKWertKB = ZEKWertKB + FEKGesamtKB;
               end
            end
         end
         ZEKWert = Runden(ZEKWert, FNKStatis);
         ZVkWert = Runden(ZVKWert, FNKStatis);
         ZErloes = Runden(ZErloes, FNKStatis);
         ZEKWertKB = Runden(ZEKWertKB, FNKStatis);
         if (ZArtikelnr <> "") then begin
            select count(*) from Statis
               where ArtikelNr  = :ZArtikelnr and Filiale   = :ZFiliale   and
                     AdressNr   = :ZAdressNr  and Vertretnr = :ZVertretnr and
                     Personalnr = :ZPersonal  and Liefernr  = :ZLiefernr  and
                     Monteur1  = :ZMonteur1   and Monteur2  = :ZMonteur2  and
                     Monteur3  = :ZMonteur3
               into :ZAnzahl;
            if (ZAnzahl = 0) then begin
               if (INr = 1) then begin
                  insert into Statis
                            (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                             Liefernr,Monteur1,Monteur2,Monteur3,MPunkte1,
                             EKMe1,EKWert1,EKWertKB1,VKMe1,VKWert1,Erloes1)
                     Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                             :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                             :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
               end
               else if (INr = 2) then begin
                  insert into Statis
                            (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                             Liefernr,Monteur1,Monteur2,Monteur3,MPunkte2,
                             EKMe2,EKWert2,EKWertKB2,VKMe2,VKWert2,Erloes2)
                     Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                             :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                             :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
               end
               else if (INr = 3) then begin
                  insert into Statis
                            (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                             Liefernr,Monteur1,Monteur2,Monteur3,MPunkte3,
                             EKMe3,EKWert3,EKWertKB3,VKMe3,VKWert3,Erloes3)
                     Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                             :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                             :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
               end
               else if (INr = 4) then begin
                  insert into Statis
                            (ArtikelNr,Filiale,AdressNr,VertretNr,PersonalNr,
                             Liefernr,Monteur1,Monteur2,Monteur3,MPunkte4,
                             EKMe4,EKWert4,EKWertKB4,VKMe4,VKWert4,Erloes4)
                     Values (:ZArtikelnr,:ZFiliale,:ZAdressNr,:ZVertretnr,:ZPersonal,
                             :ZLiefernr,:ZMonteur1,:ZMonteur2,:ZMonteur3,:ZMPunkte,
                             :ZEKMe,:ZEKWert,:ZEKWertKB,:ZVKMe,:ZVkWert,:ZErloes);
               end
            end else begin
               if (INr = 1) then begin
                  update Statis set EKMe1=:ZEKMe,EKWert1=:ZEKWert,EKWertKB1 =:ZEKWertKB,
                                    VKMe1=:ZVKMe,VKWert1=:ZVkWert,
                                    Erloes1=:ZErloes,MPunkte1=:ZMPunkte
                     where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                           AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                           Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                           Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                           Monteur3  = :ZMonteur3;
               end
               else if (INr = 2) then begin
                  update Statis set EKMe2=:ZEKMe,EKWert2=:ZEKWert,EKWertKB2 =:ZEKWertKB,
                                    VKMe2=:ZVKMe,VKWert2=:ZVkWert,
                                    Erloes2=:ZErloes,MPunkte2=:ZMPunkte
                     where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                           AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                           Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                           Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                           Monteur3  = :ZMonteur3;
               end
               else if (INr = 3) then begin
                  update Statis set EKMe3=:ZEKMe,EKWert3=:ZEKWert,EKWertKB3 =:ZEKWertKB,
                                    VKMe3=:ZVKMe,VKWert3=:ZVkWert,
                                    Erloes3=:ZErloes,MPunkte3=:ZMPunkte
                     where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                           AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                           Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                           Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                           Monteur3  = :ZMonteur3;
               end
               else if (INr = 4) then begin
                  update Statis set EKMe4=:ZEKMe,EKWert4=:ZEKWert,EKWertKB4 =:ZEKWertKB,
                                    VKMe4=:ZVKMe,VKWert4=:ZVkWert,
                                    Erloes4=:ZErloes,MPunkte4=:ZMPunkte
                     where ArtikelNr = :ZArtikelnr and Filiale   = :ZFiliale and
                           AdressNr = :ZAdressNr   and Vertretnr = :ZVertretnr and
                           Personalnr = :ZPersonal and Liefernr  = :ZLiefernr  and
                           Monteur1  = :ZMonteur1  and Monteur2  = :ZMonteur2  and
                           Monteur3  = :ZMonteur3;
               end
            end
         end
      end
      /* "AM"- Datensatz aktualisieren */
      ZArtikelnr = "";
      select Artikelnr from Statis
      where  Artikelnr= "AM" || IntToStr(:INr) and Filiale=0 and AdressNr=-1 and
             Vertretnr=-1
      into   :ZArtikelnr;

      if ((ZArtikelnr is not null) and (ZArtikelnr = "AM" || IntToStr(:INr))) then begin
         if ((IVonDatum is not null) and (IBisDatum is not null)) then
            update Statis set Zeitraum = "NOW", Personalnr = :IKzDatum
            where  Artikelnr= "AM" || IntToStr(:INr) and Filiale=0 and AdressNr=-1 and
                   Vertretnr=-1;
         else
            update Statis set Zeitraum = null, Personalnr = :IKzDatum
            where  Artikelnr= "AM" || IntToStr(:INr) and Filiale=0 and AdressNr=-1 and
                   Vertretnr=-1;
      end
      else begin
         if ((IVonDatum is not null) and (IBisDatum is not null)) then
            insert into Statis (Artikelnr,Filiale,AdressNr,Vertretnr,Personalnr,Liefernr,
                                Monteur1,Monteur2,Monteur3,Zeitraum)
                        Values ("AM" || IntToStr(:INr),0,-1,-1,:IKzDatum,-1,"","","","NOW");
         else
            insert into Statis (Artikelnr,Filiale,AdressNr,Vertretnr,Personalnr,Liefernr,
                                Monteur1,Monteur2,Monteur3,Zeitraum)
                        Values ("AM" || IntToStr(:INr),0,-1,-1,:IKzDatum,-1,"","","",null);
      end
      /* Daten wurden neu berechnet */
      Ok = 1;
   end
   suspend;
end
--

create procedure GDI_Nummer
   (TabName VarChar(40), Ind2 VarChar(40), Ind3 VarChar(40), F3 VarChar(50), Anz Integer)
returns
   (NrVon Integer, NrBis Integer, NrAkt Integer,
    PriField VarChar(50), PriIndex VarChar(50))
as
   declare variable FStep  Integer;
/* - Nummernkreis ermitteln
   - Nummernkreis vorhanden:
   - Vom Nummernkreis ausgehend die nchste freie Nummer ermitteln
   - Freie Nummer verfgbar: --> Neuanlage, Nummer zurckgeben
   - Keine freie Nummer verfgbar: --> -1 zurckgeben
   - Nummernkreis nicht vorhanden: --> -2 zurckgeben
*/
begin
   select first 1 cast(StrToInt(w1) as Integer) , cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer) , cast(StrToInt(w4) as Integer), f2, f3 from GDIDEF
   where  Satzart = "TI" and Ind1 = UpperCase(:TabName) and Ind2 = :Ind2 and Ind3 = :Ind3
   into   :NrVon, :NrBis, :NrAkt, :FStep, :PriField, :PriIndex;
   if (FStep < 1) then
      FStep = 1;
   if ((NrAkt is null) or (NrBis < 1) or (NrVon = NrBis)) then begin
      NrAkt = -2;
   end else begin
      if (NrAkt >= NrBis) then begin
         NrAkt = -1;
      end else if (Anz > 0) then begin
         if (F3 = "") then
            F3 = PriIndex;
         if (NrAkt < NrVon) then
            NrAkt = NrVon;
         else
            NrAkt = NrAkt + FStep * Anz;
         update GDIDEF
            set W3 = cast(:NrAkt as VarChar(16)), W4 = cast(:FStep as VarChar(16)), F3 = :F3
            where Satzart = "TI" and IND1 = UpperCase(:TabName) and IND2 = :Ind2 and IND3 = :Ind3;
      end
   end
   suspend;
end
--

create procedure GDI_SERIENINSERT
   (BelegTyp Char(1), BelegArt VarChar(5), BelegNr Integer, PosArt VarChar(5), PosNr Integer,
    Adressnr Integer, Artikelnr VarChar(30), Filiale Smallint, DatumPr Date, LagerEP Double Precision,
    KZSerie Char(1), SuchName VarChar(40), Text1 Varchar(255), Text2 Varchar(255),
    Text3 Varchar(255), Text4 Varchar(255), KundenNr Integer, LieferNr Integer,
    VK Double Precision, KDVon Date, KDGar SmallInt, KDBis Date,
    EK Double Precision, LFVon Date, LFGar SmallInt, LFBis Date,
    Bediener VarChar(5), Anzahl Integer, Modus Integer,
    Prefix VarChar(20), AbNummer VarChar(20), Suffix VarChar(20))
returns
   (AktNr Integer, Angelegt Integer, SerNrVon Integer, SerNrBis Integer,
    AnlageDatVon Date, AnlageDatBis Date)
as
   declare variable FVon   Integer;
   declare variable FBis   Integer;
   declare variable FAnz   Integer;
   declare variable FStep  Integer;
   declare variable FAbNr  Integer;
   declare variable FSerNr VarChar(100);
   declare variable FText1 VarChar(40);
   declare variable FText2 VarChar(40);
   declare variable FText3 VarChar(40);
   declare variable FText4 VarChar(40);
begin
   AnlageDatVon = "Now";
   select first 1 cast(StrToInt(w1) as Integer) , cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer) , cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "TI" and Ind1 = "SERIEN"
   into   :FVon, :FBis, :AktNr, :FStep;
   if (Anzahl < 1) then
      Anzahl = 1;
   if (FStep < 1) then
      FStep = 1;
   Angelegt = 0;
   SerNrVon = 0;
   SerNrBis = 0;
   if ((AktNr is null) or (FBis < 1) or (FVon = FBis)) then begin
      AktNr = -2;
   end else begin
      if ((AktNr < FVon) or (AktNr > FBis)) then
         AktNr = FVon;
      while ((Anzahl > 0) and (AktNr < FBis)) do begin
         FAnz = 1;
         while ((FAnz > 0) and (AktNr < FBis)) do begin
            AktNr = AktNr + FStep;
            select count(*) from Serien
            where SerienNr = IntToStr(:AktNr)
            into :FAnz;
         end
         if ((FAnz = 0) and (AktNr <= FBis)) then begin
            if (SerNrVon < 1) then
               SerNrVon = Aktnr;
            if (Modus = 1) then begin
               FSerNr = StrToInt(AktNr);
            end else if (Modus = 2) then begin
               FAbNr  = StrToInt(AbNummer) + Angelegt;
               FSerNr = IntToStr(FAbNr);
               while (StrLen(FSerNr) < StrLen(AbNummer)) do
                  FSerNr = "0" || FSerNr;
               FSerNr = Prefix || FSerNr || Suffix;
            end else if (Modus = 3) then begin
               FSerNr = "";
               /* Option "HerstSerNr individuell eingeben"
                  Hier knnten eigene Routinen implementiert werden
                  Muster wie GDI-Basic */
               /*
               FSerNr = IntToStr(AktNr);
               while (StrLen(FSerNr) < 7) do
                  FSerNr = "0" || FSerNr;
               FSerNr = "GDI-" || FSerNr;
               Text2  = "automatisch erstellte Seriennr.";
               */
            end

            FText1 = cast(Copy(:Text1,1,40) as VarChar(40));
            FText2 = cast(Copy(:Text2,1,40) as VarChar(40));
            FText3 = cast(Copy(:Text3,1,40) as VarChar(40));
            FText4 = cast(Copy(:Text4,1,40) as VarChar(40));
            insert into Serien
                      ( SerienNr, Suchname, KzFrei, KZEKFrei, Text1, Text2,
                        Text3, Text4, Kundennr, Liefernr, Artikelnr, VK, KDBis,
                        KDGar, KDVon, EK, LFBis, LFGar, LFVon,
                        HerstSerNr, AendBed, AendDatum)
               Values (:AktNr,   :Suchname, "1",    "1",     :FText1,:FText2,
                       :FText3,:FText4,:Kundennr,:Liefernr,:Artikelnr,:VK,:KDBis,
                       :KDGar,:KDVon,:EK,:LFBis,:LFGar,:LFVon,
                       :FSerNr, :Bediener, "Now");
            insert into SerPos
                      ( Belegtyp, Belegart, Belegnr, PosArt, Posnr, SerienNr, DatumPr,
                        Adressnr, Artikelnr, Filiale, LagerEP, KZSerie, Info,AendBed, AendDatum)
               Values (:Belegtyp,:Belegart,:Belegnr,:PosArt, :Posnr,:AktNr, :DatumPr,
                       :Adressnr,:Artikelnr,:Filiale,:LagerEP,:KZSerie, "", :Bediener,"Now");
            Angelegt = Angelegt + 1;
         end
         Anzahl = Anzahl - 1;
      end
      update GDIDEF
         set W3 = cast(:AktNr as VarChar(16))
         where Satzart = "TI" and IND1 = "SERIEN";
      SerNrBis = AktNr;
      if (AktNr > FBis) then
         AktNr = -1;
      else
         AktNr = Angelegt;
   end
   AnlageDatBis = "Now";
   suspend;
end
--

create procedure GDI_CHARGENINSERT
   (BelegTyp Char(1), BelegArt VarChar(5), BelegNr Integer, PosNr Integer, PosArt VarChar(5),
    Adressnr Integer, LieferAdr Integer, Artikelnr VarChar(30), Filiale Integer, DatumMe Date,
    KZCharge Char(1), SuchName VarChar(40), KzSperre Char(1), Text1 VarChar(255), Text2 VarChar(255),
    Text3 VarChar(255), Text4 VarChar(255), LieferNr Integer, HerstChargenNr VarChar(20),
    MHD Date, VerwDatum Date, HerstDatum Date,
    Bediener VarChar(5), Anzahl Double Precision, Modus Integer,
    Prefix VarChar(20), AbNummer VarChar(20), Suffix VarChar(20))
returns
   (AktNr Integer, Angelegt Double Precision,
    ChargenNrVon Integer, ChargenNrBis Integer,
    AnlageDatVon Date, AnlageDatBis Date)
as
   declare variable FVon   Integer;
   declare variable FBis   Integer;
   declare variable FAnz   Integer;
   declare variable FStep  Integer;
   declare variable FAbNr  Integer;
   declare variable FChargenNr VarChar(100);
   declare variable FText1 VarChar(40);
   declare variable FText2 VarChar(40);
   declare variable FText3 VarChar(40);
   declare variable FText4 VarChar(40);
   declare variable FArt   Char(2);

begin
   if ((not (BelegTyp || BelegArt in ("EBE","ELI","ERE","EGU","EMA","EFU","ERL","ECK",
                                   "VAU","VLI","VRE","VGU","VMA","VFU","VRL","VCK"))) and
       (not (BelegTyp || PosArt in ("LZ","LA")))) then
      exit;

   AnlageDatVon = "Now";
   select first 1 cast(StrToInt(w1) as Integer) , cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer) , cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "TI" and Ind1 = "CHARGEN"
   into   :FVon, :FBis, :AktNr, :FStep;
   if (FStep < 1) then
      FStep = 1;
   Angelegt = 0;
   ChargenNrVon = 0;
   ChargenNrBis = 0;
   if ((AktNr is null) or (FBis < 1) or (FVon = FBis)) then begin
      AktNr = -2;
   end else begin
      if ((AktNr < FVon) or (AktNr > FBis)) then
         AktNr = FVon;

      while ((Anzahl > 0) and (AktNr < FBis)) do begin
         FAnz = 1;
         while ((FAnz > 0) and (AktNr < FBis)) do begin
            AktNr = AktNr + FStep;
            select count(*) from Chargen
            where ChargenNr = :AktNr
            into :FAnz;
         end
         if ((FAnz = 0) and (AktNr <= FBis)) then begin
            if (ChargenNrVon < 1) then
               ChargenNrVon = Aktnr;
            if (Modus = 1) then begin
               FChargenNr = IntToStr(AktNr);
            end else if (Modus = 2) then begin
               FAbNr  = StrToInt(AbNummer) + Angelegt;
               FChargenNr = IntToStr(FAbNr);
               while (StrLen(FChargenNr) < StrLen(AbNummer)) do
                  FChargenNr = "0" || FChargenNr;
               FChargenNr = Prefix || FChargenNr || Suffix;
            end else if (Modus = 3) then begin
               FChargenNr = "";
               /* Option "HerstChargenNr individuell eingeben"
                  Hier knnten eigene Routinen implementiert werden
                  Muster wie GDI-Basic */
               /*
               FChargenNr = IntToStr(AktNr);
               while (StrLen(FChargenNr) < 7) do
                  FChargenNr = "0" || FChargenNr;
               FChargenNr = "GDI-" || FChargenNr;
               Text2  = "automatisch erstellte Chargennr.";
               */
            end
            else if (Modus = 4) then begin
               FChargenNr = HerstChargenNr;
            end

            FText1 = cast(Copy(:Text1,1,40) as VarChar(40));
            FText2 = cast(Copy(:Text2,1,40) as VarChar(40));
            FText3 = cast(Copy(:Text3,1,40) as VarChar(40));
            FText4 = cast(Copy(:Text4,1,40) as VarChar(40));

            if (BelegTyp = "V") then begin
               if      (BelegArt = "AU") then FArt = "R";
               else if (BelegArt = "GU") then FArt = "Z";
               else if (BelegArt = "RL") then FArt = "Z";
               else if (BelegArt = "CK") then FArt = "KV";
               else FArt = "A";
            end
            else if (BelegTyp = "E") then begin
               if      (BelegArt = "BE") then FArt = "B";
               else if (BelegArt = "GU") then FArt = "A";
               else if (BelegArt = "RL") then FArt = "A";
               else if (BelegArt = "CK") then FArt = "KE";
               else                       FArt = "Z";
            end
            else if (BelegTyp = "L") then begin
               if      (PosArt = "Z") then FArt = "Z";
               else if (PosArt = "A") then FArt = "A";
               else FArt = "??";
            end
            else FArt = "?";

            if ((KzSperre is null) or (KzSperre <> "1")) then
               KzSperre = "";

            insert into Chargen
                      ( ChargenNr, Suchname, KzSperre, Text1, Text2,
                        Text3, Text4, HerstChargenNr, Liefernr, Artikelnr,
                        Urmenge, MHD, VerwDatum, HerstDatum, AendBed, AendDatum, CreateBed, CreateDatum)
               Values (:AktNr,   :Suchname, :KzSperre, :FText1,:FText2,
                       :FText3,:FText4,:FChargenNr, :Liefernr,:Artikelnr,
                       :Anzahl, :MHD, :VerwDatum, :HerstDatum, :Bediener, "Now", :Bediener, "Now");
            insert into ChargePos
                      ( Belegtyp, Belegart, Belegnr, Posnr, Artikelnr, Filiale, ChargenNr,
                        Menge, UrMenge, DatumMe, Art, Adressnr, LieferAdr, AendBed, AendDatum, CreateBed, CreateDatum)
               Values (:Belegtyp,:Belegart,:Belegnr,:Posnr,:Artikelnr, :Filiale, :AktNr,
                       :Anzahl, :Anzahl, :DatumMe, :FArt, :Adressnr, :LieferAdr, :Bediener, "Now", :Bediener, "Now");
            Angelegt = Angelegt + Anzahl;
         end
         Anzahl = 0;
      end
      update GDIDEF
         set W3 = cast(:AktNr as VarChar(16))
         where Satzart = "TI" and IND1 = "CHARGEN";
      ChargenNrBis = AktNr;
      if (AktNr > FBis) then
         AktNr = -1;
      else
         AktNr = cast(Runden(Angelegt,0) as integer);
   end
   AnlageDatBis = "Now";
   suspend;
end
--

create procedure GDI_CHARGENBESTAND
   (IChargenNr Integer, IFiliale Integer)
returns
   (Chargennr  Integer,
    Filiale    Integer,
    Bestand    Double Precision,
    VBestand   Double Precision,
    Zugang     Double Precision,
    Abgang     Double Precision,
    Bestellt   Double Precision,
    Reserviert Double Precision,
    VKorrektur Double Precision,
    EKorrektur Double Precision)
as
   declare variable FFiliale Integer;
   declare variable FMenge Double Precision;
   declare variable FChargeArt Char(2);
begin
   Filiale    = -1;
   Bestand    = 0;
   VBestand   = 0;
   Zugang     = 0;
   Abgang     = 0;
   Bestellt   = 0;
   Reserviert = 0;
   VKorrektur = 0;
   EKorrektur = 0;
   ChargenNr  = IChargenNr;
   for select filiale, menge, art from Chargepos
   where chargennr = :IChargennr and ((Filiale = :IFiliale) or (:IFiliale = -1))
   order by filiale
   into :FFiliale, :FMenge, :FChargeArt do begin
      if (Filiale <> FFiliale) then begin
         if (Filiale <> -1) then
            suspend;
         Filiale = FFiliale;
         Bestand    = 0;
         VBestand   = 0;
         Zugang     = 0;
         Abgang     = 0;
         Bestellt   = 0;
         Reserviert = 0;
         VKorrektur = 0;
         EKorrektur = 0;
      end
      if (FChargeArt = "Z") then
         Zugang = Zugang + FMenge;
      else if (FChargeArt = "A") then
         Abgang = Abgang + FMenge;
      else if (FChargeArt = "B") then
         Bestellt = Bestellt + FMenge;
      else if (FChargeArt = "R") then
         Reserviert = Reserviert + FMenge;
      else if (FChargeArt = "KV") then
         VKorrektur = VKorrektur + FMenge;
      else if (FChargeArt = "KE") then
         EKorrektur = EKorrektur + FMenge;
      Bestand  = Zugang - Abgang - VKorrektur + EKorrektur;
      VBestand = Bestand - Reserviert + Bestellt;
   end
   Bestand    = Runden(Bestand,    8);
   VBestand   = Runden(VBestand,   8);
   Zugang     = Runden(Zugang,     8);
   Abgang     = Runden(Abgang,     8);
   Bestellt   = Runden(Bestellt,   8);
   Reserviert = Runden(Reserviert, 8);
   VKorrektur = Runden(VKorrektur, 8);
   EKorrektur = Runden(EKorrektur, 8);
   if (Filiale <> -1) then
      suspend;
end
--

create procedure GDI_BELEGINSERT
   (Typ Char(1), Art VarChar(5), IFiliale Integer, Bediener VarChar(5), Neu Integer)
returns
   (Nr Integer, SatzUUID VarChar(36))
as
   declare variable FVon   Integer;
   declare variable FBis   Integer;
   declare variable FAkt   Integer;
   declare variable FAnz   Integer;
   declare variable FStep  Integer;
   declare variable FName  VarChar(100);
   declare variable FCRM   Char(1);
   declare variable FAbgerBis Date;
/* - Nummernkreis ermitteln
   - Nummernkreis vorhanden:
      - bergabe einer Nummer von auen:
         - Datensatz mit dieser Nummer vorhanden: --> Nummer zurckgeben
         - Datensatz mit dieser Nummer nicht vorhanden:
            - Nummer innerhalb des Nummernkreises: --> Neuanlage, Nummer zurckgeben
            - Nummer nicht innerhalb des Nummernkreises: --> -1 zurckgeben
      - Keine Nummer von auen bergeben:
         - Vom Nummernkreis ausgehend die nchste freie Nummer ermitteln
         - Freie Nummer verfgbar: --> Neuanlage, Nummer zurckgeben
         - Keine freie Nummer verfgbar: --> -1 zurckgeben
   - Nummernkreis nicht vorhanden: --> -2 zurckgeben
*/
begin
   SatzUUID = UUIDStr();
   select first 1 B5 from GDIDEF where Satzart = "FA1" into :FCRM;
   select first 1 StrToInt(w1),StrToInt(w2),StrToInt(w3),StrToInt(w4) from GDIDEF
   where  Satzart = "TI" and Ind1 = "BELEG" and Ind2 = :Typ and Ind3 = :Art
   into   :FVon, :FBis, :FAkt, :FStep;
   Nr = FAkt;
   if (FStep < 1) then
      FStep = 1;
   if ((Nr is null) or (FBis < 1) or (FVon = FBis)) then begin
      Nr = -2;
   end else begin
      if (Neu <> 0) then begin
         select count(*) from Beleg
         where BelegTyp = :Typ and BelegArt = :Art and BelegNr = :Neu
         into :FAnz;
         if (FAnz > 0) then begin
            Nr = Neu;
         end else begin
            if ((Neu >= FVon) and (Neu <= FBis)) then begin
               if (FCRM = "1") then begin
                  select Copy(BedienerName,1,40) from UserTable
                  where Programm = "BLINE" and BedienerNr = :Bediener into :Fname;
               end else begin
                  select Copy(Name1,1,40) from Personal
                  where PersonalNr = :Bediener into :Fname;
               end
               FAbgerBis = "01.01.1970";
               select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
               into :FAbgerBis;
               if ("Now" < FAbgerBis + 1) then begin
                  FAbgerBis = FAbgerBis + 1;
               end else begin
                  FAbgerBis = "Now";
               end
               insert into Beleg (SatzUUID,BelegTyp,BelegArt,BelegNr,Belegdat,AdressNr,Suchname,
                                  Projektnr,Filiale,Personal,Persname,CreateDatum,CreateBed)
                          Values (:SatzUUID, :Typ, :Art, :Neu, :FAbgerBis, 0, "",
                                  "", :IFiliale, :Bediener, :Fname, "Now", :Bediener);
               Nr = Neu;
            end else begin
               Nr = -1;
            end
         end
      end else begin
         if ((Nr < FVon) or (Nr > FBis)) then begin
            Nr = FVon;
         end
         FAnz = 1;
         while ((FAnz > 0) and (Nr < FBis)) do begin
            Nr = Nr + FStep;
            select count(*) from Beleg
            where BelegTyp = :Typ and BelegArt = :Art and BelegNr = :Nr
            into :FAnz;
         end
         if ((FAnz = 0) and (Nr <= FBis)) then begin
            if (FCRM = "1") then begin
               select Copy(BedienerName,1,40) from UserTable
               where Programm = "BLINE" and BedienerNr = :Bediener into :Fname;
            end else begin
               select Copy(Name1,1,40) from Personal
               where PersonalNr = :Bediener into :Fname;
            end
            FAbgerBis = "01.01.1970";
            select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
            into :FAbgerBis;
            if ("Now" < FAbgerBis + 1) then begin
               FAbgerBis = FAbgerBis + 1;
            end else begin
               FAbgerBis = "Now";
            end
            insert into Beleg (SatzUUID,BelegTyp,BelegArt,BelegNr,Belegdat,AdressNr,Suchname,
                               Projektnr,Filiale,Personal,Persname,CreateDatum,CreateBed)
                       Values (:SatzUUID, :Typ, :Art, :Nr, :FAbgerBis, 0, "",
                               "", :IFiliale, :Bediener, :Fname, "Now", :Bediener);
            update GDIDEF set W3 = IntToStr(:Nr)
            where Satzart = "TI" and IND1 = "BELEG" and IND2 = :Typ and IND3 = :Art;
         end else
            Nr = -1;
      end
   end
   if (Nr < 0) then
      SatzUUID = "";
   suspend;
end
--

create procedure GDI_SETINVENTUR
   (IDatum Date,IBediener VarChar(5),ILoealt SmallInt,
    IVonArtikelNr VarChar(30), IBisArtikelNr VarChar(30))
returns
   (InvLoe Integer, InvNeu Integer, InvErr Integer)
as
   declare variable FVonGJahr  Date;
   declare variable FBisGJahr  Date;
   declare variable FAbgerBis  Date;
   declare variable FInvDatum  Date;
   declare variable FGJahr     Integer;
   declare variable RFiliale   Integer;
   declare variable FW0        Integer;
   declare variable FB1        VarChar(10);
   declare variable FFIBeweg   VarChar(5000);
   declare variable FArtikelnr VarChar(30);
   declare variable FFiliale   Integer;
   declare variable FDatum     Date;
   declare variable FMenge     Double Precision;
   declare variable FEPreis    Double Precision;
   declare variable FGesamt    Double Precision;
   declare variable FMaxPosNr  Integer;
   declare variable FLager     VarChar(10);
   declare variable FWgr       VarChar(6);
   declare variable FText      VarChar(255);
   declare variable FFNr       Char(1);
   declare variable FMeFaktor  Double Precision;
   declare variable FKzLager   Char(1);
   declare variable FHerstell  VarChar(30);
   declare variable FProfil    VarChar(30);
   declare variable FNKStatis  Integer;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;
   INVLOE = 0;
   INVNEU = 0;
   INVERR = 0;
   select first 1 StrToDateTime(W1), StrToDateTime(W2), StrToDateTime(W3), k2 from GDIDEF
   where  Satzart = "FA2"
   into   :FVonGJahr, :FBisGJahr, :FAbgerBis, :RFiliale;
   FGJahr = GetYear(FBisGJahr - 364);
   FFIBeweg = ",";
   for select w0,b1 from Gdidef
       where satzart = "FI"
       into  :FW0, :FB1
   do begin
      if (FB1 = "1") then begin
         FFIBeweg = FFIBeweg || IntToStr(FW0) || ",";
      end
   end
   if (ILoeAlt = 1) then begin
      select count(*) Anzahl from BelegPos
      where  BelegTyp = "L" and
             PosArt = "I" and
             DatumMe >= :FVonGJahr and
             Artikelnr >= :IVonArtikelNr and ArtikelNr <= :IBisArtikelNr and
             PosL("," || IntToStr(Filiale) || ",", :FFIBeweg) > 0
      into   :InvLoe;
      delete from BelegPos
      where  BelegTyp = "L" and
             PosArt = "I" and
             DatumMe >= :FVonGJahr and
             Artikelnr >= :IVonArtikelNr and ArtikelNr <= :IBisArtikelNr and
             PosL("," || IntToStr(Filiale) || ",", :FFIBeweg) > 0;

      update ARUmsatz
      set    Bestand = Runden(Bestand + InvMngAnf, 8), InvDatum = null,
             InvMenge = 0.0, InvMngAnf = 0.0, InvWert = 0.0
      where  StrToInt(Jahr) = :FGJahr and
             Artikelnr >= :IVonArtikelNr and ArtikelNr <= :IBisArtikelNr and
             PosL("," || IntToStr(Filiale) || ",", :FFIBeweg) > 0;
   end
   select Max(Posnr) MaxPosNr from BelegPos
   where  BelegTyp = "L" and BelegArt = :IBediener
   into   :FMaxPosNr;
   if (FMaxPosNr is null) then
      FMaxPosNr = 0;

   for select   artikelnr,filiale,datum,lager,wgr,text,
                menge,epreis,gesamt,mefaktor,herstell,profil
       from     Inventur
       where    Artikelnr >= :IVonArtikelNr and ArtikelNr <= :IBisArtikelNr
       order by Artikelnr
       into     :FArtikelnr,:FFiliale,:FDatum,:FLager,:FWgr,:FText,
                :FMenge,:FEPreis,:FGesamt,:FMeFaktor,:FHerstell,:FProfil
   do begin
      if (not (FArtikelnr is null) and (FArtikelnr <> "")) then begin
         if (FFiliale is null) then
            FFiliale = RFiliale;
         if (not (IDatum is null) and (IDatum > "01.01.1970")) then
            FDatum = IDatum;
         FInvDatum = FVonGJahr - 1;
         select InvDatum from ARUmsatz
         where Artikelnr = :FArtikelnr and Jahr = :FGJahr and Filiale = :FFiliale
         into  :FInvDatum;

         select KzLager from Artikel
         where Artikelnr = :FArtikelnr
         into  :FKzLager;
         if ((FKzLager is null) or (FKzLager <> "1")) then
            FKzLager = "0";

         if ((FKzLager = "1")                                             and
            ((GetDate(FDatum) > GetDate(FInvDatum)) or
             ((ILoeAlt = 2) and (GetDate(FDatum) = GetDate(FInvDatum)))) and
            (GetDate(FDatum) >= GetDate(FAbgerBis + 1))                  and
            (GetDate(FDatum) <= GetDate(FBisGJahr)))                     then begin

            if ((ILoeAlt = 2) and
               (GetDate(FDatum) = GetDate(FInvDatum))) then begin
               delete from BelegPos
               where  BelegTyp = "L"          and
                      PosArt = "I"            and
                      Artikelnr = :FArtikelNr and
                      Filiale   = :FFiliale   and
                      GetDate(DatumMe) = GetDate(:FDatum);
               InvLoe = InvLoe + 1;
            end

            InvNeu = InvNeu + 1;
            FMaxPosNr = FMaxPosNr + 1;
            FEPreis = Runden(FEPreis, FNKStatis);
            FGesamt = Runden(FGesamt, FNKStatis);
            insert into BelegPos
                   (BelegTyp,   PosArt,    BelegArt,  Artikelnr,  Filiale,
                    DatumMe,    DatumPr,   Bediener,  Menge,      EPreis,
                    LagerMe,    Gesamt,    LagerPr,   KzDruck,    PosNr,
                    KzLager,    Lagerort,  Wgr,       Text,       MeFaktor,
                    Herstell,   Profil)
            values ("L",        "I",       :IBediener,:FArtikelnr,:FFiliale,
                    :FDatum,    :FDatum,   :IBediener,:FMenge,    :FEPreis,
                    :FMenge,    :FGesamt,  :FGesamt,  "",         :FMaxPosNr,
                    "1",        :FLager,   :FWgr,     :FText,     :FMeFaktor,
                    :FHerstell, :FProfil);
            update Inventur set KZFehler = "0", FehlerTxt = ""
            where  Artikelnr = :FArtikelnr and Filiale = :FFiliale;
         end
         else if (FKzLager = "0") then begin
            InvErr = InvErr + 1;
            FFNr = "4";
            FText = "Kein Lagerartikel";
            update Inventur set KZFehler = :FFNr, FehlerTxt = :FText
            where  Artikelnr = :FArtikelnr and Filiale = :FFiliale;
         end
         else begin
            InvErr = InvErr + 1;
            if (GetDate(FDatum) < GetDate(FAbgerBis + 1)) then begin
               FFNr  = "1";
               FText = "InvDatum < Abger. Zeitraum";
            end else if (GetDate(FDatum) > GetDate(FBisGJahr)) then begin
               FFNr  = "2";
               FText = "InvDatum > Geschftsjahr";
            end else begin
               FFNr  = "3";
               FText = "InvDatum <= Letzte Inventur";
            end
            update Inventur set KZFehler = :FFNr, FehlerTxt = :FText
            where  Artikelnr = :FArtikelnr and Filiale = :FFiliale;
         end
      end else begin
         InvErr = InvErr + 1;
         FFNr = "9";
         FText = "ungltige Artikelnr";
         update Inventur set KZFehler = :FFNr, FehlerTxt = :FText
         where  Artikelnr = :FArtikelnr and Filiale = :FFiliale;
      end
   end
   suspend;
end
--

create procedure GDI_INVENTUR
   (IArtikelnr VarChar(50),IFiliale Integer, IJahr Char(4),IMonat SmallInt,
    IDatum Date, IMenge Double Precision, IWert Double Precision,
    IPreis Double Precision, IMeFaktor Double Precision)
returns
   (ErrMsg Integer)
as
   declare variable FArtikelnr VarChar(50);
   declare variable FEKMe1 Double Precision;
   declare variable FEKMe2 Double Precision;
   declare variable FEKMe3 Double Precision;
   declare variable FEKMe4 Double Precision;
   declare variable FEKMe5 Double Precision;
   declare variable FEKMe6 Double Precision;
   declare variable FEKMe7 Double Precision;
   declare variable FEKMe8 Double Precision;
   declare variable FEKMe9 Double Precision;
   declare variable FEKMe10 Double Precision;
   declare variable FEKMe11 Double Precision;
   declare variable FEKMe12 Double Precision;
   declare variable FEKMe13 Double Precision;
   declare variable FVKMe1 Double Precision;
   declare variable FVKMe2 Double Precision;
   declare variable FVKMe3 Double Precision;
   declare variable FVKMe4 Double Precision;
   declare variable FVKMe5 Double Precision;
   declare variable FVKMe6 Double Precision;
   declare variable FVKMe7 Double Precision;
   declare variable FVKMe8 Double Precision;
   declare variable FVKMe9 Double Precision;
   declare variable FVKMe10 Double Precision;
   declare variable FVKMe11 Double Precision;
   declare variable FVKMe12 Double Precision;
   declare variable FVKMe13 Double Precision;
   declare variable FAuftMenge Double Precision;
   declare variable FBestMenge Double Precision;
   declare variable FBestand   Double Precision;
   declare variable FEKSumme   Double Precision;
   declare variable FEKSuAlt   Double Precision;
   declare variable FDMengeAlt Double Precision;
   declare variable FDWertAlt  Double Precision;
   declare variable FDMenge    Double Precision;
   declare variable FDWert     Double Precision;
   declare variable FInvMenge  Double Precision;
   declare variable FInvWert   Double Precision;
   declare variable FInvMngAnf Double Precision;
   declare variable FInvEPreis Double Precision;
   declare variable FInvDatum  Date;
   declare variable VonDatum   Date;
   declare variable BisDatum   Date;
   declare variable FArt       VarChar(10);
   declare variable FBelegTyp  Char(1);
   declare variable FBelegArt  VarChar(10);
   declare variable FPosArt    VarChar(10);
   declare variable FKZDruck   VarChar(10);
   declare variable FLagerMe   Double Precision;
   declare variable FLagerPr   Double Precision;
   declare variable FEKGes     Double Precision;
   declare variable FMenge     Double Precision;
   declare variable FAnzahl    SmallInt;
   declare variable FMEK       Double Precision;
   declare variable FAbgerBis  Date;
   declare variable FNKStatis  Integer;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;
   if (gen_id(Buchen_disabled, 0) = 1) then
      exit;
   select Artikelnr , Bestand,
          BestMenge, AuftMenge,
          EKMe1,EKMe2,EKMe3,EKMe4,EKMe5,EKMe6,EKMe7,EKMe8,EKMe9,EKMe10,
          EKMe11,EKMe12,EKMe13,
          VKMe1,VKMe2,VKMe3,VKMe4,VKMe5,VKMe6,VKMe7,VKMe8,VKMe9,VKMe10,
          VKMe11,VKMe12,VKMe13,
          EKSumme,EKSuAlt,DMengeAlt,DWertAlt,InvMenge,InvWert,InvMngAnf,
          InvEPreis,InvDatum, MEK
          from ARUmsatz
   where Artikelnr = :IArtikelnr and Jahr = :IJahr and Filiale = :IFiliale
   into  :FArtikelnr , :FBestand,
         :FBestMenge, :FAuftMenge,
         :FEKMe1,:FEKMe2,:FEKMe3,:FEKMe4,:FEKMe5,:FEKMe6,:FEKMe7,:FEKMe8,
         :FEKMe9,:FEKMe10,:FEKMe11,:FEKMe12,:FEKMe13,
         :FVKMe1,:FVKMe2,:FVKMe3,:FVKMe4,:FVKMe5,:FVKMe6,:FVKMe7,:FVKMe8,
         :FVKMe9,:FVKMe10,:FVKMe11,:FVKMe12,:FVKMe13,
         :FEKSumme,:FEKSuAlt,:FDMengeAlt,:FDWertAlt,
         :FInvMenge,:FInvWert,:FInvMngAnf,:FInvEPreis,:FInvDatum, :FMEK;
   if (:FArtikelnr is null) then begin
      FEKMe1 = 0; FEKMe2 = 0; FEKMe3 = 0; FEKMe4 = 0;
      FEKMe5 = 0; FEKMe6 = 0; FEKMe7 = 0; FEKMe8 = 0;
      FEKMe9 = 0; FEKMe10= 0; FEKMe11= 0; FEKMe12= 0;
      FEKMe13= 0;
      FVKMe1 = 0; FVKMe2 = 0; FVKMe3 = 0; FVKMe4 = 0;
      FVKMe5 = 0; FVKMe6 = 0; FVKMe7 = 0; FVKMe8 = 0;
      FVKMe9 = 0; FVKMe10= 0; FVKMe11= 0; FVKMe12= 0;
      FVKMe13= 0;
      FAuftMenge = 0; FBestMenge = 0; FBestand  = 0; FEKSumme   = 0;
      FEKSuAlt   = 0; FDMengeAlt = 0; FDWertAlt = 0; FInvMenge  = 0;
      FInvWert   = 0; FInvEPreis = 0; FInvMngAnf = 0; FMek = 0;
   end

   /* berprfen des Inventurdatums: */
   if (GetDate(IDatum) = GetDate(FInvdatum)) then begin
      select count(*) anz from BelegPos
      where Belegtyp = "L"          and
            Posart = "I"            and
            Artikelnr = :IArtikelnr and
            Filiale = :IFiliale     and
            GetDate(datumme) = GetDate(:FInvDatum)
      into FAnzahl;
      if (FAnzahl > 1) then begin
         exception GDI_INVENTUR_DATUM;
      end
   end
   if (GetDate(IDatum) < GetDate(FInvdatum)) then begin
      /* "Inventurdatum mu nach der letzten Inventur liegen!" */
      exception GDI_INVENTUR_DATUM;
   end

   FAbgerBis = "01.01.1970";
   select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
   into :FAbgerBis;
   if (GetDate(IDatum) < FAbgerBis + 1) then begin
      /* "Inventurdatum liegt im abgerechneten Zeitraum!" */
      exception GDI_INVENTUR_ABGERECHNET;
   end

   FMenge = 0;
   if (extract(Day from IDatum) <>  1) then begin
      BisDatum = GetDate(IDatum);
      VonDatum = cast("01." ||
                 cast(extract(Month from BisDatum) as Char(2)) || "." ||
                 cast(extract(Year from BisDatum) as Char(4)) as Date);
      for select BelegTyp, BelegArt, PosArt, KZDruck, Lagerme from BelegPos
         where Datumme >= :VonDatum and Datumme < :BisDatum and
               Artikelnr = :IArtikelnr and Filiale = :IFiliale and
               ((not (KZDruck in ("%","A","C","t","T","P","S","E","W"))) or (KzDruck is null))
         into :FBelegTyp, :FBelegArt, :FPosArt, :FKZDruck, :FLagerMe
      do begin
         if (FBelegTyp = "L") then
            FArt = FPosArt;
         else
            FArt = FBelegArt;
         if (FBelegTyp = "V") then begin
            if (FArt in ("RE","MA","LI","FU")) then begin
               FMenge = FMenge + FLagerMe;
            end else if (FArt in ("GU","RL")) then begin
               FMenge = FMenge - FLagerMe;
            end
         end else if (FBelegTyp = "E") then begin
            if (FArt in ("RE","MA","LI","FU")) then begin
               FMenge = FMenge - FLagerMe;
            end else if (FArt in ("GU","RL")) then begin
               FMenge = FMenge + FLagerMe;
            end
         end else if (FBelegTyp = "L") then begin
            if (FArt in ("Z","K")) then begin
               FMenge = FMenge - FLagerMe;
            end else if (FArt in ("A")) then begin
               FMenge = FMenge + FLagerMe;
            end
         end
      end
   end
   if (IMonat >  1) then FMenge = FMenge - FEKMe1 + FVKMe1;
   if (IMonat >  2) then FMenge = FMenge - FEKMe2 + FVKMe2;
   if (IMonat >  3) then FMenge = FMenge - FEKMe3 + FVKMe3;
   if (IMonat >  4) then FMenge = FMenge - FEKMe4 + FVKMe4;
   if (IMonat >  5) then FMenge = FMenge - FEKMe5 + FVKMe5;
   if (IMonat >  6) then FMenge = FMenge - FEKMe6 + FVKMe6;
   if (IMonat >  7) then FMenge = FMenge - FEKMe7 + FVKMe7;
   if (IMonat >  8) then FMenge = FMenge - FEKMe8 + FVKMe8;
   if (IMonat >  9) then FMenge = FMenge - FEKMe9 + FVKMe9;
   if (IMonat > 10) then FMenge = FMenge - FEKMe10 + FVKMe10;
   if (IMonat > 11) then FMenge = FMenge - FEKMe11 + FVKMe11;
   FInvMenge  = IMenge;
   FInvWert   = Runden(IWert, FNKStatis);
   FInvMngAnf = IMenge + FMenge;
   FInvDatum  = IDatum;
   FBestand   = Runden(FEKMe1 + FEKMe2 + FEKMe3 + FEKMe4 + FEKMe5 + FEKMe6 + FEKMe7 +
                FEKMe8 + FEKMe9 + FEKMe10 + FEKMe11 + FEKMe12 + FEKMe13 -
                FVKMe1 - FVKMe2 - FVKMe3 - FVKMe4 - FVKMe5 - FVKMe6 - FVKMe7 -
                FVKMe8 - FVKMe9 - FVKMe10- FVKMe11 - FVKMe12 - FVKMe13 + FInvMngAnf, 8);
   FDMengeAlt = IMenge;
   FDWertAlt  = IWert;

   if ((IPreis = 0) and (IMenge = 0) and (IWert = 0)) then begin
      FDMengeAlt = 0.0;
      FDWertAlt  = 0.0;
      FInvEPreis = 0.0;
   end
   else if ((IPreis <> 0) and (IMenge = 0) and (IWert = 0)) then begin
      if ((IMeFaktor is null) or (Abs(IMeFaktor) < 0.0000001)) then begin
         FDMengeAlt = 1.0;
         FInvEPreis = IPreis;
      end
      else begin
         FDMengeAlt = 1.0 * IMeFaktor;
         FInvEPreis = IPreis / IMeFaktor;
      end
      FDWertAlt  = IPreis;
   end
   else if ((IPreis = 0) and (IMenge <> 0) and (IWert = 0)) then begin
      FDMengeAlt = 0.0;
      FDWertAlt  = 0.0;
      FInvEPreis = 0.0;
   end
   else begin
      if (IMenge <> 0) then
         FInvEPreis = Runden(IWert / IMenge, FNKStatis);
      else
         FInvEPreis = 0;
   end

   FDMenge  = 0;
   FDWert   = 0;
   FEkSumme = IWert;
   FEKSuAlt = 0;
   VonDatum = GetDate(IDatum);
   BisDatum = "31.12.2999";
   for select BelegTyp, BelegArt, PosArt, KZDruck, LagerPr, LagerMe, EKGesamt from Belegpos
      where Datumme >= :VonDatum and Datumme <= :BisDatum and
            Artikelnr = :IArtikelnr and Filiale = :IFiliale and
            ((not (KZDruck in ("%","A","C","t","T","P","S","E","W"))) or (KzDruck is null))
      into :FBelegTyp, :FBelegArt, :FPosArt, :FKZDruck, :FLagerPr, :FLagerMe, :FEKGes
   do begin
      if (FBelegTyp = "L") then
         FArt = FPosArt;
      else
         FArt = FBelegArt;
      if (FBelegTyp = "V") then begin
         if (FArt in ("RE","MA","LI","FU")) then begin
            FEkSumme = FEkSumme - FEKGes;
         end else if (FArt in ("GU","RL")) then begin
            FEkSumme = FEkSumme + FEKGes;
         end
      end else if (FBelegTyp = "E") then begin
         if (FArt in ("RE","MA","LI","FU")) then begin
            FEkSumme = FEkSumme + FLagerPr;
            if (FArt in ("RE","MA","FU")) then begin
               FDMenge  = FDMenge  + FLagerMe;
               FDWert   = FDWert   + FLagerPr;
            end
         end else if (FArt in ("GU","RL")) then begin
            FEkSumme = FEkSumme - FLagerPr;
         end
      end else if (FBelegTyp = "L") then begin
         if (FArt in ("Z")) then begin
            FEkSumme = FEkSumme + FLagerPr;
            FDMenge  = FDMenge  + FLagerMe;
            FDWert   = FDWert   + FLagerPr;
         end else if (FArt in ("K")) then begin
            FEkSumme = FEkSumme + FEKGes;
            FDMenge  = FDMenge  + FLagerMe;
            FDWert   = FDWert   + FEKGes;
         end else if (FArt in ("A")) then begin
            FEkSumme = FEkSumme - FEKGes;
         end
      end
   end
   if (FInvEPreis <> 0) then
      FMEK = FInvEPreis;
   if (:FArtikelnr is null) then begin
      insert into ARUmsatz
         (Artikelnr, Jahr, Filiale, Bestand,
          EKSumme,EKSuAlt,DMenge,DWert,DMengeAlt,DWertAlt,InvMenge,
          InvWert,InvMngAnf,InvEPreis,InvDatum, MEK)
      values (:IArtikelnr ,:IJahr, :IFiliale,:FBestand,
         :FEKSumme,:FEKSuAlt,:FDMenge,:FDWert,:FDMengeAlt,:FDWertAlt,:FInvMenge,
         :FInvWert,:FInvMngAnf,:FInvEPreis,:FInvDatum, :FMEK);
   end else begin
      update ARUmsatz set
         Bestand   = :FBestand,   EKSumme   = :FEKSumme,   EKSuAlt   = :FEKSuAlt,
         DMenge    = :FDMenge,    DWert     = :FDWert,     DMengeAlt = :FDMengeAlt,
         DWertAlt  = :FDWertAlt,  InvMenge  = :FInvMenge,  InvWert   = :FInvWert,
         InvMngAnf = :FInvMngAnf, InvEPreis = :FInvEPreis, InvDatum  = :FInvDatum,
         MEK       = :FMEK
      where Artikelnr = :IArtikelnr and Jahr = :IJahr and Filiale = :IFiliale;
   end
end
--

create procedure GDI_BELEGSUMME
   (TYP CHAR(1),
    ART VarChar(5),
    BELEGNR INTEGER,
    NK INTEGER)
RETURNS
   (STWERT0 DOUBLE PRECISION,
    STSATZ1 DOUBLE PRECISION,
    STSATZ2 DOUBLE PRECISION,
    STSATZ3 DOUBLE PRECISION,
    STSATZ4 DOUBLE PRECISION,
    STWERT1 DOUBLE PRECISION,
    STWERT2 DOUBLE PRECISION,
    STWERT3 DOUBLE PRECISION,
    STWERT4 DOUBLE PRECISION,
    START1 CHAR(1),
    START2 CHAR(1),
    START3 CHAR(1),
    START4 CHAR(1),
    BRUTTO DOUBLE PRECISION,
    SKONTOBRUTTO DOUBLE PRECISION,
    NETTO DOUBLE PRECISION,
    WARENWERT DOUBLE PRECISION,
    NKWARENW DOUBLE PRECISION,
    EKPREIS DOUBLE PRECISION,
    OPBETRAG DOUBLE PRECISION,
    GEWICHT DOUBLE PRECISION)
AS
   declare variable FKZDruck char(1);
   declare variable FKZSkonto char(1);
   declare variable FLagerMe double precision;
   declare variable FGewicht double precision;
   declare variable FLagerPr double precision;
   declare variable FGesamt double precision;
   declare variable FEkGesamt double precision;
   declare variable FKZErloes char(1);
   declare variable FKZNK char(1);
   declare variable FKZNetto char(1);
   declare variable FSteuersatz double precision;
   declare variable ZErloes double precision;
   declare variable FZahlung double precision;
   declare variable FSkonto double precision;
   declare variable FScheckBtr double precision;
   declare variable FPosSkontoBrutto double precision;
   declare variable FDiff double precision;
   declare variable FNetto_HW double precision;
   declare variable FISOWaehr VarChar(3);
   declare variable FHausWaehr VarChar(3);
   declare variable FWaehrFakt double precision;
   declare variable FNKStatis integer;
begin
   Stwert0   = 0;   Stsatz1   = 0;   Stsatz2   = 0;   Stsatz3   = 0; Stsatz4   = 0;
   Stwert1   = 0;   Stwert2   = 0;   Stwert3   = 0;   Stwert4   = 0; Start1    = "0";
   Start2    = "0"; Start3    = "0"; Start4    = "0"; Brutto    = 0; Netto     = 0;
   Warenwert = 0;   Nkwarenw  = 0;   Ekpreis   = 0;   Opbetrag  = 0; Gewicht   = 0;
   SkontoBrutto = 0;
   for select KzDruck, KzSkonto, LagerMe, Gewicht, LagerPr, Gesamt, EKGesamt,
           KzErloes, KZNK, KzNetto, Steuersatz from BelegPos
      where BelegTyp = :Typ and BelegArt = :Art and BelegNr = :BelegNr and
            Artikelnr <> "" and
            ((not (KZDruck in ("P","E","S","T","t","C","A"))) or (KzDruck is null))
      into :FKzDruck, :FKzSkonto, :FLagerMe, :FGewicht, :FLagerPr, :FGesamt, :FEKGesamt,
           :FKzErloes, :FKZNK, :FKzNetto, :FSteuersatz
   do begin
      Gewicht = Gewicht + FGewicht * FLagerMe;
      if (FKZDruck = "M") then begin
         FLagerpr  = 0;
         FGesamt   = 0;
         FEkGesamt = 0;
      end
      ZErloes = 0;
      if (FKZErloes <> "2") then begin
         if (FKZErloes = "1") then begin
            if (FEKGesamt <> 0) then
               ZErloes = FLagerPr - FEKGesamt;
         end else
            ZErloes = FLagerPr - FEKGesamt;
      end
      EKPreis = EKPreis + ZErloes;
      if (FKZNk <> "1") then
         Warenwert = Warenwert + FLagerpr;
      else
         NKWarenw = NKWarenw + FLagerpr;

      if (FKZNetto = "K") then
         FSteuersatz = 0;
      if (FSteuersatz = 0) then begin
         STWert0 = STWert0 +  FGesamt;
      end else if ((StSatz1 = 0) or
         ((StSatz1 = FSteuersatz) and (STArt1 = FKzNetto))) then begin
         StSatz1 = FSteuersatz;
         STArt1  = FKZNetto;
         STWert1 = STWert1 + FGesamt;
      end else if ((StSatz2 = 0) or
         ((StSatz2 = FSteuersatz) and (STArt2 = FKzNetto))) then begin
         StSatz2 = FSteuersatz;
         STArt2  = FKZNetto;
         STWert2 = STWert2 + FGesamt;
      end else if ((StSatz3 = 0) or
         ((StSatz3 = FSteuersatz) and (STArt3 = FKzNetto))) then begin
         StSatz3 = FSteuersatz;
         STArt3  = FKZNetto;
         STWert3 = STWert3 + FGesamt;
      end else if ((StSatz4 = 0) or
         ((StSatz4 = FSteuersatz) and (STArt4 = FKzNetto))) then begin
         StSatz4 = FSteuersatz;
         STArt4  = FKZNetto;
         STWert4 = STWert4 + FGesamt;
      end
      if (FKzSkonto = "1") then begin
         FPosSkontoBrutto = FGesamt;
         if ((FSteuersatz <> 0) and (FKZNetto = "N")) then begin
            FPosSkontoBrutto = FPosSkontoBrutto + (FPosSkontoBrutto * FSteuersatz / 100);
         end
         SkontoBrutto = SkontoBrutto + FPosSkontoBrutto;
      end
   end
   Brutto = StWert0;
   Netto  = StWert0;
   if (STWert1 <> 0) then begin
      if (STArt1 = "B") then begin
         Brutto = Brutto + STWert1;
         Netto  = Netto + runden(StWert1 / (1 + (StSatz1 / 100)),NK);
      end else begin
         Netto  = Netto + StWert1;
         Brutto = Brutto + StWert1 + runden((StWert1 * StSatz1) / 100,NK);
      end
   end
   if (STWert2 <> 0) then begin
      if (STArt2 = "B") then begin
         Brutto = Brutto + STWert2;
         Netto  = Netto  + runden(StWert2 / (1 + (StSatz2 / 100)),NK);
      end else begin
         Netto  = Netto + StWert2;
         Brutto = Brutto + StWert2 + runden((StWert2 * StSatz2) / 100,NK);
      end
   end
   if (STWert3 <> 0) then begin
      if (STArt3 = "B") then begin
         Brutto = Brutto + STWert3;
         Netto  = Netto + runden (StWert3 / (1 + (StSatz3 / 100)),NK);
      end else begin
         Netto  = Netto + StWert3;
         Brutto = Brutto + StWert3 + runden((StWert3 * StSatz3) / 100,NK);
      end
   end
   if (STWert4 <> 0) then begin
      if (STArt4 = "B") then begin
         Brutto = Brutto + STWert4;
         Netto  = Netto  + runden (StWert4 / (1 + (StSatz4 / 100)),NK);
      end else begin
         Netto  = Netto + StWert4;
         Brutto = Brutto + StWert4 + runden ((StWert4 * StSatz4) / 100,NK);
      end
   end
   Brutto = Runden(Brutto, NK);
   Netto  = Runden(Netto, NK);
   SkontoBrutto = Runden(SkontoBrutto, NK);
   select Zahlung, ScheckBtr, Skonto, IsoWaehr, Waehrfakt from Beleg
      where BelegTyp = :Typ and BelegArt = :Art and BelegNr = :BelegNr
      into :FZahlung, :FScheckBtr, :FSkonto, :FISOWaehr, :FWaehrFakt;
   OPBetrag = Runden(Brutto - FZahlung - FScheckBtr - FSkonto, NK);
   if ((Abs(Brutto - SkontoBrutto) < 0.03) and (Abs(Brutto) >= 0.03)) then
      SkontoBrutto = Brutto;
      
   /* Ausgleich Ausgleich Warenwert + NKWarenW = Netto auf den greren der beiden Werte */
   select first 1 copy(w5,1,3) from Gdidef where satzart = "FA2" into :FHausWaehr;
   FNetto_HW = Netto;
   if (FISOWaehr <> FHausWaehr) then
      select awert
      from GDI_Waehrumrechnen(:FNetto_HW,:FWaehrFakt,-1,:FIsoWaehr,:FHausWaehr,:FHausWaehr)
      into :FNetto_HW;
   FDiff = WarenWert + NKWarenW - FNetto_HW;
   if ((FDiff <> 0) and (Abs(FDiff) < 0.03)) then begin
      FNKStatis = null;
      select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :FNKStatis;
      if ((FNKStatis is null) or (FNKStatis = 0)) then
         FNKStatis = 2;
      if (WarenWert >= NKWarenW) then
         WarenWert = Runden(WarenWert - FDiff, FNKStatis);
      else
         NKWarenW  = Runden(NKWarenW  - FDiff, FNKStatis);
   end
   suspend;
end
--

create procedure GDI_ADUMSATZ
   (IAdressNr Integer, Monat SmallInt, IJahr Char(4), IFiliale Integer,
    Typ Char(1), Art VarChar(5), Erloes Double Precision,Umsatz Double Precision,
    Nk Double Precision)
returns
   (Errmsg Integer)
as
   declare variable FAdressNr  Integer;
   declare variable FNK1 Double Precision;
   declare variable FNK2 Double Precision;
   declare variable FNK3 Double Precision;
   declare variable FNK4 Double Precision;
   declare variable FNK5 Double Precision;
   declare variable FNK6 Double Precision;
   declare variable FNK7 Double Precision;
   declare variable FNK8 Double Precision;
   declare variable FNK9 Double Precision;
   declare variable FNK10 Double Precision;
   declare variable FNK11 Double Precision;
   declare variable FNK12 Double Precision;
   declare variable FNK13 Double Precision;
   declare variable FUmsatz1 Double Precision;
   declare variable FUmsatz2 Double Precision;
   declare variable FUmsatz3 Double Precision;
   declare variable FUmsatz4 Double Precision;
   declare variable FUmsatz5 Double Precision;
   declare variable FUmsatz6 Double Precision;
   declare variable FUmsatz7 Double Precision;
   declare variable FUmsatz8 Double Precision;
   declare variable FUmsatz9 Double Precision;
   declare variable FUmsatz10 Double Precision;
   declare variable FUmsatz11 Double Precision;
   declare variable FUmsatz12 Double Precision;
   declare variable FUmsatz13 Double Precision;
   declare variable FErloes1 Double Precision;
   declare variable FErloes2 Double Precision;
   declare variable FErloes3 Double Precision;
   declare variable FErloes4 Double Precision;
   declare variable FErloes5 Double Precision;
   declare variable FErloes6 Double Precision;
   declare variable FErloes7 Double Precision;
   declare variable FErloes8 Double Precision;
   declare variable FErloes9 Double Precision;
   declare variable FErloes10 Double Precision;
   declare variable FErloes11 Double Precision;
   declare variable FErloes12 Double Precision;
   declare variable FErloes13 Double Precision;
   declare variable FAufBest  Double Precision;
   declare variable FLiefsch  Double Precision;
   declare variable FMatBuchen Char(1);
begin
   if (gen_id(Buchen_disabled, 0) = 1) then
      exit;
   select first 1 Copy(ListValue(M1,"MATERIALBUCHUNG"),1,1) from GDIDEF
   where Satzart = "FA1" into :FMatBuchen;
   if (FMatBuchen is null) then
      FMatBuchen = " ";
   else
      FMatBuchen = cast(FMatBuchen as Char(1));
   if ((Art = "MA") and (FMatBuchen = "N")) then
      exit;
   select AdressNr , AufBest, Liefsch,
        NK1,NK2,NK3,NK4,NK5,NK6,NK7,NK8,NK9,NK10,NK11,NK12,NK13,
        Umsatz1,Umsatz2,Umsatz3,Umsatz4,Umsatz5,Umsatz6,Umsatz7 ,Umsatz8 ,
        Umsatz9,Umsatz10,Umsatz11,Umsatz12,Umsatz13 ,
        Erloes1,Erloes2,Erloes3,Erloes4,Erloes5,Erloes6,Erloes7,Erloes8,
        Erloes9,Erloes10,Erloes11,Erloes12,Erloes13
        from ADUmsatz
   where AdressNr = :IAdressNr and Jahr = :IJahr and Filiale = :IFiliale
   into :FAdressNr, :FAufBest, :FLiefsch,
        :FNK1,:FNK2,:FNK3,:FNK4,:FNK5,:FNK6,:FNK7,:FNK8,
        :FNK9,:FNK10,:FNK11,:FNK12,:FNK13,
        :FUmsatz1,:FUmsatz2,:FUmsatz3,:FUmsatz4,:FUmsatz5,:FUmsatz6,
        :FUmsatz7,:FUmsatz8 ,:FUmsatz9,:FUmsatz10,:FUmsatz11,:FUmsatz12,
        :FUmsatz13,
        :FErloes1,:FErloes2,:FErloes3,:FErloes4,:FErloes5,:FErloes6,
        :FErloes7,:FErloes8,:FErloes9,:FErloes10,:FErloes11,:FErloes12,
        :FErloes13;
   if (:FAdressNr is null) then begin
      FNK1 = 0;     FNK2 = 0;     FNK3 = 0;     FNK4 = 0;
      FNK5 = 0;     FNK6 = 0;     FNK7 = 0;     FNK8 = 0;
      FNK9 = 0;     FNK10= 0;     FNK11= 0;     FNK12= 0;
      FNK13= 0;
      FUmsatz1 = 0; FUmsatz2 = 0; FUmsatz3 = 0; FUmsatz4 = 0;
      FUmsatz5 = 0; FUmsatz6 = 0; FUmsatz7 = 0; FUmsatz8 = 0;
      FUmsatz9 = 0; FUmsatz10= 0; FUmsatz11= 0; FUmsatz12= 0;
      FUmsatz13= 0;
      FErloes1 = 0; FErloes2 = 0; FErloes3 = 0; FErloes4 = 0;
      FErloes5 = 0; FErloes6 = 0; FErloes7 = 0; FErloes8 = 0;
      FErloes9 = 0; FErloes10= 0; FErloes11= 0; FErloes12= 0;
      FErloes13= 0;
      FAufBest = 0; FLiefsch = 0;
   end

   /* EG15032001: Erls im Einkauf und Lagerzugang NICHT fortschreiben! */
   if ( (:Typ = "E") or (:Art = "Z")) then begin
      Erloes = 0;
   end

   if ((:Typ in ("E","L","V")) and (:Art in ("RE","GU","MA","Z","A"))) then begin
      if (Monat = 1) then begin
         FErloes1 = FErloes1 + Erloes;   FUmsatz1 =  FUmsatz1  + Umsatz + NK; FNK1  = FNK1  + NK;
      end else if (Monat = 2) then begin
         FErloes2 = FErloes2 + Erloes;   FUmsatz2 =  FUmsatz2  + Umsatz + NK; FNK2  = FNK2  + NK;
      end else if (Monat = 3) then begin
         FErloes3 = FErloes3 + Erloes;   FUmsatz3 =  FUmsatz3  + Umsatz + NK; FNK3  = FNK3  + NK;
      end else if (Monat = 4) then begin
         FErloes4 = FErloes4 + Erloes;   FUmsatz4 =  FUmsatz4  + Umsatz + NK; FNK4  = FNK4  + NK;
      end else if (Monat = 5) then begin
         FErloes5 = FErloes5 + Erloes;   FUmsatz5 =  FUmsatz5  + Umsatz + NK; FNK5  = FNK5  + NK;
      end else if (Monat = 6) then begin
         FErloes6 = FErloes6 + Erloes;   FUmsatz6 =  FUmsatz6  + Umsatz + NK; FNK6  = FNK6  + NK;
      end else if (Monat = 7) then begin
         FErloes7 = FErloes7 + Erloes;   FUmsatz7 =  FUmsatz7  + Umsatz + NK; FNK7  = FNK7  + NK;
      end else if (Monat = 8) then begin
         FErloes8 = FErloes8 + Erloes;   FUmsatz8 =  FUmsatz8  + Umsatz + NK; FNK8  = FNK8  + NK;
      end else if (Monat = 9) then begin
         FErloes9 = FErloes9 + Erloes;   FUmsatz9 =  FUmsatz9  + Umsatz + NK; FNK9  = FNK9  + NK;
      end else if (Monat = 10) then begin
         FErloes10 = FErloes10 + Erloes; FUmsatz10 = FUmsatz10 + Umsatz + NK; FNK10 = FNK10 + NK;
      end else if (Monat = 11) then begin
         FErloes11 = FErloes11 + Erloes; FUmsatz11 = FUmsatz11 + Umsatz + NK; FNK11 = FNK11 + NK;
      end else if (Monat = 12) then begin
         FErloes12 = FErloes12 + Erloes; FUmsatz12 = FUmsatz12 + Umsatz + NK; FNK12 = FNK12 + NK;
      end else if (Monat = 13) then begin
         FErloes13 = FErloes13 + Erloes; FUmsatz13 = FUmsatz13 + Umsatz + NK; FNK13 = FNK13 + NK;
      end
   end
   if (Art = "LI") then begin
      FLiefsch = FLiefsch + NK + Umsatz;
   end else if (Art = "RL") then begin
      FLiefsch = FLiefsch - NK - Umsatz;
   end else if (Art in ("AU","BE")) then begin
     FAufBest = FAufBest + NK + Umsatz;
   end

   if (:FAdressNr is null) then begin
      insert into ADUmsatz
        (AdressNr , Jahr, Filiale, AufBest, Liefsch,
         NK1,NK2,NK3,NK4,NK5,NK6,NK7,NK8,NK9,NK10,NK11,NK12,NK13,
         Umsatz1,Umsatz2,Umsatz3,Umsatz4,Umsatz5,Umsatz6,Umsatz7 ,Umsatz8 ,
         Umsatz9,Umsatz10,Umsatz11,Umsatz12,Umsatz13 ,
         Erloes1,Erloes2,Erloes3,Erloes4,Erloes5,Erloes6,Erloes7,Erloes8,
         Erloes9,Erloes10,Erloes11,Erloes12,Erloes13)
      values
        (:IAdressNr , :IJahr, :IFiliale, :FAufBest, :FLiefsch,
         :FNK1,:FNK2,:FNK3,:FNK4,:FNK5,:FNK6,:FNK7,:FNK8,:FNK9,:FNK10,
         :FNK11,:FNK12,:FNK13,
         :FUmsatz1,:FUmsatz2,:FUmsatz3,:FUmsatz4,:FUmsatz5,:FUmsatz6,
         :FUmsatz7 ,:FUmsatz8 ,:FUmsatz9,:FUmsatz10,:FUmsatz11,:FUmsatz12,
         :FUmsatz13 ,
         :FErloes1,:FErloes2,:FErloes3,:FErloes4,:FErloes5,:FErloes6,
         :FErloes7,:FErloes8,:FErloes9,:FErloes10,:FErloes11,:FErloes12,
         :FErloes13);
   end else begin
      update ADUmsatz set
         NK1 = :FNK1, NK2 = :FNK2, NK3 = :FNK3, NK4  = :FNK4, NK5  = :FNK5, NK6  = :FNK6,
         NK7 = :FNK7, NK8 = :FNK8, NK9 = :FNK9, NK10 = :FNK10,NK11 = :FNK11,NK12 = :FNK12,
         NK13 = :FNK13,
         Umsatz1 = :FUmsatz1, Umsatz2 = :FUmsatz2, Umsatz3 = :FUmsatz3,
         Umsatz4 = :FUmsatz4, Umsatz5 = :FUmsatz5, Umsatz6 = :FUmsatz6,
         Umsatz7 = :FUmsatz7, Umsatz8 = :FUmsatz8, Umsatz9 = :FUmsatz9,
         Umsatz10 = :FUmsatz10,Umsatz11 = :FUmsatz11,Umsatz12 = :FUmsatz12,
         Umsatz13 = :FUmsatz13,
         Erloes1 = :FErloes1, Erloes2 = :FErloes2, Erloes3 = :FErloes3,
         Erloes4 = :FErloes4, Erloes5 = :FErloes5, Erloes6 = :FErloes6,
         Erloes7 = :FErloes7, Erloes8 = :FErloes8, Erloes9 = :FErloes9,
         Erloes10 = :FErloes10,Erloes11 = :FErloes11,Erloes12 = :FErloes12,
         Erloes13 = :FErloes13,
         AufBest  = :FAufBest, Liefsch = :FLiefsch
      where AdressNr = :IAdressNr and Jahr = :IJahr and Filiale = :IFiliale;
   end
end
--

create procedure GDI_ARUMSATZ
   (IArtikelnr VarChar(50), IAdressNr Integer, Monat1 SmallInt, Monat2 SmallInt,
    IJahr VarChar(4), IFiliale Integer, DatumMe TimeStamp, Typ Char(1),
    Art VarChar(5), KzDruck Char(1), Menge Double Precision, Wert Double Precision,
    EKWert Double Precision, PreisPfl Char(1), MeFaktor Double Precision,
    KZEKWert VarChar(3))
returns
   (Errmsg Integer)
as
   declare variable FArtikelnr VarChar(50);
   declare variable FEKMe1 Double Precision;
   declare variable FEKMe2 Double Precision;
   declare variable FEKMe3 Double Precision;
   declare variable FEKMe4 Double Precision;
   declare variable FEKMe5 Double Precision;
   declare variable FEKMe6 Double Precision;
   declare variable FEKMe7 Double Precision;
   declare variable FEKMe8 Double Precision;
   declare variable FEKMe9 Double Precision;
   declare variable FEKMe10 Double Precision;
   declare variable FEKMe11 Double Precision;
   declare variable FEKMe12 Double Precision;
   declare variable FEKMe13 Double Precision;
   declare variable FVKMe1 Double Precision;
   declare variable FVKMe2 Double Precision;
   declare variable FVKMe3 Double Precision;
   declare variable FVKMe4 Double Precision;
   declare variable FVKMe5 Double Precision;
   declare variable FVKMe6 Double Precision;
   declare variable FVKMe7 Double Precision;
   declare variable FVKMe8 Double Precision;
   declare variable FVKMe9 Double Precision;
   declare variable FVKMe10 Double Precision;
   declare variable FVKMe11 Double Precision;
   declare variable FVKMe12 Double Precision;
   declare variable FVKMe13 Double Precision;
   declare variable FEKWert1 Double Precision;
   declare variable FEKWert2 Double Precision;
   declare variable FEKWert3 Double Precision;
   declare variable FEKWert4 Double Precision;
   declare variable FEKWert5 Double Precision;
   declare variable FEKWert6 Double Precision;
   declare variable FEKWert7 Double Precision;
   declare variable FEKWert8 Double Precision;
   declare variable FEKWert9 Double Precision;
   declare variable FEKWert10 Double Precision;
   declare variable FEKWert11 Double Precision;
   declare variable FEKWert12 Double Precision;
   declare variable FEKWert13 Double Precision;
   declare variable FVKWert1 Double Precision;
   declare variable FVKWert2 Double Precision;
   declare variable FVKWert3 Double Precision;
   declare variable FVKWert4 Double Precision;
   declare variable FVKWert5 Double Precision;
   declare variable FVKWert6 Double Precision;
   declare variable FVKWert7 Double Precision;
   declare variable FVKWert8 Double Precision;
   declare variable FVKWert9 Double Precision;
   declare variable FVKWert10 Double Precision;
   declare variable FVKWert11 Double Precision;
   declare variable FVKWert12 Double Precision;
   declare variable FVKWert13 Double Precision;
   declare variable FAuftWert  Double Precision;
   declare variable FBestWert  Double Precision;
   declare variable FAuftMenge Double Precision;
   declare variable FBestMenge Double Precision;
   declare variable FVKLFWert  Double Precision;
   declare variable FEKLFWert  Double Precision;
   declare variable FVKLFMenge Double Precision;
   declare variable FEKLFMenge Double Precision;
   declare variable FBestand   Double Precision;
   declare variable FEKSumme   Double Precision;
   declare variable FEKSuAlt   Double Precision;
   declare variable FMEK       Double Precision;
   declare variable FLPreis    Double Precision;
   declare variable FLMenge    Double Precision;
   declare variable FLRabatt   Double Precision;
   declare variable FDMengeAlt Double Precision;
   declare variable FDWertAlt  Double Precision;
   declare variable FDMenge    Double Precision;
   declare variable FDWert     Double Precision;
   declare variable FInvMenge  Double Precision;
   declare variable FInvWert   Double Precision;
   declare variable FInvMngAnf Double Precision;
   declare variable FKorrMenge Double Precision;
   declare variable FKorrMeAlt Double Precision;
   declare variable FInvDatum  Date;
   declare variable FLDatum    Date;
   declare variable FLiefNr    VarChar(10);
   declare variable FLEK       Double Precision;
   declare variable FMWert     Double Precision;
   declare variable FGEK       Double Precision;
   declare variable FEKWertM   Double Precision;
   declare variable FEKWertAbw Char(1);
   declare variable FInvFlag   Char(1);
   declare variable FEKMenge   Double Precision;
   declare variable FVKMenge   Double Precision;
   declare variable FEKWert    Double Precision;
   declare variable FVKWert    Double Precision;
   declare variable FKalkEk    Double Precision;
   declare variable FNKStatis  Integer;
begin
   if (gen_id(Buchen_disabled, 0) = 1) then
      exit;
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;
   select Artikelnr , Bestand,
          AuftMenge, AuftWert, BestMenge, BestWert,
          VKLFWert, EKLFWert, VKLFMenge, EKLFMenge,
          EKMe1,EKMe2,EKMe3,EKMe4,EKMe5,EKMe6,EKMe7,EKMe8,EKMe9,EKMe10,
          EKMe11,EKMe12,EKMe13,
          VKMe1,VKMe2,VKMe3,VKMe4,VKMe5,VKMe6,VKMe7,VKMe8,VKMe9,VKMe10,
          VKMe11,VKMe12,VKMe13,
          EKWert1,EKWert2,EKWert3,EKWert4,EKWert5,EKWert6,EKWert7 ,EKWert8,
          EKWert9,EKWert10,EKWert11,EKWert12,EKWert13 ,
          VKWert1,VKWert2,VKWert3,VKWert4,VKWert5,VKWert6,VKWert7,VKWert8,
          VKWert9,VKWert10,VKWert11,VKWert12,VKWert13,
          EKSumme,EKSuAlt,MEK,LPreis,LMenge,LRabatt,DMengeAlt,
          DWertAlt,DMenge,DWert,InvMenge,InvWert,InvMngAnf,KorrMenge,
          KorrMeAlt, InvDatum, LiefNr, LDatum
          from ARUmsatz

   where Artikelnr = :IArtikelnr and Jahr = :IJahr and Filiale = :IFiliale
   into  :FArtikelnr , :FBestand,
         :FAuftMenge, :FAuftWert, :FBestMenge, :FBestWert,
         :FVKLFWert, :FEKLFWert, :FVKLFMenge, :FEKLFMenge,
         :FEKMe1,:FEKMe2,:FEKMe3,:FEKMe4,:FEKMe5,:FEKMe6,:FEKMe7,:FEKMe8,
         :FEKMe9,:FEKMe10,:FEKMe11,:FEKMe12,:FEKMe13,
         :FVKMe1,:FVKMe2,:FVKMe3,:FVKMe4,:FVKMe5,:FVKMe6,:FVKMe7,:FVKMe8,
         :FVKMe9,:FVKMe10,:FVKMe11,:FVKMe12,:FVKMe13,
         :FEKWert1,:FEKWert2,:FEKWert3,:FEKWert4,:FEKWert5,:FEKWert6,
         :FEKWert7,:FEKWert8 ,:FEKWert9,:FEKWert10,:FEKWert11,:FEKWert12,:FEKWert13,
         :FVKWert1,:FVKWert2,:FVKWert3,:FVKWert4,:FVKWert5,:FVKWert6,
         :FVKWert7,:FVKWert8,:FVKWert9,:FVKWert10,:FVKWert11,:FVKWert12,:FVKWert13,
         :FEKSumme,:FEKSuAlt,:FMEK,:FLPreis,:FLMenge,:FLRabatt,:FDMengeAlt,
         :FDWertAlt,:FDMenge,:FDWert,:FInvMenge,:FInvWert,:FInvMngAnf,:FKorrMenge,
         :FKorrMeAlt, :FInvDatum, :FLiefNr, :FLDatum;
   if (:FArtikelnr is null) then begin
      FEKMe1 = 0; FEKMe2 = 0; FEKMe3 = 0; FEKMe4 = 0; FEKMe5 = 0; FEKMe6 = 0;
      FEKMe7 = 0; FEKMe8 = 0; FEKMe9 = 0; FEKMe10= 0; FEKMe11= 0; FEKMe12= 0;
      FEKMe13= 0;
      FVKMe1 = 0; FVKMe2 = 0; FVKMe3 = 0; FVKMe4 = 0; FVKMe5 = 0; FVKMe6 = 0;
      FVKMe7 = 0; FVKMe8 = 0; FVKMe9 = 0; FVKMe10= 0; FVKMe11= 0; FVKMe12= 0;
      FVKMe13= 0;
      FEKWert1 = 0; FEKWert2 = 0; FEKWert3 = 0; FEKWert4 = 0; FEKWert5 = 0; FEKWert6 = 0;
      FEKWert7 = 0; FEKWert8 = 0; FEKWert9 = 0; FEKWert10= 0; FEKWert11= 0; FEKWert12= 0;
      FEKWert13= 0;
      FVKWert1 = 0; FVKWert2 = 0; FVKWert3 = 0; FVKWert4 = 0; FVKWert5 = 0; FVKWert6 = 0;
      FVKWert7 = 0; FVKWert8 = 0; FVKWert9 = 0; FVKWert10= 0; FVKWert11= 0; FVKWert12= 0;
      FVKWert13= 0;
      FAuftWert  = 0;  FBestWert  = 0; FAuftMenge = 0; FBestMenge = 0;
      FVKLFWert  = 0;  FEKLFWert  = 0; FVKLFMenge = 0; FEKLFMenge = 0;
      FBestand   = 0;  FEKSumme   = 0; FEKSuAlt   = 0; FMEK       = 0;
      FLiefNr    = ""; FLPreis    = 0; FLMenge    = 0; FLRabatt   = 0;
      FDMengeAlt = 0;  FDWertAlt  = 0; FDMenge    = 0; FDWert     = 0;
      FInvMenge  = 0;  FInvWert   = 0; FInvMngAnf = 0; FKorrMenge = 0;
      FKorrMeAlt = 0;
   end

   FEKMenge  = 0;
   FVKMenge  = 0;
   FEKWert   = 0;
   FVKWert   = 0;
   FInvFlag = "0";
   if (not (:FInvDatum is null) and (:FInvDatum > Datumme) and
       (Monat1 > 0)) then
      FInvFlag = "1";

   if ((Typ in ("E","L")) and
      (Art in ("LI","RL","RE","GU","MA","FU","Z","K"))) then begin
      if (:FInvFlag = "1") then begin
         if (Art = "RL") then
            FInvMngAnf = FInvMngAnf + Menge;
         else
            FInvMngAnf = FInvMngAnf - Menge;
      end else if (Monat1 > 0) then begin
         if (Art = "RL") then
            FEKSumme = FEKSumme - EKWert;
         else
            FEKSumme = FEKSumme + EKWert;
      end
      if (Art = "K") then
         FKorrMenge = FKorrMenge + Menge;
      if (Art = "RL") then
         FEKMenge = -Menge;
      else
         FEkMenge = Menge;
   end else if ((Typ in ("V","L")) and
      (Art in ("LI","RL","RE","GU","MA","FU","A"))) then begin
      if (:FInvFlag = "1") then begin
         if (Art = "RL") then
            FInvMngAnf = FInvMngAnf - Menge;
         else
            FInvMngAnf = FInvMngAnf + Menge;
      end else if (Monat1 > 0) then begin
         if (Art = "RL") then
            FEKSumme = FEKSumme + EKWert;
         else
            FEKSumme = FEKSumme - EKWert;
      end
      if (Art = "FU") then
         FEkMenge = -Menge;
      else if (Art = "RL") then
         FVKMenge = -Menge;
      else
         FVkMenge = Menge;
   end

   if ((Typ in ("E","L")) and (Art in ("RE","GU","MA","FU","Z"))) then begin
      FEkWert  = Wert;
   end else if ((Typ in ("V","L")) and (Art in ("RE","GU","MA","FU","A"))) then begin
      if (Art = "FU") then
         FEkWert  = -Wert;
      else
         FVkWert  = Wert;
   end

   if ((Typ = "E") and (Art = "BE")) then begin
      FBestWert  = FBestWert  + Wert;
      FBestMenge = FBestMenge + Menge;
   end else if ((Typ = "V") and (Art = "AU")) then begin
      FAuftWert  = FAuftWert  + Wert;
      FAuftMenge = FAuftMenge + Menge;
   end else if ((Typ = "E") and (Art = "LI")) then begin
      FEKLFMenge = FEKLFMenge + Menge;
      FEKLFWert  = FEKLFWert  + Wert;
   end else if ((Typ = "V") and (Art = "LI")) then begin
      FVKLFMenge = FVKLFMenge + Menge;
      FVKLFWert  = FVKLFWert  + Wert;
   end else if ((Typ = "E") and (Art = "RL")) then begin
      FEKLFMenge = FEKLFMenge - Menge;
      FEKLFWert  = FEKLFWert  - Wert;
   end else if ((Typ = "V") and (Art = "RL")) then begin
      FVKLFMenge = FVKLFMenge - Menge;
      FVKLFWert  = FVKLFWert  - Wert;
   end

   if ((FEKMenge <> 0) or (FVKMenge <> 0)) then begin
      if (Monat1 = 1) then begin
         FEKMe1  = FEKMe1  + FEKMenge; FVKMe1  = FVKMe1  + FVKMenge;
      end else if (Monat1 = 2) then begin
         FEKMe2  = FEKMe2  + FEKMenge; FVKMe2  = FVKMe2  + FVKMenge;
      end else if (Monat1 = 3) then begin
         FEKMe3  = FEKMe3  + FEKMenge; FVKMe3  = FVKMe3  + FVKMenge;
      end else if (Monat1 = 4) then begin
         FEKMe4  = FEKMe4  + FEKMenge; FVKMe4  = FVKMe4  + FVKMenge;
      end else if (Monat1 = 5) then begin
         FEKMe5  = FEKMe5  + FEKMenge; FVKMe5  = FVKMe5  + FVKMenge;
      end else if (Monat1 = 6) then begin
         FEKMe6  = FEKMe6  + FEKMenge; FVKMe6  = FVKMe6  + FVKMenge;
      end else if (Monat1 = 7) then begin
         FEKMe7  = FEKMe7  + FEKMenge; FVKMe7  = FVKMe7  + FVKMenge;
      end else if (Monat1 = 8) then begin
         FEKMe8  = FEKMe8  + FEKMenge; FVKMe8  = FVKMe8  + FVKMenge;
      end else if (Monat1 = 9) then begin
         FEKMe9  = FEKMe9  + FEKMenge; FVKMe9  = FVKMe9  + FVKMenge;
      end else if (Monat1 = 10) then begin
         FEKMe10 = FEKMe10 + FEKMenge; FVKMe10 = FVKMe10 + FVKMenge;
      end else if (Monat1 = 11) then begin
         FEKMe11 = FEKMe11 + FEKMenge; FVKMe11 = FVKMe11 + FVKMenge;
      end else if (Monat1 = 12) then begin
         FEKMe12 = FEKMe12 + FEKMenge; FVKMe12 = FVKMe12 + FVKMenge;
      end else if (Monat1 = 13) then begin
         FEKMe13 = FEKMe13 + FEKMenge; FVKMe13 = FVKMe13 + FVKMenge;
      end
   end
   if ((FEKWert <> 0) or (FVKWert <> 0)) then begin
      if (Monat2 = 1) then begin
         FEKWert1   = FEKWert1 + FEKWert; FVKWert1   = FVKWert1 + FVKWert;
      end else if (Monat2 = 2) then begin
         FEKWert2  = FEKWert2  + FEKWert; FVKWert2  = FVKWert2  + FVKWert;
      end else if (Monat2 = 3) then begin
         FEKWert3  = FEKWert3  + FEKWert; FVKWert3  = FVKWert3  + FVKWert;
      end else if (Monat2 = 4) then begin
         FEKWert4  = FEKWert4  + FEKWert; FVKWert4  = FVKWert4  + FVKWert;
      end else if (Monat2 = 5) then begin
         FEKWert5  = FEKWert5  + FEKWert; FVKWert5  = FVKWert5  + FVKWert;
      end else if (Monat2 = 6) then begin
         FEKWert6  = FEKWert6  + FEKWert; FVKWert6  = FVKWert6  + FVKWert;
      end else if (Monat2 = 7) then begin
         FEKWert7  = FEKWert7  + FEKWert; FVKWert7  = FVKWert7  + FVKWert;
      end else if (Monat2 = 8) then begin
         FEKWert8  = FEKWert8  + FEKWert; FVKWert8  = FVKWert8  + FVKWert;
      end else if (Monat2 = 9) then begin
         FEKWert9  = FEKWert9  + FEKWert; FVKWert9  = FVKWert9  + FVKWert;
      end else if (Monat2 = 10) then begin
         FEKWert10 = FEKWert10 + FEKWert; FVKWert10 = FVKWert10 + FVKWert;
      end else if (Monat2 = 11) then begin
         FEKWert11 = FEKWert11 + FEKWert; FVKWert11 = FVKWert11 + FVKWert;
      end else if (Monat2 = 12) then begin
         FEKWert12 = FEKWert12 + FEKWert; FVKWert12 = FVKWert12 + FVKWert;
      end else if (Monat2 = 13) then begin
         FEKWert13 = FEKWert13 + FEKWert; FVKWert13 = FVKWert13 + FVKWert;
      end
   end

   FBestand = Runden(FEKMe1 + FEKMe2 + FEKMe3 + FEKMe4 + FEKMe5 + FEKMe6 + FEKMe7 +
              FEKMe8 + FEKMe9 + FEKMe10 + FEKMe11 + FEKMe12 + FEKMe13 -
              FVKMe1 - FVKMe2 - FVKMe3 - FVKMe4 - FVKMe5 - FVKMe6 - FVKMe7 -
              FVKMe8 - FVKMe9 - FVKMe10- FVKMe11 - FVKMe12 - FVKMe13 + FInvMngAnf, 8);

   if ((Menge <> 0) and (EKWert <> 0)) then
      FMEK = Runden(EkWert / Menge, FNKStatis);

   if ((Typ in ("E","L")) and (Art in ("RE","MA","FU","Z"))) then begin
      if ((not (KzDruck in ("M","W"))) or (KzDruck is null)) then begin
         FEKWertAbw = null;
         select first 1 UpperCase(Copy(ListValue(M1,"EKWERT.EINKAUF.ABWEICHEND"),1,1)) from GDIDEF
         where Satzart = "FA1" into :FEKWertAbw;
         if ((FEKWertAbw is null) or (FEKWertAbw = "")) then
            FEKWertAbw = "N";
         if ((FEKWertAbw = "J") and (Copy(KZEKWert || " ",1,1) <> " ")) then
            FEKWertM = EKWert;
         else
            FEKWertM = Wert;
         if ((:FInvFlag <> "1") and (Monat1 > 0)) then begin
            FDMenge = FDMenge + Menge;
            FDWert  = FDWert + FEKWertM;
         end
         if (Menge <> 0) then begin
            FLEK = FEKWertM / Menge;
         end else begin
            FLEK = FEKWertM;
         end
         if ((FLEK > 0) and (Menge > 0)) then begin
            FLPreis  = FLEK;
            FLMenge  = Menge;
            FLiefNr  = cast(IAdressNr as VarChar(10));
            FLDatum  = DatumMe;
         end
      end else begin
         FLEK = FLPreis;
      end
      if ((FDMenge + FDMengeAlt) <>  0) then begin
         FMWert = (FDWert + FDWertAlt) / (FDMenge + FDMengeAlt);
      end else begin
         FMWert = 0;
      end
      if (Abs(FBestand) < 0.00001) then begin
         FGEK = FMEK;
      end else begin
         FGEK = FEKSumme / FBestand;
      end

      /* KalkEK im Artikelstamm fortschreiben */
      if (PreisPfl in ("D","L","G")) then begin
         FKalkEk = 0;
         if (ABS(MeFaktor) < 0.0000001) then
            MEFaktor = 1.0;

         if (PreisPfl = "L") then begin
            if (FLEK > 0.0000001) then
               FKalkEk = FLEK * MeFaktor;
         end
         else if (PreisPfl = "D") then begin
            if (FMWert > 0.0000001) then
               FKalkEk = FMWert * MeFaktor;
         end
         else if (PreisPfl = "G") then begin
            if (FGEK > 0.0000001) then
               FKalkEk = FGEK * MeFaktor;
         end
         if (FKalkEk <> 0) then begin
            update artikel set kalkek = :FKalkEk where Artikelnr = :IArtikelnr;
         end
      end
   end

   FGEK = Runden(FGEK, FNKStatis);
   FLEK = Runden(FLEK, FNKStatis);
   FLPreis = Runden(FLPreis, 6);
   FKalkEK = Runden(FKalkEK, FNKStatis);

   if (:FArtikelnr is null) then begin
      insert into ARUmsatz
         (Artikelnr,Jahr,Filiale,Bestand,AuftMenge,AuftWert,BestMenge,
          BestWert,VKLFWert,EKLFWert,VKLFMenge,EKLFMenge,
          EKMe1,EKMe2,EKMe3,EKMe4,EKMe5,EKMe6,EKMe7,EKMe8,EKMe9,EKMe10,
          EKMe11,EKMe12,EKMe13,
          VKMe1,VKMe2,VKMe3,VKMe4,VKMe5,VKMe6,VKMe7,VKMe8,VKMe9,VKMe10,
          VKMe11,VKMe12,VKMe13,
          EKWert1,EKWert2,EKWert3,EKWert4,EKWert5,EKWert6,EKWert7,EKWert8,
          EKWert9,EKWert10,EKWert11,EKWert12,EKWert13,
          VKWert1,VKWert2,VKWert3,VKWert4,VKWert5,VKWert6,VKWert7,VKWert8,
          VKWert9,VKWert10,VKWert11,VKWert12,VKWert13,
          EKSumme,EKSuAlt,MEK,LPreis,LMenge,LRabatt,DMengeAlt,
          DWertAlt,DMenge,DWert,InvMenge,InvWert,InvMngAnf,KorrMenge,
          KorrMeAlt,InvDatum,LiefNr,LDatum)

      values (:IArtikelnr ,:IJahr, :IFiliale,:FBestand,
         :FAuftMenge, :FAuftWert, :FBestMenge, :FBestWert,
         :FVKLFWert, :FEKLFWert, :FVKLFMenge, :FEKLFMenge,
         :FEKMe1,:FEKMe2,:FEKMe3,:FEKMe4,:FEKMe5,:FEKMe6,:FEKMe7,:FEKMe8,
         :FEKMe9,:FEKMe10,:FEKMe11,:FEKMe12,:FEKMe13,
         :FVKMe1,:FVKMe2,:FVKMe3,:FVKMe4,:FVKMe5,:FVKMe6,:FVKMe7,:FVKMe8,
         :FVKMe9,:FVKMe10,:FVKMe11,:FVKMe12,:FVKMe13,
         :FEKWert1,:FEKWert2,:FEKWert3,:FEKWert4,:FEKWert5,:FEKWert6,
         :FEKWert7,:FEKWert8 ,:FEKWert9,:FEKWert10,:FEKWert11,:FEKWert12,:FEKWert13,
         :FVKWert1,:FVKWert2,:FVKWert3,:FVKWert4,:FVKWert5,:FVKWert6,
         :FVKWert7,:FVKWert8,:FVKWert9,:FVKWert10,:FVKWert11,:FVKWert12,:FVKWert13,
         :FEKSumme,:FEKSuAlt,:FMEK,:FLPreis,:FLMenge,:FLRabatt,:FDMengeAlt,
         :FDWertAlt,:FDMenge,:FDWert,:FInvMenge,:FInvWert,:FInvMngAnf,:FKorrMenge,
         :FKorrMeAlt,:FInvDatum, :FLIefNr, :FLDatum);
   end
   else begin
      update ARUmsatz set
         Bestand  = :FBestand, VKLFWert = :FVKLFWert, EKLFWert = :FEKLFWert,
         VKLFMenge = :FVKLFMenge,EKLFMenge = :FEKLFMenge,
         AuftMenge = :FAuftMenge, AuftWert = :FAuftWert,
         BestMenge = :FBestMenge, BestWert = :FBestWert,
         EKMe1 = :FEKMe1, EKMe2 = :FEKMe2, EKMe3 = :FEKMe3,
         EKMe4 = :FEKMe4, EKMe5 = :FEKMe5, EKMe6 = :FEKMe6,
         EKMe7 = :FEKMe7, EKMe8 = :FEKMe8, EKMe9 = :FEKMe9,
         EKMe10 = :FEKMe10,EKMe11 = :FEKMe11,EKMe12 = :FEKMe12,
         EKMe13 = :FEKMe13,
         VKMe1 = :FVKMe1, VKMe2 = :FVKMe2, VKMe3 = :FVKMe3,
         VKMe4 = :FVKMe4, VKMe5 = :FVKMe5, VKMe6 = :FVKMe6,
         VKMe7 = :FVKMe7, VKMe8 = :FVKMe8, VKMe9 = :FVKMe9,
         VKMe10 = :FVKMe10,VKMe11 = :FVKMe11,VKMe12 = :FVKMe12,
         VKMe13 = :FVKMe13,
         EKWert1 = :FEKWert1, EKWert2 = :FEKWert2, EKWert3 = :FEKWert3,
         EKWert4 = :FEKWert4, EKWert5 = :FEKWert5, EKWert6 = :FEKWert6,
         EKWert7 = :FEKWert7, EKWert8 = :FEKWert8, EKWert9 = :FEKWert9,
         EKWert10 = :FEKWert10,EKWert11 = :FEKWert11,EKWert12 = :FEKWert12,
         EKWert13 = :FEKWert13,
         VKWert1 = :FVKWert1, VKWert2 = :FVKWert2, VKWert3 = :FVKWert3,
         VKWert4 = :FVKWert4, VKWert5 = :FVKWert5, VKWert6 = :FVKWert6,
         VKWert7 = :FVKWert7, VKWert8 = :FVKWert8, VKWert9 = :FVKWert9,
         VKWert10 = :FVKWert10,VKWert11 = :FVKWert11,VKWert12 = :FVKWert12,
         VKWert13 = :FVKWert13 ,
         EKSumme = :FEKSumme, EKSuAlt = :FEKSuAlt, MEK = :FMEK,
         LPreis = :FLPreis, LMenge = :FLMenge,LRabatt = :FLRabatt,
         DMengeAlt = :FDMengeAlt,DWertAlt = :FDWertAlt,DMenge = :FDMenge,
         DWert = :FDWert, InvMenge = :FInvMenge,InvWert = :FInvWert,
         InvMngAnf = :FInvMngAnf, KorrMenge = :FKorrMenge,
         KorrMeAlt = :FKorrMeAlt, InvDatum = :FInvDatum,
         LiefNr   = :FLiefNr, LDatum = :FLDatum
      where Artikelnr = :IArtikelnr and Jahr = :IJahr and Filiale = :IFiliale;
   end
end
--

create procedure GDI_ADRART
   (IArtikelnr VarChar(50), IAdressnr Integer, IMonat SmallInt,
    IDatum Date, IMenge Double Precision, IWert Double Precision,
    IRabatt Double Precision, IFlag Char(1))
returns
   (Errmsg Integer)
as
   declare variable FArtikelnr VarChar(50);
   declare variable FAdressNr  Integer;
   declare variable FMenge1  Double Precision;
   declare variable FMenge2  Double Precision;
   declare variable FMenge3  Double Precision;
   declare variable FMenge4  Double Precision;
   declare variable FMenge5  Double Precision;
   declare variable FMenge6  Double Precision;
   declare variable FMenge7  Double Precision;
   declare variable FMenge8  Double Precision;
   declare variable FMenge9  Double Precision;
   declare variable FMenge10 Double Precision;
   declare variable FMenge11 Double Precision;
   declare variable FMenge12 Double Precision;
   declare variable FMenge13 Double Precision;
   declare variable FWert1   Double Precision;
   declare variable FWert2   Double Precision;
   declare variable FWert3   Double Precision;
   declare variable FWert4   Double Precision;
   declare variable FWert5   Double Precision;
   declare variable FWert6   Double Precision;
   declare variable FWert7   Double Precision;
   declare variable FWert8   Double Precision;
   declare variable FWert9   Double Precision;
   declare variable FWert10  Double Precision;
   declare variable FWert11  Double Precision;
   declare variable FWert12  Double Precision;
   declare variable FWert13  Double Precision;
   declare variable FLPreis  Double Precision;
   declare variable FLMenge  Double Precision;
   declare variable FLRabatt Double Precision;
   declare variable FLDatum  Date;
begin
   if ((IArtikelnr = "") or (IAdressNr = 0) or
       (gen_id(Buchen_disabled, 0) = 1)) then
      exit;
   select Artikelnr,
          Menge1,Menge2,Menge3,Menge4,Menge5,Menge6,Menge7,Menge8,Menge9,
          Menge10,Menge11,Menge12,Menge13,
          Wert1,Wert2,Wert3,Wert4,Wert5,Wert6,Wert7,Wert8,Wert9,Wert10,
          Wert11,Wert12,Wert13,
          LPreis, LMenge, LRabatt, LDatum
          from AdrArt
   where Artikelnr = :IArtikelnr and AdressNr = :IAdressNr
   into  :FArtikelnr ,
         :FMenge1,:FMenge2,:FMenge3,:FMenge4,:FMenge5,:FMenge6,:FMenge7,:FMenge8,
         :FMenge9,:FMenge10,:FMenge11,:FMenge12,:FMenge13,
         :FWert1,:FWert2,:FWert3,:FWert4,:FWert5,:FWert6,:FWert7,:FWert8,
         :FWert9,:FWert10,:FWert11,:FWert12,:FWert13,
         :FLPreis, :FLMenge, :FLRabatt, :FLDatum;

   if (:FArtikelnr is null) then begin
      FMenge1  = 0; FMenge2 = 0; FMenge3  = 0; FMenge4  = 0; FMenge5  = 0; FMenge6  = 0;
      FMenge7  = 0; FMenge8 = 0; FMenge9  = 0; FMenge10 = 0; FMenge11 = 0; FMenge12 = 0;
      FMenge13 = 0;
      FWert1   = 0; FWert2  = 0; FWert3   = 0; FWert4   = 0; FWert5   = 0; FWert6   = 0;
      FWert7   = 0; FWert8  = 0; FWert9   = 0; FWert10  = 0; FWert11  = 0; FWert12  = 0;
      FWert13  = 0;
      FLPreis  = 0; FLMenge = 0; FLRabatt = 0;
   end
   if (IMonat = 1) then begin
      FMenge1  = FMenge1  + IMenge; FWert1  = FWert1  + IWert;
   end else if (IMonat = 2) then begin
      FMenge2  = FMenge2  + IMenge; FWert2  = FWert2  + IWert;
   end else if (IMonat = 3) then begin
      FMenge3  = FMenge3  + IMenge; FWert3  = FWert3  + IWert;
   end else if (IMonat = 4) then begin
      FMenge4  = FMenge4  + IMenge; FWert4  = FWert4  + IWert;
   end else if (IMonat = 5) then begin
      FMenge5  = FMenge5  + IMenge; FWert5  = FWert5  + IWert;
   end else if (IMonat = 6) then begin
      FMenge6  = FMenge6  + IMenge; FWert6  = FWert6  + IWert;
   end else if (IMonat = 7) then begin
      FMenge7  = FMenge7  + IMenge; FWert7  = FWert7  + IWert;
   end else if (IMonat = 8) then begin
      FMenge8  = FMenge8  + IMenge; FWert8  = FWert8  + IWert;
   end else if (IMonat = 9) then begin
      FMenge9  = FMenge9  + IMenge; FWert9  = FWert9  + IWert;
   end else if (IMonat = 10) then begin
      FMenge10 = FMenge10 + IMenge; FWert10 = FWert10 + IWert;
   end else if (IMonat = 11) then begin
      FMenge11 = FMenge11 + IMenge; FWert11 = FWert11 + IWert;
   end else if (IMonat = 12) then begin
      FMenge12 = FMenge12 + IMenge; FWert12 = FWert12 + IWert;
   end else if (IMonat = 13) then begin
      FMenge13 = FMenge13 + IMenge; FWert13 = FWert13 + IWert;
   end

   if (IFlag = "1") then begin
      FLPreis = IWert;
      if (IMenge <> 0) then begin
         FLPreis = FLPreis / IMenge;
         FLPreis = Runden(FLPreis,4);
      end
      FLDatum  = IDatum;
      FLMenge  = IMenge;
      FLRabatt = IRabatt;
   end
   if (:FArtikelnr is null) then begin
      insert into AdrArt
         (Artikelnr, AdressNr,
          Menge1,Menge2,Menge3,Menge4,Menge5,Menge6,Menge7,Menge8,Menge9,
          Menge10,Menge11,Menge12,Menge13,
          Wert1,Wert2,Wert3,Wert4,Wert5,Wert6,Wert7,Wert8,Wert9,Wert10,
          Wert11,Wert12,Wert13,
          LPreis, LMenge, LRabatt, LDatum)
      values (:IArtikelnr,:IAdressNr,
          :FMenge1,:FMenge2,:FMenge3,:FMenge4,:FMenge5,:FMenge6,:FMenge7,
          :FMenge8,:FMenge9,:FMenge10,:FMenge11,:FMenge12,:FMenge13,
          :FWert1,:FWert2,:FWert3,:FWert4,:FWert5,:FWert6,:FWert7,:FWert8,
          :FWert9,:FWert10,:FWert11,:FWert12,:FWert13,
          :FLPreis, :FLMenge, :FLRabatt, :FLDatum);
   end else begin
      update AdrArt set
         Menge1 = :FMenge1,Menge2  = :FMenge2, Menge3  = :FMenge3, Menge4  = :FMenge4,
         Menge5 = :FMenge5,Menge6  = :FMenge6, Menge7  = :FMenge7, Menge8  = :FMenge8,
         Menge9 = :FMenge9,Menge10 = :FMenge10,Menge11 = :FMenge11,Menge12 = :FMenge12,
         Menge13 = :FMenge13,
         Wert1 = :FWert1,Wert2  = :FWert2, Wert3  = :FWert3, Wert4  = :FWert4,
         Wert5 = :FWert5,Wert6  = :FWert6, Wert7  = :FWert7, Wert8  = :FWert8,
         Wert9 = :FWert9,Wert10 = :FWert10,Wert11 = :FWert11,Wert12 = :FWert12,
         Wert13 = :FWert13,
         LPreis = :FLPreis, LMenge = :FLMenge,
         LRabatt = :FLRabatt, LDatum = :FLDatum
      where Artikelnr = :IArtikelnr and AdressNr = :IAdressNr;
   end
end
--

create procedure GDI_LoadPosSumme
   (IBelegTyp Char(1),IBelegArt VarChar(5), IBelegNr Integer, IPosNr Integer,
    IArtikelnr VarChar(50),IKzDruck Char(1),IMenge Double Precision,
    IEPreis Double Precision )
returns
   (ErrMsg    Integer,
    AMenge    Double Precision,
    AEPreis   Double Precision,
    AGesamt   Double Precision,
    AEKGesamt Double Precision)
as
   declare variable FPosNr       Integer;
   declare variable FArtikelnr   VarChar(30);
   declare variable FKzDruck     Char(1);
   declare variable FKzRabatt    Char(1);
   declare variable FMenge       Double Precision;
   declare variable FGesamt      Double Precision;
   declare variable FEkGesamt    Double Precision;
   declare variable FSumMenge    Double Precision;
   declare variable FSumGesamt   Double Precision;
   declare variable FSumGesamt2  Double Precision;
   declare variable FSumEKGesamt Double Precision;
   declare variable FFlag        Char(1);
   declare variable FBis         Char(1);
   declare variable FNr          VarChar(30);
   declare variable FBOF         Char(1);
   declare variable FAbbruch     Char(1);

begin
   if ((IKzDruck <> "E") and (IKzDruck <> "S") and (IKzDruck <> "%")) then
      exit;
   AMenge      = 0;
   AGesamt     = 0;
   AEPreis     = 0;
   FSumMenge   = 0;
   FSumGesamt  = 0;
   FSumGesamt2 = 0;
   FSumEKGesamt= 0;   
   FFlag       = "1";
   FBOF        = "1";
   FAbbruch    = "0";
   if (IKzDruck = "%") then begin
      FBis = "R";
      FNr  = "";
   end
   else begin
      FBis = "P";
      if (IKzDruck = "S") then
         FFlag = "0";
      FNr = IArtikelnr;
   end
   for select posnr, Artikelnr, kzdruck, kzrabatt,menge,gesamt,ekgesamt
   from BelegPos
   where BelegTyp = :IBelegTyp and BelegArt = :IBelegArt and BelegNr = :IBelegNr and
         posnr <= :IPosNr
   order by BelegTyp desc, BelegArt desc, BelegNr desc, posnr desc
   into :FPosnr, :FArtikelnr, :FKzDruck, :FKzRabatt, :FMenge, :FGesamt, :FEKGesamt
   do begin
      if (FAbbruch = "0") then begin
         if (((not (FKzDruck in ("C","t","T","P","S","E","M"))) or (FKzDruck is null)) and
             (FFlag = "1")                                     and
             ((FKzDruck <> "A") or (IKzDruck <> "%"))          and
             (FArtikelnr <> ""))                               then begin
            if ((IKzDruck <> "%")  or
                ((FKzRabatt = "1") and (FPosNr <> IPosNr))) then begin
               FSumMenge    = FSumMenge    + FMenge;
               FSumGesamt   = FSumGesamt   + FGesamt;
               FSumEKGesamt = FSumEKGesamt + FEKGesamt;
            end
            if (FKzDruck <> "%") then begin
               FSumGesamt2 = FSumGesamt2 + FGesamt;
            end
         end
         if ((FFlag = "1") and
             (FKzDruck = FBis) and
             ((FNr = "") or (FNr = FArtikelnr))) then begin
            FBOF = "0";
            FAbbruch = "1";
         end
         if ((FFlag = "0") and (FKzDruck = "E") and (FNr = FArtikelnr)) then
            FFlag = "1";
      end
   end
   if ((FBOF = "1") and ((IKzDruck = "E") or (IKzDruck = "S")) ) then begin
      exit;
   end
   if ((IKzDruck = "E") or (IKzDruck = "S")) then begin
      AMenge    = FSumMenge;
      AGesamt   = FSumGesamt;
      AEPreis   = IEPreis;
      AEKGesamt = FSumEKGesamt;
   end
   else begin
      AMenge  = IMenge;
      AEPreis = IEPreis;
      AGesamt = 0;
      if (IMenge < 0) then begin
         AEPreis = FSumGesamt2;
      end else begin
         if (IArtikelnr <> "") then
            AEPreis = FSumGesamt;
      end
   end
   suspend;
end
--

create procedure GDI_INV_RECHNEN_POS
   (IArtikelnr VarChar(50), IFiliale Integer,
    IJahr VarChar(4), IVonDatum Date, IBisDatum Date)
returns
   (AFiliale      Integer,
    ANewInventur  Double Precision,
    ANewEKWert    Double Precision,
    ANewDMenge    Double Precision,
    ANewDWert     Double Precision,
    ANewKorrektur Double Precision,
    ABestand      Double Precision,
    ADWert        Double Precision,
    ADWertAlt     Double Precision,
    ALPreis       Double Precision,
    ADMenge       Double Precision,
    ADMengeAlt    Double Precision,
    AEKSumme      Double Precision,
    ALiefNr       VarChar(10),
    ALMenge       Double Precision,
    ALDatum       Date,
    ABest_Bes     Double Precision,
    ABest_Min     Double Precision,
    ABest_Lim     Double Precision,
    AMEK          Double Precision)
as
   declare variable FFiliale   Integer;
   declare variable FArtikelnr VarChar(50);
   declare variable FBelegTyp  Char(1);
   declare variable FBelegArt  VarChar(10);
   declare variable FPosArt    VarChar(10);
   declare variable FLagerme   Double Precision;
   declare variable FEkgesamt  Double Precision;
   declare variable FLagerpr   Double Precision;
   declare variable FDatumme   Date;
   declare variable FInvDatum  Date;
   declare variable FInvMenge  Double Precision;
   declare variable FInvWert   Double Precision;
   declare variable FInvMngAnf Double Precision;
   declare variable FVonGJahr  Date;
   declare variable FBisGJahr  Date;
   declare variable FBestand   Double Precision;
   declare variable FDMenge    Double Precision;
   declare variable FDMengeAlt Double Precision;
   declare variable FLPreis    Double Precision;
   declare variable FDWert     Double Precision;
   declare variable FDWertAlt  Double Precision;
   declare variable FEKSumme   Double Precision;
   declare variable FLiefNr    VarChar(10);
   declare variable FLMenge    Double Precision;
   declare variable FLDatum    Date;
   declare variable FDatum     Date;
   declare variable FBest_Bes  Double Precision;
   declare variable FBest_Min  Double Precision;
   declare variable FBest_Lim  Double Precision;
   declare variable FMEK       Double Precision;
   declare variable FSumMenge  Double Precision;
   declare variable FSumWert   Double Precision;
   declare variable FSumDMenge Double Precision;
   declare variable FSumDWert  Double Precision;
   declare variable FSumKMenge Double Precision;
   declare variable FArt       VarChar(10);

begin
   select first 1 StrToDateTime(W1), StrToDateTime(W2) from GDIDEF
   where  Satzart = "FA2"
   into   :FVonGJahr, :FBisGJahr;
   /* Alle Filialen */
   for select Artikelnr, Filiale, bestand, invdatum, invmenge, invwert, invmnganf,
              liefnr, lmenge, ldatum,best_bes, best_min, best_lim, mek,
              dmenge, dmengealt, lpreis, dwert, dwertalt, eksumme
   from ARUmsatz
   where (Artikelnr = :IArtikelnr) and (Jahr = :IJahr) and
         ((Filiale = :IFiliale) or (:IFiliale = -1))
   into  :FArtikelnr, :FFiliale , :FBestand, :FInvDatum, :FInvMenge, :FInvWert,:FInvMngAnf,:FLiefNr,
         :FLMenge, :FLDatum, :FBest_Bes, :FBest_Min, :FBest_Lim, :FMEK,
         :FDMenge, :FDMengeAlt, :FLPreis, :FDWert, :FDWertAlt, :FEKSumme
   do begin
      if (not (:FArtikelnr is null)) then begin
         FSumMenge = 0;
         FSumWert  = 0;
         FSumDMenge = 0;
         FSumDWert  = 0;
         FSumKMenge = 0;

         /* Liegt VonDatum VOR der letzten Inventur:
            Zeitraum [VonGJahr.. VonDatum] durchlaufen */
         if ((FInvDatum is not null) and (IVonDatum < FInvDatum)) then begin

            FSumMenge = FInvMngAnf;

            for select Artikelnr,BelegTyp,BelegArt,posart,lagerme,
                       ekgesamt,lagerpr,datumme
            from       BelegPos
            where      Artikelnr = :IArtikelnr and
                       Filiale   = :FFiliale   and
                       ((not (kzdruck in ("%","A","C","t","T","P","S","E","W"))) or (kzdruck is null)) and
                       datumme >= :FVonGJahr and datumme < :IVonDatum + 1
            into       :FArtikelnr,:FBelegTyp,:FBelegArt,:FPosArt,:FLagerMe,
                       :FEkGesamt,:FLagerPr,:FDatumMe
            do begin
               if (FBelegTyp = "L") then
                  FArt = FPosArt;
               else
                  FArt = FBelegArt;
               if (FBelegTyp = "E") then begin
                  if (FArt in ("RE","MA","LI","FU")) then begin
                     FSumMenge = FSumMenge + FLagerMe;
                     FSumWert  = FSumWert  + FLagerPr;
                     if (FArt <> "LI") then begin
                        FSumDMenge  = FSumDMenge + FLagerMe;
                        FSumDWert   = FSumDWert  + FLagerPr;
                     end
                  end
                  else if (FArt in ("RL","GU")) then begin
                     FSumMenge = FSumMenge - FLagerMe;
                     FSumWert  = FSumWert  - FLagerPr;
                  end
               end
               else if (FBelegTyp = "V") then begin
                  if (FArt in ("RE","MA","LI","FU")) then begin
                     FSumMenge = FSumMenge  - FLagerMe;
                     FSumWert  = FSumWert   - FEkGesamt;
                  end
                  else if (FArt in ("RL","GU")) then begin
                     FSumMenge = FSumMenge  + FLagerMe;
                     FSumWert  = FSumWert   + FEkGesamt;
                  end
               end
               else if (FBelegTyp = "L") then begin
                  if (FArt = "Z") then begin
                     FSumMenge = FSumMenge   + FLagerMe;
                     FSumWert  = FSumWert    + FLagerPr;
                     FSumDMenge = FSumDMenge  + FLagerMe;
                     FSumDWert  = FSumDWert   + FLagerPr;
                  end
                  else if (FArt = "K") then begin
                     FSumMenge  = FSumMenge   + FLagerMe;
                     FSumWert   = FSumWert    + FEkGesamt;
                     FSumKMenge = FSumKMenge  + FLagerMe;
                  end
                  else if (FArt = "A") then begin
                     FSumMenge = FSumMenge - FLagerMe;
                     FSumWert  = FSumWert  - FEkGesamt;
                  end
               end
            end
            ANewInventur  = FSumMenge;
         end
         /* Liegt VonDatum NACH der letzten Inventur:
            Zeitraum [VonDatum,BisDatum] durchlaufen */
         else begin
            if (GetDate(IVonDatum) = GetDate(FBisGJahr)) then begin
               if (GetDate(FInvDatum) = GetDate(IVonDatum)) then
                  FDatum = IVonDatum;
               else
                  FDatum = IVonDatum+1;
            end
            else
               FDatum = IVonDatum;
            for select Artikelnr,BelegTyp,BelegArt,posart,lagerme,
                       ekgesamt,lagerpr,datumme
            from       BelegPos
            where      Artikelnr = :IArtikelnr and
                       Filiale   = :FFiliale   and
                       ((not (kzdruck in ("%","A","C","t","T","P","S","E","W"))) or (kzdruck is null)) and
                       datumme >= :FDatum and datumme < :IBisDatum+1
            into       :FArtikelnr,:FBelegTyp,:FBelegArt,:FPosArt,:FLagerMe,
                       :FEkGesamt,:FLagerPr,:FDatumMe
            do begin
               if (FBelegTyp = "L") then
                  FArt = FPosArt;
               else
                  FArt = FBelegArt;
               if ((FInvDatum is null) or (FDatumMe >= FInvDatum)) then begin
                  if (FBelegTyp = "E") then begin
                     if (FArt in ("RE","MA","LI","FU")) then begin
                        FSumMenge = FSumMenge + FLagerMe;
                        FSumWert  = FSumWert  + FLagerPr;
                        if (FArt <> "LI") then begin
                           FSumDMenge  = FSumDMenge  + FLagerMe;
                           FSumDWert   = FSumDWert   + FLagerPr;
                        end
                     end
                     else if (FArt in ("RL","GU")) then begin
                        FSumMenge = FSumMenge - FLagerMe;
                        FSumWert  = FSumWert  - FLagerPr;
                     end
                  end
                  else if (FBelegTyp = "V") then begin
                     if (FArt in ("RE","MA","LI","FU")) then begin
                        FSumMenge = FSumMenge  - FLagerMe;
                        FSumWert  = FSumWert   - FEkGesamt;
                     end
                     else if (FArt in ("RL","GU")) then begin
                        FSumMenge = FSumMenge  + FLagerMe;
                        FSumWert  = FSumWert   + FEkGesamt;
                     end
                  end
                  else if (FBelegTyp = "L") then begin
                     if (FArt = "Z") then begin
                        FSumMenge = FSumMenge   + FLagerMe;
                        FSumWert  = FSumWert    + FLagerPr;
                        FSumDMenge = FSumDMenge  + FLagerMe;
                        FSumDWert  = FSumDWert   + FLagerPr;
                     end
                     else if (FArt = "K") then begin
                        FSumMenge  = FSumMenge   + FLagerMe;
                        FSumWert   = FSumWert    + FEkGesamt;
                        FSumKMenge = FSumKMenge  + FLagerMe;
                     end
                     else if (FArt = "A") then begin
                        FSumMenge = FSumMenge - FLagerMe;
                        FSumWert  = FSumWert  - FEkGesamt;
                     end
                  end
               end
            end
            ANewInventur  = FBestand - FSumMenge;
         end
         AFiliale      = FFiliale;
         ANewInventur  = Runden(ANewInventur,8);
         ANewEKWert    = Runden(FSumWert,8);
         ANewDMenge    = Runden(FSumDMenge,8);
         ANewDWert     = Runden(FSumDWert,8);
         ANewKorrektur = Runden(FSumKMenge,8);
         ABestand      = FBestand;
         ADWert        = FDWert;
         ADWertAlt     = FDWertAlt;
         ALPreis       = FLPreis;
         ADMenge       = FDMenge;
         ADMengeAlt    = FDMengeAlt;
         AEKSumme      = FEKSumme;
         ALiefNr       = FLiefNr;
         ALMenge       = FLMenge;
         ALDatum       = FLDatum;
         ABest_Bes     = FBest_Bes;
         ABest_Min     = FBest_Min;
         ABest_Lim     = FBest_Lim;
         AMEK          = FMEK;
         suspend;
      end
   end
end
--

create procedure GDI_GETLAGER
   (IArtikelnr   VarChar(30),
    IJahr        VarChar(4),
    IFiliale     Integer)
returns
   (Jahr      VarChar(4),
    Filiale   Integer,
    Bestand   Double Precision,
    Vbestand  Double Precision,
    Fbestand  Double Precision,
    Rbestand  Double Precision,
    Vkwert    Double Precision,
    Ekwert    Double Precision,
    Vkmenge   Double Precision,
    Ekmenge   Double Precision,
    Eklfmenge Double Precision,
    Eklfwert  Double Precision,
    Vklfmenge Double Precision,
    Vklfwert  Double Precision,
    Auftmenge Double Precision,
    Auftwert  Double Precision,
    Bestmenge Double Precision,
    Bestwert  Double Precision,
    Invmenge  Double Precision,
    Invwert   Double Precision,
    Invmnganf Double Precision,
    Invdatum  Date,
    Kek       Double Precision,
    Dek       Double Precision,
    Gek       Double Precision,
    Mek       Double Precision,
    Lek       Double Precision,
    Mefaktor  Double Precision,
    Liefnr    VarChar(10),
    Ldatum    Date,
    Korrmenge Double Precision,
    MindBest  Double Precision,
    LimitBest Double Precision,
    BestellBest Double Precision)
as
   declare variable ZDWERT Double Precision;
   declare variable ZDMENGE Double Precision;
   declare variable ZEKSUMME Double Precision;
   declare variable FSysVBestand Char(1);
   declare variable FNKStatis  Integer;
   declare variable FNKPreis   Integer;
   declare variable FBisGJahr  Date;
begin
   FNKStatis = null;
   select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKStatis;
   if ((FNKStatis is null) or (FNKStatis = 0)) then
      FNKStatis = 2;
   FNKPreis  = null;
   select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNKPreis;
   if ((FNKPreis is null) or (FNKPreis = 0)) then
      FNKPreis = 2;
   Jahr = null;
   Filiale = 0; Bestand = 0; Vbestand = 0; Fbestand = 0; Rbestand = 0;
   Vkwert = 0;  Ekwert = 0;  Vkmenge = 0;  Ekmenge = 0;  Auftmenge = 0;
   Auftwert = 0; Bestmenge = 0; Bestwert = 0; Invmenge = 0; Invwert = 0;
   Invmnganf = 0; Invdatum = null; Kek = 0; Dek = 0; Gek = 0; Mek = 0; Lek = 0;
   Mefaktor = 0; Liefnr = ""; Ldatum = null; Korrmenge = 0; MindBest = 0;
   select first 1 Copy(ListValue(M1,"BELEG.VBESTAND"),1,1) from GDIDEF
   where Satzart = "FA1" into :FSysVBestand;
   if (FSysVBestand is null) then
      FSysVBestand = " ";
   else
      FSysVBestand = cast(FSysVBestand as Char(1));
   select kalkek, mefaktor from Artikel where Artikelnr = :IArtikelnr
   into   :KEK, :MEFAKTOR;
   if (ABS(MeFaktor) < 0.0000001) then
      MEFaktor = 1.0;
   if (IJahr = "-1") then begin
      select first 1 cast(w2 as Date) from GDIDEF
      where  Satzart = "FA2"
      into   :FBisGJahr;
      IJahr = GetYear(FBisGJahr - 364);
   end
   for select jahr, Filiale, Bestand, VBestand, FBestand, RBestand, AuftMenge,
          Auftwert, BestMenge, Bestwert,
          ekme1 + ekme2 + ekme3 + ekme4 + ekme5 + ekme6 + ekme7 + ekme8 +
          ekme9 + ekme10 + ekme11 + ekme12 + ekme13,
          ekwert1 + ekwert2 + ekwert3 + ekwert4 + ekwert5 + ekwert6 + ekwert7 +
          ekwert8 + ekwert9 + ekwert10 + ekwert11 + ekwert12 + ekwert13,
          vkme1 + vkme2 + vkme3 + vkme4 + vkme5 + vkme6 + vkme7 + vkme8 +
          vkme9 + vkme10 + vkme11 + vkme12 + vkme13,
          vkwert1 + vkwert2 + vkwert3 + vkwert4 + vkwert5 + vkwert6 + vkwert7 +
          vkwert8 + vkwert9 + vkwert10 + vkwert11 + vkwert12 + vkwert13,
          Eklfmenge, Eklfwert, Vklfmenge, Vklfwert,
          DWert + DWertAlt, DMenge + DMengeAlt, EKSumme, InvMenge, Invwert,
          InvMngAnf, LPreis, LDatum, Liefnr, MEK, Korrmenge+KorrmeAlt, INVDatum,
          Best_Min, Best_Lim, Best_Bes
          from ARUmsatz
    where Artikelnr = :IArtikelnr        and
          (:IJahr = cast("" as VarChar(4)) or Jahr = :IJahr) and
          (:IFiliale = -1 or Filiale = :IFiliale)
    order by jahr, Filiale
    into :Jahr, :Filiale, :Bestand, :VBestand, :FBestand, :RBestand,
         :Auftmenge, :Auftwert, :BestMenge, :Bestwert,
         :EKMENGE, :EKWERT, :VKMENGE, :VKWERT,
         :Eklfmenge, :Eklfwert, :Vklfmenge, :Vklfwert,
         :ZDWert, :ZDMenge, :ZEKSumme, :InvMenge, :InvWert, :InvMngAnf,
         :LEK, :LDatum , :Liefnr, :MEK , :Korrmenge, :InvDatum,
         :MindBest, :LimitBest, :BestellBest
   do begin
      DEK = 0;
      if (ZDMenge <> 0) then
         DEK = Runden(ZDWert / ZDMenge,8);
      if (Abs(Bestand) < 0.00001) then
         GEK = MEK;
      else
         GEK = Runden(ZEKSumme / Bestand,8);
      if (FSysVBestand = "2") then begin /* Bestell */
         VBestand = BestMenge;
      end else if (FSysVBestand = "3") then begin /* Auftrag */
         VBestand = AuftMenge;
      end else if (FSysVBestand = "4") then begin /*Verfuegbar */
         VBestand = Bestand - AuftMenge;
      end else if (FSysVBestand = "5") then begin /* VBestand*/
         VBestand = VBestand;
      end else begin /* 1 Bestell + Verfuegbar*/
         VBestand = BestMenge + Bestand - AuftMenge;
      end
      suspend;
   end
   KEK = Runden(KEK, FNKPreis);
   DEK = Runden(DEK, FNKPreis);
   GEK = Runden(GEK, FNKPreis);
   MEK = Runden(MEK, FNKPreis);
   LEK = Runden(LEK, FNKPreis);
   VKWert    = Runden(VKWert, FNKStatis);
   EKWert    = Runden(EKWert, FNKStatis);
   Eklfwert  = Runden(EkLfWert, FNKStatis);
   Vklfwert  = Runden(VklfWert, FNKStatis);
   Auftwert  = Runden(Auftwert, FNKStatis);
   Bestwert  = Runden(Bestwert, FNKStatis);
   Invwert   = Runden(Invwert, FNKStatis);
   if (Jahr is null) then
      suspend;
end
--

create procedure GDI_SETPREIS
   (Artikelnr  VarChar(30),
    Preislst   SmallInt,
    Rabstaffel SmallInt,
    Adressnr   Integer,
    Wert       Double Precision,
    Art        Char(1),
    Vondatum   Date,
    Bisdatum   Date,
    Bediener   VarChar(5))
returns
   (Ok Integer)
as
   declare variable FPosNr Integer;
   declare variable FAnzahl Integer;
   declare variable FRabstaffel SmallInt;
begin
   ok = 0;
   if ((Artikelnr is null) or (Artikelnr = "") or (AdressNr is null) or
      ((Art = "I") and (not(VonDatum is null) or not(BisDatum is null))) or
      ((Art = "G") and ((VonDatum is null) or not(BisDatum is null))) or
      ((Art = "A") and ((VonDatum is null) or (BisDatum is null) or
                        (BisDatum < VonDatum) ))) then begin
      ok = 1;
      suspend;
      exit;
   end
   Select count(*) from Artikel
     where Artikelnr = :Artikelnr
     into FAnzahl;
   if (FAnzahl = 0) then begin
      ok = 2;
      suspend;
      exit;
   end
   FPosNr = null;
   Select PosNr from Preise
      where Artikelnr = :Artikelnr and AdressNr = :AdressNr and
            Preislst = :Preislst and Art = :Art and
            (:VonDatum is null or VonDatum = :VonDatum) and
            (:BisDatum is null or BisDatum = :BisDatum)
      into :FPosNr;
   if (FPosNr is null) then begin
      Select Max(PosNr) from Preise
        where Artikelnr = :Artikelnr and AdressNr = :AdressNr and Preislst = :Preislst
        into :FPosnr;
      if (FPosNr is null) then begin
         FPosNr = 1;
      end else begin
         FPosNr = FPosNr + 1;
      end
      if (RabStaffel < 0) then
         FRabStaffel = 0;
      else
         FRabStaffel = RabStaffel;
      insert into Preise (Artikelnr, AdressNr, preislst, posnr,  material,
                           rabstaffel, vondatum, bisdatum, art, AendDatum, aendbed)
                  Values (:Artikelnr,:AdressNr,:Preislst,:FPosNr,:Wert,
                          :FRabstaffel,:VonDatum,:BisDatum,:Art,"Now",:Bediener);
   end else begin
      if (RabStaffel < 0) then
         select rabstaffel from Preise
         where Artikelnr = :Artikelnr and AdressNr = :AdressNr and
               Preislst = :Preislst and PosNr = :FPosNr
         into :FRabStaffel;
      else
         FRabStaffel = RabStaffel;
      update Preise
      set    Preislst   = :Preislst,    Material = :Wert,VonDatum = :VonDatum,
             BisDatum   = :BisDatum,    Art      = :Art, AendDatum = "Now",
             RabStaffel = :FRabStaffel, AendBed  = :Bediener
      where  Artikelnr = :Artikelnr and AdressNr = :AdressNr and
             Preislst = :Preislst and PosNr = :FPosNr;
   end
end
--

create procedure GDI_SETRABATT
   (Adressnr     Integer,
    Rabattgruppe VarChar(20),
    Rabatt       Double Precision,
    Art          Char(1),
    Vondatum     Date,
    Bisdatum     Date,
    Bediener     VarChar(5))
returns
   (Ok Integer)
as
   declare variable FListe Integer;
   declare variable FLfdNr Integer;
begin
   ok = 0;
   /* Plausibilittschecks */
   if ((AdressNr is null)     or (AdressNr = 0)      or
       (Rabattgruppe is null) or (Rabattgruppe = "") or
       (Art = "I" and ((VonDatum is not null) or (BisDatum is not null)))  or
       (Art = "G" and ((VonDatum is null)     or (BisDatum is not null)))  or
       (Art = "A" and ((VonDatum is null)     or (BisDatum is null))))     then begin
      ok = 1;
      suspend;
      exit;
   end
   /* Kopfsatz vorhanden? */
   select Liste
   from   Rabatte
   where  Satzart = "AR" and Liste = :AdressNr and Gruppe = :RabattGruppe and LfdNr = 0
   into   :FListe;
   if (FListe is null) then begin
      insert into Rabatte (satzart, liste, gruppe, lfdnr, AendDatum, aendbed)
                  Values  ("AR", :AdressNr, :RabattGruppe, 0, "NOW", :Bediener);
   end
   /* Rabattsatz vorhanden? */
   select LfdNr
   from   Rabatte
   where  Satzart = "RA" and Liste = :AdressNr and
          Gruppe  = :RabattGruppe and Art = :Art and
          (:VonDatum is null or VonDatum = :VonDatum) and
          (:BisDatum is null or BisDatum = :BisDatum)
   into   :FLfdNr;
   if (FLfdNr is null) then begin
      /* Neue Nummer ermitteln */
      select max(lfdnr) from Rabatte
      where  Satzart = "RA" and Liste = :AdressNr and Gruppe = :RabattGruppe
      into   :FLfdNr;
      if (FLfdNr is null) then
         FLfdNr = 0;
      FLfdNr = FLfdNr +1;
      /* Neuanlage */
      insert into Rabatte (satzart, liste, gruppe, lfdnr, rabatt,
                           vondatum, bisdatum, art, AendDatum, aendbed)
                  Values  ("RA", :AdressNr, :RabattGruppe, :FLfdNr, :Rabatt,
                           :VonDatum, :BisDatum, :Art, "NOW", :Bediener);
   end
   else begin
      update Rabatte set Rabatt = :Rabatt, VonDatum = :VonDatum,
                         BisDatum = :Bisdatum, Art = :Art,
                         AendDatum = "NOW", AendBed = :Bediener
      where  Satzart = "RA" and Liste = :AdressNr and Gruppe = :RabattGruppe and
             LfdNr = :FLfdNr;
   end
   suspend;
end
--

create procedure GDI_GETLISTPREIS
   (IARTIKELNR VARCHAR(30),IADRESSNR INTEGER,IPREISLST SMALLINT,
    IKZAKTION CHAR(1),IDATUM DATE,IMENGE DOUBLE PRECISION)
returns
   (MATERIAL DOUBLE PRECISION,RABATT DOUBLE PRECISION,KZPREIS VARCHAR(2),
    RABSTAFFEL SMALLINT)
as
   declare variable ZRabstaffel Smallint;
   declare variable ZMaterial Double Precision;
   declare variable ZRabatt Double Precision;
   declare variable ZMenge Double Precision;
   declare variable ZVonDatum Timestamp;
   declare variable ZBisDatum Timestamp;
   declare variable ZDatum Timestamp;
   declare variable ZPosnr Smallint;
   declare variable ZArt Char(1);
   declare variable Flag Varchar(2);
   declare variable FPosnr Smallint;
   declare variable FMenge Double Precision;
begin
   KZPreis = "";
   FPosNr  = 0;
   ZDatum  = null;
   ZMaterial = null;

/* Suche nach Aktionspreisen */
   select first 1 Material, Rabatt, VonDatum, BisDatum, PosNr, RabStaffel, Art
   from Preise
   where Artikelnr = :IArtikelnr and Adressnr = :IAdressnr and Preislst = :IPreislst and
         (Art = "A") and
         ((VonDatum <= :IDatum) and ((BisDatum + 1) > :IDatum))
   order by VonDatum desc
   into :ZMaterial, :ZRabatt, :ZVonDatum, :ZBisDatum, :ZPosNr, :ZRabStaffel, :ZArt;
   if (ZMaterial is not null) then begin
      KZPreis     = "A";
      Material    = ZMaterial;
      Rabatt      = ZRabatt;
      RabStaffel  = ZRabStaffel;
      FPosNr      = ZPosNr;
   end

/* Suche nach Gltig- Ab- Preisen */
   else begin
      select first 1 Material, Rabatt, VonDatum, BisDatum, PosNr, RabStaffel, Art
      from Preise
      where Artikelnr = :IArtikelnr and Adressnr = :IAdressnr and Preislst = :IPreislst and
            (Art = "G") and
            (VonDatum <= :IDatum)
      order by VonDatum desc
      into :ZMaterial, :ZRabatt, :ZVonDatum, :ZBisDatum, :ZPosNr, :ZRabStaffel, :ZArt;
      if (ZMaterial is not null) then begin
         KZPreis     = "G";
         Material    = ZMaterial;
         Rabatt      = ZRabatt;
         RabStaffel  = ZRabStaffel;
         FPosNr      = ZPosNr;
      end

/* Suche nach Immer- Gltig- Preisen (der mit der hchsten Posnr)*/
      else begin
         select first 1 Material, Rabatt, VonDatum, BisDatum, PosNr, RabStaffel, Art
         from Preise
         where Artikelnr = :IArtikelnr and Adressnr = :IAdressnr and Preislst = :IPreislst and
               (Art = "I")
         order by PosNr desc
         into :ZMaterial, :ZRabatt, :ZVonDatum, :ZBisDatum, :ZPosNr, :ZRabStaffel, :ZArt;
         if (ZMaterial is not null) then begin
            KZPreis     = "I";
            Material    = ZMaterial;
            Rabatt      = ZRabatt;
            RabStaffel  = ZRabStaffel;
            FPosNr      = ZPosNr;
         end
      end
   end

/* Mengenabhngige Preise  */
   if (FPosNr <> 0) then begin
      FMenge = 0;
      Flag   = "";
      for select Menge, Preis from PStaffel
         where Artikelnr = :IArtikelnr and Adressnr = :IAdressnr and
            Preislst = :IPreislst and PosNr = :FPosNr
         into :ZMenge, :ZMaterial
      do begin
         Flag = "S";
         if ((IMenge > 0) and (IMenge >= ZMenge)) then begin
            if (FMenge < ZMenge) then begin
               FMenge = ZMenge;
               Material = ZMaterial;
            end
         end
      end
      if (Flag <> "") then begin
         KZPreis = KZPreis || Flag;
         if (FMenge > 0) then
            RabStaffel = 0;
      end
   end
   suspend;
end
--

create procedure GDI_GETRABATT
   (IARTIKELNR VarChar(30),IADRESSNR INTEGER,IRABATTGRP VarChar(10),
    IKZAKTION CHAR(1),IDATUM DATE)
returns
   (RABATT DOUBLE PRECISION,KZRABATT CHAR(1))
as
   declare variable ZRABATT Double precision;
   declare variable ZVONDATUM TIMESTAMP;
   declare variable ZBISDATUM TIMESTAMP;
   declare variable ZDATUM TIMESTAMP;
   declare variable ZART CHAR(1);
   declare variable FLAG VarChar(2);
begin
   ZDatum   = null;
   KZRabatt = "";
   Rabatt   = 0;
   for select Rabatt, VonDatum, BisDatum, Art from Rabatte
      where Satzart = "RA" and Gruppe = :IRabattgrp and Liste = :IAdressnr and
         ((VonDatum is null or VonDatum <= :IDatum)  and
         (BisDatum is null or BisDatum >= :IDatum))
      into :ZRabatt, :ZVonDatum, :ZBisDatum, :ZArt
   do begin
      /* A=Aktion,G=Gltig ab,I=Immer */
      Flag = "";
      if ((ZBisDatum is not null) and (IKZAktion = "1")) then begin
         Flag     = "A";
      end else if ((ZVonDatum is null) and
         (KZRabatt = "")) then begin
         Flag     = "I";
      end else if (((ZDatum is null) or  (ZDatum < ZVonDatum)) and
         (KZRabatt <> "A")) then begin
         Flag     = "G";
         ZDatum   = ZVonDatum;
      end
      if (Flag <> "") then begin
         KZRabatt    = Flag;
         Rabatt      = ZRabatt;
      end
   end
   suspend;
end
--

create procedure GDI_GETPREIS
   (IARTIKELNR VARCHAR(30),IPREISLST SMALLINT,IADRESSNR INTEGER,
    IREFERENZ INTEGER,IRABATTLST SMALLINT,IRABATTGRP VARCHAR(10),
    IKZRABATT CHAR(1),IRABATT DOUBLE PRECISION,IKZAKTION CHAR(1),
    IDATUM DATE,IMENGE DOUBLE PRECISION,IJAHR VARCHAR(4),
    IFILIALE SMALLINT, IEKDEF VarChar(10))
returns
   (WAEHRUNG   VARCHAR(3),
    MATERIAL   DOUBLE PRECISION,
    Lohn       Double Precision,
    KZPREIS    VARCHAR(3),
    RABATT     DOUBLE PRECISION,
    KZRABATT   VARCHAR(3),
    EK         DOUBLE PRECISION,
    LEK        DOUBLE PRECISION,
    DEK        DOUBLE PRECISION,
    GEK        DOUBLE PRECISION,
    MEK        DOUBLE PRECISION,
    KEK        DOUBLE PRECISION,
    MEFAKTOR   DOUBLE PRECISION,
    KZEK       CHAR(1),
    BESTAND    DOUBLE PRECISION,
    VBESTAND   DOUBLE PRECISION,
    AUFTRAG    DOUBLE PRECISION,
    BESTELLT   DOUBLE PRECISION,
    STUFE      SMALLINT,
    KZBRUTTO   CHAR(1) )
as
   declare variable ZMENGE Double precision;
   declare variable ZDMENGE Double precision;
   declare variable ZDWERT Double precision;
   declare variable ZEKSUMME Double precision;
   declare variable ZRABATT Double precision;
   declare variable FRABSTAFFEL Smallint;
   declare variable FLAG Varchar(2);
   declare variable FMENGE Double precision;
   declare variable FLEK Double precision;
   declare variable FMEK Double precision;
   declare variable FDEK Double precision;
   declare variable FKEK Double precision;
   declare variable FGEK Double precision;
   declare variable FRABATTST Double precision;
   declare variable FAARABATT Double precision;
   declare variable TLEK Double Precision;
   declare variable TMEK Double Precision;
   declare variable TDEK Double Precision;
   declare variable TKEK Double Precision;
   declare variable TGEK Double Precision;
   declare variable TBestand  Double Precision;
   declare variable TVBestand Double Precision;
   declare variable TAuftrag  Double Precision;
   declare variable TBestellt Double Precision;
   declare variable FFilAnz   Double Precision;
   declare variable I   Integer;
   declare variable FNK Integer;
/*AdrArtRabatt*/
   declare variable AAFlag Varchar(2);
   declare variable FPARabatt Double precision;
/*/AdrArtRabatt*/
begin
   Bestand  = 0;
   Auftrag  = 0;
   Bestellt = 0;
   VBestand = 0;
   LEK      = 0;
   GEK      = 0;
   DEK      = 0;
   MEK      = 0;
   KEK      = 0;
   Stufe    = 0;
   Waehrung = "";
   KZBRUTTO = "";

   if (IJahr <> "")  then begin
      for select KEK, DEK, GEK, MEK, LEK, MEFAKTOR,
                 BESTAND, VBESTAND, AUFTMENGE, BESTMENGE
      from GDI_GetLager (:IArtikelnr, :IJahr, :IFiliale)
      into :TKEK, :TDEK, :TGEK, :TMEK, :TLEK, :MEFAKTOR,
           :TBestand, :TVBestand, :TAuftrag, :TBestellt do begin
         FFilAnz = FFilAnz + 1;
         if (FFilAnz = 1) then begin
            KEK = TKEK;
            DEK = TDEK;
            GEK = TGEK;
            MEK = TMEK;
            LEK = TLEK;
            Bestand = TBestand;
            Auftrag = TAuftrag;
            Bestellt = TBestellt;
            VBestand = TVBestand;
         end else begin
            KEK = KEK + TKEK;
            DEK = DEK + TDEK;
            GEK = GEK + TGEK;
            MEK = MEK + TMEK;
            LEK = LEK + TLEK;
            Bestand = Bestand + TBestand;
            Auftrag = Auftrag + TAuftrag;
            Bestellt = Bestellt + TBestellt;
            VBestand = VBestand + TVBestand;
         end
      end
      if (FFilAnz > 1) then begin
         KEK = KEK / FFilAnz;
         DEK = DEK / FFilAnz;
         GEK = GEK / FFilAnz;
         MEK = MEK / FFilAnz;
         LEK = LEK / FFilAnz;
      end
      i = 1;
      if (IEKDEF <> "") then begin
         KZEK = Copy(IEKDEF,i,1);
         while ((i < 10) and (KZEK in ("K","D","L","G","M"))) do begin
            if (KZEK = "K") then begin
               EK = KEK;
            end else if (KZEK = "D") then begin
               EK = DEK;
            end else if (KZEK = "G") then begin
               EK = GEK;
            end else if (KZEK = "L") then begin
               EK = LEK;
            end else if (KZEK = "M") then begin
               EK = MEK;
            end
            if (EK <> 0) then begin
               i = 10;
            end else begin
               i = i + 1;
               KZEK = Copy(IEKDEF,i,1);
            end
         end
      end
      if (FFilAnz > 1) then begin
         FNK = null;
         select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
         where Satzart = "FA1" into :FNK;
         if ((FNK is null) or (FNK = 0)) then
            FNK = 2;
         EK  = Runden(EK,FNK);
         KEK = Runden(KEK,FNK);
         DEK = Runden(DEK,FNK);
         GEK = Runden(GEK,FNK);
         LEK = Runden(LEK,FNK);
         MEK = Runden(MEK,FNK);
      end
   end

   /* Preise */
   KZPreis     = "";
   FRabstaffel = 0;
   FAARabatt   = 0;
   /***AdrArtRabatt***/
   AAFLAG      = "";
   /***AdrArtRabatt***/

   if ((IPreislst = 0) or (IAdressnr <> 0)) then begin
      execute procedure GDI_GETLISTPREIS IARTIKELNR,IADRESSNR,0,IKZAKTION,IDATUM,IMENGE
              RETURNING_VALUES :Material, :FAARabatt,:KZPreis,:FRabStaffel;
      if (KZPreis <> "") then begin
         KZPreis = "A" || KZPreis;
         Stufe = 1;
         /*AdrArtRabatt*/
         if ((Material = 0) and (FAARabatt <> 0)) then begin
            KZPreis = "";
            FPARabatt = FAARabatt;
            AAFlag = "A";
         end
         /*/AdrArtRabatt*/
      end
   end
   if (IPreislst <> 0) then begin
      /*AdrArtRabatt*/
      if ((KZPreis = "") and (IReferenz <> 0) and (AAFLAG <> "A")) then begin
      /*/AdrArtRabatt*/
         execute procedure GDI_GETLISTPREIS IARTIKELNR,IReferenz,0,IKZAKTION,IDATUM,IMENGE
                 RETURNING_VALUES :Material, :FAARabatt,:KZPreis,:FRabStaffel;
         if (KZPreis <> "") then begin
            KZPreis = "R" || KZPreis;
            Stufe = 2;
            /*AdrArtRabatt*/
            if ((Material = 0) and (FAARabatt <> 0)) then begin
               KZPreis = "";
               FPARabatt = FAARabatt;
               AAFlag = "A";
            end
            /*/AdrArtRabatt*/
         end
      end
      if (KZPreis = "") then begin
         execute procedure GDI_GETLISTPREIS IARTIKELNR,0,IPreislst,IKZAKTION,IDATUM,IMENGE
                 RETURNING_VALUES :Material, :FAARabatt,:KZPreis,:FRabStaffel;
         if (KZPreis <> "") then begin
            KZPreis = "P" || KZPreis;
            Stufe = 3;
            /*AdrArtRabatt*/
            if (AAFlag = "A") then begin
               FAARabatt = FPARabatt;
               Stufe = 1;
            end
            /*/AdrArtRabatt*/
         end
      end
   end
    /* Rabatte */
   Flag     = "";
   KZRabatt = "";
   Rabatt   = 0;
   if (IKZRabatt = "1") then begin
      if (Stufe in (1,2)) then begin  /* Adress-Artikel */
         if (FAARabatt <> 0) then begin
            KzRabatt    = "F";
            Rabatt      = FAARabatt;
            FRabStaffel = 0;
         end
      end else begin       /* Rabattgruppen */
         if ((IAdressnr <> 0) and (IRabattGrp <> "")) then begin
            execute procedure GDI_GetRabatt IARTIKELNR,IADRESSNR,IRABATTGRP,IKZAKTION,IDATUM
               RETURNING_VALUES :Rabatt,:KZRabatt;
            if (KZRabatt <> "") then begin
               KZRabatt = "A" || KZRabatt;
               FRabStaffel = 0;
            end
         end
         if ((KZRabatt = "") and (IReferenz <> 0) and (IRabattGrp <> "")) then begin
            execute procedure GDI_GetRabatt IARTIKELNR,IReferenz,IRABATTGRP,IKZAKTION,IDATUM
               RETURNING_VALUES :Rabatt,:KZRabatt;
            if (KZRabatt <> "") then begin
               KZRabatt = "R" || KZRabatt;
               FRabStaffel = 0;
            end
         end
         if ((KZRabatt = "") and (IRabattlst <> 0)) then begin
            ZRabatt = null;
            select first 1 Rabatt from Rabatte
            where Satzart = "LG" and Liste = :IRabattLst and Gruppe = :IRabattGrp
            order by SatzArt, Liste, Gruppe, LfdNr
            into :ZRabatt;
            if (ZRabatt is not null) then begin
               KzRabatt = "G";
               Rabatt = ZRabatt;
               FRabStaffel = 0;
            end
         end
      end
      /* Rabattstaffel  */
      FRabattSt = 0;
      if (FRabStaffel <> 0) then begin
         FMenge = 0;
         Flag   = "";
         I = 0;
         select count(*) from Rabatte
         where SatzArt = "ST" and Liste = :FRabStaffel
         into :I;
         if (I > 0) then begin
            KzRabatt = "S";
            Flag     = "S";
         end
         if (I > 1) then begin
            KzRabatt = "s";
            Flag     = "s";
         end

         select first 1 Rabatt from Rabatte
         where SatzArt = "ST" and Liste = :FRabStaffel and Menge <= :IMenge
         order by Satzart,Liste,Menge desc
         into :FRabattSt;
         if (FRabattSt is null) then
            FRabattSt = 0;
         if (FRabattSt <> 0) then begin
            if (I > 1) then begin
               KzRabatt = "s";
               Flag     = "s";
            end
            else begin
               KzRabatt = "S";
               Flag     = "S";
            end
         end
      end
      if (KZRabatt <> "F") then begin
         if (Stufe in (1,2)) then begin
            Rabatt = FRabattst;
         end else begin
            Rabatt = Rabatt + FRabattst;
            if (KZRabatt = Flag) then begin
               Rabatt = Rabatt + IRabatt;
               if (IRabatt <> 0.0) then
                  KZRabatt = "KI" || KZRabatt;
            end
         end
      end
   end

   /*AdrArtRabatt*/
   if (Stufe in (1,2) and (AAFlag <> "A")) then begin
   /*/AdrArtRabatt*/
      select ISOWaehr, KZBrutto from Adrart
      where Adressnr = :IAdressnr and Artikelnr = :IArtikelnr
      into :Waehrung, :KZBrutto;
   end else if (IPreislst > 0) then begin
       select first 1 ISOWaehr, KZBRutto from Rabatte
       where Liste = :IPreislst and Satzart = "PL" and ISOWaehr <> ""
       into :Waehrung, :KZBrutto;
   end
   suspend;
end
--

create procedure GDI_BERATUNG
   (IArtikelnr    VarChar(50),
    IFiliale      Integer,
    IBasisfiliale Integer,
    IJahr         VarChar(4),
    IPreislst     SmallInt,
    IAdressnr     Integer,
    IRabattlst    SmallInt,
    IRabattgr     VarChar(10),
    IKzrabatt     Char(1),
    IRabatt       Double Precision,
    IMenge        Double Precision,
    IWaehrung     VarChar(3),
    IHauswaehrung VarChar(3),
    IKzBrutto     Char(1),
    IDienstpreis  Double Precision,
    IKalkEk       Double Precision,
    IKb_Akt       Double Precision,
    IArtPreispfl  Char(1),
    IKzLager      Char(1),
    ISteuerschl   SmallInt,
    IKzAl         Char(1),
    ILagerflag    Char(1),
    IAlflag       Char(1),
    IAdrArtflag   Char(1),
    IKzAktion     Char(1),
    IVar_EkVkLager VarChar(50),
    IVar_EkVk      VarChar(50),
    IVar_EkSpanne  VarChar(10))
returns
   (APreis         Double Precision,
    AEpreis        Double Precision,
    ARabatt        Double Precision,
    AGesamt        Double Precision,
    AServicepreis  Double Precision,
    AEkwert        Double Precision,
    AEkgesamt      Double Precision,
    AKzpreis       VarChar(3),
    AKzrabatt      VarChar(3),
    AKzPreisRabatt VarChar(20),
    AVbestand      Double Precision,
    ABestand       Double Precision,
    ABestmenge     Double Precision,
    AAuftMenge     Double Precision,
    ADek           Double Precision,
    ALek           Double Precision,
    AGek           Double Precision,
    ASpanne        Double Precision,
    ASpanneproz    Double Precision,
    AKb_akt        Double Precision,
    AKalkek        Double Precision)
as
   declare variable FMaterial Double Precision;
   declare variable FRabatt Double Precision;
   declare variable FWaehrung VarChar(3);
   declare variable FEK Double Precision;
   declare variable FKzPreis VarChar(3);
   declare variable FKzRabatt VarChar(3);
   declare variable FBestand Double Precision;
   declare variable FVBestand Double Precision;
   declare variable FAuftMenge Double Precision;
   declare variable FBestMenge Double Precision;
   declare variable TBestand Double Precision;
   declare variable TVBestand Double Precision;
   declare variable TAuftMenge Double Precision;
   declare variable TBestMenge Double Precision;
   declare variable FDEK Double Precision;
   declare variable FLEK Double Precision;
   declare variable FGEK Double Precision;
   declare variable TDEK Double Precision;
   declare variable TLEK Double Precision;
   declare variable TGEK Double Precision;
   declare variable FSteuersatz Double Precision;
   declare variable FHausWaehr VarChar(3);
   declare variable FGesamt Double Precision;
   declare variable FEKDef VarChar(10);
   declare variable S VarChar(50);
   declare variable S2 VarChar(10);
   declare variable i SmallInt;
   declare variable T Char(1);
   declare variable FAnzeigen Char(1);
   declare variable FDienstPreis Double Precision;
   declare variable FSpanne Double Precision;
   declare variable FWert Double Precision;
   declare variable FKzBrutto Char(1);
   declare variable FNettoMaterial Double Precision;
   declare variable FShowBestand Char(1);
begin
   APreis = 0;
   AEPreis = 0; ARabatt = 0; AGesamt = 0; AServicePreis =0;
   AEKWert = 0; AEKGesamt = 0; AKzPreis = ""; AKzRabatt = "";
   AKzPreisRabatt = ""; ASpanne = 0; ASpanneProz = 0; AKB_Akt = 0;
   AKalkEK = 0; ADEK = 0; ALEK = 0; AGEK = 0;
   ABestand = 0; AVBestand = 0; AAuftMenge = 0; ABestMenge = 0;

   /* Anzeige der Bestnde auch fr Nicht-Lagerartikel */
   select first 1 Copy(ListValue(M1,"LAGERTAB.NICHTLAGER"),1,1) from GDIDEF
   where Satzart = "FA1" into :FShowBestand;
   if (FShowBestand is null) then
      FShowBestand = "J";
   else
      FShowBestand = cast(FShowBestand as Char(1));

   /* Preise, Rabatt aus GDI_GetPreis */
   S = "";
   if (IArtPreisPfl is null) then
      S = :IVar_EkVkLager;
   else begin
      if      (IArtPreisPfl = "1") then S = "M";
      else if (IArtPreisPfl = "2") then S = "D";
      else if (IArtPreisPfl = "3") then S = "L";
      else if (IArtPreisPfl = "4") then S = "K";
      else if (IArtPreisPfl = "5") then S = "G";
      else begin
         if (IKzLager = "1") then
            S = :IVar_EkVkLager;
         else
            S = :IVar_EkVk;
      end
   end
   if ((S = "") or (S is null)) then
      S = "D,K,G,L,M";
   FEKDef = "";
   i  = 0;
   S2 = GetCommaPos(S,i);
   while (S2 <> "") do begin
      T = UpperCase(Copy(S2,1,1));
      if (T in ("K","G","L","D","M")) then
         FEkDef = FEkDef || T;
      i = i + 1;
      S2 = GetCommaPos(S,i);
   end

   FKzBrutto = "0";
   select material,rabatt,waehrung,ek,lek,dek,gek,
          kzpreis,kzrabatt,bestand,vbestand,auftrag,bestellt,kzbrutto
   from GDI_GetPreis(:IArtikelnr,:IPreisLst,:IAdressNr,0,:IRabattLst,:IRabattGr,
                     :IKzRabatt,:IRabatt,:IKZAktion,"NOW", :IMenge, :IJahr, :IFiliale, :FEkDef)
   into   :FMaterial,:FRabatt,:FWaehrung,:FEK,:FLEK,:FDEK,:FGEK,
          :FKzPreis,:FKzRabatt,:FBestand,:FVBestand,:FAuftMenge,:FBestMenge,:FKzBrutto;

   if (:IWaehrung <> :IHausWaehrung) then
      select awert from GDI_Waehrumrechnen(:FMaterial,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :FMaterial;

   if ((ISteuerSchl is null) or (ISteuerSchl < 1)) then
      ISteuerSchl = 1;

   FNettoMaterial = FMaterial;
   FSteuerSatz = 0;
   if ((IKzBrutto = "1") and (FKzBrutto <> "1")) then begin
      select first 1 StrToFloat(w1) from Gdidef where satzart = "ST" and w0=:ISteuerSchl
      into :FSteuerSatz;
      FMaterial = FMaterial * ((100 + FSteuerSatz) / 100);
   end
   else if ((IKzBrutto <> "1") and (FKzBrutto = "1")) then begin
      select first 1 StrToFloat(w1) from Gdidef where satzart = "ST" and w0=:ISteuerSchl
      into :FSteuerSatz;
      FMaterial = FMaterial / ((100 + FSteuerSatz) / 100);
      FNettoMaterial = FMaterial;
   end
   else if ((IKzBrutto = "1") and (FKzBrutto = "1")) then begin
      select first 1 StrToFloat(w1) from Gdidef where satzart = "ST" and w0=:ISteuerSchl
      into :FSteuerSatz;
      FNettoMaterial = FMaterial / ((100 + FSteuerSatz) / 100);
   end

   APreis = FMaterial;

   if (FRabatt <> 0) then begin
      FMaterial = FMaterial * (1 - (FRabatt / 100));
      FNettoMaterial = FNettoMaterial * (1 - (FRabatt / 100));
   end   

   FGesamt = FMaterial * IMenge;
   if (FGesamt is null) then
      FGesamt = 0;

   /* Dienstpreis ist bereis in Zielwhrung! */
   FDienstPreis = IDienstPreis;
   if (FRabatt <> 0) then
      FDienstPreis = FDienstPreis * (1 - (FRabatt / 100));

   AKB_Akt = IKB_Akt;
   AKalkEk = IKalkEk;
   if (:IWaehrung <> :IHausWaehrung) then begin
      select awert from GDI_Waehrumrechnen(:FLEK,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :FLEK;
      select awert from GDI_Waehrumrechnen(:FDEK,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :FDEK;
      select awert from GDI_Waehrumrechnen(:FGEK,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :FGEK;
      select awert from GDI_Waehrumrechnen(:IKB_Akt,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :AKB_Akt;
      select awert from GDI_Waehrumrechnen(:IKalkEk,-1,-1,"",:IWaehrung,:IHausWaehrung)
      into :AKalkEk;
   end

   FSpanne = FNettoMaterial;

   S = :IVar_EKSpanne;
   if ((S = "") or (S is null)) then
      S = "K";

   if      (S = "K") then FWert = AKalkEk;
   else if (S = "D") then FWert = FDEK;
   else if (S = "G") then FWert = FGEK;
   else if (S = "L") then FWert = FLEK;

   ASpanne = FSpanne - FWert;
   if (Abs(FSpanne) > 0.000001) then
      ASpanneProz = Runden((1 - (FWert / FSpanne)) * 100,2);
   if (ASpanne is null) then ASpanne = 0;
   if (ASpanneProz is null) then ASpanneProz = 0;

   if (FMaterial is null) then
      AEPreis = 0; else AEPreis = FMaterial;
   if (FRabatt is null) then
      ARabatt = 0; else ARabatt = FRabatt;
   if (FGesamt is null) then
      AGesamt = 0; else AGesamt = FGesamt;
   if (FGesamt + (FDienstPreis * IMenge) is null) then
      AServicePreis = 0; else AServicePreis = FGesamt + (FDienstPreis * IMenge);
   if (FEK is null) then
      AEKWert = 0; else AEKWert = FEK;
   if (FEK * IMenge is null) then
      AEKGesamt = 0; else AEKGesamt = FEK * IMenge;
   if (FKzPreis is null) then
      AKzPreis = ""; else AKzPreis = FKzPreis;
   if (FKzRabatt is null) then
      AKzRabatt = ""; else AKzRabatt = FKzRabatt;
   AKzPreisRabatt = IntToStr(IPreisLst) || AKzPreis || "/" || IntToStr(IRabattLst) || AKzRabatt;

   /* Bestandsanzeige Nicht-LagerArtikel */
   if ((FShowBestand <> "N") or (IKZLager = "1"))then begin
      if (FVBestand is null) then
         AVBestand = 0; else AVBestand = FVBestand;
      if (FBestand is null) then
         ABestand = 0; else ABestand = FBestand;
      if (FAuftMenge is null) then
         AAuftMenge = 0; else AAuftMenge = FAuftMenge;
      if (FBestMenge is null) then
         ABestMenge = 0; else ABestMenge = FBestMenge;
   end
   else begin
      AVBestand = 0;
      ABestand = 0;
      AAuftMenge = 0;
      ABestMenge = 0;
   end

   if (FDEK is null) then
      ADEK = 0;   else ADEK = FDEK;
   if (FLEK is null) then
      ALEK = 0;   else ALEK = FLEK;
   if (FGEK is null) then
      AGEK = 0;   else AGEK = FGEK;

   /* Filterung fr Anzeige */
   FAnzeigen = "0";
   if ((IAdrArtFlag = "1") and (Copy(FKzPreis,1,1) <> "A") ) then
      FAnzeigen = "0";
   else begin
      if (ILagerFlag = "1") then begin
         /* Nicht-Lagerartikel immer anzeigen */
         if (IKzLager <> "1") then begin
            FAnzeigen = "1";
         end
         else begin
            if (FVBestand > 0.00001) then
               FAnzeigen = "1";
         end
      end
      else begin
         if (IALFlag = "1") then begin
            FAnzeigen = "1";
         end
         else begin
            if (IKzAl = "1") then begin
               if (FVBestand > 0.00001) then
                  FAnzeigen = "1";
            end
            else begin
                FAnzeigen = "1";
            end
         end
      end
   end
   if (FAnzeigen = "0") then
      AEPreis = null;
   suspend;
end
--

create procedure GDI_ANSPRECH
   (IDatei     VarChar(255), IReferenz  VarChar(255), ISuchname  VarChar(255),
    IName1     VarChar(255), IName2     VarChar(255), IName3     VarChar(255),
    IStrasse   VarChar(255), ILand      VarChar(255), IPlz       VarChar(255),
    IOrt       VarChar(255), IProvinz   VarChar(255), IIsoA2Land VarChar(255),
    IPostfach  VarChar(255), IPLZpfach  VarChar(255), ITelefon   VarChar(255),
    IHandy     VarChar(255), ITelefax   VarChar(255), IEMail     VarChar(255),
    IHomepage  VarChar(255), IAendbed   VarChar(255), IAendDatum Date)
as
   declare variable FExists VarChar(10);
   declare variable FDatei VarChar(30);
   declare variable FReferenz VarChar(10);
   declare variable FSuchname VarChar(40);
   declare variable FName1 VarChar(40);
   declare variable FName2 VarChar(40);
   declare variable FName3 VarChar(40);
   declare variable FStrasse VarChar(40);
   declare variable FLand VarChar(3);
   declare variable FPlz VarChar(9);
   declare variable FOrt VarChar(30);
   declare variable FProvinz VarChar(2);
   declare variable FIsoA2Land VarChar(2);
   declare variable FPostfach VarChar(10);
   declare variable FPLZpfach VarChar(10);
   declare variable FTelefon VarChar(20);
   declare variable FHandy VarChar(20);
   declare variable FTelefax VarChar(20);
   declare variable FEMail VarChar(255);
   declare variable FHomepage VarChar(50);
   declare variable FAendbed   VarChar(5);
   declare variable FAendDatum Date;
   declare variable FSortNr Integer;
begin
   FDatei     = cast(Copy(:IDatei,1,30) as VarChar(30));
   FReferenz  = cast(Copy(:IReferenz,1,10) as VarChar(10));
   FSuchname  = cast(Copy(:ISuchname,1,40) as VarChar(40));
   FName1     = cast(Copy(:IName1,1,40) as VarChar(40));
   FName2     = cast(Copy(:IName2,1,40) as VarChar(40));
   FName3     = cast(Copy(:IName3,1,40) as VarChar(40));
   FStrasse   = cast(Copy(:IStrasse,1,40) as VarChar(40));
   FLand      = cast(Copy(:ILand,1,3) as VarChar(3));
   FPlz       = cast(Copy(:IPLZ,1,9) as VarChar(9));
   FOrt       = cast(Copy(:IOrt,1,30) as VarChar(30));
   FProvinz   = cast(Copy(:IProvinz,1, 2) as VarChar(2));
   FIsoA2Land = cast(Copy(:IIsoA2Land,1,2) as VarChar(2));
   FPostfach  = cast(Copy(:IPostfach,1,10) as VarChar(10));
   FPLZpfach  = cast(Copy(:IPLZpfach,1,10) as VarChar(10));
   FTelefon   = cast(Copy(:ITelefon,1,20) as VarChar(20));
   FHandy     = cast(Copy(:IHandy,1,20) as VarChar(20));
   FTelefax   = cast(Copy(:ITelefax,1,20) as VarChar(20));
   FEMail     = cast(Copy(:IEMail,1,255) as VarChar(255));
   FHomepage  = cast(Copy(:IHomepage,1,50) as VarChar(50));
   FAendBed   = cast(Copy(:IAendBed,1,5) as VarChar(5));
   FAendDatum = IAendDatum;
   FSortNr    = 0;

    select Referenz,SortNr from Ansprech
    where Datei = :FDatei and Referenz = :FReferenz and lfdnr = 0
    into :FExists,:FSortNr;
    if (FSortNr is null) then
       FSortNr = 0;
    if (FExists is null) then begin
       insert into Ansprech
              (datei,referenz,lfdnr,suchname,name1,name2,name3,
               strasse,land,plz,ort,provinz,isoa2land,Postfach,PLZpfach,
               Telefon, Handy,Telefax,EMail,Homepage,aendbed,AendDatum,SortNr)
       values (:FDatei,:FReferenz,0,:FSuchname,:FName1,:FName2,:FName3,
               :FStrasse,:FLand,:FPLZ,:FOrt,:FProvinz,:FIsoa2land,:FPostfach,:FPLZpfach,
               :FTelefon,:FHandy,:FTelefax,:FEMail,:FHomepage,:FAendBed,:FAendDatum,:FSortNr);
    end else begin
       update ansprech
       set suchname  = :FSuchname,  name1     = :FName1,    name2     = :FName2,
           name3     = :FName3,     strasse   = :FStrasse,  land      = :FLand,
           plz       = :FPLZ,       ort       = :FOrt,      provinz   = :FProvinz,
           isoa2land = :FIsoA2Land, Postfach  = :FPostfach, PLZpfach  = :FPLZpfach,
           Telefon   = :FTelefon,   Handy     = :FHandy,    Telefax   = :FTelefax,
           EMail     = :FEMail,     Homepage  = :FHomepage, aendbed   = :FAendBed,
           AendDatum = :FAendDatum, SortNr    = :FSortNr
       where datei = :FDatei and referenz = :FReferenz and lfdnr = 0;
    end
end
--

create procedure GDI_STUCKBERECHNUNG
   (IStuck VarChar(50), IArtikelnr VarChar(50), IPosnr      SmallInt,
    ILevel Integer,     ILfdnr     Integer,     ISperrmodus SmallInt,
    IJahr  VarChar(4),  IFiliale   Integer,     IBediener   VarChar(5),
    IEkdef VarChar(10), IUpdate    Char(1),     IMenge      Double Precision)
returns
   (ASatzart       Char(1),
    AStuck         VarChar(50),
    AArtikelnr     VarChar(50),
    APosnr         Integer,
    ALevel         Integer,
    ALfdnr         Integer,
    ASperrmodus    SmallInt,
    AText          VarChar(255),
    ATextNeu       VarChar(255),
    AMenge         Double Precision,
    AEkwert        Double Precision,
    AEkwertneu     Double Precision,
    AAufproz       Double Precision,
    AAufschlag     Double Precision,
    AAufschlagneu  Double Precision,
    AMefaktor      Double Precision,
    AMefaktorneu   Double Precision,
    AMengeneinh    Double Precision,
    AMengeneinhneu Double Precision,
    AGesamt        Double Precision,
    AGesamtneu     Double Precision,
    AKzart         Char(1),
    AKzartneu      Char(1),
    AKzbaugrp      Char(1),
    AKzbaugrpneu   Char(1),
    AAuffert       Double Precision,
    AAuffertneu    Double Precision,
    AAufmat        Double Precision,
    AAufmatneu     Double Precision,
    AFertzeit      Double Precision,
    AVorlzeit      Double Precision,
    AKorrflag      Char(1))
as
   declare variable FArtikelnr VarChar(50);
   declare variable FFaktor Float;
   declare variable FOperator Char(1);
   declare variable FSumGesamtNeu Double Precision;
   declare variable FSumAufFertNeu Double Precision;
   declare variable FSumAufMatNeu Double Precision;
   declare variable FSumFertZeit Double Precision;
   declare variable FSumVorlZeit Double Precision;
   declare variable TmpEkWert Double Precision;
   declare variable TmpAufschlag Double Precision;
   declare variable TmpKzArt Char(1);
   declare variable TmpKzBauGrp Char(1);
   declare variable TmpMengenEinh Double Precision;
   declare variable TmpMeFaktor Double Precision;
   declare variable TmpGesamt Double Precision;
   declare variable TmpAufFert Double Precision;
   declare variable TmpAufMat Double Precision;
   declare variable FNK Integer;
   declare variable FMenge Double precision;
   declare variable FPreisMEFaktor Double precision;
   declare variable FKzEk Char(1);
   declare variable FArtTextNeu VarChar(255);
begin
   if ((ILevel > 10) or (ILfdnr > 10000)) then
      exit;
   FNK = null;
   select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNK;
   if ((FNK is null) or (FNK = 0)) then
      FNK = 2;
   ILfdnr = ILfdnr +1;
   AKorrFlag = "";
   /* Oberteil ausgeben */
   ASatzart       = "O";          AStuck         = IArtikelnr;
   AArtikelnr     = "";           APosnr         = IPosNr;
   ALevel         = ILevel;       ALfdNr         = ILfdNr;

   /* Text aus Artikelstamm oder Stuck holen */
   AText = "";
   if ((IStuck <> "")     and (IStuck     is not null)  and
       (IArtikelnr <> "") and (IArtikelnr is not null)) then begin
      select Text from stuck where stuckl = :IStuck and artikelnr = :IArtikelnr and posnr = :IPosNr
      into :AText;
   end else begin
      select arttext from artikel where artikelnr = :IArtikelnr
      into :AText;
   end
   ATextNeu = AText;

   AMenge         = IMenge;
   AEKWert        = 0;            AEKWertNeu     = 0;
   AAufProz       = 0;            AAufschlag     = 0;
   AAufschlagNeu  = 0;            AMeFaktor      = 0;
   AMeFaktorNeu   = 0;            AMengenEinh    = 0;
   AMengenEinhNeu = 0;            AGesamt        = 0;
   AGesamtNeu     = 0;            AKzArt         = "";
   AKzArtNeu      = "";           AKzBaugrp      = "P";
   AKzBaugrpNeu   = "P";          AAufFert       = 0;
   AAufFertNeu    = 0;            AAufMat        = 0;
   AAufMatNeu     = 0;            AFertZeit      = 0;
   AVorlZeit      = 0;
   suspend;
   ILevel = ILevel +1;
   FSumGesamtNeu  = 0;
   FSumAufFertNeu = 0;
   FSumAufMatNeu  = 0;
   FSumFertZeit   = 0;
   FSumVorlZeit   = 0;
   for select stuckl,Artikelnr,posnr,text,menge,ekwert,aufproz,aufschlag,kzart,kzbaugrp,
              mengeneinh,mefaktor,fertzeit,vorlzeit,gesamt,auffert,aufmat
   from       stuck
   where      stuckl = :AStuck and Satzart = "P"
   order by   satzart,stuckl,posnr
   into       :AStuck,:FArtikelnr,:APosNr,:AText,:AMenge,:AEkWert,:AAufProz,:AAufschlag,:AKZArt,:AKzBauGrp,
              :AMengenEinh,:AMeFaktor,:AFertZeit,:AVorlZeit,:AGesamt,:AAufFert,:AAufMat
   do begin
      if (Abs(AMEFaktor) < 0.000001) then
         AMEFaktor = 1;
      /* Sperrmodus der Stckliste */
      if (ISperrModus <> 1) then begin
         select sperrmodus
         from stuck
         where satzart = "S" and stuckl= :AStuck and posnr = 0
         into :ISperrModus;
      end

      /* Prfen, ob Unterteil noch eine Baugruppe ist */
      select kzStueck
      from artikel
      where artikelnr = :FArtikelnr
      into AKzBauGrp;

      /* Stckliste? --> weiter auflsen! */
      if (AKzBauGrp = "P") then begin
         FMenge = AMenge;
         for select ASatzart, AStuck, AArtikelnr, APosnr, ALevel, ALfdNr, ASperrModus,
                    AText,ATextNeu, AMenge, AEKWert, AEKWertNeu,AAufProz,
                    AAufschlag,AAufschlagNeu, AMEFaktor, AMEFaktorNeu,
                    AMengenEinh,AMengenEinhNeu,AGesamt,AGesamtNeu,AKzArt,AKzArtNeu,
                    AKzBauGrp,AKzBauGrpNeu, AAufFert,AAufFertNeu,AAufMat,AAufMatNeu,
                    AFertZeit,AVorlZeit, AKorrFlag
         from       GDI_STUCKBERECHNUNG (:AStuck, :FArtikelnr,:APosNr, :ILevel, :ILfdNr, :ISperrModus, :IJahr, :IFiliale, :IBediener, :IEkDef, :IUpdate,:AMenge)
         into       :ASatzart, :AStuck, :AArtikelnr, :APosnr, :ALevel, :ALfdNr, :ASperrModus,
                    :AText, :ATextNeu, :AMenge, :AEKWert, :AEKWertNeu,:AAufProz,
                    :AAufschlag,:AAufschlagNeu, :AMEFaktor, :AMEFaktorNeu,
                    :AMengenEinh,:AMengenEinhNeu,:AGesamt,:AGesamtNeu,:AKzArt,:AKzArtNeu,
                    :AKzBauGrp,:AKzBauGrpNeu, :AAufFert,:AAufFertNeu,:AAufMat,:AAufMatNeu,
                    :AFertZeit,:AVorlZeit, :AKorrFlag
         do begin
            if (AStuck = IArtikelNr) then begin
               Ilfdnr = ALfdnr;
               FSumGesamtNeu = FSumGesamtNeu + AGesamtNeu;
               if (AKzArtNeu = "F") then begin
                  FSumAufFertNeu = FSumAufFertNeu + AAufschlagNeu;
               end
               else if (AKzArtNeu = "M") then begin
                  FSumAufMatNeu = FSumAufMatNeu + AAufschlagNeu;
               end
               FSumFertZeit = FSumFertZeit + AFertZeit;
               FSumVorlZeit = FSumVorlZeit + AVorlZeit;
            end
            suspend;
         end
      end
      /* Artikelposition */
      else begin
         ASatzart = "";
         if (IFiliale >= -1) then begin
            select ek, mefaktor, kzek from GDI_GETPREIS (:FArtikelnr,0,0,0,0,"","",0,"","NOW",0,
                                                         :IJahr,:IFiliale,:IEkDef)
            into  :AEKWertNeu, FPreisMEFaktor, FKzEk;
            if (AEKWertNeu is null) then
                AEKWertNeu = 0;
            if (Abs(FPreisMEFaktor) < 0.000001) then
               FPreisMEFaktor = 1;
            /* Bei allen EK-Quellen auer KalkEk : Rckrechnung des ME-Faktors!!! */
            if (FKzEK <> "K") then
               AEKWertNeu = Runden(AEKWertNeu * FPreisMEFaktor, FNK);
         end
         else
            AEKWertNeu = 0;

         ILfdnr = ILfdnr +1;
         AArtikelnr = FArtikelnr;
         ALevel = ILevel;
         ALfdNr = ILfdNr;
         /* Werte aus dem Artikel holen */
         select MeFaktor, MeVk, KzArt, KzStueck, ArtText
         from Artikel
         where Artikelnr = :FArtikelnr
         into :AMEFaktorNeu,:AMengenEinhNeu, :AKzArtNeu, :AKzBauGrpNeu, :FArtTextNeu;
         if (Abs(AMEFaktorNeu) < 0.000001) then
            AMEFaktorNeu = 1;
         AAufschlagNeu = Runden( AMenge * AEKWertNeu / AMEFaktorNeu * AAufProz / 100, FNK);
         /* GesamtPreis neu berechnen */
         AGesamtNeu = AEKWertNeu;
         /* Mengeneinheit verrechnen */
         AMengenEinhNeu = AMengenEinh;
         if (AMengenEinhNeu <> 0) then begin
            FFaktor = 0;
            FOperator = "";
            select first 1 StrToFloat(W2) , W1 from gdidef
            where satzart = "ME" and W0 = :AMengenEinhNeu
            into FFaktor, FOperator;
            if (FFaktor <> 0) then begin
               if  (FOperator = "*") then begin
                  AGesamtNeu = AGesamtNeu * FFaktor;
               end
               else if (FOperator = "/") then begin
                  AGesamtNeu = AGesamtNeu / FFaktor;
               end
            end
         end
         AGesamtNeu = Runden((AMenge * AGesamtNeu / AMEFaktorNeu)+ AAufschlagNeu,FNK);
         FSumGesamtNeu = FSumGesamtNeu + AGesamtNeu;
         if (AKzArtNeu = "F") then begin
            FSumAufFertNeu = FSumAufFertNeu + AAufschlagNeu;
         end
         else if (AKzArtNeu = "M") then begin
            FSumAufMatNeu = FSumAufMatNeu + AAufschlagNeu;
         end
         FSumFertZeit = FSumFertZeit + AFertZeit;
         FSumVorlZeit = FSumVorlZeit + AVorlZeit;
         AKorrFlag = "";
         if (ISperrModus <> 1) then begin

            if (IUpdate in ("2", "3")) then begin
               ATextNeu = FArtTextNeu;
            end
            else begin
               ATextNeu = AText;
            end

            /* Aktualisieren der Stckliste? */
            if (IUpdate in ("1", "3")) then begin
               select ekwert,aufschlag,kzart,kzbaugrp,mengeneinh,mefaktor,gesamt,text
               from stuck
               where satzart = "P" and stuckl= :AStuck and
                     Artikelnr= :FArtikelnr and posnr = :APosNr
               into :TmpEkWert,:TmpAufschlag,:TmpKzArt,:TmpKzBaugrp,:TmpMengeneinh,:TmpMefaktor,:TmpGesamt,:AText;
               if ((TmpEkWert <> AEkWertNeu) or
                  (TmpAufschlag  <> AAufschlagNeu) or
                  (TmpKzArt  <> AKzArtNeu) or
                  (TmpKzBaugrp  <> AKzBauGrpNeu) or
                  (TmpMengeneinh  <> AMengenEinhNeu) or
                  (TmpMefaktor  <> AMeFaktorNeu) or
                  (TmpGesamt <> AGesamtNeu) or
                  (AText <> ATextNeu)) then begin
                  update stuck set
                     ekwert = :AEKWertNeu, aufschlag = :AAufschlagNeu, kzart = :AKzArtNeu,
                     kzbaugrp = :AKzBauGrpNeu, mengeneinh = :AMengenEinhNeu,
                     mefaktor = :AMeFaktorNeu, gesamt = :AGesamtNeu,
                     text = :ATextNeu, aenddatum = "now", aendbed = :IBediener
                  where satzart = "P" and stuckl= :AStuck and
                        Artikelnr= :FArtikelnr and posnr = :APosNr;
                  AKorrFlag = "1";
               end
            end
         end
         ASperrModus = ISperrModus;
         suspend;
      end
   end
/* Summenzeile ausgeben */
/* Altwerte aus Stuck holen */
   if ((IStuck <> "") and (IStuck is not null)) then begin
      select text,menge,aufschlag,aufproz,ekwert,gesamt,auffert,aufmat,fertzeit,vorlzeit,mengeneinh,mefaktor
      from stuck
      where satzart = "P" and stuckl = :IStuck and posnr = :IPosNr and Artikelnr = :IArtikelnr
      into  :AText,:AMenge,:AAufschlag,:AAufProz, :AEkWert,:AGesamt, :AAufFert, :AAufMat, :AFertZeit,:AVorlZeit,:AMengenEinh,:AMeFaktor;
   end
   else begin
      AText = "";
      AMenge = 0;
      AEkWert =0;
      AGesamt =0;
      AAufFert=0;
      AAufMat=0;
      AFertZeit=0;
      AVorlZeit=0;
   end
   ASatzart     = "S";
   AStuck       = IStuck;
   AArtikelnr   = IArtikelnr;
   APosNr       = IPosNr;
   ALevel       = ILevel;
   ALfdNr       = ILfdNr;
   if ((AMeFaktor is null) or (Abs(AMEFaktor) < 0.000001)) then
      AMeFaktor = 1;
   AGesamtNeu   = FSumGesamtNeu;
   if (AMengenEinh <> 0) then begin
      FFaktor = 0;
      FOperator = "";
      select first 1 StrToFloat(W2) , W1 from gdidef
      where satzart = "ME" and W0 = :AMengenEinh
      into FFaktor, FOperator;
      if (FFaktor <> 0) then begin
         if  (FOperator = "*") then begin
            AGesamtNeu = AGesamtNeu * FFaktor;
         end
         else if (FOperator = "/") then begin
            AGesamtNeu = AGesamtNeu / FFaktor;
         end
      end
   end
   AAufschlagNeu = Runden(AMenge * AGesamtNeu / AMEFaktor * AAufProz / 100, FNK);
   AGesamtNeu = Runden((AMenge * AGesamtNeu / AMEFaktor)+ AAufschlagNeu,FNK);
   AMengenEinhNeu = AMengenEinh;
   AEKWertNeu     = FSumGesamtNeu;
   AAufFertNeu    = FSumAufFertNeu;
   AAufMatNeu     = FSumAufMatNeu;
   AMeFaktorNeu   = AMeFaktor;
   AKorrFlag      = "";
   select kzstueck, arttext from artikel where artikelnr = :IArtikelnr
      into AKzBauGrpNeu, :FArtTextNeu;

   select ekwert,gesamt,auffert,aufmat,kzbaugrp
   from  stuck
   where satzart = "P" and stuckl= :IStuck and
         Artikelnr= :IArtikelnr and posnr = :IPosNr
   into :TmpEkWert,:TmpGesamt,:TmpAufFert,:TmpAufMat,:TmpKzBauGrp;
   AKzBauGrp = TmpKzBauGrp;

   if (IUpdate in ("2", "3")) then begin
      ATextNeu = FArtTextNeu;
   end
   else begin
      ATextNeu = AText;
   end

/* Aktualisieren der Stckliste */
   if ((ISperrModus <> 1) and (IUpdate in ("1","3")) and (IStuck <> "") and (IStuck is not null)) then begin
      if ((TmpEkWert   <> AEkWertNeu)   or
          (TmpGesamt   <> AGesamtNeu)   or
          (TmpAufFert  <> AAufFertNeu)  or
          (TmpAufMat   <> AAufMatNeu)   or
          (TmpKzBauGrp <> AKzBauGrpNeu) or
          (AText       <> ATextNeu))    then begin
         update stuck
         set    ekwert = :aekwertneu, gesamt = :agesamtneu, auffert = :aauffertneu, aufmat = :aaufmatneu,
                aufschlag = :aaufschlagneu, kzbaugrp = :akzbaugrpneu, text = :AText
         where  satzart = "P" and stuckl= :IStuck and
                Artikelnr= :IArtikelnr and posnr = :IPosnr;
         AKorrFlag = "1";
      end
   end
   suspend;
end
--

create procedure GDI_STUCKSUMME
   (IStuckl VarChar(50),IBediener VarChar(10),ISatzArt Char(1))
as
   declare variable FKzArt      VarChar(10);
   declare variable FKzBauGrp   VarChar(10);
   declare variable FEKWert     Double Precision;
   declare variable FAufSchlag  Double Precision;
   declare variable FFertZeit   Double Precision;
   declare variable FVorlZeit   Double Precision;
   declare variable FGesamt     Double Precision;
   declare variable FAufFert    Double Precision;
   declare variable FAufMat     Double Precision;
   declare variable FMeFaktor   Double Precision;
   declare variable FMenge      Double Precision;
   declare variable SEKWert     Double Precision;
   declare variable SAufSchlag  Double Precision;
   declare variable SFertZeit   Double Precision;
   declare variable SVorlZeit   Double Precision;
   declare variable SGesamt     Double Precision;
   declare variable SAufFert    Double Precision;
   declare variable SAufMat     Double Precision;
   declare variable SAufProz    Double Precision;
   declare variable AMeFaktor   Double Precision;
   declare variable AKZStueck   VarChar(10);
   declare variable AKzArt      VarChar(10);
   declare variable FAnzahl     Integer;
   declare variable FAnzArt     Integer;
   declare variable FNK         Integer;
begin
   if (gen_id(Buchen_disabled, 0) = 1) then
      exit;
   select Count(*) AnzArt from Artikel
   where  Artikelnr = :IStuckl
   into   :FAnzArt;
   if (FAnzArt = 0) then begin
      select Count(*) Anzahl from Stuck
      where  Stuckl = :IStuckl
      into   :FAnzahl;
      if (FAnzahl > 0) then
         delete from Stuck where Stuckl = :IStuckl;
   end else begin
      FNK = null;
      select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :FNK;
      if ((FNK is null) or (FNK = 0)) then
           FNK = 2;
      AKZStueck = "";
      AKZArt    = "";
      AMEFaktor = 1;
      select KZSTUECK,KZART,MEFAKTOR from Artikel
      where  Artikelnr = :IStuckl
      into   :AKZStueck,:AKZArt,:AMeFaktor;
      if (AKZStueck is null) then
         AKZStueck = "";
      if (AKZArt is null) then
         AKZArt = "";
      if (ISatzArt <> "S") then begin
         SAufSchlag = 0.0;
         SEKWert    = 0.0;
         SFertZeit  = 0.0;
         SVorlZeit  = 0.0;
         SGesamt    = 0.0;
         SAufFert   = 0.0;
         SAufMat    = 0.0;
         for select EKWert,MEFAKTOR,AUFSCHLAG,KZART,KZBAUGRP,FERTZEIT,
                    VORLZEIT,GESAMT,AUFFERT,AUFMAT,MENGE
             from   Stuck
             where  Stuckl = :IStuckl and Satzart = "P"
             into   :FEkWert,:FMEFaktor,:FAufSchlag,:FKzArt,:FKzBauGrp,:FFertZeit,
                    :FVorlZeit,:FGesamt,:FAufFert,:FAufMat,:FMenge
         do begin
            if (FKzArt = "F") then
               SAufFert = SAufFert + FAufSchlag;
            else
               SAufMat = SAufMat + FAufschlag;
            if (FMEFaktor = 0.0) then
               FMEFaktor = 1.0;
            SEKWert    = SEKWert    + FEKWert * FMenge / FMEFaktor;
            SAufSchlag = SAufSchlag + FAufschlag;
            SFertZeit  = SFertZeit  + FFertZeit;
            SVorlZeit  = SVorlZeit  + FVorlZeit;
            SGesamt    = SGesamt    + FGesamt;
         end
         SAufSchlag = Runden(SAufSchlag,FNK);
         SEKWert    = Runden(SEKWert   ,FNK);
         SFertZeit  = Runden(SFertZeit ,FNK);
         SVorlZeit  = Runden(SVorlZeit ,FNK);
         SGesamt    = Runden(SGesamt   ,FNK);
         SAufFert   = Runden(SAufFert  ,FNK);
         SAufMat    = Runden(SAufMat   ,FNK);
         if (SEKWert <> 0.0) then
            SAufProz = runden(SAufSchlag / SEKWert,2);
         else
            SAufProz = 0.0;
         select Count(*) Anzahl from Stuck
         where  Stuckl = :IStuckl and Satzart = "S"
         into   :FAnzahl;
         if (FAnzahl = 0) then begin
            insert into Stuck (Satzart,Stuckl,EKWert,Aufschlag,KzArt,KzBauGrp,FertZeit,
                               MeFaktor,Vorlzeit,Gesamt,AufFert,AufMat,AendDatum,AendBed)
            values ("S",:IStuckl,:SEKWert,:SAufschlag,:AKzArt,:AKZStueck,:SFertZeit,
                    :AMeFaktor,:SVorlZeit,:SGesamt,:SAufFert,:SAufMat,"now",:IBediener);
         end else begin
            select EKWert,Aufschlag,KzArt,KzBauGrp,FertZeit,MeFaktor,VorlZeit,Gesamt,AufFert,AufMat
            from   Stuck
            where  stuckl = :IStuckl and satzart = "S"
            into   :FEkWert,:FAufschlag,:FKzArt,:FKzBauGrp,:FFertZeit,:FMeFaktor,:FVorlZeit,:FGesamt,
                   :FAufFert,:FAufMat;
            if ((FEkWert <> SEkWert) or (FAufschlag <> SAufSchlag) or (FKzArt <> AKzArt) or
                (FKzBauGrp <> AKZStueck) or (FFertZeit <> SFertZeit) or (FMefaktor <> AMefaktor) or
                (FVorlZeit <> SVorlZeit) or (FGesamt <> SGesamt) or (FAufFert <> SAufFert) or
                (FAufMat <> SAufMat)) then begin
               update Stuck
               set    Satzart   = "S",         Stuckl   = :IStuckl,   EKWert   = :SEKWert,
                      Aufschlag = :SAufSchlag, KzArt    = :AKzArt,    /* KzBauGrp = :AKZStueck, */
                      FertZeit  = :SFertZeit,  MeFaktor = :AMefaktor, VorlZeit = :SVorlZeit,
                      Gesamt    = :SGesamt,    AufFert  = :SAufFert,  AufMat   = :SAufMat,
                      AendDatum = "now",       AendBed  = :IBediener
               where  stuckl = :IStuckl and satzart = "S";
            end
         end
      end
   end
end
--

create procedure GDI_BESTANDWERT
   (IGJahr Date, IBis Date, IArtikelnr VarChar(50), IFiliale Integer)
returns
   (AFiliale Integer,
    AMenge   Double Precision,
    AWert    Double Precision)
as
   declare variable FMenge Double Precision;
   declare variable FWert Double Precision;
   declare variable FBelegTyp Char(1);
   declare variable FBelegArt Char(5);
   declare variable FPosart Char(5);
   declare variable FJahr Char(4);
   declare variable FGJahr Date;
   declare variable FVon Date;
   declare variable FInvDatum Date;
   declare variable FInvMenge Double Precision;
   declare variable FDMengeAlt Double Precision;
   declare variable FDWertAlt  Double Precision;
   declare variable FSumMenge Double Precision;
   declare variable FSumWert  Double Precision;
begin
   if ((IGJahr is null) or (IBis is null) or (IArtikelnr is null)) then
      exit;
   if (IGJahr <= IBis) then
      FGJahr = IGJahr;
   else
      FGJahr = cast(cast(extract(Day from IGJahr) as Char(2)) || "." ||
               cast(extract(Month from IGJahr) as Char(2)) || "." ||
               cast(extract(Year from IBis) as Char(4)) as Date);

   FSumMenge = 0;
   FSumWert  = 0;
   FJahr = cast(extract(Year from :FGJahr) as Char(4));
   for select Filiale, InvmngAnf, InvMenge, InvDatum, DMengeAlt, DWertAlt
      from ARUmsatz Where Artikelnr = :IArtikelnr and (Filiale = :IFiliale
      or -1 = :IFiliale) and Jahr = :FJahr
      order by Artikelnr, Jahr, Filiale
      into :AFiliale, :AMenge, :FInvMenge, :FInvDatum, :FDMengeAlt, :FDWertAlt
      do begin
      AWert = 0;

      if (FInvDatum is null) then
         FVon = FGJahr;
      else begin
         if (FInvDatum < IBIS) then begin
            FVon = FInvDatum;
            AMenge = FInvMenge;
         end
         else
            FVon = FGJahr;
      end

      /* Summiere Abgaenge als Menge*/
      for select BelegTyp, BelegArt, PosArt, Lagerme from BelegPos
         where Artikelnr = :IArtikelnr and Filiale = :AFiliale and
         Datumme >= :FVon and Datumme < :IBis +1 and
         (BelegTyp = "L" or BelegArt in ("LI","RL","RE","GU","MA","FU")) and
         (Posart <> "I" or (Posart is Null)) and
         ((not (kzdruck in ("%","A","C","T","t","P","S","E","W"))) or (kzdruck is null))
         order by Artikelnr, Filiale, Datumme
      into :FBelegTyp, :FBelegArt, :FPosArt, :FMenge do begin
         if (FBelegTyp = "V") then begin
            if (FBelegArt in ("RE","MA","LI","FU")) then
               AMenge = AMenge - FMenge;
            else
               AMenge = AMenge + FMenge;
         end
         else if (FBelegTyp = "E") then begin
            if (FBelegArt in ("GU","RL")) then
               AMenge = AMenge - FMenge;
         end
         else if (FBelegTyp = "L") then begin
            if (FPosart = "A") then
               AMenge = AMenge - FMenge;
            if (FPosart = "K") then
               AMenge = AMenge + FMenge; /* wie Einkauf ohne Wert */
         end
      end

      /* wenn InvAnfMenge > als Abgang ist, Wert aus durchsch EK*/
      if ((AMenge > 0) and (FDMengeAlt <> 0)) then
         AWert = AMenge * (FDWertAlt / FDMengeAlt);
      if ((AMenge > 0) and (AWert = 0)) then
         FDMengeAlt = AMenge; /*Merke Menge ohne Preis*/
      else
         FDMengeAlt = 0;

      /* Zugang dazurechnen bis Menge > 0 und EKPreis merken*/
      for select BelegTyp, BelegArt, Lagerme, EKGesamt from BelegPos
         where Artikelnr = :IArtikelnr and Filiale = :AFiliale and
         Datumme >= :FVon and Datumme < :IBis +1 and
         ((BelegTyp = "E" and BelegArt in ("RE","MA","LI","FU")) or
          (BelegTyp = "L" and Posart = "Z"))
         order by Artikelnr, Filiale, Datumme
      into :FBelegTyp, :FBelegArt, :FMenge, :FWert do begin
         if (AMenge > 0) then begin
            AMenge = AMenge + FMenge;
            AWert = AWert + FWert;
         end
         else begin
            AMenge = AMenge + FMenge;
            if ((AMenge > 0) and (FMenge <> 0)) then
               AWert = AMenge * (FWert/FMenge);
         end
         if ((AMenge > 0) and (FDMengeAlt <> 0) and (FMenge <> 0)) then begin
            AWert = AWert + (FDMengeAlt * (FWert/FMenge));
            FDMengeAlt = 0;
         end
      end
      FSumWert = FSumWert + AWert;
      FSumMenge = FSumMenge + AMenge;
   end
   AMenge = FSumMenge;
   if (AMenge = 0) then
      AWert = 0;
   else
      AWert  = FSumWert;
   suspend;
end
--

create procedure GDI_BELEGADRUPD
   (Typ Char(1), Art VarChar(5), IBelegNr Integer, IAdressNr Integer)
returns
   (Errmsg Integer)
as
   declare variable SatzUUID VarChar(40);
   declare variable FNr Integer;
   declare variable VonDebitor Integer;
   declare variable BisDebitor Integer;
   declare variable VonKreditor Integer;
   declare variable BisKreditor Integer;
   declare variable AdrUUID VarChar(40);
   declare variable Suchname VarChar(40);
   declare variable Name1 VarChar(60);
   declare variable Name2 VarChar(60);
   declare variable Name3 VarChar(60);
   declare variable Strasse VarChar(60);
   declare variable Land VarChar(10);
   declare variable Plz VarChar(10);
   declare variable Ort VarChar(50);
   declare variable Provinz VarChar(2);
   declare variable ISOA2Land VarChar(3);
   declare variable PLZpfach VarChar(60);
   declare variable Postfach VarChar(60);
   declare variable Telefax VarChar(60);
   declare variable Telefon VarChar(60);
   declare variable Bank VarChar(60);
   declare variable Blz VarChar(60);
   declare variable KontoNr VarChar(60);
   declare variable Sprache SmallInt;
   declare variable AdressGrp VarChar(6);
   declare variable UstIDNr VarChar(40);
   declare variable SteuerNr VarChar(40);
   declare variable Rabatt DOUBLE PRECISION;
   declare variable Referenz Integer;
   declare variable SktProz1 DOUBLE PRECISION;
   declare variable SktProz2 DOUBLE PRECISION;
   declare variable SktTag1 SmallInt;
   declare variable SktTag2 SmallInt;
   declare variable NettoTag SmallInt;
   declare variable ZahlZiel SmallInt;
   declare variable KzAdrArt char(1);
   declare variable Steuerber char(1);
   declare variable Bemerkung VarChar(255);
   declare variable VtNr Integer;
   declare variable ProvProz DOUBLE PRECISION;
   declare variable Preislst SmallInt;
   declare variable Rabattlst SmallInt;
   declare variable LieferNr Integer;
   declare variable VersndArt SmallInt;
   declare variable ZahlArt SmallInt;
   declare variable Steuerschl SmallInt;
   declare variable FLiefAdrAlt VarChar(10);
   declare variable L_ADRUUID VarChar(40);
   declare variable L_NAME1 VarChar(60);
   declare variable L_NAME2 VarChar(60);
   declare variable L_NAME3 VarChar(60);
   declare variable L_STRASSE VarChar(60);
   declare variable L_Land VarChar(10);
   declare variable L_Plz VarChar(10);
   declare variable L_ORT VarChar(50);
   declare variable L_Provinz VarChar(2);
   declare variable L_ISOA2Land VarChar(3);
   declare variable KZNetto char(1);
   declare variable ISOWaehr VarChar(3);
   declare variable WaehrBez VarChar(4);
   declare variable WaehrFakt DOUBLE PRECISION;
   declare variable WaehrNk SmallInt;
   declare variable LFKDNr VarChar(20);
   declare variable Temp VarChar(255);
   declare variable BelegDat Date;
begin
   select SatzUUID,BelegNr,BelegDat from Beleg
   where  BelegTyp = :Typ and Belegart = :Art and BelegNr = :IBelegNr
   into   :SatzUUID, :FNr, :BelegDat;
   if (FNr <> IBelegNr) then begin
      Errmsg = -1;
      suspend;
      exit;
   end
   select first 1 cast(StrToInt(w1) as Integer), cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer), cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "FA3"
   into   :VonDebitor, :BisDebitor, :VonKreditor, :BisKreditor;
   if ((IAdressNr >= VonDebitor) and (IAdressNr <= BisDebitor)) then begin
      select AdrUUID,Suchname,Name1,Name2,Name3,Strasse,Land,Plz,Ort,Provinz,
         ISOA2Land,PLZpfach,Postfach,Telefax,Telefon,Bank,Blz,KontoNr,Sprache,
         AdressGrp,UstIDNr,SteuerNr,Rabatt,Refadr,SktoProz1,SktoProz2,SktoTage1,
         SktoTage2,NettoTage,ZahlZiel,KzAdrArt,Steuerber,Bemerk1,VertrNr,ProvProz,
         Preislist,Rabattlst,StrToInt(LieferAdr),VersndArt,ZahlArt,ISOWaehr,Steuerschl
         From Kunden Where KundenNr = :IAdressNr
      into :AdrUUID,:Suchname,:Name1,:Name2,:Name3,:Strasse,:Land,:Plz,:Ort,:Provinz,
         :ISOA2Land,:PLZpfach,:Postfach,:Telefax,:Telefon,:Bank,:Blz,:KontoNr,:Sprache,
         :AdressGrp,:UstIDNr,:SteuerNr,:Rabatt,:Referenz,:SktProz1,:SktProz2,:SktTag1,
         :SktTag2,:NettoTag,:ZahlZiel,:KzAdrArt,:Steuerber,:Bemerkung,:VtNr,:ProvProz,
         :Preislst,:Rabattlst,:LieferNr,:VersndArt,:ZahlArt,:ISOWaehr,:Steuerschl;
      if (Art = "FU") then
         Preislst = 0;
      else begin
         if ((Preislst = 0) or (Preislst is NULL)) then
            Preislst = 1;
      end
      if ((SktProz1 = 0) and (SktProz2 = 0) and (SktTag1 = 0) and (SktTag2 = 0)
          and (NettoTag = 0) and (ZahlZiel <> 0)) then begin
         select first 1 Satzart from GDIDEF where Satzart = "ZB" and W0 =:ZahlZiel into :Temp;
         if (Temp = "ZB") then begin
            select first 1 StrToInt(W1),StrToFloat(W2),StrToInt(W3),StrToFloat(W4),StrToInt(F4)
            from GDIDEF where Satzart = "ZB" and W0 =:ZahlZiel
            into :SktTag1, :SktProz1, :SktTag2, :SktProz2, :NettoTag;
         end
      end
      Temp = Steuerschl;
      Steuerschl = 0;
      if ((Art = "FU") or
          (copy(SteuerBer,1,1) = "4")  or
          (copy(SteuerBer,1,1) = "5")  or
          (copy(SteuerBer,1,1) = "6")) then
         KZNetto = "K";
      else begin
         if (SteuerBer = "3") then
            Steuerschl = Temp; /* Kunden.Steuerschl */
         select KZBrutto from Rabatte where Satzart = "PL" and Liste =:Preislst into :Temp;
         if (Temp = "1") then
            KZNetto = "B";
         else
            KZNetto = "N";
      end
      if ((ISOWaehr = "") or (ISOWaehr is Null)) then begin
         select ISOWaehr from Rabatte where Satzart = "PL" and Liste =:Preislst into :ISOWaehr;
         if ((ISOWaehr = "") or (ISOWaehr is Null)) then
            select first 1 W5 from GDIDEF where Satzart = "FA2" into :ISOWaehr;
      end
   end else if ((IAdressNr >= VonKreditor) and (IAdressNr <= BisKreditor)) then begin
      select AdrUUID,Suchname,Name1,Name2,Name3,Strasse,Land,Plz,Ort,Provinz,
         ISOA2Land,PLZpfach,Postfach,Telefax,Telefon,Bank,Blz,KontoNr,Sprache,
         AdressGrp,UstIDNr,SteuerNr,Rabatt,SktoProz1,SktoProz2,SktoTage1,SktoTage2,
         NettoTage,ZahlZiel,KzAdrArt,Kundennr,Steuerber,ISOWaehr
         From Liefer Where LieferNr = :IAdressNr
      into :AdrUUID,:Suchname,:Name1,:Name2,:Name3,:Strasse,:Land,:Plz,:Ort,:Provinz,
         :ISOA2Land,:PLZpfach,:Postfach,:Telefax,:Telefon,:Bank,:Blz,:KontoNr,:Sprache,
         :AdressGrp,:UstIDNr,:SteuerNr,:Rabatt,:SktProz1,:SktProz2,:SktTag1,:SktTag2,
         :NettoTag,:ZahlZiel,:KzAdrArt,:LFKDNr,:Steuerber,:ISOWaehr;
      Bemerkung = "";
      VtNr = 0;
      ProvProz = 0;
      Preislst = 0;
      Rabattlst = 0;
      LieferNr = 0;
      VersndArt = 0;
      ZahlArt = 0;
      Referenz = 0;
      Steuerschl = 0;
      if ((Art = "FU") or
          (copy(SteuerBer,1,1) = "3")  or
          (copy(SteuerBer,1,1) = "4")  or
          (copy(SteuerBer,1,1) = "5")  or
          (copy(SteuerBer,1,1) = "6")) then
         KZNetto = "K";
      else begin
         if (KZNetto = "B") then
            KZNetto = "B";
         else if (KZNetto = "K") then
            KZNetto = "K";
         else
            KZNetto = "N";
      end
      if ((ISOWaehr = "") or (ISOWaehr is Null)) then
         select first 1 W5 from GDIDEF where Satzart = "FA2" into :ISOWaehr;
   end
   FLiefAdrAlt = null;
   select first 1 Copy(ListValue(M1,"LieferAdresseAlt"),1,1) from GDIDEF
   where Satzart = "FA1" into :FLiefAdrAlt;
   if (FLiefAdrAlt is null) then
      FLiefAdrAlt = " ";
   else
      FLiefAdrAlt = UpperCase(Copy(FLiefAdrAlt,1,1));
   if ((LieferNr >= VonDebitor) and (LieferNr <= BisDebitor)) then begin
      Select AdrUUID, Name1, Name2, Name3, Strasse, Land, PLZ, Ort, Provinz, ISOA2Land
      from Kunden where KundenNr = :LieferNr
      Into :L_AdrUUID,:L_Name1,:L_Name2,:L_Name3,:L_Strasse,:L_Land,:L_PLZ,:L_Ort,:L_Provinz,:L_ISOA2Land;
   end else if ((LieferNr >= VonKreditor) and (LieferNr <= BisKreditor)) then begin
      Select AdrUUID, Name1, Name2, Name3, Strasse, Land, PLZ, Ort, Provinz, ISOA2Land
      from Liefer where LieferNr = :LieferNr
      Into :L_AdrUUID,:L_Name1,:L_Name2,:L_Name3,:L_Strasse,:L_Land,:L_PLZ,:L_Ort,:L_Provinz,:L_ISOA2Land;
   end
   if (FLiefAdrAlt <> "N") then
      L_Ort = Trim2(Trim2(Trim2(L_Land) || " " || Trim2(L_PLZ)) || " " || Trim2(L_ORT));
   select first 1 Satzart from GDIDEF where Satzart = "VS" and W0 =:VersndArt into :Temp;
   if (Temp <> "VS") then
      VersndArt = 0;
   select first 1 Satzart from GDIDEF where Satzart = "ZA" and W0 =:ZahlArt into :Temp;
   if (Temp <> "ZA") then
      ZahlArt = 0;
   if ((ISOWaehr in ("ATS","BEF","DEM","ESP","FIM","FRF","GRD","IEP","ITL","LUF",
      "NLG","PTE")) and (BelegDat >= "01.01.2002")) then
      ISOWaehr = "EUR";
   select Kuerzel, Faktor, NKStellen from Waehrung where ISOCode = :ISOWaehr
   into :WaehrBez,:WaehrFakt,:WaehrNk;
   if (Abs(WaehrFakt) < 0.0000001) then
      WaehrFakt = 1;
   if (AdrUUID is Null) then AdrUUID = "";
   if (Sprache is Null) then Sprache = 0;
   if (Rabatt is Null) then Rabatt = 0;
   if (Referenz is Null) then Referenz = 0;
   if (SktProz1 is Null) then SktProz1 = 0;
   if (SktProz2 is Null) then SktProz2 = 0;
   if (SktTag1 is Null) then SktTag1 = 0;
   if (SktTag2 is Null) then SktTag2 = 0;
   if (NettoTag is Null) then NettoTag = 0;
   if (ZahlZiel is Null) then ZahlZiel = 0;
   if (VtNr is Null) then VtNr = 0;
   if (ProvProz is Null) then ProvProz = 0;
   if (Preislst is Null) then Preislst = 0;
   if (Rabattlst is Null) then Rabattlst = 0;
   if (LieferNr is Null) then LieferNr = 0;
   if (VersndArt is Null) then VersndArt = 0;
   if (ZahlArt is Null) then ZahlArt = 0;
   if (Steuerschl is Null) then Steuerschl = 0;
   if (WaehrFakt is Null) then WaehrFakt = 0;
   if (WaehrNk is Null) then WaehrNk = 0;
   if (L_AdrUUID is Null) then L_AdrUUID = "";
   if (L_Name1 is Null) then L_Name1 = "";
   if (L_Name2 is Null) then L_Name2 = "";
   if (L_Name3 is Null) then L_Name3 = "";
   if (L_Strasse is Null) then L_Strasse = "";
   if (L_Ort is Null) then L_Ort = "";
   if (L_PLZ is Null) then L_PLZ = "";
   if (L_Provinz is Null) then L_Provinz = "";
   if (Provinz is Null) then Provinz = "";
   Land   = cast(Copy(:Land,1,3) as VarChar(3));
   L_Land = cast(Copy(:L_Land,1,3) as VarChar(3));
   ISOA2Land   = cast(Copy(:ISOA2Land,1,2) as VarChar(2));
   L_ISOA2Land = cast(Copy(:L_ISOA2Land,1,2) as VarChar(2));
   Update Beleg set
      ADRESSNR   = :IADRESSNR,   Suchname    = :Suchname,    Name1     = :Name1,
      Name2      = :Name2,       Name3       = :Name3,       Strasse   = :Strasse,
      Land       = :Land,        PLZ         = :Plz,         Ort       = :Ort,
      Provinz    = :Provinz,     ISOA2Land   = :ISOA2Land,   PLZpfach  = :PLZpfach,
      Postfach   = :Postfach,    Telefax     = :Telefax,     Telefon   = :Telefon,
      Bank       = :Bank,        BLZ         = :Blz,         KontoNr   = :KontoNr,
      Sprache    = :Sprache,     AdressGrp   = :AdressGrp,   UstIDNr   = :UstIDNr,
      SteuerNr   = :SteuerNr,    Rabatt      = :Rabatt,      Referenz  = :Referenz,
      SktProz1   = :SktProz1,    SktProz2    = :SktProz2,    SktTag1   = :SktTag1,
      SktTag2    = :SktTag2,     NettoTag    = :NettoTag,    ZahlZiel  = :ZahlZiel,
      KZAdrArt   = :KzAdrArt,    Steuerber   = :Steuerber,   Bemerkung = :Bemerkung,
      VtNr       = :VtNr,        ProvProz    = :ProvProz,    Preislst  = :Preislst,
      Rabattlst  = :Rabattlst,   LieferNr    = :LieferNr,    L_Name1   = :L_Name1,
      L_Name2    = :L_Name2,     L_Name3     = :L_Name3,     L_Strasse = :L_Strasse,
      L_Ort      = :L_Ort,       L_Land      = :L_Land,      L_PLZ     = :L_PLZ,
      L_Provinz  = :L_Provinz,   L_ISOA2Land = :L_ISOA2Land, VersndArt = :VersndArt,
      ZahlArt    = :ZahlArt,     ISOWaehr    = :ISOWaehr,    WaehrBez  = :WaehrBez,
      WaehrFakt  = :WaehrFakt,   WaehrNk     = :WaehrNk,     KZNetto   = :KZNetto,
      Steuerschl = :Steuerschl,  AdrUUID     = :AdrUUID,     L_AdrUUID = :L_AdrUUID,
      AendDatum   = "now"
   where Belegtyp = :Typ and Belegart = :Art and Belegnr = :IBelegnr;
   Errmsg = 0;
   suspend;
end
--

create procedure GDI_PreisUmrechnen
   (Preis DOUBLE PRECISION, PreisWaehr VarChar(3),
    PreisNetto Char(1), BelegWaehr Char(3), WaehrFakt DOUBLE PRECISION,
    BelegKZNetto char(1), NKPreis SmallInt, HausWaehr Char(3), Steuersatz DOUBLE PRECISION)
returns
   (APreis DOUBLE PRECISION)
as
begin
   APreis = Preis;
   if (BelegKZNetto = "B") then begin
      if (PreisNetto = "N") then
         APreis = Runden(Preis * (100 + Steuersatz) / 100, NKPreis);
   end else begin
      if (PreisNetto <> "N") then
         APreis = Runden(Preis / (100 + Steuersatz) * 100, NKPreis);
   end
   if ((PreisWaehr <> "")and(BelegWaehr <> "")
       and(PreisWaehr <> BelegWaehr)) then
      select AWert from GDI_WAEHRUMRECHNEN (:APreis,-1,:WaehrFakt,:PreisWaehr,
         :BelegWaehr, :HausWaehr) into :APreis;
   suspend;
end
--

create procedure GDI_GetEKDef
   (Typ Char(1), Art VarChar(5), ILagerArtikel Char(1), IPreispfl Char(1))
returns
   (AEKDEF VarChar(10))
AS
   declare variable M1 Blob;
   declare variable FPreisPfl VarChar(40);
   declare variable I SmallInt;
begin
   i = StrToInt(IPreispfl);
   select first 1 M1 from GDIDEF where Satzart ="FA1" into :M1;
   if ((Typ = "V") and (Art="FU")) then begin
      FPreisPfl = ListValue(M1,"EPreis.Abgang");
      if (FPreisPfl = "") then
         FPreisPfl = "DurchEK,KalkEK,GleitEK,LetzterEK";
   end else if ((Typ = "E") and (Art="FU")) then begin
      FPreispfl = ListValue(M1,"EPreis.Zugang");
      if (FPreispfl = "") then
         FPreispfl = "KalkEk";
   end else begin
      if ((Typ in ("E","L")) and (Art = "Z")) then begin
         if (ILagerArtikel = "1") then begin
            FPreispfl = ListValue(M1,"EPreis." || Typ || "." || Art || ".Lager");
            if (FPreispfl = "") then
               FPreispfl = ListValue(M1,"EPreis.Einkauf.Lager");
         end else begin
            FPreispfl = ListValue(M1, "EPreis." || Typ || "." || Art);
            if (FPreispfl = "") then
               FPreispfl = ListValue(M1,"EPreis.Einkauf");
         end
         if (FPreispfl = "") then
            FPreispfl = "K";
      end
      else if ((Typ in ("V","L")) and (Art in ("A","K"))) then begin
         if (i = 1) then
            FPreispfl = "M";
         else if (i = 2) then
            FPreispfl = "D";
         else if (i = 3) then
            FPreispfl = "L";
         else if (i = 4) then
            FPreispfl = "K";
         else if (i = 5) then
            FPreispfl = "G";
         else begin
            if (ILagerArtikel = "1") then
               FPreispfl = ListValue(M1,"EK.Verkauf.Lager");
            else
               FPreispfl = ListValue(M1,"EK.Verkauf");
            if (FPreispfl = "") then
               FPreispfl = "D,K,G,L,M";
         end
      end
      else if ((Typ = "L") and (Art = "I")) then
         FPreispfl = ListValue(M1,"EPreis.Inventur");
      else
         FPreispfl = ListValue(M1,Typ);
      if (FPreispfl = "") then
         FPreisPfl = "DurchEK,KalkEK,GleitEK,LetzterEK";
   end
   AEKDEF = "";
   i = StrLen(FPreisPfl);
   while (i > 0) do begin
      IPreispfl = UpperCase(copy(FPreisPfl,1,1));
      if (IPreispfl in ("K","G","L","D","M")) then
         AEKDEF = AEKDEF || IPreispfl;
      i = Pos(",",FPreisPfl);
      if (i > 0) then
         FPreisPfl = copy(FPreisPfl,i+1,40);
   end
   suspend;
end
--

create procedure GDI_BELEGPOSUPDATE
   (Typ Char(1), Art VarChar(5), IBelegNr Integer, IPosNr Integer)
returns
   (APosNr INTEGER)
AS
   declare variable FBelNr Integer;
   declare variable FArtikelNr VarChar(50);
   declare variable FEKDef VarChar(10);
   declare variable FDatumME Date;
   declare variable FDatumPR Date;
   declare variable FAdressNr INTEGER;
   declare variable FPreisLst SmallInt;
   declare variable FRabattLst SmallInt;
   declare variable FMenge DOUBLE PRECISION;
   declare variable FEPreis DOUBLE PRECISION;
   declare variable FRabatt DOUBLE PRECISION;
   declare variable FFiliale Integer;
   declare variable FKzNetto Char(1);
   declare variable FBelProvProz DOUBLE PRECISION;
   declare variable FKzAdrArt Char(1);
   declare variable FSteuerschl SmallInt;
   declare variable FSprache SmallInt;
   declare variable FBelKZNetto Char(1);
   declare variable FBediener VarChar(10);
   declare variable FKzrabatt Char(1);
   declare variable FKzDruck Char(1);
   declare variable FKzSkonto Char(1);
   declare variable FKzLager Char(1);
   declare variable FKzNK Char(1);
   declare variable FKZErloes Char(1);
   declare variable FKzSerie Char(1);
   declare variable FPreispfl Char(1);
   declare variable FStammLOrt VarChar(40);
   declare variable FWGR VarChar(10);
   declare variable FRabattGr VarChar(10);
   declare variable FGewicht DOUBLE PRECISION;
   declare variable FArtProvProz DOUBLE PRECISION;
   declare variable FKZAdress Char(1);
   declare variable FSteuerVK DOUBLE PRECISION;
   declare variable FSteuerEK DOUBLE PRECISION;
   declare variable FKzProv Char(1);
   declare variable FKzpreis VarChar(3);
   declare variable FEk DOUBLE PRECISION;
   declare variable FKzEk Char(1);
   declare variable FKzbrutto Char(1);
   declare variable FRabKz VarChar(3);
   declare variable FMeFaktor DOUBLE PRECISION;
   declare variable FProvSatz DOUBLE PRECISION;
   declare variable FSteuerSatz DOUBLE PRECISION;
   declare variable FKZRABLST VarChar(3);
   declare variable FKZPREISL VarChar(3);
   declare variable FGesamt DOUBLE PRECISION;
   declare variable FEKGesamt DOUBLE PRECISION;
   declare variable FLagerME DOUBLE PRECISION;
   declare variable FLagerPR DOUBLE PRECISION;
   declare variable M1 Blob;
   declare variable S VarChar(255);
   declare variable NKPreis SmallInt;
   declare variable NKBeleg SmallInt;
   declare variable NKStatistik SmallInt;
   declare variable FMengenEinh SmallInt;
   declare variable FOperatorME VarChar(20);
   declare variable FOperatorPE VarChar(20);
   declare variable FOperandME DOUBLE PRECISION;
   declare variable FOperandPE DOUBLE PRECISION;
begin
   FBelNr = Null;
   FDatumMe = Null;
   select BelegNr, BelegDat, LieferDat, Adressnr, PreisLst,
      RabattLst, Filiale, ProvProz, KzAdrArt, Steuerschl, Sprache, KZNetto, Personal
   from Beleg
   where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art
   into :FBelNr,:FDatumPR,:FDatumME,:FAdressnr,:FPreisLst,
      :FRabattLst,:FFiliale,:FBelProvProz,:FKzAdrArt,:FSteuerschl,:FSprache,
      :FBelKZNetto,:FBediener;
   if (FBelNr is Null) then begin
      APosNr = -1;
      suspend;
      exit;
   end
   FBelNr = Null;
   select BelegNr, Artikelnr, KzDruck, MengenEinh, MeFaktor,
          EPreis, Menge, Rabatt, EKWert
   from   Belegpos
   where  BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art and Posnr = :IPosNr
   into   :FBelNr,:FArtikelnr,:FKzDruck,:FMengenEinh,:FMeFaktor,
          :FEPreis, :FMenge, :FRabatt, :FEK;
   if (FBelNr is Null) then begin
      APosNr = -2;
      suspend;
      exit;
   end
   if ((FDatumME is Null) or (FDatumME <= "01.01.1900")) then
      FDatumME = FDatumPR;
   FKZDruck = "";
   FProvSatz = 0;
   FKZAdrArt = "";
   if ((FArtikelNr is not null) and (FArtikelNr <> "")) then begin
      select ArtikelNr, KZRabatt, KZDruck, KZSkonto, KZLager, KZNK,
         KZErloes,KzSerie, Preispfl, StammLOrt, WGR, Rabattgr,
         Gewicht, ProvProz, KZAdress, SteuerVK, SteuerEK, KZProv
      from Artikel where ArtikelNr = :FArtikelNr
      into :FArtikelNr,:FKZRabatt, :FKZDruck, :FKZSkonto, :FKZLager, :FKZNK,
         :FKZErloes, :FKzSerie, :FPreispfl, :FStammLOrt, :FWGR, :FRabattgr,
         :FGewicht, :FArtProvProz, :FKZAdress, :FSteuerVK, :FSteuerEK, :FKZProv;
      if (FArtikelNr is Null) then begin
         APosNr = -3;
         suspend;
         exit;
      end
      if (FArtProvProz <> 0) then
         FProvSatz = FArtProvProz;
      else
         FProvSatz = FBelProvProz;
      if (FKzAdrArt = "1") then
         FKZAdrArt = FKZAdress;
      if (FSteuerschl = 0) then begin
         if (Typ = "V") then begin
            FSteuerschl = FSteuerVK;
            FKZProv = FKZProv;
         end else begin
            FSteuerschl = FSteuerEK;
         end
         if (FSteuerschl < 1) then
            FSteuerschl = 1;
      end
      if (FBelKZNetto = "K") then
         FSteuerSatz = 0;
      else
         select first 1 StrToFloat(W1) from GDIDEF
         where  Satzart ="ST" and W0 =:FSteuerschl
         into   :FSteuerSatz;
      NKPreis = null;
      select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKPreis;
      if ((NKPreis is null) or (NKPreis = 0)) then
         NKPreis = 2;
      NKBeleg = null;
      select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKBeleg;
      if ((NKBeleg is null) or (NKBeleg = 0)) then
         NKBeleg = 2;
      NKStatistik = null;
      select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKStatistik;
      if ((NKStatistik is null) or (NKStatistik = 0)) then
         NKStatistik = 2;
   end
   select first 1 W1, W3, StrToFloat(W2), StrToFloat(W4) from GDIDEF
   where satzart = "ME" and W0 = :FMengenEinh
   into :FOperatorME, :FOperatorPE, :FOperandME, :FOperandPE;
   if (FKZDruck = "%") then begin
      FGesamt  = - (FMenge * FEPreis / 100);
      FRabatt  = 0;
      FLagerMe = 0;
   end else begin
      FLagerMe = FMenge;
      if (FOperandME <> 0) then begin
         if (FOperatorME = "*") then
            FLagerMe = FMenge * FOperandME;
         else if (FOperatorME = "/") then
            FLagerMe = FMenge / FOperandME;
      end
      FGesamt = FEPreis;
      if (FOperandPE <> 0) then begin
         if (FOperatorPE = "*") then
            FGesamt = FEPreis * FOperandPE;
         else if (FOperatorPE = "/") then
            FGesamt = FEPreis / FOperandPE;
      end
      if (FKZRabatt <> "1") then
         FRabatt = 0;
      if ((Typ = "V") or (Abs(FMEFaktor) < 0.0000001)) then
         FMEFaktor = 1;
      FGesamt = ((FMenge * FGesamt) - ((FMenge * FGesamt) * FRabatt / 100)) / FMEFaktor;
   end
   FLagerPr = FGesamt;
   if (Pos(FKZDruck, "PES%tT") = 0) then begin
      if ((Typ = "V") or ((Typ = "L") and (Art in ("K","A")))) then begin
         if ((FEK = 0) and ((FLagerPr <> 0) or (FLagerMe <> 0))) then begin
            /*
               Funktion SetErloesEK fehlt noch
               EKWert :=  SetErloesEK(Typ, Art,s);
               if S <> "K" then   // nicht bei KalkEK
                  EKWert := EKWert * MEFaktor2;
            */
            if (FKzEk <> "K") then
               FEK = FLagerPr / FLagerMe * FMEFaktor;
            else
               FEK = FLagerPr / FLagerMe;
         end
      end else begin
         if (Abs(FLagerme) > 0.000001) then
            FEK = FLagerPr / FLagerme * FMEFaktor;
         else
            FEK = FLagerPr;
      end
   end else
      FEK = 0;
   FEK = runden(FEK,NKPreis);
   FEKGesamt = runden(FLagerme * FEK, NKStatistik);
   if (((Typ ="V") or ((Typ="L") and (Art in ("K","A"))))
      and (Abs(FMeFAKTOR) > 0.0000001)) then
      FEKGesamt = FEKGesamt / FMeFAKTOR;
   FGesamt = runden(FGesamt, NKBeleg);
   FLagerPr = runden(FLagerPr, NKStatistik);
   if (FFiliale is Null) then FFiliale = 0;
   if (FRABATT is Null) then FRABATT = 0;
   if (FEPREIS is Null) then FEPREIS = 0;
   if (FGESAMT is Null) then FGESAMT = 0;
   if (FLAGERME is Null) then FLAGERME = 0;
   if (FLAGERPR is Null) then FLAGERPR = 0;
   if (FSTEUERSATZ is Null) then FSTEUERSATZ = 0;
   if (FSTEUERSCHL is Null) then FSTEUERSCHL = 0;
   if (FPREISLST is Null) then FPREISLST = 0;
   if (FRABATTLST is Null) then FRABATTLST = 0;
   if (FGEWICHT is Null) then FGEWICHT = 0;
   if (FPROVSATZ is Null) then FPROVSATZ = 0;
   if (FEK is Null) then FEK = 0;
   if (FEKGESAMT is Null) then FEKGESAMT = 0;
   if (FKZDRUCK is Null) then FKZDRUCK = "";
   if (FBelKZNETTO is Null) then FBelKZNETTO = "";
   if (FKZNK is Null) then FKZNK = "";
   if (FKZERLOES is Null) then FKZERLOES = "";
   if (FPREISPFL is Null) then FPREISPFL = "";
   if (FWGR is Null) then FWGR = "";
   if (FBEDIENER is Null) then FBEDIENER = "";
   if (FRABATTGR is Null) then FRABATTGR = "";
   if (FKZPROV is Null) then FKZPROV = "";
   if (FKZRABATT is Null) then FKZRABATT = "";
   if (FKZSKONTO is Null) then FKZSKONTO = "";
   if (FKZLAGER is Null) then FKZLAGER = "";
   if (FKZADRART is Null) then FKZADRART = "";
   if (FKZPREISL is Null) then FKZPREISL = "";
   if (FKZRABLST is Null) then FKZRABLST = "";
   if (FKZSERIE is Null) then FKZSERIE = "";
   Update Belegpos
      set ADRESSNR = :FAdressnr,   Filiale    = :FFiliale,
          Rabatt   = :FRabatt,     EPreis     = :FEPREIS,     Gesamt     = :FGesamt,
          LagerMe  = :FLagerMe,    LagerPr    = :FLagerPr,    DatumMe    = :FDatumMe,
          DatumPr  = :FDatumPr,    KzProv     = :FKzProv,     KzRabatt   = :FKzRabatt,
          KzSkonto = :FKzSkonto,   KzLager    = :FKzLager,    KzAdrArt   = :FKzAdrArt,
          KzNetto  = :FBelKzNetto, KzNK       = :FKzNK,       KzErloes   = :FKzErloes,
          PreisPfl = :FPreisPfl,   Steuersatz = :FSteuerSatz, SteuerSchl = :FSteuerSchl,
          KzPreisl = :FKzPreisl,   PreisLst   = :FPreisLst,   KzRabLst   = :FKzRabLst,
          KZSerie  = :FKzSerie,    RabattLst  = :FRabattLst,  Gewicht    = :FGewicht,
          ProvSatz = :FProvSatz,   WGR        = :FWGR,        EkWert     = :FEK,
          EKGesamt = :FEkGesamt,   RabattGr   = :FRabattGr,   AendDatum = "NOW",
          Bediener = :FBediener
   where Belegtyp = :Typ and Belegart = :Art and Belegnr = :IBelegnr and PosNr = :IPosNr;
   APosNr = IPosNr;
   suspend;
end
--

create procedure GDI_BELEGPOSINSERT (Typ Char(1), Art VarChar(5), IBelegNr Integer,
   IPosNr Integer, IKZDruck Char(1), IArtikelNr VarChar(50), IArtText VarChar(255),
   IMenge DOUBLE PRECISION, IEPreis VarChar(30), IRabatt VarChar(30),
   IMEFaktor DOUBLE PRECISION, IMengenEinh SmallInt, IJahr Char(4), IEKDef Char(10))
returns (APosNr INTEGER)
AS
   declare variable FBelNr Integer;
   declare variable FDatumME Date;
   declare variable FDatumPR Date;
   declare variable FAdressNr INTEGER;
   declare variable FPreisLst SmallInt;
   declare variable FRabattLst SmallInt;
   declare variable FRabatt DOUBLE PRECISION;
   declare variable FReferenz INTEGER;
   declare variable FFiliale Integer;
   declare variable FProjektNr VarChar(20);
   declare variable FKzNetto Char(1);
   declare variable FBelProvProz DOUBLE PRECISION;
   declare variable FKommnr VarChar(20);
   declare variable FVTNr INTEGER;
   declare variable FKzAdrArt Char(1);
   declare variable FSteuerschl SmallInt;
   declare variable FSprache SmallInt;
   declare variable FBelegWaehr VarChar(3);
   declare variable FWaehrFakt DOUBLE PRECISION;
   declare variable FBelegKZNetto Char(1);
   declare variable FBediener VarChar(10);
   declare variable FKzrabatt Char(1);
   declare variable FKzDruck Char(1);
   declare variable FKzSkonto Char(1);
   declare variable FKzLager Char(1);
   declare variable FKzNK Char(1);
   declare variable FKZErloes Char(1);
   declare variable FKzSerie Char(1);
   declare variable FPreispfl Char(1);
   declare variable FKZMehrLag Char(1);
   declare variable FStammLOrt VarChar(40);
   declare variable FWGR VarChar(10);
   declare variable FRabattGr VarChar(10);
   declare variable FGewicht DOUBLE PRECISION;
   declare variable FArtMeFaktor DOUBLE PRECISION;
   declare variable FArtProvProz DOUBLE PRECISION;
   declare variable FKZAdress Char(1);
   declare variable FSteuerVK DOUBLE PRECISION;
   declare variable FSteuerEK DOUBLE PRECISION;
   declare variable FMEVK SmallInt;
   declare variable FMEEK SmallInt;
   declare variable FKzProv Char(1);
   declare variable FLaenge DOUBLE PRECISION;
   declare variable FHoehe DOUBLE PRECISION;
   declare variable FBreite DOUBLE PRECISION;
   declare variable FHerstell VarChar(30);
   declare variable FProfil VarChar(30);
   declare variable FEANCode VarChar(20);
   declare variable FText1 Blob;
   declare variable FText2 Blob;
   declare variable FText3 Blob;
   declare variable FText4 Blob;
   declare variable FPreisWaehr VarChar(3);
   declare variable FMaterial DOUBLE PRECISION;
   declare variable FKzpreis VarChar(3);
   declare variable FEk DOUBLE PRECISION;
   declare variable FKzEk Char(1);
   declare variable FKzbrutto Char(1);
   declare variable FKZAltTeil Char(1);
   declare variable FRabKz VarChar(3);
   declare variable FMeFaktor DOUBLE PRECISION;
   declare variable FLagerOrt VarChar(20);
   declare variable FLager VarChar(20);
   declare variable FProvSatz DOUBLE PRECISION;
   declare variable FSteuerSatz DOUBLE PRECISION;
   declare variable FSteuerRef  DOUBLE PRECISION;
   declare variable FFolgeStSatz Integer;
   declare variable FKZRABLST VarChar(3);
   declare variable FKZPREISL VarChar(3);
   declare variable FGesamt DOUBLE PRECISION;
   declare variable FEKGesamt DOUBLE PRECISION;
   declare variable FLagerME DOUBLE PRECISION;
   declare variable FLagerPR DOUBLE PRECISION;
   declare variable FEPreis DOUBLE PRECISION;
   declare variable FText VarChar(32000);
   declare variable LangText Blob;
   declare variable DimenText Blob;
   declare variable ArtText VarChar(255);
   declare variable BestText Blob;
   declare variable M1 Blob;
   declare variable S VarChar(255);
   declare variable NKPreis SmallInt;
   declare variable NKBeleg SmallInt;
   declare variable NKStatistik SmallInt;
   declare variable HausWaehr VarChar(3);
   declare variable FOperatorME VarChar(20);
   declare variable FOperatorPE VarChar(20);
   declare variable FOperandME DOUBLE PRECISION;
   declare variable FOperandPE DOUBLE PRECISION;
   declare variable MaxPosNr Integer;
   declare variable Anzahl Integer;
   declare variable Step Integer;
begin
   if (IMenge is Null) then
      IMenge = 0;
   if (IMEFaktor is Null) then
      IMEFaktor = 0;
   if (IMengenEinh is Null) then
      IMengenEinh = 0;
   FBelNr = Null;
   FDatumMe = Null;
   select BelegNr, BelegDat, LieferDat, Adressnr, PreisLst, Referenz,
      RabattLst, Rabatt, Filiale, ProjektNr, ProvProz, Kommnr,
      VTNr, KzAdrArt, Steuerschl, Sprache, ISOWaehr, WaehrFakt,
      KZNetto, Personal
      from Beleg where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art
      into :FBelNr,:FDatumPR,:FDatumME,:FAdressnr,:FPreisLst,:FReferenz,
      :FRabattLst,:FRabatt,:FFiliale,:FProjektNr,:FBelProvProz,:FKommnr,
      :FVTNr,:FKzAdrArt,:FSteuerschl,:FSprache,:FBelegWaehr,:FWaehrFakt,
      :FBelegKZNetto,:FBediener;
   if (FBelNr is Null) then begin
      APosNr = -1;
      suspend;
      exit;
   end
   if ((FDatumME is Null) or (FDatumME <= "01.01.1900")) then
      FDatumME = FDatumPR;
   MaxPosNr = Null;
   select Max(PosNr) MaxPosNr from Belegpos
   where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art
   into :MaxPosNr;
   if (MaxPosNr is Null) then
      MaxPosNr = 0;
   if ((IPosNr is Null) or (IPosNr = 0)) then begin
      Step = null;
      select first 1 StrToInt(Copy(ListValue(M1,"PosGrid.Schrittweite"),1,1)) from GDIDEF
      where Satzart = "FA1" into :Step;
      if ((Step is null) or (Step < 1)) then
         Step = 100;
      IPosNr = MaxPosNr + Step;
   end
   if (IPosNr <= MaxPosNr) then begin
      APosNr = IPosNr;
      select Count(*) from belegpos
      where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art and Posnr = :APosNr
      into :Anzahl;
      if (Anzahl > 0) then begin
         APosNr = APosNr + 1;
         select Count(*) from belegpos
         where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art and Posnr = :APosNr
         into :Anzahl;
         if (Anzahl > 0) then begin
            update belegpos
            set posnr = posnr + :MaxPosNr + 11
            where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art and Posnr >= :APosNr;
            update belegpos
            set posnr = posnr - :MaxPosNr
            where BelegNr = :IBelegNr and BelegTyp = :Typ and BelegArt = :Art and Posnr >= :APosNr;
         end
      end
   end else
      APosNr = IPosNr;
   FMEVK = 0;
   FMEEK = 0;
   FKZDruck = "";
   FLager = "";
   FLagerOrt = "";
   FProvSatz = 0;
   FKZAdress = "";
   if ((IArtikelNr is not null) and (IArtikelNr <> "")) then begin
      select ArtikelNr, KZRabatt, KZDruck, KZSkonto, KZLager, KZNK,
         KZErloes, KzSerie, KZAltTeil, Preispfl, KZMehrLag, StammLOrt, WGR,
         Rabattgr, Gewicht, MEFaktor, ProvProz, KZAdress, SteuerVK,
         SteuerEK, MEVK, MEEK, KZProv, Laenge, Hoehe, Breite,
         Herstell, Profil, EANCode, LangText, DimenText, ArtText, BestText,
         Text1, Text2, Text3, Text4
      from Artikel where ArtikelNr = :IArtikelNr
      into :IArtikelNr, :FKZRabatt, :FKZDruck, :FKZSkonto, :FKZLager, :FKZNK,
         :FKZErloes, :FKzSerie, :FKZAltTeil, :FPreispfl, :FKZMehrLag, :FStammLOrt, :FWGR,
         :FRabattgr, :FGewicht, :FArtMEFaktor, :FArtProvProz, :FKZAdress, :FSteuerVK,
         :FSteuerEK, :FMEVK, :FMEEK, :FKZProv, :FLaenge, :FHoehe, :FBreite,
         :FHerstell, :FProfil, :FEANCode, :LangText,:DimenText,:ArtText,:BestText,
         :FText1, :FText2, :FText3, :FText4;
      if (IArtikelNr is Null) then begin
         APosNr = -2;
         suspend;
         exit;
      end
      if (FMEVK is Null) then
         FMEVK = 0;
      if (FMEEK is Null) then
         FMEEK = 0;
      FLagerOrt = FStammLOrt;
      if (FKZMehrlag = "1") then
         FLager = FStammLOrt;
      if (FArtProvProz <> 0) then
         FProvSatz = FArtProvProz;
      else
         FProvSatz = FBelProvProz;
      if ((FKzAdrArt = "1") and (FKZAdress = "1")) then
         FKZAdrArt = "1";
      else
         FKZAdrArt = "";
      if (FSteuerschl = 0) then begin
         if (Typ = "V") then begin
            FSteuerschl = FSteuerVK;
         end else begin
            FSteuerschl = FSteuerEK;
         end
         if (FSteuerschl < 1) then
            FSteuerschl = 1;
      end
      if (Typ = "V") then begin
         if (IMengenEinh = 0) then
            IMengenEinh = FMEVK;
         FKZProv = FKZProv;
      end else begin
         if (IMengenEinh = 0) then
            IMengenEinh = FMEEK;
         FKZProv = "";
      end
      if (FBelegKZNetto = "K") then begin
         FSteuerSatz = 0;
      end else begin
         select first 1 StrToFloat(W1),StrToInt(K1) from GDIDEF
         where  Satzart = "ST" and W0 = :FSteuerSchl
         into   :FSteuerSatz, :FFolgeStSatz;
         if (StrToInt(FKZAltTeil) > 0) then begin
            if (FFolgeStSatz > 0) then begin
               FSteuerSchl = FFolgeStSatz;
               FSteuerRef  = FSteuerSatz;
               FSteuerSatz = Null;
               select first 1 StrToFloat(W1) from GDIDEF
               where  Satzart = "ST" and W0 = :FSteuerSchl
               into   :FSteuerSatz;
               if ((FSteuerSatz is Null) or (FSteuerSatz <= FSteuerRef)) then begin
                  exception GDI_ALTTEIL_STEUERSATZ;
               end
            end else begin
               exception GDI_ALTTEIL_STEUERSCHL;
            end
         end
      end
      select Waehrung,Material,Kzpreis,Rabatt,Kzrabatt,Ek,Mefaktor,Kzek,Kzbrutto
      from GDI_GETPREIS (:IArtikelnr,:FPreislst,:FAdressnr,:FReferenz,
         :FRabattlst,:FRabattgr,:FKzrabatt,:FRabatt,"1",:FDatumMe,:IMenge,
         :IJahr,:FFiliale,:IEKDef)
      Into :FPreisWaehr, :FMaterial, :FKzpreis, :FRabatt, :FRabKz, :FEk,
         :FMefaktor, :FKzEK, :FKzbrutto;
      if (FMaterial is Null) then
         FMaterial = 0;
      if (Typ || Art = "VFU") then begin
         FMaterial = FEK;
         FKzPreis  = FKzEk;
         FPreisLst = 0;
      end
      FKZRABLST = FRabKz;
      FKZPREISL = FKzPreis;
      select first 1 copy(w5,1,3) from gdidef where satzart = "FA2" into :HausWaehr;
      if (FPreisWaehr = "") then
         FPreisWaehr = HausWaehr;
      NKPreis = null;
      select first 1 StrToInt(Copy(ListValue(M1,"PREIS.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKPreis;
      if ((NKPreis is null) or (NKPreis = 0)) then
         NKPreis = 2;
      NKBeleg = null;
      select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKBeleg;
      if ((NKBeleg is null) or (NKBeleg = 0)) then
         NKBeleg = 2;
      NKStatistik = null;
      select first 1 StrToInt(Copy(ListValue(M1,"STATISTIK.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :NKStatistik;
      if ((NKStatistik is null) or (NKStatistik = 0)) then
         NKStatistik = 2;
      if (IRabatt <> "") then begin
         FRabatt = StrToFloat(IRabatt);
         FKZRABLST = "M";
      end
      if (IEPreis <> "") then begin
         FEPreis = StrToFloat(IEPreis);
         FKZPreisl = "M";
      end else begin
         if (Typ = "E") then begin
            if (FMaterial <> 0) then begin
               select APreis from GDI_Preisumrechnen(:FMaterial, :FPreisWaehr,
                 "N", :FBelegWaehr, :FWaehrFakt, :FBelegKZNetto, :NKPreis,
                 :HausWaehr, :FSteuersatz) into :FEPREIS;
            end else begin
               if ((FKzEk <> "") and (copy(FKzEk,1,1) in ("L","D","G"))) then
                  FEK = FEK * IMEFaktor;
               select APreis from GDI_Preisumrechnen(:FEK, :HausWaehr,
                 "N", :FBelegWaehr, :FWaehrFakt, :FBelegKZNetto, :NKPreis,
                 :HausWaehr, :FSteuersatz) into :FEPREIS;
               FKZPREISL = FKzEk;
            end
         end else begin
            if ((IMenge <> 0) or (Uppercase(Copy(FKzPreis,3,1)) <> "S")) then begin
               if (FKzbrutto <> "1") then
                  S = "N"; else S = "B";
               select APreis from GDI_Preisumrechnen(:FMaterial, :FPreisWaehr,
                 :S, :FBelegWaehr, :FWaehrFakt, :FBelegKZNetto, :NKPreis,
                 :HausWaehr, :FSteuersatz) into :FEPREIS;
            end
         end
      end
   end else begin
      if (IEPreis <> "") then begin
         FEPreis = StrToFloat(IEPreis);
         FKZPreisl = "M";
      end
   end
   if (IKZDruck <> "") then
      FKZDruck = IKZDruck;
   select first 1 W1, W3, StrToFloat(W2), StrToFloat(W4) from GDIDEF
   where  satzart = "ME" and W0 = :IMengenEinh
   into  :FOperatorME, :FOperatorPE, :FOperandME, :FOperandPE;
   if (FKZDruck = "%") then begin
      FGesamt  = - (IMenge * FEPreis / 100);
      FRabatt  = 0;
      FLagerMe = 0;
   end else begin
      FLagerMe = IMenge;
      if (FOperandME <> 0) then begin
         if (FOperatorME = "*") then
            FLagerMe = IMenge * FOperandME;
         else if (FOperatorME = "/") then
            FLagerMe = IMenge / FOperandME;
      end
      FGesamt = FEPreis;
      if (FOperandPE <> 0) then begin
         if (FOperatorPE = "*") then
            FGesamt = FEPreis * FOperandPE;
         else if (FOperatorPE = "/") then
            FGesamt = FEPreis / FOperandPE;
      end
      if (FKZRabatt <> "1") then
         FRabatt = 0;
      if ((Typ = "V") or (Abs(IMEFaktor) < 0.0000001)) then
         IMEFaktor = 1;
      FGesamt = ((IMenge * FGesamt) - ((IMenge * FGesamt) * FRabatt / 100)) / IMEFaktor;
   end
   FLagerPr = FGesamt;
   if (Pos(FKZDruck, "PES%tT") = 0) then begin
      if ((Typ = "V") or ((Typ = "L") and (Art in ("K","A")))) then begin
         if ((FEK = 0) and ((FLagerPr <> 0) or (FLagerMe <> 0))) then begin
            /*
               Funktion SetErloesEK fehlt noch
               EKWert :=  SetErloesEK(Typ, Art,s);
               if S <> "K" then   // nicht bei KalkEK
                  EKWert := EKWert * MEFaktor2;
            */
            if (FKzEk <> "K") then
               FEK = FLagerPr / FLagerMe * IMEFaktor;
            else
               FEK = FLagerPr / FLagerMe;
         end
      end else begin
         if (Abs(FLagerme) > 0.000001) then
            FEK = FLagerPr / FLagerme * IMEFaktor;
         else
            FEK = FLagerPr;
      end
   end else
      FEK = 0;
   FEK = runden(FEK,NKPreis);
   FEKGesamt = runden(FLagerme * FEK, NKStatistik);
   if (((Typ = "V") or ((Typ = "L") and (Art in ("K","A")))) and (Abs(FArtMeFAKTOR) > 0.0000001)) then
      FEKGesamt = FEKGesamt / FArtMeFAKTOR;
   FGesamt = runden(FGesamt, NKBeleg);
   FLagerPr = runden(FLagerPr, NKStatistik);
   if ((IArtText <> "") or (IArtikelNr is null) or (IArtikelNr = "")) then begin
      FText = IArtText;
   end else begin
      FText = "";
      if (FKZDruck = "z") then begin
         FText = TrimL(BlobToStr(LangText));
         FText = FText || " " || TrimL(BlobToStr(DimenText));
      end else if (FKZDruck = "Z") then begin
         FText = TrimL(ArtText);
         if (Typ = "E") then begin
            FText = FText || " " || TrimL(BlobToStr(BestText));
         end else begin
            FText = FText || " " || TrimL(BlobToStr(LangText));
            FText = FText || " " || TrimL(BlobToStr(DimenText));
         end
      end else begin
         S = ListValue(M1,"BelegPos.BestellText");
         if ((UpperCase(copy(S,1,1)) <> "N") and (Typ="E") and (Art="BE")) then begin
            FText = BlobToStr(BestText);
         end
         if (FText = "") then begin
            S = ListValue(M1,"BelegPos.SprachText");
            if ((UpperCase(copy(S,1,1)) <> "N") and (Typ="V")) then begin
               if (FSprache = 1) then
                  FText = BlobToStr(FText1);
               else if (FSprache = 2) then
                  FText = BlobToStr(FText2);
               else if (FSprache = 3) then
                  FText = BlobToStr(FText3);
               else if (FSprache = 4) then
                  FText = BlobToStr(FText4);
            end
            if (FText = "") then
               FText = ArtText;
         end
      end
   end
   if (FFiliale is Null) then FFiliale = 0;
   if (FRABATT is Null) then FRABATT = 0;
   if (FEPREIS is Null) then FEPREIS = 0;
   if (FGESAMT is Null) then FGESAMT = 0;
   if (FLAGERME is Null) then FLAGERME = 0;
   if (FLAGERPR is Null) then FLAGERPR = 0;
   if (FSTEUERSATZ is Null) then FSTEUERSATZ = 0;
   if (FSTEUERSCHL is Null) then FSTEUERSCHL = 0;
   if (FPREISLST is Null) then FPREISLST = 0;
   if (FRABATTLST is Null) then FRABATTLST = 0;
   if (FGEWICHT is Null) then FGEWICHT = 0;
   if (FVTNr is Null) then FVTNr = 0;
   if (FPROVSATZ is Null) then FPROVSATZ = 0;
   if (FEK is Null) then FEK = 0;
   if (FEKGESAMT is Null) then FEKGESAMT = 0;
   if (FBREITE is Null) then FBREITE = 0;
   if (FHOEHE is Null) then FHOEHE = 0;
   if (FLAENGE is Null) then FLAENGE = 0;
   if (FArtMeFAKTOR is Null) then FArtMeFAKTOR = 0;
   if (FKZDRUCK is Null) then FKZDRUCK = "";
   if (FLAGER is Null) then FLAGER = "";
   if (FLAGERORT is Null) then FLAGERORT = "";
   if (FEANCODE is Null) then FEANCODE = "";
   if (FBelegKZNETTO is Null) then FBelegKZNETTO = "";
   if (FKZNK is Null) then FKZNK = "";
   if (FKZERLOES is Null) then FKZERLOES = "";
   if (FPREISPFL is Null) then FPREISPFL = "";
   if (FWGR is Null) then FWGR = "";
   if (FPROJEKTNR is Null) then FPROJEKTNR = "";
   if (FKOMMNR is Null) then FKOMMNR = "";
   if (FBEDIENER is Null) then FBEDIENER = "";
   if (FRABATTGR is Null) then FRABATTGR = "";
   if (FKZPROV is Null) then FKZPROV = "";
   if (FKZRABATT is Null) then FKZRABATT = "";
   if (FKZSKONTO is Null) then FKZSKONTO = "";
   if (FKZLAGER is Null) then FKZLAGER = "";
   if (FKZADRART is Null) then FKZADRART = "";
   if (FKZMEHRLAG is Null) then FKZMEHRLAG = "";
   if (FKZPREISL is Null) then FKZPREISL = "";
   if (FKZRABLST is Null) then FKZRABLST = "";
   if (FKZSERIE is Null) then FKZSERIE = "";
   if (FKZAltTeil is Null) then FKZAltTeil = "";
   Insert into Belegpos (
      BELEGTYP,BELEGART,BELEGNR,POSNR,ADRESSNR,KZDRUCK,ARTIKELNR,FILIALE,LAGER,
      LAGERORT,EANCODE,TEXT,MENGE,RABATT,EPREIS,GESAMT,LAGERME,LAGERPR,
      DATUMME,DATUMPR,KZPROV,KZRABATT,KZSKONTO,KZLAGER,KZAltTeil,
      KZADRART,KZNETTO,KZNK,KZERLOES,PREISPFL,MENGENEINH,STEUERSATZ,
      STEUERSCHL,KZMEHRLAG,KZPREISL,PREISLST,KZRABLST,KZSERIE,RABATTLST,
      GEWICHT,VERTRETER,PROVSATZ,WGR,EKWERT,EKGESAMT,PROJEKTNR,KOMMNR,BEDIENER,
      BREITE,HOEHE,LAENGE,RABATTGR,MEFAKTOR,
      CreateBed,CreateDatum,AendBed,AendDatum)
   Values (
      :Typ,:Art,:IBelegnr,:APosNr,:FAdressnr,:FKZDRUCK,:IArtikelNr,:FFiliale,:FLAGER,
      :FLAGERORT,:FEANCODE,:FText,:IMenge,:FRABATT,:FEPREIS,:FGESAMT,:FLAGERME,:FLAGERPR,
      :FDATUMME,:FDATUMPR,:FKZPROV,:FKZRABATT,:FKZSKONTO,:FKZLAGER,:FKZAltTeil,
      :FKZADRART,:FBelegKZNETTO,:FKZNK,:FKZERLOES,:FPREISPFL,:IMENGENEINH,:FSTEUERSATZ,
      :FSTEUERSCHL,:FKZMEHRLAG,:FKZPREISL,:FPREISLST,:FKZRABLST,:FKZSERIE,:FRABATTLST,
      :FGEWICHT,:FVTNr,:FPROVSATZ,:FWGR,:FEK,:FEKGESAMT,:FPROJEKTNR,:FKOMMNR,:FBEDIENER,
      :FBREITE,:FHOEHE,:FLAENGE,:FRABATTGR,:FArtMeFAKTOR,
      :FBediener,"now",:FBediener,"now");
   suspend;
end
--

create procedure GDI_BelegSetSumme
   (ITYP CHAR(1), IART VarChar(5), IBELEGNR INTEGER, IADRESSNR INTEGER,
    IDATUM DATE, IBEDNAME VarChar(5))
returns
   (Errmsg Integer)
as
   declare variable STWERT0 DOUBLE PRECISION;
   declare variable STSATZ1 DOUBLE PRECISION;
   declare variable STSATZ2 DOUBLE PRECISION;
   declare variable STSATZ3 DOUBLE PRECISION;
   declare variable STSATZ4 DOUBLE PRECISION;
   declare variable STWERT1 DOUBLE PRECISION;
   declare variable STWERT2 DOUBLE PRECISION;
   declare variable STWERT3 DOUBLE PRECISION;
   declare variable STWERT4 DOUBLE PRECISION;
   declare variable START1 CHAR(1);
   declare variable START2 CHAR(1);
   declare variable START3 CHAR(1);
   declare variable START4 CHAR(1);
   declare variable BRUTTO DOUBLE PRECISION;
   declare variable SKONTOBRUTTO DOUBLE PRECISION;
   declare variable NETTO DOUBLE PRECISION;
   declare variable WARENWERT DOUBLE PRECISION;
   declare variable NKWARENW DOUBLE PRECISION;
   declare variable EKPREIS DOUBLE PRECISION;
   declare variable OPBETRAG DOUBLE PRECISION;
   declare variable GEWICHT DOUBLE PRECISION;
   declare variable PREIS Double precision;
   declare variable JAHR Char(4);
   declare variable FOPHAUS DOUBLE PRECISION;
   declare variable FCount Integer;
   declare variable ISOWAEHR VarChar(3);
   declare variable WAEHRFAKT DOUBLE PRECISION;
   declare variable NKBeleg SmallInt;
begin
   Select Count(*) from Beleg
   where BelegTyp = :ITyp and BelegArt = :IArt and Belegnr = :IBelegnr
   into :FCount;
   if (FCount = 0) then begin
      ErrMsg = -9;
      Suspend;
      exit;
   end
   NKBeleg = null;
   select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :NKBeleg;
   if ((NKBeleg is null) or (NKBeleg = 0)) then
      NKBeleg = 2;
   execute procedure GDI_BELEGSUMME :ITyp, :IArt, :IBelegnr, :NKBeleg
       RETURNING_VALUES :STWERT0, :STSATZ1, :STSATZ2, :STSATZ3,
            :STSATZ4, :STWERT1, :STWERT2, :STWERT3, :STWERT4,
            :START1, :START2, :START3, :START4, :BRUTTO, :SKONTOBRUTTO, :NETTO,
            :WARENWERT, :NKWARENW, :EKPREIS, :OPBETRAG, :GEWICHT;
   select WAEHRFAKT,ISOWAEHR from Beleg
   where BelegTyp = :ITyp and BelegArt = :IArt and BelegNr = :IBelegNr
   into :WAEHRFAKT,:ISOWAEHR;
   select AWert from GDI_WAEHRUMRECHNEN(:OPBETRAG,:WaehrFakt,-1,:ISOWaehr,"","")
   Into :FOPHAUS;
   if (IADRESSNR is Null) then IADRESSNR = 0;
   if (STWERT0 is Null) then STWERT0 = 0;
   if (STWERT1 is Null) then STWERT1 = 0;
   if (STWERT2 is Null) then STWERT2 = 0;
   if (STWERT4 is Null) then STWERT4 = 0;
   if (STWERT3 is Null) then STWERT3 = 0;
   if (STSATZ1 is Null) then STSATZ1 = 0;
   if (STSATZ2 is Null) then STSATZ2 = 0;
   if (STSATZ3 is Null) then STSATZ3 = 0;
   if (STSATZ4 is Null) then STSATZ4 = 0;
   if (START1 is Null) then START1 = "";
   if (START2 is Null) then START2 = "";
   if (START3 is Null) then START3 = "";
   if (START4 is Null) then START4 = "";
   if (BRUTTO is Null) then BRUTTO = 0;
   if (SKONTOBRUTTO is Null) then SKONTOBRUTTO = 0;
   if (NETTO is Null) then NETTO = 0;
   if (WARENWERT is Null) then WARENWERT = 0;
   if (NKWARENW is Null) then NKWARENW = 0;
   if (EKPREIS is Null) then EKPREIS = 0;
   if (OPBETRAG is Null) then OPBETRAG = 0;
   if (FOPHAUS is Null) then FOPHAUS = 0;
   if (GEWICHT is Null) then GEWICHT = 0;
   if (IBEDNAME is Null) then IBEDNAME = "";
   if (IDATUM is Null) then IDATUM = "now";
   Update Beleg set
      ADRESSNR = :IADRESSNR,   AendDatum = :IDATUM,    STWERT0  = :STWERT0,
      STSATZ1  = :STSATZ1,     STSATZ2   = :STSATZ2,   STSATZ3  = :STSATZ3,
      STSATZ4  = :STSATZ4,     STWERT1   = :STWERT1,   STWERT2  = :STWERT2,
      STWERT3  = :STWERT3,     STWERT4   = :STWERT4,   START1   = :START1,
      START2   = :START2,      START3    = :START3,    START4   = :START4,
      BRUTTO   = :BRUTTO,      NETTO     = :NETTO,     WARENWERT= :WARENWERT,
      NKWARENW = :NKWARENW,    EKPREIS   = :EKPREIS,   OPBETRAG = :OPBETRAG,
      OPHAUS   = :FOPHAUS,     GEWICHT   = :GEWICHT,   AENDBED  = :IBEDNAME,
      SKONTOBRUTTO = :SKONTOBRUTTO
   where Belegtyp = :ITyp and Belegart = :IArt and Belegnr =:IBelegnr;
   Errmsg = 0;
   suspend;
end
--

create procedure GDI_BelegAddStuck
   (ITYP CHAR(1), IART VarChar(5), IBELEGNR INTEGER, IADRESSNR INTEGER,
    IDATUM DATE, IFILIALE INTEGER, IBEDNAME VarChar(5),
    IPOSNR INTEGER, IKZDRUCK CHAR(1), ISTUCKL VarChar(30), IARTTEXT VarChar(255),
    IMENGE DOUBLE PRECISION, IEPREIS VarChar(30), IRABATT VarChar(30),
    IMODE INTEGER )
returns (Errmsg Integer, BelegNr Integer, PosNr Integer)
AS
   declare variable SatzUUID VarChar(40);
   declare variable PREIS Double precision;
   declare variable JAHR Char(4);
   declare variable FKZStueck Char(1);
   declare variable FArtikelNr VarChar(40);
   declare variable FCount Integer;
   declare variable FMenge DOUBLE PRECISION;
   declare variable FMENGENEINH SmallInt;
   declare variable FMefaktor DOUBLE PRECISION;
   declare variable FEKDEF VarChar(10);
   declare variable FKzLager char(1);
   declare variable FPreispfl char(1);
begin
   Errmsg = 0;
   FKZStueck = "";
   if (ITyp = "E") then begin
      select KZStueck,MEFaktor,MEEK,KzLager,Preispfl
      from Artikel where Artikelnr = :IStuckL
      into :FKZStueck,:FMEFaktor,:FMENGENEINH,:FKzLager,:FPreispfl;
   end else begin
      select KZStueck,MEFaktor,MEVK,KzLager,Preispfl
      from Artikel where Artikelnr = :IStuckL
      into :FKZStueck,:FMEFaktor,:FMENGENEINH,:FKzLager,:FPreispfl;
   end
   if ((FKZStueck <> "H") and (FKZStueck <> "P")) then begin
      Errmsg = -1;
      suspend;
      exit;
   end
   FCount = 0;
   select count(*) from Stuck where StuckL =:IStuckL and SatzArt = "P"
   into :FCount;
   if (FCount > 0) then begin
      FCount = 0;
      if (IBelegNr > 0) then begin
         select count(*) from Beleg
         where Belegtyp = :ITyp and Belegart = :IArt and Belegnr = :IBelegNr
         into :FCount;
      end
      if ((FCount = 0) or (IBelegNr < 1)) then begin
         if (IBelegNr < 0) then
            IBelegNr = 0;
         execute procedure GDI_BELEGINSERT :ITyp,:IArt,:IFiliale,:IBedName,:IBelegNr
            RETURNING_VALUES :Belegnr,:SatzUUID;
         if (Belegnr < 1) then begin
            Errmsg = -2;
            suspend;
            exit;
         end
         execute procedure GDI_BELEGADRUPD :ITyp,:IArt,:BelegNr,:IADRESSNR
            RETURNING_VALUES :FCount;
      end else begin
         Belegnr = IBelegNr;
      end
   end else begin
      Errmsg = -3;
      suspend;
      exit;
   end
   PosNr = IPosNr;
   Jahr = cast (extract (Year from :IDatum) as Char(4));
   if ((IMode = 1) or (IMode = 2) or (IMode = 9)) then begin
      execute PROCEDURE GDI_GetEKDef :ITyp,:IArt,:FKzLager,:FPreispfl
         RETURNING_VALUES :FEKDEF;
      execute PROCEDURE GDI_BELEGPOSINSERT :ITyp,:IArt,:BelegNr,:PosNr,:IKZDruck,:IStuckl,
         :IArtText,:IMenge,:IEPREIS,:IRABATT,:FMEFaktor,:FMENGENEINH,:Jahr,:FEKDEF
         RETURNING_VALUES :PosNr;
   end
   if ((IMode = 0) or (IMode = 1) or (IMode = 9)) then begin
      if (((IMode = 1) or (IMode = 9)) and (IKZDruck = "")) then
         IKZDruck = "M";
      for select st.Artikelnr,st.Menge,st.MEFaktor,st.MENGENEINH,a.KzLager,a.Preispfl
         from Stuck st Left join Artikel a on a.Artikelnr = st.Artikelnr
         where st.StuckL =:IStuckL and st.SatzArt = "P"
         into :FArtikelNr,:FMenge,:FMEFaktor,:FMENGENEINH,:FKzLager,:FPreispfl do begin
         if (IMode = 9) then
            FMenge = FMenge * -IMenge;
         else
            FMenge = FMenge *  IMenge;
         execute PROCEDURE GDI_GetEKDef :ITyp,:IArt,:FKzLager,:FPreispfl
            RETURNING_VALUES :FEKDEF;
         execute PROCEDURE GDI_BELEGPOSINSERT :ITyp,:IArt,:BelegNr,:PosNr,:IKZDruck,
                   :FArtikelNr,"",:FMenge,"","",:FMEFaktor,:FMENGENEINH,:Jahr,:FEKDEF
            RETURNING_VALUES :PosNr;
      end
   end
   execute procedure GDI_BELEGSETSUMME :ITyp,:IArt,:Belegnr,:IAdressNr,:IDatum,:IBedName
      RETURNING_VALUES :Errmsg;
   suspend;
end
--

create procedure GDI_BelegAddPos
   (ITYP CHAR(1), IART VarChar(5), IBELEGNR INTEGER, IADRESSNR INTEGER,
    IDATUM DATE, IFILIALE INTEGER, IBEDNAME VarChar(5),
    IPOSNR INTEGER, IKZDRUCK CHAR(1), IARTIKELNR VarChar(30), IARTTEXT VarChar(255),
    IMENGE DOUBLE PRECISION, IEPREIS VarChar(30), IRABATT VarChar(30) )
returns (Errmsg Integer, BelegNr Integer, PosNr Integer)
AS
   declare variable SatzUUID VarChar(40);
   declare variable PREIS Double precision;
   declare variable JAHR Char (4);
   declare variable FCount Integer;
   declare variable FMENGENEINH SmallInt;
   declare variable FMefaktor DOUBLE PRECISION;
   declare variable FEKDEF VarChar(10);
   declare variable FKzLager char(1);
   declare variable FPreispfl char(1);
begin
   Errmsg = 0;
   FCount = 0;
   if (IBelegNr > 0) then begin
      select count(*) from Beleg
      where Belegtyp = :ITyp and Belegart = :IArt and Belegnr = :IBelegNr
      into :FCount;
   end
   if ((FCount = 0) or (IBelegNr < 1)) then begin
      if (IBelegNr < 0) then
         IBelegNr = 0;
      execute procedure GDI_BELEGINSERT :ITyp,:IArt,:IFiliale,:IBedName,:IBelegNr
         RETURNING_VALUES :Belegnr,:SatzUUID;
      if (Belegnr < 1) then begin
         Errmsg = -2;
         suspend;
         exit;
      end
      execute procedure GDI_BELEGADRUPD :ITyp,:IArt,:BelegNr,:IADRESSNR
         RETURNING_VALUES :FCount;
   end else begin
      Belegnr = IBelegNr;
   end
   if (IDatum is null) then
      IDatum = "now";
   Jahr = cast (extract (Year from :IDatum) as Char(4));
   if (ITyp = "E") then begin
      select MEFaktor,MEEK,KzLager,Preispfl
      from Artikel where Artikelnr = :IArtikelnr
      into :FMEFaktor,:FMENGENEINH,:FKzLager,:FPreispfl;
   end else begin
      select MEFaktor,MEVK,KzLager,Preispfl
      from Artikel where Artikelnr = :IArtikelnr
      into :FMEFaktor,:FMENGENEINH,:FKzLager,:FPreispfl;
   end
   execute PROCEDURE GDI_GetEKDef :ITyp,:IArt,:FKzLager,:FPreispfl
      RETURNING_VALUES :FEKDEF;
   execute PROCEDURE GDI_BELEGPOSINSERT :ITyp,:IArt,:BelegNr,:IPosNr,:IKZDruck,:IArtikelNr,
         :IArtText,:IMenge,:IEPREIS,:IRABATT,:FMEFaktor,:FMENGENEINH,:Jahr,:FEKDEF
      RETURNING_VALUES :PosNr;
   execute procedure GDI_BELEGSETSUMME :ITyp,:IArt,:Belegnr,:IAdressNr,:IDatum,:IBedName
      RETURNING_VALUES :Errmsg;
   suspend;
end
--

create procedure GDI_StuckChArt
   (ITYP CHAR(1), IART VarChar(5), IARTIKELNR VarChar(40), ILEVEL INTEGER)
returns
   (Errmsg Integer, Artikelnr VarChar(40), KZSperre Char(1),
    ErsatzArt VarChar(40), ALevel Integer)
AS
   declare variable FKZSperre Char(1);
   declare variable FCount Integer;
begin
   ALevel = ILevel + 1;
   select count(*) from Artikel where Artikelnr = :IArtikelnr
   into FCount;
   if (FCount < 1) then begin
      Errmsg = -1;
      Artikelnr = IArtikelnr;
      suspend;
   end
   for select Artikelnr,ErsatzArt,KZSperre
      from Artikel where Artikelnr = :IArtikelnr
      into :Artikelnr,:ErsatzArt,:KZSperre do begin
      if (KZSperre = "1") then begin
         suspend;
         for select Errmsg,Artikelnr,KZSperre,ErsatzArt,ALevel
            from GDI_STUCKCHART(:ITyp,:IArt,:ErsatzArt,:ILevel)
            into :Errmsg,:Artikelnr,:KZSperre,:ErsatzArt,:ALevel do begin
            suspend;
         end
      end else
         suspend;
   end
end
--

create procedure GDI_StuckCheck
   (ITYP CHAR(1), IART VarChar(5), ISTUCKL VarChar(40),
    IMENGE DOUBLE PRECISION, IJAHR VarChar(4), IFiliale Integer)
returns (Errmsg Integer, Artikelnr VarChar(40), Text VarChar(255),
    Menge DOUBLE PRECISION, KZSperre Char(1), ErsatzArt VarChar(40), ALevel Integer,
    MengenEinh Integer, GBasBeleg Integer, GBasMengenEinh Integer,
    Verfuegbar DOUBLE PRECISION, GesMenge DOUBLE PRECISION)
AS
   declare variable FBasicPrg Blob;
   declare variable FKZStueck Char(1);
   declare variable FKZLager Char(1);
   declare variable FBasicTxt VarChar(32760);
   declare variable FBestand DOUBLE PRECISION;
   declare variable FMindBest DOUBLE PRECISION;
   declare variable FMindestMenge DOUBLE PRECISION;
   declare variable FLagNegBasis Integer;
   declare variable FCount Integer;
begin
   ALevel = 1;
   FKZStueck = "";
   GesMenge = 0;

   select KZStueck,KZSperre
   from Artikel where Artikelnr = :IStuckL
   into :FKZStueck,:KZSperre;
   if ((FKZStueck <> "H") and (FKZStueck <> "P")) then begin
      Errmsg = -1;
      suspend;
      exit;
   end
   FCount = 0;
   select count(*) from Stuck where StuckL =:IStuckL and SatzArt = "P"
   into :FCount;
   if (FCount < 1) then begin
      Errmsg = -3;
      suspend;
      exit;
   end
   Select count(*) from gdidef
   where Satzart = "TI" and Ind1 = "BELEG" and Ind2 = :ITyp and Ind3 = :IArt
   into :GBasBeleg;
   if (GBasBeleg > 0) then begin
      Select M4 from gdidef
      where Satzart = "TI" and Ind1 = "BELEG" and Ind2 = :ITyp and Ind3 = :IArt
      into :FBasicPrg;
      if (BlobSize(FBasicPrg) > 0) then begin
         FBasictxt = UpperCaseL(BlobToStr(FBasicPrg));
         GBasBeleg = PosL("LADEN.ARTIKEL",FBasicTxt) +
                     PosL("LADEN.ARTTEXT",FBasicTxt);
      end else
         GBasBeleg = 0;
   end
   FLagNegBasis = 0;
   select first 1 StrToInt(Copy(ListValue(M1,"LAGERNEGATIV.BASIS"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FLagNegBasis;
   if ((FLagNegBasis is null) or (FLagNegBasis < 0) or (FLagNegBasis > 1)) then
      FLagNegBasis = 0;
   for select st.Artikelnr,st.Text,st.Menge,st.MengenEinh,a.Ersatzart,a.KZStueck,a.KZSperre,a.KZLager
      from Stuck st Left join Artikel a on a.Artikelnr = st.Artikelnr
      where st.StuckL =:IStuckL and st.SatzArt = "P" order by st.posnr
      into :ArtikelNr,:Text,:Menge,:MengenEinh,:ErsatzArt,:FKZStueck,:KZSperre,:FKZLager do begin
      Verfuegbar = 0.0;
      GesMenge = Menge * IMenge;

      if (FKZLager = "1") then begin
         Select bestand,mindbest from GDI_GETLAGER(:Artikelnr,:IJahr,:IFiliale)
         into :FBestand,:FMindBest;
         if (FLagNegBasis = 1) then
            FMindestMenge = FMindBest;
         else
            FMindestMenge = 0;
         if (ITyp = "V") then begin
            if ((IArt = "LI") or (IArt = "RE") or (IArt = "MA")) then begin
                Verfuegbar = FBestand - FMindestMenge - Menge * IMenge;
             end else if (IArt = "GU") then begin
                Verfuegbar = FBestand - FMindestMenge + Menge * IMenge;
             end
          end else if (ITyp = "E") then begin
             if ((IArt = "LI") or (IArt = "RE") or (IArt = "MA")) then begin
                Verfuegbar = FBestand - FMindestMenge + Menge * IMenge;
             end else if (IArt = "GU") then begin
                Verfuegbar = FBestand - FMindestMenge - Menge * IMenge;
             end
         end
      end
      FCount = 0;
      Select count(*) from gdidef
      where Satzart = "ME" and W0 = :MengenEinh
      into :GBasMengenEinh;
      if (GBasMengenEinh > 0) then begin
         Select first 1 M2 from gdidef
         where Satzart = "ME" and W0 = :MengenEinh
         into :FBasicPrg;
         GBasMengenEinh = BlobSize(FBasicPrg);
      end
      if (KZSperre = "1") then begin
         suspend;
         for select Errmsg,Artikelnr,KZSperre,ErsatzArt,ALevel
            from GDI_STUCKCHART(:ITyp,:IArt,:ErsatzArt,:ALevel)
            into :Errmsg,:Artikelnr,:KZSperre,:ErsatzArt,:ALevel do begin
            suspend;
         end
         end else
            suspend;
      end
   end
--

create procedure GDI_StuckDaten
   (ITYP CHAR(1), IART VarChar(5), ISTUCKL VarChar(40),
    IMENGE DOUBLE PRECISION, IJAHR VarChar(4), IFiliale Integer,
    IMaxEbene SmallInt, IEbene Smallint)
returns
   (Artikelnr VarChar(40), Text VarChar(255), Menge DOUBLE PRECISION,
    GesMenge DOUBLE PRECISION, KZSperre Char(1), ErsatzArt VarChar(40), ALevel Integer,
    MengenEinh Integer, Errmsg Integer, Verfuegbar DOUBLE PRECISION, Bestand DOUBLE PRECISION)
AS
   declare variable FKZStueck Char(1);
   declare variable FKZLager Char(1);
   declare variable FBestand DOUBLE PRECISION;
   declare variable FVBestand DOUBLE PRECISION;
   declare variable FMindBest DOUBLE PRECISION;
   declare variable FMindestMenge DOUBLE PRECISION;
   declare variable FLagNegBasis Integer;
   declare variable FCount Integer;
begin
   FKZStueck = "";
   GesMenge  = 0;
   Verfuegbar = 0;
   Bestand    = 0;
   select KZStueck,KZSperre
   from Artikel where Artikelnr = :IStuckL
   into :FKZStueck,:KZSperre;
   if (not (FKZStueck in ("H","P"))) then begin
      Errmsg = -1;
      suspend;
      exit;
   end
   FCount = 0;
   select count(*) from Stuck where StuckL =:IStuckL and SatzArt = "P"
   into :FCount;
   if (FCount < 1) then begin
      Errmsg = -3;
      suspend;
      exit;
   end
   FLagNegBasis = 0;
   select first 1 StrToInt(Copy(ListValue(M1,"LAGERNEGATIV.BASIS"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FLagNegBasis;
   if ((FLagNegBasis is null) or (FLagNegBasis < 0) or (FLagNegBasis > 1)) then
      FLagNegBasis = 0;
   for select st.Artikelnr,st.Text,st.Menge,st.MengenEinh,a.Ersatzart,a.KZStueck,
              a.KZSperre,a.KZLager,a.KZStueck
      from Stuck st Left join Artikel a on a.Artikelnr = st.Artikelnr
      where st.StuckL =:IStuckL and st.SatzArt = "P" order by st.posnr
      into :ArtikelNr,:Text,:Menge,:MengenEinh,:ErsatzArt,:FKZStueck,
           :KZSperre,:FKZLager,FKZStueck do begin
      ALevel = IEbene;
      Verfuegbar = 0.0;
      GesMenge = Menge * IMenge;
      if (FKZLager = "1") then begin
         Select bestand, vbestand, mindbest from GDI_GETLAGER(:Artikelnr,:IJahr,:IFiliale)
         into :FBestand, :FVBestand, :FMindBest;
         if (FLagNegBasis = 1) then
            FMindestMenge = FMindBest;
         else
            FMindestMenge = 0;
         if (ITyp = "V") then begin
            if (IArt in ("LI", "RE", "MA", "FU")) then begin
                Bestand    = FBestand  - FMindestMenge - Menge * IMenge;
                Verfuegbar = FVBestand - FMindestMenge - Menge * IMenge;
            end
            else if (IArt in ("GU", "RL")) then begin
               Bestand    = FBestand  - FMindestMenge + Menge * IMenge;
               Verfuegbar = FVBestand - FMindestMenge + Menge * IMenge;
            end
            else if (IArt = "AU") then begin
               Bestand    = FBestand  - FMindestMenge;
               Verfuegbar = FVBestand - FMindestMenge - Menge * IMenge;
            end
         end
         else if (ITyp = "E") then begin
            if (IArt in ("LI", "RE", "MA", "FU")) then begin
               Bestand    = FBestand  - FMindestMenge + Menge * IMenge;
               Verfuegbar = FVBestand - FMindestMenge + Menge * IMenge;
            end
            else if (IArt in ("GU", "RL")) then begin
               Bestand    = FBestand  - FMindestMenge;
               Verfuegbar = FVBestand - FMindestMenge - Menge * IMenge;
            end
            else if (IArt = "BE") then begin
               Bestand    = FBestand  - FMindestMenge;
               Verfuegbar = FVBestand - FMindestMenge + Menge * IMenge;
            end
         end
         else if (ITyp = "L") then begin
            if (IArt = "Z") then begin
               Bestand    = FBestand  - FMindestMenge + Menge * IMenge;
               Verfuegbar = FVBestand - FMindestMenge + Menge * IMenge;
            end
            else if (IArt = "A") then begin
               Bestand    = FBestand  - FMindestMenge - Menge * IMenge;
               Verfuegbar = FVBestand - FMindestMenge - Menge * IMenge;
            end
         end
      end
      if (KZSperre = "1") then begin
         suspend;
      end else begin
         if ((FKZStueck in ("H","P")) and (IEbene < IMaxEbene)) then begin
            for select Artikelnr, Text, Menge, Gesmenge, KZSperre, ErsatzArt,
                       ALevel, MengenEinh, ErrMsg, Verfuegbar
               from GDI_STUCKDATEN(:ITYP, :IART, :Artikelnr, :GesMenge, :IJAHR,
                                   :IFiliale, :IMaxEbene, :IEbene + 1)
               into :Artikelnr, :Text, :Menge, :GesMenge, :KZSperre,
                    :ErsatzArt, :ALevel, :MengenEinh, :Errmsg, :Verfuegbar do begin
               suspend;
            end
         end else
            suspend;
      end
   end
end
--

create procedure GDI_ZAHLUNGEN
   (IBelegTyp     Char(1),
    IBelegArt     VarChar(5),
    IBelegNr      Integer,
    IAdressNr     Integer,
    IZahlDatum    TimeStamp,
    IZahlArt      Integer,
    IKzZahlung    Char(1),
    IZahlungAlt   Double Precision,
    IZahlungNeu   Double Precision,
    ISkontoAlt    Double Precision,
    ISkontoNeu    Double Precision,
    IScheckBtrAlt Double Precision,
    IScheckBtrNeu Double Precision,
    IAendBed      VarChar(5))
as
   declare variable FZahlDiff   Double Precision;
   declare variable FSkontoDiff Double Precision;
   declare variable FScheckDiff Double Precision;
   declare variable FLfdNr      Integer;
   declare variable FNK         SmallInt;
begin
   if ((IKZZahlung = "D") or (IKZZahlung = "I") or (IKZZahlung = "U")) then
      exit;
   FNK = null;
   select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNK;
   if ((FNK is null) or (FNK <= 0)) then
      FNK = 2;
   FZahlDiff   = Runden(IZahlungNeu   - IZahlungAlt, FNK);
   FSkontoDiff = Runden(ISkontoNeu    - ISkontoAlt, FNK);
   FScheckDiff = Runden(IScheckBtrNeu - IScheckBtrAlt, FNK);
   if ((Abs(FZahlDiff)   > 0)  or
       (Abs(FSkontoDiff) > 0)  or
       (Abs(FScheckDiff) > 0)) then begin
      FLfdNr = 0;
      select max(lfdnr) from Zahlungen
      where belegnr = :IBelegnr and belegtyp = :IBelegtyp and belegart = :IBelegart
      into :FLfdNr;
      if (FLfdNr is null) then
         FLfdNr = 0;
      FLfdNr = FLfdNr + 1;
      if (IZahlDatum is null) then
         IZahlDatum = "now";
      insert into Zahlungen
         (lfdnr, zahldatum, belegtyp, belegart, belegnr, adressnr, zahlart,
          KzZahlung, zahlung, skonto, scheckbtr, aendbed, AendDatum)
      values
         (:FLfdNr, :IZahlDatum, :IBelegTyp, :IBelegArt, :IBelegNr, :IAdressNr, :IZahlArt,
          :IKzZahlung, :FZahlDiff, :FSkontoDiff, :FScheckDiff, :IAendBed, "now");
   end
end
--

create procedure GDI_BELEGCHANGE
   (TYP     CHAR(1),
    ART     VarChar(5),
    BELEGNR INTEGER,
    NEUTYP  CHAR(1),
    NEUART  VarChar(5),
    DATUM   DATE)
returns
   (NR INTEGER)
as
   declare variable FPosNr Integer;
   declare variable FVon Integer;
   declare variable FBis Integer;
   declare variable FAnz Integer;
   declare variable FStep Integer;
   declare variable FName VarChar(100);
   declare variable FText VarChar(100);
   declare variable FBelegdat Date;
begin
   select Belegdat from Beleg
   where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr into :FBelegdat;
   if (Art = "AN") then begin
      FText = "laut Angebot-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end else if (Art = "AU") then begin
      FText = "laut Auftrag-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end else if (Art = "LI") then begin
      FText = "laut Lieferschein-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end else if ((Art = "RL") and (Typ = "E")) then begin
      FText = "laut Rcksendung-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end else if ((Art = "RL") and (Typ = "V")) then begin
      FText = "laut Rcknahme-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end else if (Art = "RE") then begin
      FText = "laut Rechnung-Nr.: " || Inttostr(Belegnr) || "  vom: " ||
              copy(datetimetostr(FBelegdat),1,10);
   end
   select first 1 cast(StrToInt(w1) as Integer) , cast(StrToInt(w2) as Integer),
           cast(StrToInt(w3) as Integer) , cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "TI" and Ind1 = "BELEG" and Ind2 = :NeuTyp and Ind3 = :NeuArt
   into   :FVon, :FBis, :Nr, :FStep;
   if (FStep < 1) then
      FStep = 1;
   if (Nr < FVon) then begin
      Nr = FVon;
   end
   FAnz = 1;
   while ((FAnz > 0) and (Nr < FBis)) do begin
      Nr = Nr + FStep;
      select count(*) from Beleg
       where BelegTyp = :NeuTyp and BelegArt = :NeuArt and BelegNr = :Nr
       into :FAnz;
   end
   if ((FAnz = 0) and (Nr <= FBis) and (FBelegdat > "01.01.1900")) then begin
      if (Art = "LI") then begin
         update Beleg set
            Liefnr   = Belegnr,
            LiefDat  = Belegdat,
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            Belegdat = :Datum
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr;
      end else if (Art = "RL") then begin
         update Beleg set
            RLiefnr  = Belegnr,
            RLiefDat = Belegdat,
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            Belegdat = :Datum
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr;
      end else if (Art = "AU") then begin
         update Beleg set
            Auftrnr  = Belegnr,
            AuftrDat = Belegdat,
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            Belegdat = :Datum
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr;
      end else if (Art = "AN") then begin
         update Beleg set
            AngebNr   = Belegnr,
            AngebDat  = Belegdat,
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            Belegdat = :Datum
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr;
      end else begin
         update Beleg set
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            Belegdat = :Datum
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr;
      end

      update GDIDEF set W3 = Inttostr(:Nr)
      where Satzart = "TI" and IND1 = "BELEG" and IND2 = :NeuTyp and IND3 = :NeuArt;

      for select PosNr from BelegPos
         where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr
         order by PosNr desc into :FPosNr
      do begin
         update BelegPos set
            Belegart = :NeuArt,
            Belegtyp = :NeuTyp,
            Belegnr  = :Nr,
            PosNr    = Posnr + 10,
            Datumpr  = :Datum
          where belegart = :Art and Belegtyp = :Typ and Belegnr = :Belegnr and PosNr = :FPosnr;
      end
      insert into Belegpos (Belegart,Belegtyp,Belegnr,PosNr,Text)
         Values (:NeuArt,:NeuTyp,:Nr,10,:Ftext);
   end else
      Nr = -1;
   suspend;
end
--

create procedure GDI_SHOPWGR_SORT
   (Parent_ID  Integer)
returns
  (ID         Integer,
   Parent     Integer,
   Name       VarChar(10000),
   CCount     Integer,
   SortIndex  Integer,
   ImageIndex Integer,
   StateIndex Integer,
   Node_Level Integer,
   FullPath   VarChar(32765))
as
   declare Variable Test_Parent Integer;
begin
   for select ID, PARENT, NAME, CCOUNT, SORTINDEX, IMAGEINDEX, STATEINDEX, FULLPATH
   from SHOPWGR where PARENT = :PARENT_ID order by SORTINDEX
   into :ID, :PARENT, :NAME , :CCOUNT, :SORTINDEX, :IMAGEINDEX, :STATEINDEX, :FULLPATH
   do begin
      NODE_LEVEL = 0;
      TEST_PARENT = PARENT;
      while (TEST_PARENT > 0) do begin
         select S.PARENT from SHOPWGR S where S.ID = :TEST_PARENT
         into :TEST_PARENT;
         NODE_LEVEL = NODE_LEVEL + 1;
      end
      suspend;
      if (CCOUNT <> 0) then begin
         TEST_PARENT = ID;
         for select ID, PARENT, NAME, CCOUNT, SORTINDEX,  IMAGEINDEX, STATEINDEX, FULLPATH
         from GDI_SHOPWGR_SORT(:TEST_PARENT)
         into :ID, :PARENT, :NAME, :CCOUNT, :SORTINDEX, :IMAGEINDEX, :STATEINDEX, :FULLPATH
         do begin
            NODE_LEVEL = 0;
            TEST_PARENT = PARENT;
            while (TEST_PARENT > 0) do begin
               select S.PARENT from SHOPWGR S where S.ID = :TEST_PARENT
               into :TEST_PARENT;
               NODE_LEVEL = NODE_LEVEL + 1;
            end
            suspend;
         end
      end
   end
end
--

create trigger GDI_SHOPCROSSSEL_BEFOREDELETE for SHOPCROSSSELL active before delete
as
   declare variable Anzahl integer;
   declare variable KzShop varchar(1);
begin
   select kzshop from artikel where artikelnr = old.artikelnr into :KzShop;
   if (KzShop = "1") then begin
      select count(*) Anzahl from SHOPTRANSFER
      where Nummer = old.Artikelnr and Typ = "CROS" and Nummer1 = old.Artikelnr1
      into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (Typ,Art,Nummer,Datum,Nummer1)
         values ("CROS","DELETE",Old.Artikelnr,"Now",Old.Artikelnr1) ;
      else
         update shoptransfer set Art = "DELETE", Datum="Now"
         where Typ = "CROS" and Nummer = Old.Artikelnr and Nummer1 = Old.Artikelnr1;
   end
end
--

create trigger GDI_SHOPCROSSSEL_BEFOREINSUPD for SHOPCROSSSELL active before insert or update
as
   declare variable Anzahl Integer;
   declare variable KZSHOP VarChar(1);
begin
   select KzShop from artikel where artikelnr = New.Artikelnr into :KzShop;
   if (kzshop = "1") then begin
      select count(*) Anzahl from SHOPTRANSFER
      where Nummer = New.Artikelnr and Typ = "CROS" and Nummer1 = New.Artikelnr1
      into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (Typ,Art,Nummer,Datum,Nummer1)
         values ("CROS","UPDATE",New.Artikelnr,"Now",New.Artikelnr1) ;
      else
         update shoptransfer set art = "UPDATE", Datum="Now"
         where TYP = "CROS" and Nummer = New.Artikelnr and Nummer1 = New.Artikelnr1;
   end
end
--

create trigger GDI_SHOPVARIANTEN_BEFOREDELETE for SHOPVARIANTEN active before delete
as
   declare variable Anzahl Integer;
   declare variable KZSHOP VarChar(1);
begin
   select KzShop from artikel where artikelnr= Old.Artikelnr into :KzShop;
   if (kzshop = "1") then begin
      select count(*) Anzahl
      from SHOPTRANSFER
      where Nummer = OLD.Artikelnr and TYP = "VARI" and Nummer1 = OLD.Artikelnr1
      into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (Typ,Art,Nummer,Datum,Nummer1)
         values ("VARI","DELETE",Old.Artikelnr,"Now",Old.Artikelnr1);
      else
         update shoptransfer set art = "DELETE", Datum="Now"
         where TYP = "VARI" and Nummer = Old.Artikelnr and Nummer1 = Old.Artikelnr1;
   end
end
--

create trigger GDI_SHOPVARIANTEN_BEFOREINSUPD for SHOPVARIANTEN active before insert or update
as
   declare variable Anzahl Integer;
   declare variable KZSHOP VarChar(1);
begin
   select KzShop from artikel where artikelnr=New.Artikelnr into :KzShop;
   if (kzshop = "1") then begin
      select count(*) Anzahl
      from SHOPTRANSFER
      where Nummer = New.Artikelnr and TYP = "VARI" and Nummer1 = New.Artikelnr1
      into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (Typ,Art,Nummer,Datum,Nummer1)
         values ("VARI","UPDATE",New.Artikelnr,"Now",New.Artikelnr1);
      else
         update shoptransfer set art = "UPDATE", Datum="Now"
         where TYP = "VARI" and Nummer = New.Artikelnr and Nummer1 = New.Artikelnr1;
   end
end
--

create trigger GDI_SHOPWGR_BEFOREDELETE for SHOPWGR active before delete
as
begin
   if (old.ccount > 0) then
      exception GDI_SHOPWGR_UNTERKNOTEN;
   update SHOPWGR S set S.CCOUNT = S.CCOUNT - 1 where S.ID = Old.PARENT;
   /* DELETE FROM SHOPWGR S WHERE S.PARENT = OLD.ID; */
end
--

create trigger GDI_SHOPWGR_BEFOREINSERT for SHOPWGR active before insert
as
   declare VARIABLE TESTPARENT INTEGER;
   declare VARIABLE TESTPATH VARCHAR(32765);
   declare VARIABLE TESTInfo VARCHAR(32765);
   declare VARIABLE MAXSORTINDEX INTEGER;
begin
   if (NEW.ID is null) then
       NEW.ID = GEN_ID(SHOPWGR_ID, 1);
   if (NEW.PARENT = NEW.ID) then
      exception GDI_TREE_CICLE_NODE;
   TESTPATH = '';
   TestInfo = '';
   if (NEW.PARENT <> 0) then begin
      select ID from SHOPWGR where ID = NEW.PARENT into TESTPARENT;
      if (TESTPARENT is null) then exception GDI_TREE_PARENT_NOT_FOUND;
      update SHOPWGR S set S.CCOUNT = S.CCOUNT + 1 where S.ID = NEW.PARENT;
      select S.FULLPATH from SHOPWGR S where (S.ID = NEW.PARENT) into :TESTPATH;
      select S.FULLInfo from SHOPWGR S where (S.ID = New.PARENT) into :TESTInfo;
   end
   NEW.FULLPATH = (TESTPATH || cast (NEW.ID as VARCHAR(20)) || '.');
   New.FULLInfo = (TESTInfo || New.Name || ' | ');

   select MAX(S.SORTINDEX) from SHOPWGR S
   where S.PARENT = NEW.PARENT into MAXSORTINDEX;
   if (MAXSORTINDEX is null) then
      NEW.SORTINDEX = 0;
   else
      NEW.SORTINDEX = MAXSORTINDEX + 1;
end
--

create trigger GDI_SHOPWGR_BEFOREUPDATE for SHOPWGR active before update
as
   declare VARIABLE TESTID INTEGER;
   declare VARIABLE TESTPARENT INTEGER;
   declare VARIABLE TESTPATH VARCHAR(32765);
   declare VARIABLE TestInfo VARCHAR(32765);
   declare VARIABLE NewInfo VARCHAR(32765);
   declare VARIABLE TestName VARCHAR(255);
   declare VARIABLE OLDPATH VARCHAR(32765);
   declare VARIABLE NEWPATH VARCHAR(32765);
   declare VARIABLE MAXSORTINDEX INTEGER;
begin
   if ((OLD.PARENT <> NEW.PARENT) or (Old.Name <> New.Name)) then begin
      if (NEW.PARENT <> 0) then begin
         select ID from SHOPWGR where ID = NEW.PARENT into :TESTPARENT;
         if (TESTPARENT is null) then exception GDI_TREE_PARENT_NOT_FOUND;
      end
      TESTPARENT = NEW.PARENT;
      WHILE (TESTPARENT > 0) DO begin
        select S.PARENT from SHOPWGR S where S.ID = :TESTPARENT into :TESTPARENT;
        if (TESTPARENT = NEW.ID) then exception GDI_TREE_CICLE_NODE;
      end

      select S.FULLPATH from SHOPWGR S where (S.ID = NEW.PARENT) into :TESTPATH;
      if (TESTPATH is null) then TESTPATH = '';
      select S.FULLInfo from SHOPWGR S where (S.ID = NEW.PARENT) into :TestInfo;
      if (TestInfo is null) then TestInfo = '';
      NEW.FULLPATH = (TESTPATH || cast(NEW.ID as VarChar(20)) || '.');
      NEW.FULLInfo = (TestInfo || New.Name || ' | ');

      update SHOPWGR S set S.CCOUNT = S.CCOUNT - 1 where S.ID = OLD.PARENT;
      update SHOPWGR S set S.CCOUNT = S.CCOUNT + 1 where S.ID = NEW.PARENT;
      if (OLD.CCOUNT > 0) then  begin /* CORRECT FULLPATH for CHILDREN */
        OLDPATH = OLD.FULLPATH;
        NEWPATH = NEW.FULLPATH;
        NEWInfo = NEW.FULLInfo;
        for select S.ID, S.PARENT, S.Name from SHOPWGR S
        where S.ID <> NEW.ID AND S.FULLPATH like (:OLDPATH || '%')
        into :TESTID, :TESTPARENT, :TestName
        do begin
           TESTPATH = cast(TESTID as VARCHAR(20)) || '.';
           TestInfo = TestName || ' | ';
           while (TESTPARENT <> NEW.ID) do begin
              TESTPATH = Cast(TESTPARENT as VARCHAR(20)) || '.' || TESTPATH;
              TestInfo = TestName || ' | ' || TestInfo;
              select S2.PARENT, S2.Name from SHOPWGR S2 where S2.ID = :TESTPARENT
              into :TESTPARENT, :TestName;
           end
           TESTPATH = NEWPATH || TESTPATH;
           TestInfo = NewInfo || TestInfo;
           update SHOPWGR S2 set S2.FULLPATH = :TESTPATH, S2.FULLInfo = :TestInfo
           where S2.ID = :TESTID;
        end
      end
      if (Old.Parent <> New.Parent) then begin
         select MAX(S.SORTINDEX) from SHOPWGR S
         where S.PARENT = NEW.PARENT into MAXSORTINDEX;
         if (MAXSORTINDEX is null) then
            NEW.SORTINDEX = 0;
         else
            NEW.SORTINDEX = MAXSORTINDEX + 1;
      end
   end
end
--

create trigger GDI_SHOPWGR_BEFOREINSUPDDEL for SHOPWGR before insert or update or delete
as
  declare variable Anzahl Integer;
begin
   select count(*) Anzahl from SHOPTRANSFER where TYP = "SHOPWGR"  into :Anzahl;
   if (Anzahl = 0) then
      insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("SHOPWGR","UPDATE","","Now") ;
   else
      update shoptransfer set art = "UPDATE", Datum="Now" where TYP="SHOPWGR";
end
--

create trigger GDI_SHOPARTIKEL_BEFOREDELETE for SHOPARTIKEL active before delete
AS
  declare variable Anzahl Integer;
  declare variable KZSHOP VarChar(1);
  declare variable Artikelnr VarChar(30);
begin
    Artikelnr = null;
    select first 1 artikelnr1 from ShopCrossSell
    where artikelnr1 = Old.Artikelnr into :Artikelnr;
    if (Artikelnr is not null) then
       Exception GDI_ShopArtikel_Delete;

    select first 1 artikelnr1 from ShopVarianten
    where artikelnr1 = Old.Artikelnr into :Artikelnr;
    if (Artikelnr is not null) then
       Exception GDI_ShopArtikel_Delete;

    select count(*) from SHOPTRANSFER where (TYP= "ARTIKEL" and Nummer = Old.Artikelnr) into :Anzahl;
    if (Anzahl = 0) then
       insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","DELETE",old.Artikelnr,"Now") ;
    else
       update shoptransfer set art = "DELETE", Datum="Now" where (TYP= "ARTIKEL" and Nummer=Old.Artikelnr);
end
--

create trigger GDI_SHOPARTIKEL_BEFOREINSUPD for SHOPARTIKEL active before insert or update
as
  declare variable Anzahl Integer;
  declare variable KZSHOP VarChar(1);
begin
    select KzShop from artikel where artikelnr= New.Artikelnr into :KzShop;
    if (KzShop = "1") then begin
       select count(*) from SHOPTRANSFER where (TYP="ARTIKEL" and Nummer = New.Artikelnr) into :Anzahl;
       if (Anzahl = 0) then
          insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","UPDATE",New.Artikelnr,"Now") ;
       else
          update shoptransfer set art = "UPDATE", Datum="Now" where (TYP="ARTIKEL" and Nummer=New.Artikelnr);
    end
    if (Kzshop = "0") then begin
       select count(*) from SHOPTRANSFER where (TYP = "ARTIKEL" and Nummer = New.Artikelnr) into :Anzahl;
       if (Anzahl = 0) then
          insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","DELETE",New.Artikelnr,"Now") ;
       else
          update shoptransfer set art = "DELETE", Datum="Now" where (TYP="ARTIKEL" and Nummer=New.Artikelnr);
    end
end
--

create trigger GDI_SHOPARTIKEL_AFTERUPDATE for SHOPARTIKEL active after update
as
begin
   if (old.shopwgr <> new.shopwgr) then
      update shopmerkmale set shopwgr = new.shopwgr where artikelnr = new.artikelnr;
end
--

create trigger GDI_SHOPARTIKEL_AFTERDELETE for SHOPARTIKEL active after delete
as
begin
   delete from ShopMerkmale where Artikelnr = Old.Artikelnr;
   delete from ShopVarianten where (Artikelnr = Old.Artikelnr) or (Artikelnr1 = Old.Artikelnr);
   delete from ShopCrossSell where (Artikelnr = Old.Artikelnr) or (Artikelnr1 = Old.Artikelnr);
end
--

create trigger GDI_KUNDEN_BEFOREINSUPD for KUNDEN before insert or update
as
  declare variable FAdrUUID VarChar(40);
begin
   if (New.KundenNr = 0) then
      exception GDI_STAMMKEY_INSUPD;
   if (New.AdressNr = 0) then begin
      New.AdrUUID = '';
   end else begin
      select first 1 AdrUUID from CM_Adressen where AdressNr = New.AdressNr into :FAdrUUID;
      New.AdrUUID = FAdrUUID;
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_KUNDEN_AFTERDELETE for KUNDEN after delete
as
begin
   delete from Ansprech where Datei = "KUNDEN" and Referenz = IntToStr(Old.Kundennr);
   delete from Notiz where Datei = "KUNDEN" and Referenz = IntToStr(Old.Kundennr);
   delete from AdrArt where AdressNr = Old.Kundennr;
   delete from Preise where AdressNr = Old.Kundennr and Old.Kundennr <> 0;
   delete from Rabatte where Liste = Old.Kundennr and Satzart = "AR";
   execute procedure GDI_DELDATEI "KUNDEN", "KUNDENNR", IntToStr(Old.Kundennr);
end
--

create trigger GDI_KUNDEN_AFTERINSERT for KUNDEN after insert
as
begin
   execute procedure GDI_Ansprech("KUNDEN",IntToStr(New.kundennr),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_KUNDEN_AFTERUPDATE for KUNDEN after update
as
begin
   if ((Old.Suchname <> New.Suchname) or (Old.Name1 <> New.Name1) or
      (Old.Name2 <> New.Name2) or (Old.Name3 <> New.Name3) or
      (Old.Strasse <> New.Strasse) or (Old.Land <> New.Land) or
      (Old.PLZ <> New.PLZ) or (Old.ort <> New.ort) or
      (Old.provinz <> New.provinz) or (Old.isoa2land <> New.isoa2land) or
      (Old.Postfach <> New.Postfach) or (Old.PLZpfach <> New.PLZpfach) or
      (Old.Telefon <> New.Telefon) or (Old.Handy <> New.Handy) or
      (Old.Telefax <> New.Telefax) or (Old.EMail <> New.EMail) or
      (Old.Homepage <> New.Homepage)) then
      execute procedure GDI_Ansprech("KUNDEN",IntToStr(New.kundennr),
        New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
        New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
        New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
        New.aendbed,New.AendDatum);
end
--

create trigger GDI_LIEFER_BEFOREINSUPD for LIEFER before insert or update
as
  declare variable FAdrUUID VarChar(40);
begin
   if (New.LieferNr = 0) then
      exception GDI_STAMMKEY_INSUPD;
   if (New.AdressNr = 0) then begin
      New.AdrUUID = '';
   end else begin
      select first 1 AdrUUID from CM_Adressen where AdressNr = New.AdressNr into :FAdrUUID;
      New.AdrUUID = FAdrUUID;
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then begin
      New.OffFiliale = New.OffFiliale * -1;
   end else begin
      New.OffFiliale = 0;
   end
end
--

create trigger GDI_LIEFER_AFTERDELETE for LIEFER after delete
as
begin
   delete from Ansprech where datei = "LIEFER" and referenz = IntToStr(Old.Liefernr);
   delete from Notiz where Datei = "LIEFER" and Referenz = IntToStr(Old.Liefernr);
   delete from AdrArt where AdressNr = Old.Liefernr;
   delete from Preise where AdressNr = Old.Liefernr and Old.Liefernr <> 0;
   execute procedure GDI_DELDATEI "LIEFER", "LIEFERNR", IntToStr(Old.LIEFERNR);
end
--

create trigger GDI_LIEFER_AFTERINSERT for LIEFER after insert
as
begin
   execute procedure GDI_Ansprech("LIEFER",IntToStr(New.liefernr),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_LIEFER_AFTERUPDATE for LIEFER after update
as
begin
   if ((Old.Suchname <> New.Suchname) or (Old.Name1 <> New.Name1) or
      (Old.Name2 <> New.Name2) or (Old.Name3 <> New.Name3) or
      (Old.Strasse <> New.Strasse) or (Old.Land <> New.Land) or
      (Old.PLZ <> New.PLZ) or (Old.ort <> New.ort) or
      (Old.provinz <> New.provinz) or (Old.isoa2land <> New.isoa2land) or
      (Old.Postfach <> New.Postfach) or (Old.PLZpfach <> New.PLZpfach) or
      (Old.Telefon <> New.Telefon) or (Old.Handy <> New.Handy) or
      (Old.Telefax <> New.Telefax) or (Old.EMail <> New.EMail) or
      (Old.Homepage <> New.Homepage)) then
      execute procedure GDI_Ansprech("LIEFER",IntToStr(New.liefernr),
        New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
        New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
        New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
        New.aendbed,New.AendDatum);
end
--

create trigger GDI_VERTRET_BEFOREINSUPD for VERTRET before insert or update
as
  declare variable FAdrUUID VarChar(40);
begin
   if (New.VertretNr = 0) then
      exception GDI_STAMMKEY_INSUPD;
   if (New.AdressNr = 0) then begin
      New.AdrUUID = '';
   end else begin
      select first 1 AdrUUID from CM_Adressen where AdressNr = New.AdressNr into :FAdrUUID;
      New.AdrUUID = FAdrUUID;
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then begin
      New.OffFiliale = New.OffFiliale * -1;
   end else begin
      New.OffFiliale = 0;
   end
end
--

create trigger GDI_VERTRET_AFTERDELETE for VERTRET after delete
as
begin
   delete from Ansprech where datei = "VERTRET" and referenz = IntToStr(Old.VERTRETNR);
   delete from Notiz where Datei = "VERTRET" and Referenz = intToStr(Old.VERTRETNR);
   execute procedure GDI_DELDATEI "VERTRET", "VERTRETNR", IntToStr(Old.Vertretnr);
end
--

create trigger GDI_VERTRET_AFTERINSERT for VERTRET after insert
as
begin
   execute procedure GDI_Ansprech("VERTRET",IntToStr(New.VERTRETNR),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_VERTRET_AFTERUPDATE for VERTRET after update
as
begin
   if ((Old.Suchname <> New.Suchname) or (Old.Name1 <> New.Name1) or
      (Old.Name2 <> New.Name2) or (Old.Name3 <> New.Name3) or
      (Old.Strasse <> New.Strasse) or (Old.Land <> New.Land) or
      (Old.PLZ <> New.PLZ) or (Old.ort <> New.ort) or
      (Old.provinz <> New.provinz) or (Old.isoa2land <> New.isoa2land) or
      (Old.Postfach <> New.Postfach) or (Old.PLZpfach <> New.PLZpfach) or
      (Old.Telefon <> New.Telefon) or (Old.Handy <> New.Handy) or
      (Old.Telefax <> New.Telefax) or (Old.EMail <> New.EMail) or
      (Old.Homepage <> New.Homepage)) then
   execute procedure GDI_Ansprech("VERTRET",IntToStr(New.VERTRETNR),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_PERSONAL_BEFOREINSUPD for PERSONAL before insert or update
as
   declare variable FAdrUUID VarChar(40);
begin
   if ((New.PersonalNr is Null) or (New.PersonalNr = "")) then
      exception GDI_STAMMKEY_INSUPD;
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_PERSONAL_AFTERDELETE for PERSONAL after delete
as
begin
   delete from Ansprech where datei = "PERSONAL" and referenz = Old.PERSONALNR;
   delete from Notiz where Datei = "PERSONAL" and Referenz = Old.PERSONALNR;
   execute procedure GDI_DELDATEI "PERSONAL", "PERSONALNR", Old.PERSONALNR;
end
--

create trigger GDI_PERSONAL_AFTERINSERT for PERSONAL after insert
as
begin
   execute procedure GDI_Ansprech("PERSONAL",New.PERSONALNR,
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_PERSONAL_AFTERUPDATE for PERSONAL after update
as
begin
   if ((Old.Suchname <> New.Suchname) or (Old.Name1 <> New.Name1) or
      (Old.Name2 <> New.Name2) or (Old.Name3 <> New.Name3) or
      (Old.Strasse <> New.Strasse) or (Old.Land <> New.Land) or
      (Old.PLZ <> New.PLZ) or (Old.ort <> New.ort) or
      (Old.provinz <> New.provinz) or (Old.isoa2land <> New.isoa2land) or
      (Old.Postfach <> New.Postfach) or (Old.PLZpfach <> New.PLZpfach) or
      (Old.Telefon <> New.Telefon) or (Old.Handy <> New.Handy) or
      (Old.Telefax <> New.Telefax) or (Old.EMail <> New.EMail) or
      (Old.Homepage <> New.Homepage)) then
   execute procedure GDI_Ansprech("PERSONAL",New.PERSONALNR,
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_INTERESS_BEFOREINSUPD for INTERESS before insert or update
as
  declare variable FAdrUUID VarChar(40);
begin
   if (New.InteressNr = 0) then
      exception GDI_STAMMKEY_INSUPD;
   if (New.AdressNr = 0) then begin
      New.AdrUUID = '';
   end else begin
      select first 1 AdrUUID from CM_Adressen where AdressNr = New.AdressNr into :FAdrUUID;
      New.AdrUUID = FAdrUUID;
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_INTERESS_AFTERDELETE for INTERESS after delete
as
begin
   delete from Ansprech where datei = "INTERESS" and referenz = IntToStr(Old.INTERESSNR);
   delete from Notiz where Datei = "INTERESS" and Referenz = IntToStr(Old.INTERESSNR);
   execute procedure GDI_DELDATEI "INTERESS", "INTERESSNR", IntToStr(Old.INTERESSNR);
end
--

create trigger GDI_INTERESS_AFTERINSERT for INTERESS after insert
as
begin
   execute procedure GDI_Ansprech("INTERESS",IntToStr(New.INTERESSNR),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_INTERESS_AFTERUPDATE for INTERESS after update
as
begin
   if ((Old.Suchname <> New.Suchname) or (Old.Name1 <> New.Name1) or
      (Old.Name2 <> New.Name2) or (Old.Name3 <> New.Name3) or
      (Old.Strasse <> New.Strasse) or (Old.Land <> New.Land) or
      (Old.PLZ <> New.PLZ) or (Old.ort <> New.ort) or
      (Old.provinz <> New.provinz) or (Old.isoa2land <> New.isoa2land) or
      (Old.Postfach <> New.Postfach) or (Old.PLZpfach <> New.PLZpfach) or
      (Old.Telefon <> New.Telefon) or (Old.Handy <> New.Handy) or
      (Old.Telefax <> New.Telefax) or (Old.EMail <> New.EMail) or
      (Old.Homepage <> New.Homepage)) then
   execute procedure GDI_Ansprech("INTERESS",IntToStr(New.INTERESSNR),
     New.Suchname,New.Name1,New.Name2,New.Name3,New.Strasse,
     New.Land,New.PLZ,New.ort,New.provinz,New.isoa2land,New.Postfach,
     New.PLZpfach,New.Telefon,New.Handy,New.Telefax,New.EMail,New.Homepage,
     New.aendbed,New.AendDatum);
end
--

create trigger GDI_BELEGPOS_BEFOREINSERT for BELEGPOS before insert
as
   declare variable  FAbgerBis Date;
   declare variable  FAdrUUID  VarChar(40);
begin
   if ((New.BelegTyp || New.PosArt = "LZ")  or
       (New.BelegTyp || New.PosArt = "LA")  or
       (New.BelegTyp || New.PosArt = "LK")) then begin
      FAbgerBis = "01.01.1970";
      select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
      into :FAbgerBis;
      if (New.DatumPr < FAbgerBis + 1) then
         /* "Buchungsdatum liegt im abgerechneten Zeitraum" */
         exception GDI_LAGER_ABGERECHNET;
   end
   /* Inventurdatum immer 0 Uhr! */
   if ((New.BelegTyp = "L") and (New.PosArt = "I")) then begin
      New.DatumMe = GetDate(New.DatumMe);
      New.DatumPr = GetDate(New.DatumPr);
   end
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   if ((New.AdrUUID is null) or (StrLen(New.AdrUUID) < 32)) then begin
      select first 1 AdrUUID from Beleg
      where BelegNr = New.BelegNr and BelegTyp = New.BelegTyp and BelegArt = New.BelegArt
      Into :FAdrUUID;
      New.AdrUUID  = FAdrUUID;
   end
   New.CreateDatum = "Now";
   New.AendDatum = "Now";
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_BELEGPOS_BEFOREUPDATE for BELEGPOS before update
as
   declare variable  FAbgerBis Date;
   declare variable  FDatum    VarChar(30);
   declare variable  FBlobSize Integer;
   declare variable  FKzArt    Char(1);
   declare variable  FAdrUUID  VarChar(40);
begin
   if (gen_id(Buchen_disabled, 0) = 0) then begin
      if ((New.BelegTyp || New.PosArt = "LZ")  or
          (New.BelegTyp || New.PosArt = "LA")  or
          (New.BelegTyp || New.PosArt = "LK")) then begin
         FAbgerBis = "01.01.1970";
         select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
         into :FAbgerBis;
         if (New.DatumPr < FAbgerBis + 1) then
            /* "Buchungsdatum liegt im abgerechneten Zeitraum" */
            exception GDI_LAGER_ABGERECHNET;
      end
      /* Inventurdatum immer 0 Uhr! */
      if ((New.BelegTyp = "L") and (New.PosArt = "I")) then begin
         New.DatumMe = GetDate(New.DatumMe);
         New.DatumPr = GetDate(New.DatumPr);
      end
   end
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   if ((New.AdrUUID is null) or (StrLen(New.AdrUUID) < 32)) then begin
      select first 1 AdrUUID from Beleg
      where BelegNr = New.BelegNr and BelegTyp = New.BelegTyp and BelegArt = New.BelegArt
      Into :FAdrUUID;
      New.AdrUUID  = FAdrUUID;
   end
   New.AendDatum = "Now";
   if (gen_id(Historie_Disabled, 0) = 0) then begin
      if ((New.BelegTyp <> Old.BelegTyp) or (New.BelegArt  <> Old.BelegArt)  or
          (New.BelegNr  <> Old.BelegNr)  or (New.PosNr     <> Old.PosNr)     or
          (New.DatumME  <> Old.DatumME)  or (New.AdressNr  <> Old.AdressNr)  or
          (New.KzDruck  <> Old.KzDruck)  or (New.ArtikelNr <> Old.ArtikelNr) or
          (New.Menge    <> Old.Menge)    and (Old.Menge     <> 0.0)          or
          (New.EPreis   <> Old.EPreis)   and (Old.EPreis    <> 0.0)          or
          (New.Rabatt   <> Old.Rabatt)   and (Old.Rabatt    <> 0.0)          or
          (New.Gesamt   <> Old.Gesamt)   and (Old.Gesamt    <> 0.0)          or
          (New.EKwert   <> Old.EKwert)   and (Old.EKwert    <> 0.0)          or
          (New.EKgesamt <> Old.EKgesamt) and (Old.EKgesamt  <> 0.0)          or
          (New.LagerME  <> Old.LagerME)  and (Old.LagerME   <> 0.0)          or
          (New.LagerPR  <> Old.LagerPR)  and (Old.LagerPR   <> 0.0) ) then begin
         FBlobSize = BlobSize(New.Historie);
         if ((FBlobSize < 1) or (FBlobSize > 30000)) then begin
            New.Historie = StrToBlob("KzArt=C1BelegTyp=C1BelegArt=C5BelegNr=I"    ||
               "PosNr=IDatumME=DAdressNr=IKzDruck=C1ArtikelNr=C30Text=C255"     ||
               "MengenEinh=IMenge=FEPreis=FRabatt=FGesamt=FEKwert=FEKgesamt=F" ||
               "LagerME=FLagerPR=FAendDatum=DBediener=C5" ||
               Ascii_Char2(255) || Ascii_Char2(13) || Ascii_Char2(10) );
         end
         if (New.KzTeilUeb <> Old.KzTeilUeb) then
            FKzArt = "";
         else
            FKzArt = "";
         FDatum = DateTimeToStr("now");
         New.Historie = StrToBlob( BlobToStr(New.Historie) || FKzArt   || "" ||
            Old.BelegTyp || "" || Old.BelegArt || "" || Old.BelegNr  || "" ||
            Old.PosNr    || "" || DateTimeToStr(Old.DatumME)          || "" ||
            Old.Adressnr || "" || Old.KzDruck || "" || Old.Artikelnr || "" ||
            BlobToSubString(Old.Text,1,255)   || "" || Old.MengenEinh || "" ||
            FloatToStr(Old.Menge)  || "" || FloatToStr(Old.EPreis)    || "" ||
            FloatToStr(Old.Rabatt) || "" || FloatToStr(Old.Gesamt)    || "" ||
            FloatToStr(Old.EKwert) || "" || FloatToStr(Old.EKgesamt)  || "" ||
            FloatToStr(Old.LagerME) || "" || FloatToStr(Old.LagerPR)  || "" ||
            FDatum || "" || New.Bediener || "" ||
            Ascii_Char2(255) || Ascii_Char2(13) || Ascii_Char2(10) );
      end
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_BELEGPOS_AFTERINSERT for BELEGPOS after insert
as
   declare variable FVon       Date;
   declare variable FBis       Date;
   declare variable FAb        Date;
   declare variable FJahr      SmallInt;
   declare variable FVonMonat  SmallInt;
   declare variable FMonatMe   SmallInt;
   declare variable FMonatpr   SmallInt;
   declare variable FArt       VarChar(10);
   declare variable FMenge     Double Precision;
   declare variable FWert      Double Precision;
   declare variable FEKGesamt  Double Precision;
   declare variable FEKWert    Double Precision;
   declare variable FNK        Double Precision;
   declare variable FErloes    Double Precision;
   declare variable FUmsatz    Double Precision;
   declare variable FErrMsg    SmallInt;
   declare variable FCJahr     Char(4);
   declare variable FPreisPfl  Char(1);
   declare variable FChargeArt Char(2);
   declare variable FEKWertAbw Char(1);
begin
   if (New.BelegTyp = "L") then
      FArt = New.PosArt;
   else
      FArt = New.BelegArt;
   if ((New.Artikelnr <> "") and
       ((not (New.KzDruck in ("P","S","E","T","t","C","A"))) or (New.kzdruck is null)) and
       /* Invenur/Korrektur mu auch mit Menge/Wert 0 mglich sein! */
       ((FArt = "I") or (FArt = "K") or
        (New.Lagerpr <> 0) or (New.Lagerme <> 0) or (New.EKGesamt <> 0)) and
       (FArt in ("RE","RL","LI","AU","BE","GU","MA","FU","Z","K","A","I"))) then begin
      if ((New.BelegTyp <> "L") and
          ((New.AdressNr = 0) or (New.AdressNr is null))) then begin
         exception GDI_AdressNr_INS;
      end
      select first 1 StrToDateTime(W1), StrToDateTime(W2), StrToDateTime(W3),
                     cast(K3 as Char(1)) from GDIDEF
      where  Satzart = "FA2"
      into  :FVon, :FBis, :FAb, :FPreisPfl;
      FJahr     = extract(Year from FVon);
      FVonMonat = FJahr * 12 + extract(Month from FVon);
      FMonatMe  = (extract(Year from New.Datumme) * 12 +
                   extract(Month from New.Datumme)) + 1 - FVonMonat;
      if (:FMonatMe > 12) then
         FMonatMe = 13;
      FMonatPr  = (extract(Year from New.Datumpr) * 12 +
                   extract(Month from New.Datumpr)) + 1 - FVonMonat;
      if (:FMonatPr > 12) then
         FMonatPr = 13;
      FCJahr = cast(FJahr as Char(4));
      if (FArt = "I")  then begin
         if ((New.DatumMe >= :FAb) and (FMonatMe > 0 ) and (FMonatMe < 13)) then begin
            execute procedure GDI_Inventur New.Artikelnr, New.Filiale, :FCJahr,
                                           FMonatMe, New.Datumme, New.Lagerme,
                                           New.Lagerpr, New.EPreis, New.MeFaktor
               RETURNING_VALUES :FErrMsg;
         end
         else begin
            if ((New.DatumMe >= :FVon) and (New.DatumMe < :FAb)) then begin
               /* "Inventurdatum liegt im abgerechneten Zeitraum!" */
               exception GDI_INVENTUR_ABGERECHNET;
            end
            else begin
               /* "Inventurdatum liegt auerhalb des gltigen Geschftsjahres!" */
               exception GDI_INVENTUR_JAHR;
            end
         end
      end else begin
          FMenge  = New.Lagerme;
          FWert   = New.Lagerpr;
         FEKWertAbw = null;
         select first 1 UpperCase(Copy(ListValue(M1,"EKWERT.EINKAUF.ABWEICHEND"),1,1)) from GDIDEF
         where Satzart = "FA1" into :FEKWertAbw;
         if ((FEKWertAbw is null) or (FEKWertAbw = "")) then
            FEKWertAbw = "N";
         if ((FEKWertAbw <> "J") and ((New.BelegTyp = "E") or (:FArt = "Z"))) then
              FEKGesamt = New.Lagerpr;
          else
              FEKGesamt = New.EKGesamt;
          if (:FArt in ("GU")) then begin
             FMenge  = -FMenge;
             FWert   = -FWert;
             FEKGesamt = -FEKGesamt;
          end
          FEkWert = FEKGesamt;
          if (New.KzDruck = "M") then begin
             FWert = 0;
             FEKGesamt = 0;
          end else if (New.KzDruck = "W") then begin
             FMenge = 0;
             FEKWert = 0;
          end
          execute procedure GDI_ARUMSATZ New.Artikelnr, New.AdressNr,
             :FMonatme, :FMonatpr, :FCJahr, New.Filiale,
             New.DatumMe, New.BelegTyp, :FArt, New.KzDruck, :FMenge, :FWert,
             :FEKWert, :FPreisPfl, New.MeFaktor, New.KZEKWert
             RETURNING_VALUES :FErrMsg;
          if ((New.KZAdrArt = "1") and (FMonatpr > 0) and (Fmonatpr <= 13) and
              (FArt in ("RE","GU","MA","FU","Z","A"))) then begin
             execute procedure GDI_AdrArt New.Artikelnr,New.AdressNr,:FMonatpr,New.Datumpr,:FMenge,:FWert,New.rabatt,"1"
                RETURNING_VALUES :FErrMsg;
          end
      end
      FNK     = 0;
      FUmsatz = 0;
      FErloes = 0;
      if (New.KZNK = "1") then
         FNK     = FWert;
      else
         FUmsatz = FWert;
      if (New.KZErloes <> "2") then begin
         if (New.KZErloes = "1") then begin
            if (New.EKGesamt <> 0) then
               FErloes = FWert -FEKGesamt;
         end else
            FErloes = FWert -FEKGesamt;
      end
      if (((FMonatPr > 0) or (FArt in ("AU","BE","LI","RL"))) and (New.AdressNr <> 0)) then begin
          execute procedure GDI_ADUmsatz New.AdressNr, :FMonatpr,
                :FCJahr, New.Filiale,New.BelegTyp,:FArt,:FErloes,:FUmsatz, FNk
             RETURNING_VALUES :FErrMsg;
      end
      if (New.KZSerie in ("1","2")) then begin
            update SerPos set PosArt    = New.PosArt,    Artikelnr = New.Artikelnr,
                              Filiale   = New.Filiale,   AdressNr  = New.AdressNr,
                              Datumpr   = New.Datumpr,   LagerEp   = Division (New.LagerPr, New.LagerMe),
                              AendBed   = New.Bediener,  AendDatum = "Now"
            where BelegTyp = New.BelegTyp and BelegArt = New.BelegArt and
                  BelegNr  = New.BelegNr  and posnr    = New.posnr;
      end

      if ((New.KZCharge in ("1","2")) and (New.BelegTyp in ("E", "V", "L"))) then begin
         if (New.BelegTyp = "V") then begin
            if      (FArt = "AU") then FChargeArt = "R";
            else if (FArt = "GU") then FChargeArt = "Z";
            else if (FArt = "RL") then FChargeArt = "Z";
            else if (FArt = "CK") then FChargeArt = "KV";
            else FChargeArt = "A";
         end
         else if (New.BelegTyp = "E") then begin
            if      (FArt = "BE") then FChargeArt = "B";
            else if (FArt = "GU") then FChargeArt = "A";
            else if (FArt = "RL") then FChargeArt = "A";
            else if (FArt = "CK") then FChargeArt = "KE";
            else FChargeArt = "Z";
         end
         else if (New.BelegTyp = "L") then begin
            if      (FArt = "Z") then FChargeArt = "Z";
            else if (FArt = "A") then FChargeArt = "A";
            else FChargeArt = "?";
         end
         else FChargeArt = "?";
/* Noch zu prfen: Feld ChargePos.LieferAdr hier setzen? */
         update ChargePos set Artikelnr = New.Artikelnr, Filiale  = New.Filiale,
                              Datumme   = New.Datumme,   Art      = :FChargeArt,
                              AdressNr  = New.AdressNr,  AendBed  = New.Bediener,
                              AendDatum = "Now"
         where BelegNr  = New.BelegNr  and BelegArt = New.BelegArt and
               BelegTyp = New.BelegTyp and Posnr    = New.Posnr;
      end
   end
end
--

create trigger GDI_BELEGPOS_AFTERUPDATE for BELEGPOS after update
as
   declare variable FVon       Date;
   declare variable FBis       Date;
   declare variable FAb        Date;
   declare variable FJahr      SmallInt;
   declare variable FVonMonat  SmallInt;
   declare variable FMonatMe   SmallInt;
   declare variable FMonatpr   SmallInt;
   declare variable FArt       VarChar(10);
   declare variable FMenge     Double Precision;
   declare variable FWert      Double Precision;
   declare variable FEKGesamt  Double Precision;
   declare variable FEKWert    Double Precision;
   declare variable FNK        Double Precision;
   declare variable FErloes    Double Precision;
   declare variable FUmsatz    Double Precision;
   declare variable FErrMsg    SmallInt;
   declare variable FCJahr     Char(4);
   declare variable FPreisPfl  Char(1);
   declare variable FChargeArt Char(2);
   declare variable FEKWertAbw Char(1);
begin
   if ((Old.Artikelnr <> New.Artikelnr) or (Old.AdressNr <> New.AdressNr) or
       (Old.KzDruck   <> New.KZDruck)   or (Old.LagerMe  <> New.LagerMe)  or
       (Old.LagerPr   <> New.Lagerpr)   or (Old.EKGesamt <> New.EKGesamt) or
       (Old.KzAdrArt  <> New.KZAdrArt)  or (Old.Filiale  <> New.Filiale)  or
       (Old.Datumme   <> New.Datumme)   or (Old.Datumpr  <> New.Datumpr)  or
       (Old.KzNK      <> New.KzNK)      or (Old.EPreis   <> New.EPreis))  then begin
      select first 1 StrToDateTime(W1), StrToDateTime(W2), StrToDateTime(W3),
                     cast(k3 as Char(1)) from GDIDEF
      where Satzart = "FA2"
      into  :FVon, :FBis, :FAb, :FPreisPfl;
      if (Old.BelegTyp = "L") then
         FArt = Old.PosArt;
      else
         FArt = Old.BelegArt;
      FJahr     = extract(Year from FVon);
      FVonMonat = FJahr * 12 + extract(Month from FVon);
      if ((Old.Artikelnr <> "") and
          ((not (Old.KzDruck in ("P","S","E","T","t","C","A"))) or (Old.kzdruck is null)) and
          ((Old.Lagerpr <> 0) or (Old.Lagerme <> 0) or (Old.EKGesamt <> 0)) and
          (FArt in ("RE","RL","LI","AU","BE","GU","MA","FU","Z","K","A","I"))) then begin
         FMonatMe  = (extract(Year from Old.Datumme) * 12 +
                      extract(Month from Old.Datumme)) + 1 - FVonMonat;
         if (:FMonatMe > 12) then
            FMonatMe = 13;
         FMonatPr  = (extract(Year from Old.Datumpr) * 12 +
                      extract(Month from Old.Datumpr)) + 1 - FVonMonat;
         if (:FMonatPr > 12) then
            FMonatPr = 13;
         FMenge  = -Old.Lagerme;
         FWert   = -Old.Lagerpr;
         FEKWertAbw = null;
         select first 1 UpperCase(Copy(ListValue(M1,"EKWERT.EINKAUF.ABWEICHEND"),1,1)) from GDIDEF
         where Satzart = "FA1" into :FEKWertAbw;
         if ((FEKWertAbw is null) or (FEKWertAbw = "")) then
            FEKWertAbw = "N";
         if ((FEKWertAbw <> "J") and ((Old.BelegTyp = "E") or (:FArt = "Z"))) then
             FEKGesamt = -Old.Lagerpr;
         else
             FEKGesamt = -Old.EKGesamt;
         if (:FArt in ("GU")) then begin
            FMenge  = -FMenge;
            FWert   = -FWert;
            FEkGesamt = -FEkGesamt;
         end
         FEkWert = FEKGesamt;
         if (Old.KzDruck = "M") then begin
            FWert = 0;
            FEkGesamt = 0;
         end else if (Old.KzDruck = "W") then begin
            FMenge  = 0;
            FEKWert = 0;
         end
         FCJahr = cast(FJahr as Char(4));
         execute procedure GDI_ARUmsatz Old.Artikelnr, Old.AdressNr,
               :FMonatme, :FMonatpr, :FCJahr, Old.Filiale,
               Old.DatumMe, Old.BelegTyp, :FArt, Old.KzDruck, :FMenge, :FWert,
               :FEKWert, :FPreisPfl, Old.MeFaktor, Old.KZEKWert
            RETURNING_VALUES :FErrMsg;
         if ((Old.KZAdrArt = "1") and (FMonatpr > 0) and (Fmonatpr <= 13) and
            (FArt in ("RE","GU","MA","FU","Z","A"))) then begin
            execute procedure GDI_AdrArt Old.Artikelnr,Old.AdressNr,:FMonatpr,Old.Datumpr,:FMenge,:FWert,Old.rabatt,"0"
               RETURNING_VALUES :FErrMsg;
         end
         FNK     = 0;
         FUmsatz = 0;
         FErloes = 0;
         if (Old.KZNK = "1") then
            FNK     = FWert;
         else
            FUmsatz = FWert;
         if (Old.KZErloes <> "2") then begin
            if (Old.KZErloes = "1") then begin
               if (Old.EKGesamt <> 0) then
                  FErloes = FWert -FEKGesamt;
            end else
               FErloes = FWert -FEKGesamt;
         end
         if (((FMonatPr > 0) or (FArt in ("AU","BE","LI","RL"))) and (Old.AdressNr <> 0)) then begin
             execute procedure GDI_ADUmsatz Old.AdressNr, :FMonatpr,
                  :FCJahr, Old.Filiale,Old.BelegTyp,:FArt,:FErloes,:FUmsatz, FNk
                RETURNING_VALUES :FErrMsg;
         end
      end
      if (New.BelegTyp = "L") then
         FArt = New.PosArt;
      else
         FArt = New.BelegArt;
      if ((New.Artikelnr <> "") and
          ((not (New.KzDruck in ("P","S","E","T","t","C","A"))) or (New.kzdruck is null)) and
          ((FArt = "I") or (New.Lagerpr <> 0) or (New.Lagerme <> 0) or (New.EKGesamt <> 0)) and
          (FArt in ("RE","LI","RL","AU","BE","GU","MA","FU","Z","K","A","I"))) then begin
         if ((New.BelegTyp <> "L") and
             ((New.AdressNr = 0) or (New.AdressNr is null))) then begin
            exception GDI_AdressNr_UPD;
         end
         FMonatMe  = (extract(Year from New.Datumme) * 12 +
                      extract(Month from New.Datumme)) + 1 - FVonMonat;
         if (:FMonatMe > 12) then
            FMonatMe = 13;
         FMonatPr  = (extract(Year from New.Datumpr) * 12 +
                      extract(Month from New.Datumpr)) + 1 - FVonMonat;
         if (:FMonatPr > 12) then
            FMonatPr = 13;
         FMenge  = New.Lagerme;
         FWert   = New.Lagerpr;
         FEKWertAbw = null;
         select first 1 UpperCase(Copy(ListValue(M1,"EKWERT.EINKAUF.ABWEICHEND"),1,1)) from GDIDEF
         where Satzart = "FA1" into :FEKWertAbw;
         if ((FEKWertAbw is null) or (FEKWertAbw = "")) then
            FEKWertAbw = "N";
         if ((FEKWertAbw <> "J") and ((New.BelegTyp = "E") or (:FArt = "Z"))) then
             FEKGesamt = New.Lagerpr;
         else
             FEKGesamt = New.EKGesamt;
         if (:FArt in ("GU")) then begin
            FMenge  = -FMenge;
            FWert   = -FWert;
            FEkGesamt = -FEkGesamt;
         end
         FEKWert = FEKGesamt;
         if (New.KzDruck = "M") then begin
            FWert = 0;
            FEkGesamt = 0;
         end else if (New.KzDruck = "W") then begin
            FMenge = 0;
            FEKWert = 0;
         end
         FCJahr = cast(FJahr as Char(4));
         if (FArt = "I")  then begin
            if ((New.Datumme >= :FAb) and (FMonatMe > 0 ) and (FMonatMe < 13)) then begin
               execute procedure GDI_Inventur New.Artikelnr, New.Filiale, :FCJahr,
                                              FMonatMe, New.Datumme, New.Lagerme,
                                              New.Lagerpr, New.EPreis, New.MeFaktor
                  RETURNING_VALUES :FErrMsg;
            end
            /* else Fehlermeldung */
         end else begin
             execute procedure GDI_ARUmsatz New.Artikelnr, New.AdressNr,
                   :FMonatme, :FMonatpr, :FCJahr, New.Filiale,
                   New.DatumMe,New.BelegTyp,:FArt, New.KzDruck, :FMenge, :FWert,
                   :FEKWert,:FPreisPfl, New.MeFaktor, New.KZEKWert
                RETURNING_VALUES :FErrMsg;
             if ((New.KZAdrArt = "1") and (FMonatpr > 0) and (Fmonatpr <= 13) and
                (FArt in ("RE","GU","MA","FU","Z","A"))) then begin
                execute procedure GDI_AdrArt New.Artikelnr,New.AdressNr,:FMonatpr,New.Datumpr,:FMenge,:FWert,New.rabatt,"1"
                   RETURNING_VALUES :FErrMsg;
             end
             FNK     = 0;
             FUmsatz = 0;
             FErloes = 0;
             if (New.KZNK = "1") then
                FNK     = FWert;
             else
                FUmsatz = FWert;
             if (New.KZErloes <> "2") then begin
                if (New.KZErloes = "1") then begin
                   if (New.EKGesamt <> 0) then
                      FErloes = FWert -FEKGesamt;
                end else
                   FErloes = FWert -FEKGesamt;
             end
             if (((FMonatPr > 0) or (FArt in ("AU","BE","LI","RL"))) and (New.AdressNr <> 0)) then begin
                execute procedure GDI_ADUmsatz New.AdressNr, :FMonatpr,
                      :FCJahr, New.Filiale,New.BelegTyp,:FArt,:FErloes,:FUmsatz, FNk
                   RETURNING_VALUES :FErrMsg;
             end
         end
      end
   end
   if (New.KZSerie in ("1","2")) then begin
      if ((Old.BelegTyp  <> New.BelegTyp)  or (Old.BelegArt  <> New.BelegArt)  or
          (Old.BelegNr   <> New.BelegNr)   or (Old.PosArt    <> New.PosArt)    or
          (Old.PosNr     <> New.PosNr)     or (Old.Artikelnr <> New.Artikelnr) or
          (Old.Filiale   <> New.Filiale)   or (Old.AdressNr  <> New.AdressNr)  or
          (Old.DatumPr   <> New.DatumPr)   or (Old.KZSerie   <> New.KZSerie)   or
          (Division(New.LagerPr, New.LagerMe) <> Division(Old.LagerPr, Old.LagerMe))) then begin
         update SerPos set BelegTyp  = New.BelegTyp,  BelegArt  = New.BelegArt,
                           BelegNr   = New.BelegNr,   PosArt    = New.PosArt,
                           Posnr     = New.Posnr,     Artikelnr = New.Artikelnr,
                           Filiale   = New.Filiale,   AdressNr  = New.AdressNr,
                           DatumPr   = New.DatumPr,   LagerEp   = Division (New.LagerPr, New.LagerMe),
                           AendBed   = New.Bediener,  AendDatum = "Now"
         where BelegTyp = Old.BelegTyp and BelegArt = Old.BelegArt and
               BelegNr  = Old.BelegNr  and posnr    = Old.Posnr;
      end
   end else if (Old.KZSerie in ("1","2")) then begin
      delete from SerPos
      where BelegTyp = old.BelegTyp and BelegArt = old.BelegArt and
            BelegNr  = old.BelegNr  and posnr    = old.posnr;
   end

   if (New.BelegTyp = "L") then
      FArt = New.PosArt;
   else
      FArt = New.BelegArt;

   if ((New.KZCharge in ("1","2")) and (New.BelegTyp in ("E", "V", "L"))) then begin
      if ((Old.BelegTyp  <> New.BelegTyp)  or (Old.BelegArt <> New.BelegArt) or
          (Old.BelegNr   <> New.BelegNr)   or (Old.PosNr    <> New.PosNr)    or
          (Old.Artikelnr <> New.Artikelnr) or (Old.Filiale  <> New.Filiale)  or
          (Old.DatumMe   <> New.DatumMe)   or (Old.AdressNr <> New.AdressNr) or
          (Old.KZCharge <> New.KZCharge))                                    then begin
         if (New.BelegTyp = "V") then begin
            if      (FArt = "AU") then FChargeArt = "R";
            else if (FArt = "GU") then FChargeArt = "Z";
            else if (FArt = "RL") then FChargeArt = "Z";
            else if (FArt = "CK") then FChargeArt = "KV";
            else FChargeArt = "A";
         end
         else if (New.BelegTyp = "E") then begin
            if      (FArt = "BE") then FChargeArt = "B";
            else if (FArt = "GU") then FChargeArt = "A";
            else if (FArt = "RL") then FChargeArt = "A";
            else if (FArt = "CK") then FChargeArt = "KE";
            else FChargeArt = "Z";
         end
         else if (New.BelegTyp = "L") then begin
            if      (FArt = "Z") then FChargeArt = "Z";
            else if (FArt = "A") then FChargeArt = "A";
            else FChargeArt = "?";
         end
         else FChargeArt = "?";
         update ChargePos set BelegTyp  = New.BelegTyp,  BelegArt = New.BelegArt,
                              BelegNr   = New.BelegNr,   Posnr    = New.Posnr,
                              Artikelnr = New.Artikelnr, Filiale  = New.Filiale,
                              DatumMe   = New.DatumMe,   Art      = :FChargeArt,
                              AdressNr  = New.AdressNr,  AendBed  = New.Bediener,
                              AendDatum = "Now"
         where BelegNr  = Old.BelegNr  and BelegArt = Old.BelegArt and
               BelegTyp = Old.BelegTyp and Posnr    = Old.Posnr;
      end
      /* Anpassen der UrPosNr */
      if (Old.PosNr <> New.PosNr) then begin
         update ChargePos set UrPosnr = New.Posnr
         where UrBelegNr = New.BelegNr  and UrBelegArt = New.BelegArt and
               UrBelegTyp = New.BelegTyp and UrPosnr   = Old.Posnr;
      end
   end
   else if (Old.KZCharge in ("1","2")) then begin
      delete from ChargePos
      where BelegNr  = Old.BelegNr  and BelegArt = Old.BelegArt and
            BelegTyp = Old.BelegTyp and Posnr    = Old.Posnr;
   end
end
--

create trigger GDI_BELEGPOS_AFTERDELETE for BELEGPOS after delete
as
   declare variable FVon       Date;
   declare variable FBis       Date;
   declare variable FAb        Date;
   declare variable FJahr      SmallInt;
   declare variable FVonMonat  SmallInt;
   declare variable FMonatMe   SmallInt;
   declare variable FMonatpr   SmallInt;
   declare variable FArt       VarChar(10);
   declare variable FMenge     Double Precision;
   declare variable FWert      Double Precision;
   declare variable FEKGesamt  Double Precision;
   declare variable FEKWert    Double Precision;
   declare variable FNK        Double Precision;
   declare variable FErloes    Double Precision;
   declare variable FUmsatz    Double Precision;
   declare variable FErrMsg    SmallInt;
   declare variable FCJahr     Char(4);
   declare variable FPreisPfl  Char(1);
   declare variable FP         VarChar(255);
begin
   if (Old.BelegTyp = "L") then
      FArt = Old.PosArt;
   else
      FArt = Old.BelegArt;
   if ((Old.Artikelnr <> "") and
       ((not (Old.KzDruck in ("P","S","E","T","t","C","A"))) or (Old.kzdruck is null)) and
       ((Old.Lagerpr <> 0) or (Old.Lagerme <> 0) or (Old.EKGesamt <> 0)) and
       (FArt in ("RE","LI","RL","AU","BE","GU","MA","FU","Z","K","A","I"))) then begin
      if ((Old.BelegTyp <> "L") and
          ((Old.AdressNr = 0) or (Old.AdressNr is null))) then begin
         exception GDI_AdressNr_DEL;
      end
      select first 1 StrToDateTime(W1), StrToDateTime(W2), StrToDateTime(W3),
             cast(k3 as Char(1)) from GDIDEF
      where Satzart = "FA2"
      into :FVon, :FBis, :FAb, :FPreisPfl;
      FJahr     = extract(Year from FVon);
      FVonMonat = FJahr * 12 + extract(Month from FVon);
      FMonatMe  = (extract(Year from Old.Datumme) * 12 +
                   extract(Month from Old.Datumme)) + 1 - FVonMonat;
      if (:FMonatMe > 12) then
         FMonatMe = 13;
      FMonatPr  = (extract(Year from Old.Datumpr) * 12 +
                   extract(Month from Old.Datumpr)) + 1 - FVonMonat;
      if (:FMonatPr > 12) then
         FMonatPr = 13;
      if (Old.BelegTyp = "L") then
         FArt = Old.PosArt;
      else
         FArt = Old.BelegArt;
      FMenge  = -Old.Lagerme;
      FWert   = -Old.Lagerpr;
      if ((Old.BelegTyp = "E") or (:FArt = "Z")) then
          FEKGesamt = -Old.Lagerpr;
      else
          FEKGesamt = -Old.EKGesamt;
      if (:FArt in ("GU")) then begin
         FMenge  = -FMenge;
         FWert   = -FWert;
         FEKGesamt = -FEKGesamt;
      end
      FEKWert = FEKGesamt;
      if (Old.KzDruck = "M") then begin
         FWert = 0;
         FEKGesamt = 0;
      end else if (Old.KzDruck = "W") then begin
         FMenge = 0;
         FEKWert = 0;
      end
      FCJahr = cast(FJahr as Char(4));
      execute procedure GDI_ARUmsatz Old.Artikelnr, Old.AdressNr,
            :FMonatme, :FMonatpr, :FCJahr, Old.Filiale,
            Old.DatumMe, Old.BelegTyp, :FArt, Old.KzDruck, :FMenge, :FWert,
            :FEKWert, :FPreisPfl, Old.MeFaktor, Old.KZEKWert
         RETURNING_VALUES :FErrMsg;
      if ((Old.KZAdrArt = "1") and (FMonatpr > 0) and (Fmonatpr <= 13) and
         (FArt in ("RE","GU","MA","FU","Z","A"))) then begin
         execute procedure GDI_AdrArt Old.Artikelnr, Old.AdressNr, :FMonatpr,Old.Datumpr,FMenge,FWert,Old.rabatt,"0"
            RETURNING_VALUES :FErrMsg;
      end
      FNK     = 0;
      FUmsatz = 0;
      FErloes = 0;
      if (Old.KZNK = "1") then
         FNK     = FWert;
      else
         FUmsatz = FWert;
      if (Old.KZErloes <> "2") then begin
         if (Old.KZErloes = "1") then begin
            if (Old.EKGesamt <> 0) then
               FErloes = FWert -FEKGesamt;
         end else
            FErloes = FWert -FEKGesamt;
      end
      if (((FMonatPr > 0) or (FArt in ("AU","BE","LI","RL"))) and (Old.AdressNr <> 0)) then begin
         execute procedure GDI_ADUmsatz Old.AdressNr, :FMonatpr,
               :FCJahr, Old.Filiale,Old.BelegTyp,:FArt,:FErloes,:FUmsatz, FNk
            RETURNING_VALUES :FErrMsg;
      end
   end
   if (Old.KZSerie in ("1","2")) then begin
      delete from SerPos
      where BelegTyp = Old.BelegTyp and BelegArt = Old.BelegArt and
            BelegNr  = Old.BelegNr  and posnr    = Old.posnr;
   end
   /* Achtung: Kein Lschen von ChargePos- Datenstzen per Trigger!
   if ((Old.KZCharge in ("1","2")) and (Old.BelegTyp in ("E", "V"))) then begin
   end
   */
   if (Old.BelegTyp = "L") then begin
      FP = Old.BelegTyp || ',' || Old.BelegArt || ',' ||
           IntToStr(Old.BelegNr) || ',' || IntToStr(Old.Posnr);
      execute procedure GDI_DELDATEI "BELEGPOS","BELEGTYP,BELEGART,BELEGNR,POSNR",FP;
   end
end
--

create trigger GDI_BELEG_BEFOREINSERT for BELEG before insert
as
   declare variable FAbgerBis Date;
   declare Variable FAdressNr Integer;
   declare Variable FAdrUUID VarChar(40);
   declare variable FNK Integer;
   declare variable FName VarChar(80);
begin
   FNK = null;
   select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
   where Satzart = "FA1" into :FNK;
   if ((FNK is null) or (FNK = 0)) then
      FNK = 2;
   select Copy(Name1,1,40) from Personal where personalnr = New.Personal into :FName;
   New.PersName = FName;
   FAbgerBis = "01.01.1970";
   select first 1 StrToDateTime(W3) AbgerBis from GDIDEF where Satzart = "FA2"
   into :FAbgerBis;
   if (New.BelegDat is null) then
      New.BelegDat = "Now";
   if (New.BelegDat < FAbgerBis + 1) then begin
      /* "Das Belegdatum liegt im abgerechneten Zeitraum!!" */
      exception GDI_BELEG_DATUM;
   end
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   FAdrUUID = "";
   if (New.AdressNr > 0) then begin
      FAdressNr = Null;
      Select First 1 AdressNr from Kunden Where KundenNr = New.AdressNr Into :FAdressNr;
      if (FAdressNr is Null) then
         Select First 1 AdressNr from Liefer Where LieferNr = New.AdressNr Into :FAdressNr;
      if ((FAdressNr is not Null) and (FAdressNr > 0)) then
         Select First 1 AdrUUID from CM_Adressen Where AdressNr = :FAdressNr Into :FAdrUUID;
   end
   New.AdrUUID = FAdrUUID;
   FAdrUUID = "";
   if (New.LieferNr > 0) then begin
      FAdressNr = Null;
      Select First 1 AdressNr from Kunden Where KundenNr = New.LieferNr Into :FAdressNr;
      if (FAdressNr is Null) then
         Select First 1 AdressNr from Liefer Where LieferNr = New.LieferNr Into :FAdressNr;
      if ((FAdressNr is not Null) and (FAdressNr > 0)) then
         Select First 1 AdrUUID from CM_Adressen Where AdressNr = :FAdressNr Into :FAdrUUID;
   end
   New.L_AdrUUID = FAdrUUID;
   New.CreateDatum = "Now";
   New.AendDatum = "Now";
   New.OPBetrag = Runden(New.Brutto - New.Zahlung - New.ScheckBtr - New.Skonto,FNK);
   select AWert from GDI_WAEHRUMRECHNEN(New.OPBetrag,New.WaehrFakt,-1,New.ISOWaehr,"","")
   into New.OPHaus;
   execute procedure GDI_Zahlungen New.BelegTyp,  New.BelegArt, New.BelegNr,
         New.Adressnr, New.Zahldatum, New.ZahlArt, New.KzZahlung, 0.0, New.Zahlung, 0.0,
         New.Skonto, 0.0, New.ScheckBtr, New.AendBed;
   New.KzZahlung = "";
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_BELEG_BEFOREUPDATE for BELEG before update
as
   declare Variable FAbgerechnet Date;
   declare Variable FAdressNr Integer;
   declare Variable FAdrUUID VarChar(40);
   declare Variable FNK Integer;
begin
   if (New.BelegDat <> Old.BelegDat) then begin
      select first 1 cast(w3 as Date) from GDIDEF where Satzart = "FA2"
      into :FAbgerechnet;
      if (New.BelegDat < FAbgerechnet + 1) then begin
         /* "Das Belegdatum liegt im abgerechneten Zeitraum!!" */
         exception GDI_BELEG_DATUM;
      end
   end
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   FAdrUUID = "";
   if (New.AdressNr > 0) then begin
      FAdressNr = Null;
      Select First 1 AdressNr from Kunden Where KundenNr = New.AdressNr Into :FAdressNr;
      if (FAdressNr is Null) then
         Select First 1 AdressNr from Liefer Where LieferNr = New.AdressNr Into :FAdressNr;
      if ((FAdressNr is not Null) and (FAdressNr > 0)) then
         Select First 1 AdrUUID from CM_Adressen Where AdressNr = :FAdressNr Into :FAdrUUID;
   end
   New.AdrUUID = FAdrUUID;
   FAdrUUID = "";
   if (New.LieferNr > 0) then begin
      FAdressNr = Null;
      Select First 1 AdressNr from Kunden Where KundenNr = New.LieferNr Into :FAdressNr;
      if (FAdressNr is Null) then
         Select First 1 AdressNr from Liefer Where LieferNr = New.LieferNr Into :FAdressNr;
      if ((FAdressNr is not Null) and (FAdressNr > 0)) then
         Select First 1 AdrUUID from CM_Adressen Where AdressNr = :FAdressNr Into :FAdrUUID;
   end
   New.L_AdrUUID = FAdrUUID;
   New.AendDatum = "Now";
   if ((New.WaehrFakt <> Old.WaehrFakt) or (New.ISOWaehr <> Old.ISOWaehr) or
       (New.Brutto    <> Old.Brutto)    or (New.Zahlung  <> Old.Zahlung)  or
       (New.ScheckBtr <> Old.ScheckBtr) or (New.Skonto   <> Old.Skonto)) then begin
      FNK = null;
      select first 1 StrToInt(Copy(ListValue(M1,"BELEG.NK"),1,1)) from GDIDEF
      where Satzart = "FA1" into :FNK;
      if ((FNK is null) or (FNK = 0)) then
         FNK = 2;
      New.OPBetrag = Runden(New.Brutto - New.Zahlung - New.ScheckBtr - New.Skonto,FNK);
      select AWert from GDI_WAEHRUMRECHNEN(New.OPBetrag,New.WaehrFakt,-1,New.ISOWaehr,"","")
      into New.OPHaus;
   end
   execute procedure GDI_Zahlungen New.BelegTyp, New.BelegArt, New.BelegNr, New.Adressnr,
      New.Zahldatum, New.ZahlArt, New.KzZahlung, Old.Zahlung, New.Zahlung,
      Old.Skonto, New.Skonto, Old.ScheckBtr, New.ScheckBtr, New.AendBed;
   New.KzZahlung = "";
   if (New.Personal <> Old.Personal) then begin
      select Copy(Name1,1,40) from Personal
      where  personalnr = New.Personal into New.PersName;
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_BELEG_AFTERINSERT for Beleg active after insert
as
   declare variable FP VarChar(255);
begin
   if (gen_id(offline_disabled, 0) = 0) then begin
      FP = new.BelegTyp || "," || new.BelegArt || "," || IntToStr(new.BelegNr);
      delete from deldatei where Datei = "BELEG" and Referenz = :FP;
   end
end
--

create trigger GDI_BELEG_AFTERUPDATE for Beleg active after update
as
begin
   update Versand
   set   Belegtyp = New.Belegtyp, Belegart = New.Belegart, Belegnr = New.Belegnr
   where BelegTyp = Old.BelegTyp and BelegArt = Old.BelegArt and BelegNr = Old.BelegNr;
   /* nderung in Lieferadresse: Chargepos- Datenstze anpassen */
   if (Old.LieferNr <> New.LieferNr) then begin
      update ChargePos set LieferAdr = New.LieferNr
      where BelegNr = New.BelegNr and BelegArt = New.BelegArt and BelegTyp = New.BelegTyp;
   end
   if (Old.AdressNr <> New.Adressnr) then begin
      update zahlungen set adressnr = New.AdressNr
      where BelegNr = New.BelegNr and BelegArt = New.BelegArt and BelegTyp = New.BelegTyp;
   end
end
--

create trigger GDI_BELEG_AFTERDELETE for Beleg active after delete
as
   declare variable FP VarChar(255);
begin
   update Versand
   set   Belegtyp = Lower(Old.Belegtyp), Belegart = Lower(Old.Belegart)
   where BelegTyp = Old.BelegTyp and BelegArt = Old.BelegArt and BelegNr = Old.BelegNr;
   delete from Belegpos where BelegTyp = Old.BelegTyp
      and BelegArt = Old.BelegArt and BelegNr = Old.BelegNr;
   delete from Zahlungen where BelegTyp = Old.BelegTyp
      and BelegArt = Old.BelegArt and BelegNr = Old.BelegNr;
   FP = Old.BelegTyp || "," || Old.BelegArt || "," || IntToStr(Old.BelegNr);
   execute procedure GDI_DELDATEI "BELEG", "BELEGTYP,BELEGART,BELEGNR", FP;
end
--

create trigger GDI_RABATTE_BEFOREINSUPD for RABATTE before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_RABATTE_AFTERDELETE for RABATTE after delete
as
   declare variable FP VarChar(255);
begin
   if (Old.Satzart = "PL" and Old.Liste > 0) then begin
      delete from Preise where Preislst = Old.liste;
   end
   else if (Old.Satzart = "RL") then begin
      delete from Rabatte where Satzart = "LG" and Liste = Old.Liste;
   end
   else if (Old.Satzart = "RS") then begin
      delete from Rabatte where Satzart = "ST" and Liste = Old.Liste;
   end
   else if (Old.Satzart = "RG") then begin
      delete from Rabatte where Satzart = "LG" and Gruppe = Old.Gruppe;
      delete from Rabatte where Satzart = "AR" and Gruppe = Old.Gruppe;
   end
   else if (Old.Satzart = "AR") then begin
      delete from Rabatte where Satzart = "RA" and Liste = Old.Liste and Gruppe = Old.Gruppe;
   end
   FP = Old.Satzart || "," || IntToStr(Old.Liste) || "," ||
        Old.Gruppe  || "," || IntToStr(Old.LfdNr);
   execute procedure GDI_DELDATEI "RABATTE", "SATZART,LISTE,GRUPPE,LFDNR", FP;
end
--

create trigger GDI_RABATTE_AFTERUPDATE for RABATTE after update
as
begin
   if ((Old.Satzart = "AR") and
       ((Old.Gruppe <> New.Gruppe) or (Old.Liste <> New.Liste))) then begin
      update Rabatte set Liste = New.Liste, Gruppe = New.Gruppe
      where Satzart = "RA" and Liste = Old.Liste and Gruppe = Old.Gruppe;
   end
end
--

create trigger GDI_ARTIKEL_BEFOREINSUPD for ARTIKEL before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ARTIKEL_AFTERDELETE for ARTIKEL after delete
as
 begin
    delete from Notiz where Datei = "ARTIKEL" and Referenz = old.Artikelnr;
    delete from AdrArt where Artikelnr = old.Artikelnr;
    delete from Preise where Artikelnr = old.Artikelnr and PreisLst > 0;
    delete from Stuck where STUCKL = old.Artikelnr;
    delete from Bestell where Artikelnr = old.Artikelnr;
    delete from ShopArtikel where Artikelnr = old.Artikelnr;
    execute procedure GDI_DELDATEI "ARTIKEL", "ARTIKELNR", Old.Artikelnr;
 end
--

create trigger GDI_SERIEN_BEFOREINSUPD for SERIEN before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_SERIEN_AFTERDELETE for SERIEN after delete
as
begin
   delete from Notiz where Datei = "SERIEN" and Referenz = Old.SerienNr;
   delete from SerTeil where SerienNr = Old.SerienNr;
   delete from SerPos  where SerienNr = Old.SerienNr;
   execute procedure GDI_DELDATEI "Serien", "SERIEN", Old.Seriennr;
end
--

create trigger GDI_SERTEIL_BEFOREINSUPD for SERTEIL before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_SERTEIL_AFTERDELETE for SERTEIL after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.Seriennr || "," || Old.SerTeil;
   execute procedure GDI_DELDATEI "SERTEIL","SERIENNR,SERTEIL", FP;
end
--

create trigger GDI_CHARGEN_AFTERDELETE for CHARGEN after delete
as
begin
   delete from Notiz where Datei = "CHARGEN" and Referenz = Old.ChargenNr;
   delete from ChargePos  where ChargenNr = Old.ChargenNr;
   execute procedure GDI_DELDATEI "Chargen", "CHARGEN", Old.ChargenNr;
end
--

create trigger GDI_ADRART_BEFOREINSERT for ADRART before insert
as
   declare variable VonDebitor Integer;
   declare variable BisDebitor Integer;
   declare variable VonKreditor Integer;
   declare variable BisKreditor Integer;
begin
   select first 1 cast(StrToInt(w1) as Integer), cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer), cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "FA3"
   into   :VonDebitor, :BisDebitor, :VonKreditor, :BisKreditor;
   if ((New.AdressNr >= VonDebitor) and (New.AdressNr <= BisDebitor)) then begin
      New.KZAdrTyp = "K";
   end else if ((New.AdressNr >= VonKreditor) and (New.AdressNr <= BisKreditor)) then begin
      New.KZAdrTyp = "L";
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ADRART_BEFOREUPDATE for ADRART before update
as
   declare variable VonDebitor Integer;
   declare variable BisDebitor Integer;
   declare variable VonKreditor Integer;
   declare variable BisKreditor Integer;
begin
   select first 1 cast(StrToInt(w1) as Integer), cast(StrToInt(w2) as Integer),
          cast(StrToInt(w3) as Integer), cast(StrToInt(w4) as Integer) from GDIDEF
   where  Satzart = "FA3"
   into  :VonDebitor, :BisDebitor, :VonKreditor, :BisKreditor;
   if ((New.AdressNr >= VonDebitor) and (New.AdressNr <= BisDebitor)) then begin
      New.KZAdrTyp = "K";
   end else if ((New.AdressNr >= VonKreditor) and (New.AdressNr <= BisKreditor)) then begin
      New.KZAdrTyp = "L";
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ADRART_AFTERDELETE for ADRART after delete
as
begin
   delete from Preise
   where Artikelnr = Old.Artikelnr and AdressNr = Old.AdressNr and PREISLST = 0;
end
--

create trigger GDI_PREISE_BEFOREINSUPDDEL for PREISE before insert or update or delete
as
  declare variable kzshop varchar(1);
  declare variable Anzahl Integer;
  declare variable Artikelnr varchar(30);
begin
   if (INSERTING) then
      Artikelnr = New.Artikelnr;
   else
      Artikelnr = OLD.Artikelnr;
   select kzshop from artikel where artikelnr= :Artikelnr into kzshop;
   if (kzshop = "1") then begin
      select count(*) Anzahl from SHOPTRANSFER where Nummer = :Artikelnr and TYP = "ARTIKEL"  into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","UPDATE", :Artikelnr,"Now") ;
      else
         update shoptransfer set art = "UPDATE", Datum="Now" where (TYP="ARTIKEL" and Nummer=:Artikelnr);
   end
   if (INSERTING or UPDATING) then begin
      New.OfflineDat = "Now";
      if (New.OffFiliale < 0) then
         New.OffFiliale = New.OffFiliale * -1;
      else
         New.OffFiliale = 0;
   end
end
--

create trigger GDI_PREISE_AFTERDELETE for PREISE after delete
as
   declare variable FP VarChar(255);
begin
   delete from PSTAFFEL where Artikelnr = old.Artikelnr and
      AdressNr = old.AdressNr and PreisLst = old.PreisLst and PosNr = old.PosNr;
   FP = Old.Artikelnr || "," || IntToStr(Old.AdressNr) || "," ||
        IntToStr(Old.Preislst) || "," || IntToStr(Old.PosNr);
   execute procedure GDI_DELDATEI "PREISE", "Artikelnr,ADRESSNR,PREISLST,POSNR", FP;
end
--

create trigger GDI_ADUMSATZ_BEFOREINSUPD for ADUMSATZ before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ADUMSATZ_AFTERDELETE for ADUMSATZ after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.ADRESSNR || "," || IntToStr(Old.JAHR) || "," || IntToStr(Old.FILIALE);
   execute procedure GDI_DELDATEI "ADUMSATZ","ADRESSNR,JAHR,FILIALE", FP;
end
--

create trigger GDI_ARUMSATZ_BEFOREINSUPD for ARUMSATZ before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ARUMSATZ_AFTERDELETE for ARUMSATZ after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.ARTIKELNR || "," || IntToStr(Old.JAHR) || "," || IntToStr(Old.FILIALE);
   execute procedure GDI_DELDATEI "ARUMSATZ","ARTIKELNR,JAHR,FILIALE", FP;
end
--

create trigger GDI_ANSPRECH_AFTERDELETE for ANSPRECH after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.Referenz || "," || Old.Datei || "," || IntToStr(Old.LFDNR);
   execute procedure GDI_DELDATEI "Ansprech","REFERENZ,DATEI,LFDNR", FP;
end
--

create trigger GDI_ANSPRECH_BEFOREINSUPD for ANSPRECH before insert or update
as
begin
   if ((New.AdrUUID is null) or (StrLen(New.AdrUUID) < 32)) then begin
      New.AdrUUID = UUIDStr();
   end
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_PROJEKT_BEFOREINSUPD for PROJEKT before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_PROJEKT_AFTERDELETE for PROJEKT after delete
as
begin
   execute procedure GDI_DELDATEI "PROJEKT","PROJEKTNR", Old.PROJEKTNR;
end
--

create trigger GDI_VERSAND_BEFOREINSUPD for VERSAND before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_VERSAND_AFTERDELETE for VERSAND after delete
as
begin
   execute procedure GDI_DELDATEI "VERSAND","VORGANGNR", Old.VORGANGNR;
end
--

create trigger GDI_GDIDEF_BEFOREUPDATE for GDIDEF before update
as
   declare variable FWgr      VarChar(6);
   declare variable FUmsatzGr VarChar(10);
begin
   if (New.Satzart in ("AG", "BR", "ME", "PL", "RG", "RL", "SO", "ST", "VS",
      "WA", "WG", "ZA", "ZB", "TK")) then begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
   /* nderung in der Umsatzgruppe: Artikelstamm anpassen */
   if ((New.Satzart = "WG") and (Old.W2 <> New.W2)) then begin
      FWgr      = Copy(New.Ind1,1,6);
      FUmsatzGr = Copy(New.W2,1,10);
      update artikel set umsatzgr = :FUmsatzGr
      where  wgr = :FWgr;
   end
end
--

create trigger GDI_GDIDEF_BEFOREINSERT for GDIDEF before insert
as
begin
   if (New.Satzart in ("AG", "BR", "ME", "PL", "RG", "RL", "SO", "ST", "VS",
      "WA", "WG", "ZA", "ZB", "TK")) then begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
end
--

create trigger GDI_STUCK_BEFOREINSUPD for STUCK before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_STUCK_AFTERINSUPD for STUCK after insert or update
as
begin
/*
   execute procedure GDI_STUCKSUMME New.Stuckl, New.AendBed, New.SatzArt;
*/
end
--

create trigger GDI_STUCK_AFTERDELETE for STUCK after delete
as
   declare variable FP VarChar(255);
begin
/*
   execute procedure GDI_STUCKSUMME Old.Stuckl, Old.AendBed, Old.SatzArt;
*/
   FP = Old.Satzart || "," || Old.Stuckl || "," || IntToStr(Old.Posnr);
   execute procedure GDI_DELDATEI "STUCK", "SATZART,STUCKL,POSNR", FP;
end
--

create trigger GDI_NOTIZ_BEFOREINSUPD for NOTIZ before insert or update
as
   declare variable MaxNr Integer;
begin
   if (New.Nr <= 0) then begin
      MaxNr = 0;
      select First 1 Nr from Notiz where Filiale = New.Filiale Order by Nr desc into :MaxNr;
      New.Nr = MaxNr + 1;
   end
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_NOTIZ_AFTERDELETE for NOTIZ after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.SatzUUID || "," || Old.Referenz || "," || Old.Datei;
   execute procedure GDI_DELDATEI "NOTIZ", "SATZUUID,REFERENZ,DATEI", FP;
end
--

create trigger GDI_PSTAFFEL_BEFOREINSUPDDEL for PSTAFFEL before insert or update or delete
as
  declare variable kzshop varchar(1);
  declare variable Anzahl Integer;
  declare variable Artikelnr varchar(30);
begin
   if (INSERTING) then
      Artikelnr = New.Artikelnr;
   else
      Artikelnr = OLD.Artikelnr;
   select kzshop from artikel where artikelnr= :Artikelnr into kzshop;
   if (kzshop = "1") then begin
      select count(*) Anzahl from SHOPTRANSFER where Nummer = :Artikelnr and TYP = "ARTIKEL"  into :Anzahl;
      if (Anzahl = 0) then
         insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","UPDATE", :Artikelnr,"Now") ;
      else
         update shoptransfer set art = "UPDATE", Datum="Now" where (TYP="ARTIKEL" and Nummer=:Artikelnr);
   end
   if (INSERTING or UPDATING) then begin
      New.OfflineDat = "Now";
      if (New.OffFiliale < 0) then
         New.OffFiliale = New.OffFiliale * -1;
      else
         New.OffFiliale = 0;
   end
end
--

create trigger GDI_PSTAFFEL_AFTERDELETE for PSTAFFEL after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.Artikelnr || "," || IntToStr(Old.AdressNr) || "," ||
        IntToStr(Old.Preislst) || "," || IntToStr(Old.PosNr) || "," ||
        FloatToStr(Old.Menge);
   execute procedure GDI_DELDATEI "PSTAFFEL",
        "Artikelnr,ADRESSNR,PREISLST,POSNR,MENGE", FP;
end
--

create trigger GDI_SERPOS_AFTERINSUPD for SERPOS after insert or update
as
begin
   execute procedure GDI_SERIEN_UPD New.BelegTyp,New.BelegArt,New.BelegNr, New.PosArt,
                 New.SerienNr,New.AdressNr,New.DatumPr,New.LagerEP,New.KzSerie;
end
--

create trigger GDI_SERPOS_AFTERDELETE for SERPOS after delete
as
  declare variable Anzahl      Integer;
  declare variable GURLAnz     Integer;
  declare variable FV_Freigabe Integer;
begin
  if ((Old.BelegTyp = "V") or (Old.BelegTyp || Old.PosArt = "LA")) then begin
      /* Freigabe fr V-Gutschriften/Rcklieferungen?
         0=Keine, 1=GU, 2=RL, 3=GU+RL */
      FV_Freigabe = null;
      select first 1 StrToInt(Copy(ListValue(M1,"SERIEN.FREIGABE.VERKAUF"),1,1)) from GDIDEF
      where Satzart = "FA1" into :FV_Freigabe;
      if ((FV_Freigabe is null) or (FV_Freigabe not in (0,1,2,3))) then
         FV_Freigabe = 0;

     if (FV_Freigabe > 0) then begin
        GURLAnz = 0;
        if (FV_Freigabe = 1) then begin
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and Belegart = "GU"
              into :GURLAnz;
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and (Belegart not in ("GU"))
              into :Anzahl;
        end else if (FV_Freigabe = 2) then begin
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and Belegart = "RL"
              into :GURLAnz;
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and (Belegart not in ("RL"))
              into :Anzahl;
        end else if (FV_Freigabe = 3) then begin
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and Belegart in ("RL","GU")
              into :GURLAnz;
           select count(*) from Serpos
              where Seriennr = Old.Seriennr and BelegTyp = Old.BelegTyp and (Belegart not in ("RL","GU"))
              into :Anzahl;
        end
        if ((Anzahl = 0) and (GURLAnz = 0)) then
           update serien
              set vk = 0, kundennr = 0, kzfrei = "1"
              where Seriennr = Old.Seriennr;
        else if ((Anzahl = 0) and (GURLAnz <> 0)) then
           update serien
              set kzfrei = "1"
              where Seriennr = Old.Seriennr;
        else if ((Anzahl <> 0) and (GURLAnz = 0)) then
           update serien
              set kzfrei = "0"
              where Seriennr = Old.Seriennr;
     end
     else begin
        select count(*) from Serpos
           where Seriennr = Old.Seriennr and
                (BelegTyp = "V" or BelegTyp || PosArt = "LA")
           into :Anzahl;
        if (Anzahl = 0) then
           update serien
              set vk = 0, kundennr = 0, kzfrei = "1"
              where Seriennr = Old.Seriennr;
     end
  end else if ((Old.BelegTyp = "E") or (Old.BelegTyp || Old.PosArt = "LZ")) then begin
     select count(*) from Serpos
        where Seriennr = Old.Seriennr and
              (BelegTyp = "E" or BelegTyp || PosArt = "LZ")
        into :Anzahl;
     if (Anzahl = 0) then
        update serien
        set ek = 0, liefernr = 0, kzekfrei = "1"
        where Seriennr = Old.Seriennr;
  end
end
--

create trigger GDI_ARTIKEL_BEFOREDELETE for ARTIKEL before DELETE
as
   declare variable Anzahl Integer;
begin
   if (old.kzshop = "1") then
      exception GDI_Artikel_Webshop;
   select count(*) from Stuck where Artikelnr = old.Artikelnr and Satzart = "P"
   into :Anzahl;
   if (Anzahl > 0) then
      exception GDI_ARTIKEL_STUCKL;
end
--

create trigger GDI_ARTIKEL_AFTERUPDATE for ARTIKEL after update
as
  declare variable ArtNr varChar(30);
  declare variable Anzahl integer;
begin
  if ((old.Artikelnr <> New.Artikelnr) and
      (old.Artikelnr <> "") and (new.Artikelnr <> "") and
      (old.Artikelnr is not null) and (new.Artikelnr is not null)) then begin
     if (Gen_ID (Buchen_Disabled,1) = 1) then begin
        update Belegpos
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Stuck
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Stuck
           set Stuckl = New.Artikelnr
           where Stuckl = Old.Artikelnr;
     end
     if (Gen_ID (Buchen_Disabled,-1) = 0) then begin
        update Adrart
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Artikel
           set ErsatzArt = New.Artikelnr
           where ErsatzArt = Old.Artikelnr;
        update ARUmsatz
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Bestell
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Inventur
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Notiz
           set Referenz = New.Artikelnr
           where Datei = "ARTIKEL" and Referenz = Old.Artikelnr;
        update Preise
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update PStaffel
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Serien
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update SerPos
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update SerTeil
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Chargen
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update ChargePos
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Statis
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update Wieder
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update ShopArtikel
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update ShopCrossSell
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update ShopCrossSell
           set Artikelnr1 = New.Artikelnr
           where Artikelnr1 = Old.Artikelnr;
        update ShopVarianten
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
        update ShopVarianten
           set Artikelnr1 = New.Artikelnr
           where Artikelnr1 = Old.Artikelnr;
        update ShopMerkmale
           set Artikelnr = New.Artikelnr
           where Artikelnr = Old.Artikelnr;
     end
  end
  /* ggf. ShopArtikel anlegen  */
  if (Old.KzShop <> New.KzShop) then begin
     if (New.KzShop = "1") then begin
        ArtNr = null;
        select Artikelnr from ShopArtikel where Artikelnr = New.Artikelnr into :ArtNr;
        if (ArtNr is null) then
           insert into ShopArtikel (ArtikelNr, KzShop) Values (New.artikelnr, "1");
     end
     select count(*) from SHOPTRANSFER where (TYP="ARTIKEL" and Nummer = New.Artikelnr) into :Anzahl;
     if (New.KZShop <> "1") then begin
        if (Anzahl = 0) then
           insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","DELETE",New.Artikelnr,"Now") ;
        else
           update shoptransfer set art = "DELETE", Datum="Now" where (TYP="ARTIKEL" and Nummer=New.Artikelnr);
     end else begin
        if (Anzahl = 0) then
           insert into shoptransfer (TYP,ART,NUMMER,Datum) values ("ARTIKEL","UPDATE",New.Artikelnr,"Now") ;
        else
           update shoptransfer set art = "UPDATE", Datum="Now" where (TYP="ARTIKEL" and Nummer=New.Artikelnr);
     end
  end
end
--

create trigger GDI_DELDATEI_BEFOREINSUPD for DELDATEI before insert or update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_MENUES_BEFOREUPDATE for MENUES before update
as
   declare variable FAnz integer;
begin
   if (New.gruppe <> Old.gruppe) then begin
      FAnz = 0;
      select count(*) from Usertable
      where programm = Old.programm and gruppe = Old.gruppe and bedienernr = "admin"
      into :FAnz;
      if (FAnz > 0) then
         /* Dieses Menue kann nicht gendert werden, da ihm Bediener ADMIN zugeordnet ist! */
         exception GDI_MENUES_ADMIN;
   end
end
--

create trigger GDI_MENUES_AFTERUPDATE for MENUES after update
as
begin
   if (New.gruppe <> Old.gruppe) then begin
      update usertable set gruppe = New.gruppe
      where  programm = New.programm and gruppe = Old.gruppe;
      update gdidef set ind2 = New.gruppe
      where satzart = "TD" and ind2 = Old.gruppe;
      update gdidef set ind3 = New.gruppe
      where satzart = "TD" and ind3 = Old.gruppe;
   end
end
--

create trigger GDI_MENUES_BEFOREDELETE for MENUES before delete
as
   declare variable FAnz integer;
begin
   FAnz = 0;
   select count(*) from Usertable where programm = Old.programm and gruppe = Old.gruppe
   into :FAnz;
   if (FAnz > 0) then
      /* Dieses Menue kann nicht gelscht werden, da ihm Bediener zugeordnet sind! */
      exception GDI_MENUES_USED;
end
--

create trigger GDI_MENUES_AFTERDELETE for MENUES after delete
as
begin
   delete from gdidef where satzart = "TD" and ind2 = Old.gruppe;
   delete from gdidef where satzart = "TD" and ind3 = Old.gruppe;
end
--

create trigger GDI_USERTABLE_BEFOREDELETE for USERTABLE before delete
as
begin
   if (Old.bedienernr = "admin") then
      exception GDI_USERTABLE_ADMIN;  /* Bediener "admin" darf nicht gelscht werden! */
end
--

create trigger GDI_INVENTUR_BEFOREINSUPD for INVENTUR before insert or update
as
begin
   New.diffmenge = Runden(New.menge - New.sollmenge, 4);
   New.diffpreis = Runden(New.epreis - New.sollpreis, 4);
end
--

create trigger GDI_ZAHLUNGEN_AFTERUPDATE for ZAHLUNGEN after update
as
   declare variable FAnz Integer;
begin
   select Count(*) Anzahl from Beleg
   where  BelegNr = Old.BelegNr and Belegtyp = Old.BelegTyp and Belegart = Old.BelegArt
   into   :FAnz;
   if ((FAnz = 1) and (New.KzZahlung <> "V") and           /* Versionswechsel 2.0.5.6 */
       ((Old.Zahlung <> New.Zahlung) or
        (Old.Skonto <> New.Skonto) or (Old.ScheckBtr <> New.ScheckBtr))) then begin
      update Beleg set KzZahlung = "U", Zahlung = Zahlung - Old.Zahlung + New.Zahlung,
         ScheckBtr = ScheckBtr - Old.ScheckBtr + New.ScheckBtr, Skonto = Skonto - Old.Skonto + New.Skonto
      where BelegNr = Old.BelegNr and Belegtyp = Old.BelegTyp and Belegart = Old.BelegArt;
   end
end
--

create trigger GDI_ZAHLUNGEN_AFTERINSERT for ZAHLUNGEN after insert
as
   declare variable FAnz Integer;
begin
   select Count(*) Anzahl from Beleg
   where  BelegNr = New.BelegNr and Belegtyp = New.BelegTyp and Belegart = New.BelegArt
   into   :FAnz;
   if ((FAnz = 1) and (New.KzZahlung <> "V")) then begin   /* Versionswechsel 2.0.5.6 */
      update Beleg set KzZahlung = "I", Zahlung = Zahlung + New.Zahlung,
                       ScheckBtr = ScheckBtr + New.ScheckBtr, Skonto = Skonto + New.Skonto
      where BelegNr = New.BelegNr and Belegtyp = New.BelegTyp and Belegart = New.BelegArt;
   end
end
--

create trigger GDI_ZAHLUNGEN_AFTERDELETE for ZAHLUNGEN after delete
as
   declare variable FAnz Integer;
begin
   select Count(*) Anzahl from Beleg
   where  BelegNr = Old.BelegNr and Belegtyp = Old.BelegTyp and Belegart = Old.BelegArt
   into   :FAnz;
   if (FAnz = 1) then begin
      update Beleg set KzZahlung = "D", Zahlung = Zahlung - Old.Zahlung,
                       ScheckBtr = ScheckBtr - Old.ScheckBtr, Skonto = Skonto - Old.Skonto
      where BelegNr = Old.BelegNr and Belegtyp = Old.BelegTyp and Belegart = Old.BelegArt;
   end
end
--

create trigger GDI_ARCHIV_BEFOREINSUPD for ARCHIV before insert or update
as
begin
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ARCHIV_AFTERDELETE for ARCHIV after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.BelegTyp || "," || Old.BelegArt || "," || IntToStr(Old.BelegNr)
                     || "," || Old.VFiliale  || "," || Old.Lfdnr;
   execute procedure GDI_DELDATEI "ARCHIV", "BELEGTYP,BELEGART,BELEGNR,VFILIALE,LFDNR", FP;
end
--

create trigger GDI_ARCHIVDATEN_BEFOREINSERT for ARCHIVDATEN before insert
as
   declare variable FLfdNr Integer;
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
   select Max(LfdNr) from ARCHIVDATEN into :FLfdNr;
   if (FLfdNr is Null) then
      FLfdNr = 0;
   New.LfdNr = FLfdNr + 1;
end
--

create trigger GDI_ARCHIVDATEN_BEFOREUPDATE for ARCHIVDATEN before update
as
begin
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--

create trigger GDI_ARCHIVDATEN_AFTERDELETE for ARCHIVDATEN after delete
as
   declare variable FP VarChar(255);
begin
   FP = Old.Lfdnr;
   execute procedure GDI_DELDATEI "ARCHIVDATEN", "LFDNR", FP;
end
--

create trigger GDI_STARTDIALOG_BEFOREINSUPD for STARTDIALOG before insert or update
as
   declare Variable FZeit Date;
begin
   FZeit = "Now";
   if ((New.SatzUUID is null) or (StrLen(New.SatzUUID) < 32)) then
      New.SatzUUID = UUIDStr();
   if (INSERTING) then
      New.CreateDatum = FZeit;
   New.AendDatum = FZeit;
   POST_EVENT New.Event;
end
--

create trigger GDI_CM_ADRESSEN_BEFOREINSUPD for CM_ADRESSEN before insert or update position 1
as
   declare Variable FZeit Date;
begin
   FZeit = "Now";
   if ((New.AdrUUID is null) or (StrLen(New.AdrUUID) < 32)) then
      New.AdrUUID = UUIDStr();
   if (INSERTING) then begin
      New.CreateDatum = FZeit;
      New.CreateBed   = New.AendBed;
   end
   New.AendDatum = FZeit;
   New.OfflineDat = "Now";
   if (New.OffFiliale < 0) then
      New.OffFiliale = New.OffFiliale * -1;
   else
      New.OffFiliale = 0;
end
--


